/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 79*/ GIMT_Encode4(130925),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35988), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36626), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36789), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36810),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(91274), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(98936),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(99094),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(99252),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99573), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(99669),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(99827),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100432),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100590),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(100806),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(100914), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(101187), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101519),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(101767),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(102136),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(102781),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(104081),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(104726), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(105746),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(108099),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(109776),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(110757), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(112848), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(113013),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114544),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(114780),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(115052),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116386),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(117720),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118372), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(119024), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(119800),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120392), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(120984),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(121718), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122452),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122485),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122521),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(122650), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(122683),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(123226),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(123769),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(124690),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125611), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(126082), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126155),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126455), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126512), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(127073),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(127181),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127471),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(127903), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(128278),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128416),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128791),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(129087), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129225),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129271), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129358), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129779),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(130059),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130348),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130629),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 80: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1187), // Rule ID 5670 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5670,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 91: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1262), // Rule ID 5671 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5671,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 92: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1337), // Rule ID 5705 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5705,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 93: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1412), // Rule ID 5706 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5706,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 94: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1487), // Rule ID 2000 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 2000,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 95: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1562), // Rule ID 2001 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 2001,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 96: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1637), // Rule ID 2239 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2239,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 97: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1712), // Rule ID 2240 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2240,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 98: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1840), // Rule ID 5681 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5681,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 99: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1968), // Rule ID 5682 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5682,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 100: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2096), // Rule ID 2106 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2106,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 101: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2224), // Rule ID 5680 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5680,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 102: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2334), // Rule ID 5449 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5449,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 103: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2444), // Rule ID 5486 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5486,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 104: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 105: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 106: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2777), // Rule ID 5448 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5448,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 107: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2890), // Rule ID 5485 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5485,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 108: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3003), // Rule ID 5447 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5447,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 109: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3116), // Rule ID 5484 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5484,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 110: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 111: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 112: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 113: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 114: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3659), // Rule ID 5679 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5679,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 115: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3750), // Rule ID 2105 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2105,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 116: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3866), // Rule ID 5446 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5446,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 117: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3982), // Rule ID 5483 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5483,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 118: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 119: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 120: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4302), // Rule ID 3248 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3248,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 121: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4390), // Rule ID 3249 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3249,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 122: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4478), // Rule ID 3252 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3252,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 123: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4566), // Rule ID 5950 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5950,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 124: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4654), // Rule ID 5951 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5951,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 125: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4742), // Rule ID 5954 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5954,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 126: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 127: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 128: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 129: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 130: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 131: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 132: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 133: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 134: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5314), // Rule ID 5672 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5672,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 135: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5385), // Rule ID 5673 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5673,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 136: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5456), // Rule ID 5707 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5707,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 137: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5527), // Rule ID 5708 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5708,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 138: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 139: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 140: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5730), // Rule ID 3053 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3053,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 141: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5793), // Rule ID 3081 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3081,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 142: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5856), // Rule ID 3091 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3091,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 143: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5932), // Rule ID 5443 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5443,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 144: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6008), // Rule ID 5444 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5444,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 145: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6078), // Rule ID 5481 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5481,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 146: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6149), // Rule ID 2004 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2004,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 147: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6220), // Rule ID 2005 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2005,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 148: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6291), // Rule ID 2243 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2243,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 149: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6362), // Rule ID 2244 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2244,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 150: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6432), // Rule ID 5445 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5445,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 151: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6502), // Rule ID 5482 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5482,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 152: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6565), // Rule ID 5926 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5926,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 153: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6628), // Rule ID 5940 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5940,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 154: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6691), // Rule ID 5945 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5945,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 155: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 156: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 157: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 158: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6875), // Rule ID 5463 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5463,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 159: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 90: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 81: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6923), // Rule ID 762 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 762,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 160: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 82: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7005), // Rule ID 5532 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5532,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 162: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7071), // Rule ID 889 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 889,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 163: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7107), // Rule ID 758 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 758,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 164: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 161: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 83: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7192), // Rule ID 782 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 782,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 166: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7260), // Rule ID 781 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 781,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 167: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7328), // Rule ID 770 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 770,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 168: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7396), // Rule ID 780 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 780,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 169: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7464), // Rule ID 779 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 779,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 170: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7517), // Rule ID 5511 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5511,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 171: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7570), // Rule ID 5505 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5505,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 172: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7623), // Rule ID 5510 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5510,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 173: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7676), // Rule ID 791 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 791,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 174: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7729), // Rule ID 785 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 785,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 175: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7782), // Rule ID 790 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 790,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 176: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7818), // Rule ID 763 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 763,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 177: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 165: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 84: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7901), // Rule ID 5531 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5531,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 179: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7967), // Rule ID 888 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 888,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 180: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8003), // Rule ID 757 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 757,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 181: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 178: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 85: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8088), // Rule ID 778 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 778,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 183: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8160), // Rule ID 777 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 777,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 184: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8232), // Rule ID 769 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 769,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 185: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8304), // Rule ID 776 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 776,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 186: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8376), // Rule ID 775 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 775,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 187: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8446), // Rule ID 5535 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5535,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 188: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8503), // Rule ID 5509 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5509,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 189: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8560), // Rule ID 5504 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5504,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 190: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8617), // Rule ID 5508 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5508,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 191: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8687), // Rule ID 892 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 892,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 192: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8744), // Rule ID 789 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 789,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 193: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8801), // Rule ID 784 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 784,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 194: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8858), // Rule ID 788 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 788,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 195: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8898), // Rule ID 761 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 761,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 196: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8959), // Rule ID 3496 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3496,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 197: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 182: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 86: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9042), // Rule ID 5530 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5530,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 199: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9108), // Rule ID 887 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 887,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 200: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9144), // Rule ID 756 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 756,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 201: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 198: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 87: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9229), // Rule ID 774 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 774,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 203: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9301), // Rule ID 773 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 773,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 204: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9373), // Rule ID 768 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 768,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 205: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9445), // Rule ID 772 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 772,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 206: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9517), // Rule ID 771 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 771,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 207: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9587), // Rule ID 5534 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5534,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 208: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9644), // Rule ID 5507 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5507,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 209: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9701), // Rule ID 5503 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5503,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 210: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9758), // Rule ID 5506 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5506,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 211: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9828), // Rule ID 891 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 891,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 212: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9885), // Rule ID 787 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 787,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 213: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9942), // Rule ID 783 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 783,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 214: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(9999), // Rule ID 786 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 786,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 215: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10039), // Rule ID 760 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 760,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 216: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10100), // Rule ID 3492 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3492,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 217: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 202: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 88: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10183), // Rule ID 5533 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5533,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 219: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10253), // Rule ID 890 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 890,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 220: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10293), // Rule ID 759 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 759,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 221: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10354), // Rule ID 3488 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3488,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 222: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 218: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 89: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 223: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 234: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 235: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 236: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 237: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 238: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 239: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 240: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 241: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 242: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 243: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 244: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 233: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 224: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11088), // Rule ID 966 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 966,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 245: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 225: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11170), // Rule ID 917 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 917,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 247: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11202), // Rule ID 962 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 962,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 248: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 246: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 226: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11287), // Rule ID 986 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 986,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 250: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11355), // Rule ID 985 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 985,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 251: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11423), // Rule ID 974 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 974,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 252: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 984 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 984,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11559), // Rule ID 983 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 983,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 254: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11612), // Rule ID 995 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 995,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 255: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11665), // Rule ID 989 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 989,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 256: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11718), // Rule ID 994 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 994,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 257: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11754), // Rule ID 967 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 967,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 258: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 249: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 227: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11837), // Rule ID 916 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 916,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 260: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11869), // Rule ID 961 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 961,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 261: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 259: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 228: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11954), // Rule ID 982 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 982,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 263: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12026), // Rule ID 981 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 981,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 264: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12098), // Rule ID 973 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 973,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 265: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12170), // Rule ID 980 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 980,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 266: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 979 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 979,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12312), // Rule ID 920 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 920,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 268: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12369), // Rule ID 993 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 993,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 269: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12426), // Rule ID 988 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 988,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 270: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12483), // Rule ID 992 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 992,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 271: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12523), // Rule ID 965 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 965,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 272: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12584), // Rule ID 3508 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3508,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 273: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 262: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 229: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12667), // Rule ID 915 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 915,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 275: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12699), // Rule ID 960 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 960,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 276: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 274: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 230: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12784), // Rule ID 978 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 978,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 278: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12856), // Rule ID 977 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 977,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 279: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12928), // Rule ID 972 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 972,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 280: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13000), // Rule ID 976 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 976,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 281: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13072), // Rule ID 975 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 975,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 282: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13142), // Rule ID 919 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 919,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 283: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13199), // Rule ID 991 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 991,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 284: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13256), // Rule ID 987 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 987,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 285: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13313), // Rule ID 990 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 990,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 286: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13353), // Rule ID 964 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 964,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 287: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13414), // Rule ID 3504 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3504,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 288: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 277: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 231: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13497), // Rule ID 918 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 918,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 290: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13537), // Rule ID 963 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 963,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 291: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13598), // Rule ID 3500 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3500,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 292: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 289: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 232: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 293: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 302: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 303: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 304: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 305: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 306: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 307: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 308: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 309: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 310: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 311: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 312: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 313: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 301: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 294: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14637), // Rule ID 837 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 837,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 314: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 295: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14684), // Rule ID 836 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 836,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 315: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 296: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14811), // Rule ID 4421 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4421,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 317: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14851), // Rule ID 840 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 840,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 318: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14912), // Rule ID 3466 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3466,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 319: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 316: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 297: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14960), // Rule ID 835 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 835,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 320: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 298: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15087), // Rule ID 4426 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4426,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 322: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15127), // Rule ID 839 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 839,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 323: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15188), // Rule ID 3462 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3462,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 324: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 321: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 299: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15241), // Rule ID 838 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 838,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 326: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15302), // Rule ID 3458 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3458,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 327: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 325: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 300: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 329: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 330: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 328: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 332: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 333: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 331: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 334: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15652), // Rule ID 1855 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1855,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 349: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15725), // Rule ID 2112 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2112,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 350: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15773), // Rule ID 1997 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1997,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 351: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15821), // Rule ID 1998 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1998,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 352: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15869), // Rule ID 1999 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1999,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 353: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15917), // Rule ID 2236 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2236,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 354: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15965), // Rule ID 2237 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2237,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 355: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16013), // Rule ID 2238 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2238,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 356: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16090), // Rule ID 5439 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5439,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 357: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16167), // Rule ID 5472 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5472,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 358: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16244), // Rule ID 5438 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5438,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 359: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16321), // Rule ID 5471 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5471,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 360: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16398), // Rule ID 5437 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5437,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 361: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16475), // Rule ID 5470 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5470,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 362: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 363: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 364: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16700), // Rule ID 5440 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5440,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 365: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16771), // Rule ID 5461 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5461,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 366: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16842), // Rule ID 5473 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5473,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 367: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 368: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 369: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 370: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 371: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 372: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17204), // Rule ID 1894 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1894,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 373: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 374: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 375: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 376: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 377: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 378: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 379: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 380: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 348: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 335: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17606), // Rule ID 2526 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2526,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 381: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 336: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17724), // Rule ID 1826 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1826,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 382: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 337: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17771), // Rule ID 1133 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1133,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 383: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 338: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17823), // Rule ID 2529 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2529,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 385: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17884), // Rule ID 3370 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3370,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 386: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 384: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 339: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18003), // Rule ID 1827 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1827,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 387: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 340: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18050), // Rule ID 2525 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2525,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 388: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 341: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18102), // Rule ID 1134 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1134,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 390: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18163), // Rule ID 3366 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3366,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 391: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 389: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 342: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18282), // Rule ID 1828 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1828,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 392: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 343: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18329), // Rule ID 2524 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2524,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 393: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 344: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18381), // Rule ID 2528 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2528,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 395: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18442), // Rule ID 3362 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3362,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 396: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 394: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 345: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18561), // Rule ID 1829 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1829,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 397: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 346: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18613), // Rule ID 2527 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2527,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 399: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18674), // Rule ID 3358 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3358,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 400: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 398: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 347: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 401: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18886), // Rule ID 5655 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5655,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 416: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19013), // Rule ID 5697 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5697,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 417: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19140), // Rule ID 1914 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1914,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 418: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19267), // Rule ID 2196 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2196,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 419: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19400), // Rule ID 5453 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5453,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 420: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19533), // Rule ID 5490 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5490,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 421: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19666), // Rule ID 5660 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5660,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 422: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19799), // Rule ID 5702 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5702,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 423: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19932), // Rule ID 5452 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5452,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 424: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20065), // Rule ID 5489 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5489,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 425: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 426: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 427: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20464), // Rule ID 1919 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1919,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 428: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20597), // Rule ID 2201 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2201,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 429: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 430: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 431: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20968), // Rule ID 1915 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1915,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 432: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21073), // Rule ID 2197 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2197,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 433: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21178), // Rule ID 5656 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5656,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 434: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21283), // Rule ID 5698 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5698,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 435: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21389), // Rule ID 1918 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1918,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 436: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21495), // Rule ID 2200 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2200,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 437: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21601), // Rule ID 1917 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1917,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 438: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21707), // Rule ID 2199 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2199,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 439: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21813), // Rule ID 1916 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1916,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 440: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21919), // Rule ID 2198 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2198,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 441: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22025), // Rule ID 5659 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5659,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 442: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22131), // Rule ID 5701 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5701,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 443: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22237), // Rule ID 5658 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5658,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 444: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22343), // Rule ID 5700 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5700,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 445: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22449), // Rule ID 5657 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5657,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 446: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22555), // Rule ID 5699 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5699,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 447: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22632), // Rule ID 5477 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5477,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 448: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22709), // Rule ID 5476 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5476,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 449: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22786), // Rule ID 5475 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5475,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 450: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 451: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22934), // Rule ID 5478 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5478,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 452: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 453: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23060), // Rule ID 1848 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1848,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 454: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23115), // Rule ID 2094 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2094,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 455: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 456: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 457: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 458: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 459: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 460: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 415: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 402: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23415), // Rule ID 2532 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2532,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 461: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 403: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23533), // Rule ID 1834 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1834,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 462: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 404: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23580), // Rule ID 1137 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1137,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 463: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 405: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23632), // Rule ID 2535 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2535,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 465: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23693), // Rule ID 3384 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3384,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 466: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 464: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 406: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23812), // Rule ID 1835 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1835,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 467: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 407: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23859), // Rule ID 2531 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2531,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 468: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 408: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23911), // Rule ID 1138 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1138,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 470: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23972), // Rule ID 3380 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3380,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 471: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 469: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 409: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24091), // Rule ID 1836 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1836,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 472: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 410: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24138), // Rule ID 2530 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2530,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 473: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 411: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24190), // Rule ID 2534 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2534,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 475: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24251), // Rule ID 3376 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3376,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 476: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 474: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 412: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24370), // Rule ID 1837 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1837,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 477: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 413: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24422), // Rule ID 2533 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2533,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 479: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24483), // Rule ID 3372 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3372,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 480: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 478: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 414: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 481: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24623), // Rule ID 5480 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5480,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 496: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 497: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 498: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 499: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 500: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 501: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 502: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 503: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 504: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 505: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 495: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 482: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25110), // Rule ID 2538 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2538,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 506: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 483: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25228), // Rule ID 1830 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1830,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 507: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 484: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25275), // Rule ID 1135 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1135,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 508: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 485: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25327), // Rule ID 2541 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2541,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 510: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25388), // Rule ID 3398 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3398,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 511: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 509: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 486: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25507), // Rule ID 1831 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1831,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 512: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 487: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25554), // Rule ID 2537 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2537,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 513: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 488: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25606), // Rule ID 1136 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1136,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 515: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25667), // Rule ID 3394 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3394,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 516: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 514: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 489: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25786), // Rule ID 1832 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1832,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 517: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 490: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25833), // Rule ID 2536 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2536,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 518: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 491: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25885), // Rule ID 2540 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2540,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 520: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25946), // Rule ID 3390 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3390,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 521: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 519: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 492: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26065), // Rule ID 1833 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1833,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 522: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 493: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26117), // Rule ID 2539 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2539,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 524: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26178), // Rule ID 3386 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3386,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 525: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 523: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 494: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 527: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26301), // Rule ID 3024 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3024,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 532: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 528: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26364), // Rule ID 3025 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3025,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 534: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26403), // Rule ID 3028 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3028,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 535: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 533: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 529: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26467), // Rule ID 3026 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3026,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 537: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26506), // Rule ID 3029 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3029,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 538: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 536: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 530: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26565), // Rule ID 3027 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3027,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 539: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 531: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 526: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 540: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26681), // Rule ID 692 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 692,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 551: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26715), // Rule ID 693 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 693,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 552: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26785), // Rule ID 2718 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2718,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 553: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 550: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 541: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26819), // Rule ID 2720 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2720,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 554: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26851), // Rule ID 2721 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2721,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 555: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26883), // Rule ID 2732 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2732,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 556: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26915), // Rule ID 2733 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2733,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 557: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26947), // Rule ID 2734 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2734,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 558: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26979), // Rule ID 2735 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2735,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 559: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27011), // Rule ID 2736 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2736,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 560: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27043), // Rule ID 2737 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2737,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 561: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27075), // Rule ID 2738 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2738,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 562: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27107), // Rule ID 2739 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2739,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 563: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27139), // Rule ID 2740 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2740,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 564: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27171), // Rule ID 2741 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2741,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 565: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27208), // Rule ID 2804 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2804,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 566: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27245), // Rule ID 2805 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2805,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 567: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27282), // Rule ID 2806 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2806,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 568: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27319), // Rule ID 2807 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2807,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 569: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27356), // Rule ID 2808 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2808,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 570: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27393), // Rule ID 2809 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2809,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 571: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27430), // Rule ID 2810 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2810,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 572: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27467), // Rule ID 2811 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2811,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 573: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27504), // Rule ID 2812 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2812,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 574: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27541), // Rule ID 2813 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2813,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 575: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 542: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27574), // Rule ID 2722 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2722,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 576: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27606), // Rule ID 2723 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2723,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 577: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27638), // Rule ID 2742 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2742,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 578: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27670), // Rule ID 2743 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2743,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 579: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27702), // Rule ID 2744 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2744,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 580: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27734), // Rule ID 2745 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2745,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 581: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27766), // Rule ID 2746 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2746,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 582: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27798), // Rule ID 2747 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2747,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 583: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27830), // Rule ID 2748 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2748,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 584: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27862), // Rule ID 2749 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2749,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 585: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27894), // Rule ID 2750 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2750,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 586: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27926), // Rule ID 2751 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2751,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 587: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27963), // Rule ID 2814 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2814,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 588: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28000), // Rule ID 2815 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2815,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 589: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28037), // Rule ID 2816 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2816,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 590: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28074), // Rule ID 2817 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2817,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 591: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28111), // Rule ID 2818 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2818,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 592: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28148), // Rule ID 2819 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2819,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 593: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28185), // Rule ID 2820 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2820,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 594: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28222), // Rule ID 2821 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2821,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 595: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28259), // Rule ID 2822 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2822,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 596: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28296), // Rule ID 2823 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2823,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 597: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 543: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28329), // Rule ID 2726 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2726,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 598: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28361), // Rule ID 2727 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2727,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 599: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28393), // Rule ID 2768 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2768,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 600: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28425), // Rule ID 2769 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2769,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 601: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28457), // Rule ID 2770 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2770,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 602: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28489), // Rule ID 2771 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2771,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 603: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28521), // Rule ID 2772 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2772,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 604: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28553), // Rule ID 2773 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2773,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 605: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28585), // Rule ID 2774 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2774,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 606: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28617), // Rule ID 2775 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2775,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 607: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28649), // Rule ID 2776 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2776,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 608: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28681), // Rule ID 2777 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2777,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 609: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28718), // Rule ID 2840 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2840,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 610: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28755), // Rule ID 2841 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2841,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 611: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28792), // Rule ID 2842 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2842,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 612: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28829), // Rule ID 2843 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2843,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 613: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28866), // Rule ID 2844 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2844,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 614: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28903), // Rule ID 2845 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2845,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 615: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28940), // Rule ID 2846 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2846,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 616: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28977), // Rule ID 2847 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2847,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 617: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29014), // Rule ID 2848 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2848,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 618: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29051), // Rule ID 2849 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2849,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 619: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29083), // Rule ID 5283 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5283,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 620: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29115), // Rule ID 5284 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5284,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 621: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29147), // Rule ID 5289 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5289,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 622: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29179), // Rule ID 5290 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5290,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 623: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29211), // Rule ID 5291 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5291,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 624: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29243), // Rule ID 5292 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5292,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 625: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29275), // Rule ID 5293 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5293,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 626: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29307), // Rule ID 5294 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5294,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 627: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29339), // Rule ID 5295 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5295,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 628: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29371), // Rule ID 5296 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5296,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 629: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29403), // Rule ID 5297 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5297,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 630: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29435), // Rule ID 5298 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5298,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 631: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29493), // Rule ID 5325 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5325,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 632: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29551), // Rule ID 5326 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5326,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 633: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29609), // Rule ID 5327 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5327,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 634: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29667), // Rule ID 5328 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5328,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 635: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29725), // Rule ID 5329 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5329,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 636: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29783), // Rule ID 5330 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5330,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 637: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29841), // Rule ID 5331 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5331,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 638: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29899), // Rule ID 5332 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5332,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 639: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29957), // Rule ID 5333 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5333,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 640: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30015), // Rule ID 5334 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5334,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 641: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 544: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30048), // Rule ID 2724 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2724,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 642: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30080), // Rule ID 2725 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2725,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 643: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30112), // Rule ID 2752 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2752,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 644: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30144), // Rule ID 2753 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2753,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 645: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30176), // Rule ID 2754 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2754,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 646: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30208), // Rule ID 2755 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2755,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 647: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30240), // Rule ID 2756 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2756,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 648: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30272), // Rule ID 2757 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2757,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 649: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30304), // Rule ID 2758 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2758,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 650: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30336), // Rule ID 2759 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2759,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 651: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30368), // Rule ID 2760 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2760,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 652: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30400), // Rule ID 2761 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2761,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 653: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30437), // Rule ID 2824 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2824,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 654: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30474), // Rule ID 2825 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2825,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 655: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30511), // Rule ID 2826 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2826,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 656: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30548), // Rule ID 2827 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2827,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 657: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30585), // Rule ID 2828 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2828,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 658: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30622), // Rule ID 2829 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2829,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 659: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30659), // Rule ID 2830 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2830,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 660: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30696), // Rule ID 2831 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2831,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 661: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30733), // Rule ID 2832 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2832,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 662: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30770), // Rule ID 2833 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2833,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 663: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 545: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30803), // Rule ID 2728 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2728,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 664: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30835), // Rule ID 2729 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2729,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 665: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30867), // Rule ID 2778 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2778,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 666: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30899), // Rule ID 2779 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2779,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 667: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30931), // Rule ID 2780 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2780,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 668: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30963), // Rule ID 2781 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2781,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 669: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(30995), // Rule ID 2782 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2782,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 670: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31027), // Rule ID 2783 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2783,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 671: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31059), // Rule ID 2784 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2784,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 672: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31091), // Rule ID 2785 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2785,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 673: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31123), // Rule ID 2786 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2786,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 674: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31155), // Rule ID 2787 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2787,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 675: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31192), // Rule ID 2850 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2850,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 676: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31229), // Rule ID 2851 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2851,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 677: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31266), // Rule ID 2852 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2852,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 678: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31303), // Rule ID 2853 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2853,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 679: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31340), // Rule ID 2854 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2854,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 680: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31377), // Rule ID 2855 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2855,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 681: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31414), // Rule ID 2856 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2856,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 682: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31451), // Rule ID 2857 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2857,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 683: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31488), // Rule ID 2858 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2858,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 684: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31525), // Rule ID 2859 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2859,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 685: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31557), // Rule ID 5285 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5285,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 686: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31589), // Rule ID 5286 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5286,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 687: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31621), // Rule ID 5299 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5299,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 688: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31653), // Rule ID 5300 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5300,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 689: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31685), // Rule ID 5301 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5301,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 690: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31717), // Rule ID 5302 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5302,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 691: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31749), // Rule ID 5303 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5303,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 692: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31781), // Rule ID 5304 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5304,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 693: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31813), // Rule ID 5305 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5305,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 694: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31845), // Rule ID 5306 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5306,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 695: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31877), // Rule ID 5307 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5307,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 696: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31909), // Rule ID 5308 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5308,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 697: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31967), // Rule ID 5335 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5335,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 698: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32025), // Rule ID 5336 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5336,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 699: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32083), // Rule ID 5337 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5337,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 700: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32141), // Rule ID 5338 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5338,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 701: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32199), // Rule ID 5339 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5339,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 702: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32257), // Rule ID 5340 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5340,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 703: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32315), // Rule ID 5341 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5341,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 704: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32373), // Rule ID 5342 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5342,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 705: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32431), // Rule ID 5343 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5343,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 706: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32489), // Rule ID 5344 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5344,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 707: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 546: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32522), // Rule ID 2762 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2762,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 708: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32554), // Rule ID 2763 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2763,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 709: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32586), // Rule ID 2764 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2764,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 710: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32618), // Rule ID 2765 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2765,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 711: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32650), // Rule ID 2766 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2766,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 712: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32682), // Rule ID 2767 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2767,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 713: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32719), // Rule ID 2834 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2834,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 714: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32756), // Rule ID 2835 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2835,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 715: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32793), // Rule ID 2836 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2836,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 716: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32830), // Rule ID 2837 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2837,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 717: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32867), // Rule ID 2838 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2838,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 718: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32904), // Rule ID 2839 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2839,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 719: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 547: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32937), // Rule ID 2730 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2730,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 720: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32969), // Rule ID 2731 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2731,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 721: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33001), // Rule ID 2788 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2788,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 722: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33033), // Rule ID 2789 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2789,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 723: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33065), // Rule ID 2790 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2790,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 724: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33097), // Rule ID 2791 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2791,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 725: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33129), // Rule ID 2792 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2792,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 726: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33161), // Rule ID 2793 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2793,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 727: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33193), // Rule ID 2794 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2794,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 728: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33225), // Rule ID 2795 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2795,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 729: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33257), // Rule ID 2796 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2796,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 730: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33289), // Rule ID 2797 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2797,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 731: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33326), // Rule ID 2860 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2860,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 732: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33363), // Rule ID 2861 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2861,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 733: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33400), // Rule ID 2862 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2862,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 734: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33437), // Rule ID 2863 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2863,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 735: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33474), // Rule ID 2864 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2864,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 736: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33511), // Rule ID 2865 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2865,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 737: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33548), // Rule ID 2866 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2866,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 738: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33585), // Rule ID 2867 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2867,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 739: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33622), // Rule ID 2868 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2868,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 740: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33659), // Rule ID 2869 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2869,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 741: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33691), // Rule ID 5287 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5287,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 742: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33723), // Rule ID 5288 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5288,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 743: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33755), // Rule ID 5309 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5309,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 744: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33787), // Rule ID 5310 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5310,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 745: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33819), // Rule ID 5311 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5311,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 746: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33851), // Rule ID 5312 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5312,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 747: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33883), // Rule ID 5313 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5313,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 748: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33915), // Rule ID 5314 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5314,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 749: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33947), // Rule ID 5315 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5315,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 750: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33979), // Rule ID 5316 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5316,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 751: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34011), // Rule ID 5317 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5317,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 752: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34043), // Rule ID 5318 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5318,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 753: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34101), // Rule ID 5345 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5345,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 754: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34159), // Rule ID 5346 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5346,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 755: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34217), // Rule ID 5347 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5347,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 756: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34275), // Rule ID 5348 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5348,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 757: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34333), // Rule ID 5349 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5349,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 758: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34391), // Rule ID 5350 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5350,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 759: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34449), // Rule ID 5351 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5351,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 760: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34507), // Rule ID 5352 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5352,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 761: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34565), // Rule ID 5353 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5353,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 762: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34623), // Rule ID 5354 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5354,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 763: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 548: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34656), // Rule ID 2798 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2798,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 764: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34688), // Rule ID 2799 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2799,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 765: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34720), // Rule ID 2800 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2800,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 766: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34752), // Rule ID 2801 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2801,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 767: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34784), // Rule ID 2802 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2802,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 768: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34816), // Rule ID 2803 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2803,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 769: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34853), // Rule ID 2870 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2870,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 770: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34890), // Rule ID 2871 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2871,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 771: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34927), // Rule ID 2872 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2872,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 772: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34964), // Rule ID 2873 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2873,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 773: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35001), // Rule ID 2874 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2874,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 774: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35038), // Rule ID 2875 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2875,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 775: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35070), // Rule ID 5319 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5319,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 776: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35102), // Rule ID 5320 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5320,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 777: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35134), // Rule ID 5321 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5321,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 778: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35166), // Rule ID 5322 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5322,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 779: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35198), // Rule ID 5323 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5323,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 780: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35230), // Rule ID 5324 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5324,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 781: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35288), // Rule ID 5355 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5355,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 782: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35346), // Rule ID 5356 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5356,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 783: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35404), // Rule ID 5357 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5357,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 784: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35462), // Rule ID 5358 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5358,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 785: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35520), // Rule ID 5359 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5359,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 786: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35578), // Rule ID 5360 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5360,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 787: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 549: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 795*/ GIMT_Encode4(35987),
     /*  35591 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35719), GIMT_Encode4(0),
     /*  35607 */ /*GILLT_v2s32*//*Label 791*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35619 */ /*GILLT_v4s16*//*Label 792*/ GIMT_Encode4(35784),
     /*  35623 */ /*GILLT_v4s32*//*Label 793*/ GIMT_Encode4(35811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 794*/ GIMT_Encode4(35899),
     /*  35643 */ // Label 788: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 796: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 789: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 797: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 790: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 798: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 791: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(35783), // Rule ID 1703 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  35776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  35781 */   GIR_RootConstrainSelectedInstOperands,
     /*  35782 */   // GIR_Coverage, 1703,
     /*  35782 */   GIR_Done,
     /*  35783 */ // Label 799: @35783
     /*  35783 */ GIM_Reject,
     /*  35784 */ // Label 792: @35784
     /*  35784 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(35810), // Rule ID 1705 //
     /*  35789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  35792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  35795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35803 */   // (ftrunc:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  35803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  35808 */   GIR_RootConstrainSelectedInstOperands,
     /*  35809 */   // GIR_Coverage, 1705,
     /*  35809 */   GIR_Done,
     /*  35810 */ // Label 800: @35810
     /*  35810 */ GIM_Reject,
     /*  35811 */ // Label 793: @35811
     /*  35811 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(35898),
     /*  35816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35819 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(35842), // Rule ID 1704 //
     /*  35824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  35827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35835 */     // (ftrunc:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  35835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  35840 */     GIR_RootConstrainSelectedInstOperands,
     /*  35841 */     // GIR_Coverage, 1704,
     /*  35841 */     GIR_Done,
     /*  35842 */   // Label 802: @35842
     /*  35842 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(35897), // Rule ID 3982 //
     /*  35847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35858 */     // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35875 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35895 */     GIR_RootConstrainSelectedInstOperands,
     /*  35896 */     // GIR_Coverage, 3982,
     /*  35896 */     GIR_EraseRootFromParent_Done,
     /*  35897 */   // Label 803: @35897
     /*  35897 */   GIM_Reject,
     /*  35898 */ // Label 801: @35898
     /*  35898 */ GIM_Reject,
     /*  35899 */ // Label 794: @35899
     /*  35899 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(35986),
     /*  35904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35907 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35930), // Rule ID 1706 //
     /*  35912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  35915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35923 */     // (ftrunc:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  35923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  35928 */     GIR_RootConstrainSelectedInstOperands,
     /*  35929 */     // GIR_Coverage, 1706,
     /*  35929 */     GIR_Done,
     /*  35930 */   // Label 805: @35930
     /*  35930 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(35985), // Rule ID 3970 //
     /*  35935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35946 */     // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35963 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35983 */     GIR_RootConstrainSelectedInstOperands,
     /*  35984 */     // GIR_Coverage, 3970,
     /*  35984 */     GIR_EraseRootFromParent_Done,
     /*  35985 */   // Label 806: @35985
     /*  35985 */   GIM_Reject,
     /*  35986 */ // Label 804: @35986
     /*  35986 */ GIM_Reject,
     /*  35987 */ // Label 795: @35987
     /*  35987 */ GIM_Reject,
     /*  35988 */ // Label 11: @35988
     /*  35988 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 814*/ GIMT_Encode4(36362),
     /*  35999 */ /*GILLT_s16*//*Label 807*/ GIMT_Encode4(36051),
     /*  36003 */ /*GILLT_s32*//*Label 808*/ GIMT_Encode4(36078),
     /*  36007 */ /*GILLT_s64*//*Label 809*/ GIMT_Encode4(36105), GIMT_Encode4(0),
     /*  36015 */ /*GILLT_v2s32*//*Label 810*/ GIMT_Encode4(36132), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36027 */ /*GILLT_v4s16*//*Label 811*/ GIMT_Encode4(36159),
     /*  36031 */ /*GILLT_v4s32*//*Label 812*/ GIMT_Encode4(36186), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36047 */ /*GILLT_v8s16*//*Label 813*/ GIMT_Encode4(36274),
     /*  36051 */ // Label 807: @36051
     /*  36051 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36077), // Rule ID 674 //
     /*  36056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36070 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  36075 */   GIR_RootConstrainSelectedInstOperands,
     /*  36076 */   // GIR_Coverage, 674,
     /*  36076 */   GIR_Done,
     /*  36077 */ // Label 815: @36077
     /*  36077 */ GIM_Reject,
     /*  36078 */ // Label 808: @36078
     /*  36078 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36104), // Rule ID 675 //
     /*  36083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36097 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  36102 */   GIR_RootConstrainSelectedInstOperands,
     /*  36103 */   // GIR_Coverage, 675,
     /*  36103 */   GIR_Done,
     /*  36104 */ // Label 816: @36104
     /*  36104 */ GIM_Reject,
     /*  36105 */ // Label 809: @36105
     /*  36105 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36131), // Rule ID 676 //
     /*  36110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36124 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36129 */   GIR_RootConstrainSelectedInstOperands,
     /*  36130 */   // GIR_Coverage, 676,
     /*  36130 */   GIR_Done,
     /*  36131 */ // Label 817: @36131
     /*  36131 */ GIM_Reject,
     /*  36132 */ // Label 810: @36132
     /*  36132 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36158), // Rule ID 1699 //
     /*  36137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36151 */   // (fround:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  36151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  36156 */   GIR_RootConstrainSelectedInstOperands,
     /*  36157 */   // GIR_Coverage, 1699,
     /*  36157 */   GIR_Done,
     /*  36158 */ // Label 818: @36158
     /*  36158 */ GIM_Reject,
     /*  36159 */ // Label 811: @36159
     /*  36159 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36185), // Rule ID 1701 //
     /*  36164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  36170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36178 */   // (fround:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  36178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  36183 */   GIR_RootConstrainSelectedInstOperands,
     /*  36184 */   // GIR_Coverage, 1701,
     /*  36184 */   GIR_Done,
     /*  36185 */ // Label 819: @36185
     /*  36185 */ GIM_Reject,
     /*  36186 */ // Label 812: @36186
     /*  36186 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36273),
     /*  36191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36194 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36217), // Rule ID 1700 //
     /*  36199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36210 */     // (fround:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  36210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 1700,
     /*  36216 */     GIR_Done,
     /*  36217 */   // Label 821: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36272), // Rule ID 3980 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36233 */     // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36250 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36270 */     GIR_RootConstrainSelectedInstOperands,
     /*  36271 */     // GIR_Coverage, 3980,
     /*  36271 */     GIR_EraseRootFromParent_Done,
     /*  36272 */   // Label 822: @36272
     /*  36272 */   GIM_Reject,
     /*  36273 */ // Label 820: @36273
     /*  36273 */ GIM_Reject,
     /*  36274 */ // Label 813: @36274
     /*  36274 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36361),
     /*  36279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36282 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36305), // Rule ID 1702 //
     /*  36287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36298 */     // (fround:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  36298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  36303 */     GIR_RootConstrainSelectedInstOperands,
     /*  36304 */     // GIR_Coverage, 1702,
     /*  36304 */     GIR_Done,
     /*  36305 */   // Label 824: @36305
     /*  36305 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36360), // Rule ID 3968 //
     /*  36310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36321 */     // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36338 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36358 */     GIR_RootConstrainSelectedInstOperands,
     /*  36359 */     // GIR_Coverage, 3968,
     /*  36359 */     GIR_EraseRootFromParent_Done,
     /*  36360 */   // Label 825: @36360
     /*  36360 */   GIM_Reject,
     /*  36361 */ // Label 823: @36361
     /*  36361 */ GIM_Reject,
     /*  36362 */ // Label 814: @36362
     /*  36362 */ GIM_Reject,
     /*  36363 */ // Label 12: @36363
     /*  36363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 831*/ GIMT_Encode4(36625),
     /*  36374 */ /*GILLT_s16*//*Label 826*/ GIMT_Encode4(36426),
     /*  36378 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(36453),
     /*  36382 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(36480), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36406 */ /*GILLT_v4s32*//*Label 829*/ GIMT_Encode4(36507), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36422 */ /*GILLT_v8s16*//*Label 830*/ GIMT_Encode4(36566),
     /*  36426 */ // Label 826: @36426
     /*  36426 */ GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(36452), // Rule ID 678 //
     /*  36431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36445 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36450 */   GIR_RootConstrainSelectedInstOperands,
     /*  36451 */   // GIR_Coverage, 678,
     /*  36451 */   GIR_Done,
     /*  36452 */ // Label 832: @36452
     /*  36452 */ GIM_Reject,
     /*  36453 */ // Label 827: @36453
     /*  36453 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(36479), // Rule ID 680 //
     /*  36458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36472 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36477 */   GIR_RootConstrainSelectedInstOperands,
     /*  36478 */   // GIR_Coverage, 680,
     /*  36478 */   GIR_Done,
     /*  36479 */ // Label 833: @36479
     /*  36479 */ GIM_Reject,
     /*  36480 */ // Label 828: @36480
     /*  36480 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(36506), // Rule ID 682 //
     /*  36485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36499 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36504 */   GIR_RootConstrainSelectedInstOperands,
     /*  36505 */   // GIR_Coverage, 682,
     /*  36505 */   GIR_Done,
     /*  36506 */ // Label 834: @36506
     /*  36506 */ GIM_Reject,
     /*  36507 */ // Label 829: @36507
     /*  36507 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(36565), // Rule ID 3976 //
     /*  36512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36526 */   // (froundeven:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  36541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36543 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36563 */   GIR_RootConstrainSelectedInstOperands,
     /*  36564 */   // GIR_Coverage, 3976,
     /*  36564 */   GIR_EraseRootFromParent_Done,
     /*  36565 */ // Label 835: @36565
     /*  36565 */ GIM_Reject,
     /*  36566 */ // Label 830: @36566
     /*  36566 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(36624), // Rule ID 3964 //
     /*  36571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36585 */   // (froundeven:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  36600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36602 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36607 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36613 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36622 */   GIR_RootConstrainSelectedInstOperands,
     /*  36623 */   // GIR_Coverage, 3964,
     /*  36623 */   GIR_EraseRootFromParent_Done,
     /*  36624 */ // Label 836: @36624
     /*  36624 */ GIM_Reject,
     /*  36625 */ // Label 831: @36625
     /*  36625 */ GIM_Reject,
     /*  36626 */ // Label 13: @36626
     /*  36626 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(36788),
     /*  36631 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36637 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(36712), // Rule ID 2053 //
     /*  36642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36656 */     // MIs[0] Rn
     /*  36656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36664 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36676 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36682 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36688 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36710 */     GIR_RootConstrainSelectedInstOperands,
     /*  36711 */     // GIR_Coverage, 2053,
     /*  36711 */     GIR_EraseRootFromParent_Done,
     /*  36712 */   // Label 838: @36712
     /*  36712 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(36787), // Rule ID 2054 //
     /*  36717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36731 */     // MIs[0] Rn
     /*  36731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36739 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36751 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36757 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36763 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36785 */     GIR_RootConstrainSelectedInstOperands,
     /*  36786 */     // GIR_Coverage, 2054,
     /*  36786 */     GIR_EraseRootFromParent_Done,
     /*  36787 */   // Label 839: @36787
     /*  36787 */   GIM_Reject,
     /*  36788 */ // Label 837: @36788
     /*  36788 */ GIM_Reject,
     /*  36789 */ // Label 14: @36789
     /*  36789 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(36809), // Rule ID 5421 //
     /*  36794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36797 */   // MIs[0] Operand 0
     /*  36797 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36800 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36804 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36807 */   GIR_RootConstrainSelectedInstOperands,
     /*  36808 */   // GIR_Coverage, 5421,
     /*  36808 */   GIR_EraseRootFromParent_Done,
     /*  36809 */ // Label 840: @36809
     /*  36809 */ GIM_Reject,
     /*  36810 */ // Label 15: @36810
     /*  36810 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(41917),
     /*  36815 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36818 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(36866), // Rule ID 1856 //
     /*  36823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36845 */     // (intrinsic_wo_chain:{ *:[i32] } 3945:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36864 */     GIR_RootConstrainSelectedInstOperands,
     /*  36865 */     // GIR_Coverage, 1856,
     /*  36865 */     GIR_EraseRootFromParent_Done,
     /*  36866 */   // Label 842: @36866
     /*  36866 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(36914), // Rule ID 2110 //
     /*  36871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36893 */     // (intrinsic_wo_chain:{ *:[i32] } 3945:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36912 */     GIR_RootConstrainSelectedInstOperands,
     /*  36913 */     // GIR_Coverage, 2110,
     /*  36913 */     GIR_EraseRootFromParent_Done,
     /*  36914 */   // Label 843: @36914
     /*  36914 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(36950), // Rule ID 677 //
     /*  36919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36941 */     // (intrinsic_wo_chain:{ *:[f16] } 3833:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36948 */     GIR_RootConstrainSelectedInstOperands,
     /*  36949 */     // GIR_Coverage, 677,
     /*  36949 */     GIR_EraseRootFromParent_Done,
     /*  36950 */   // Label 844: @36950
     /*  36950 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(36986), // Rule ID 679 //
     /*  36955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36977 */     // (intrinsic_wo_chain:{ *:[f32] } 3833:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36984 */     GIR_RootConstrainSelectedInstOperands,
     /*  36985 */     // GIR_Coverage, 679,
     /*  36985 */     GIR_EraseRootFromParent_Done,
     /*  36986 */   // Label 845: @36986
     /*  36986 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37022), // Rule ID 681 //
     /*  36991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37013 */     // (intrinsic_wo_chain:{ *:[f64] } 3833:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  37013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  37016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  37018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37020 */     GIR_RootConstrainSelectedInstOperands,
     /*  37021 */     // GIR_Coverage, 681,
     /*  37021 */     GIR_EraseRootFromParent_Done,
     /*  37022 */   // Label 846: @37022
     /*  37022 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37067), // Rule ID 696 //
     /*  37027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  37035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37049 */     // (intrinsic_wo_chain:{ *:[f32] } 3946:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  37052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37065 */     GIR_RootConstrainSelectedInstOperands,
     /*  37066 */     // GIR_Coverage, 696,
     /*  37066 */     GIR_EraseRootFromParent_Done,
     /*  37067 */   // Label 847: @37067
     /*  37067 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37112), // Rule ID 697 //
     /*  37072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  37080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37094 */     // (intrinsic_wo_chain:{ *:[f32] } 3946:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  37097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37110 */     GIR_RootConstrainSelectedInstOperands,
     /*  37111 */     // GIR_Coverage, 697,
     /*  37111 */     GIR_EraseRootFromParent_Done,
     /*  37112 */   // Label 848: @37112
     /*  37112 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37157), // Rule ID 698 //
     /*  37117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37139 */     // (intrinsic_wo_chain:{ *:[f32] } 3947:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  37142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37155 */     GIR_RootConstrainSelectedInstOperands,
     /*  37156 */     // GIR_Coverage, 698,
     /*  37156 */     GIR_EraseRootFromParent_Done,
     /*  37157 */   // Label 849: @37157
     /*  37157 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37202), // Rule ID 699 //
     /*  37162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37184 */     // (intrinsic_wo_chain:{ *:[f32] } 3947:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  37187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37200 */     GIR_RootConstrainSelectedInstOperands,
     /*  37201 */     // GIR_Coverage, 699,
     /*  37201 */     GIR_EraseRootFromParent_Done,
     /*  37202 */   // Label 850: @37202
     /*  37202 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37247), // Rule ID 1242 //
     /*  37207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37229 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3801:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  37232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37245 */     GIR_RootConstrainSelectedInstOperands,
     /*  37246 */     // GIR_Coverage, 1242,
     /*  37246 */     GIR_EraseRootFromParent_Done,
     /*  37247 */   // Label 851: @37247
     /*  37247 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37292), // Rule ID 1243 //
     /*  37252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37274 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3801:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  37277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37290 */     GIR_RootConstrainSelectedInstOperands,
     /*  37291 */     // GIR_Coverage, 1243,
     /*  37291 */     GIR_EraseRootFromParent_Done,
     /*  37292 */   // Label 852: @37292
     /*  37292 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37337), // Rule ID 1244 //
     /*  37297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37319 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3801:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  37322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37335 */     GIR_RootConstrainSelectedInstOperands,
     /*  37336 */     // GIR_Coverage, 1244,
     /*  37336 */     GIR_EraseRootFromParent_Done,
     /*  37337 */   // Label 853: @37337
     /*  37337 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37382), // Rule ID 1245 //
     /*  37342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37364 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3801:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  37367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37380 */     GIR_RootConstrainSelectedInstOperands,
     /*  37381 */     // GIR_Coverage, 1245,
     /*  37381 */     GIR_EraseRootFromParent_Done,
     /*  37382 */   // Label 854: @37382
     /*  37382 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37427), // Rule ID 1246 //
     /*  37387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37409 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3801:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37425 */     GIR_RootConstrainSelectedInstOperands,
     /*  37426 */     // GIR_Coverage, 1246,
     /*  37426 */     GIR_EraseRootFromParent_Done,
     /*  37427 */   // Label 855: @37427
     /*  37427 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37472), // Rule ID 1247 //
     /*  37432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37454 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3801:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37470 */     GIR_RootConstrainSelectedInstOperands,
     /*  37471 */     // GIR_Coverage, 1247,
     /*  37471 */     GIR_EraseRootFromParent_Done,
     /*  37472 */   // Label 856: @37472
     /*  37472 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(37517), // Rule ID 1248 //
     /*  37477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37499 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3802:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37515 */     GIR_RootConstrainSelectedInstOperands,
     /*  37516 */     // GIR_Coverage, 1248,
     /*  37516 */     GIR_EraseRootFromParent_Done,
     /*  37517 */   // Label 857: @37517
     /*  37517 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(37562), // Rule ID 1249 //
     /*  37522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37544 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3802:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37560 */     GIR_RootConstrainSelectedInstOperands,
     /*  37561 */     // GIR_Coverage, 1249,
     /*  37561 */     GIR_EraseRootFromParent_Done,
     /*  37562 */   // Label 858: @37562
     /*  37562 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(37607), // Rule ID 1250 //
     /*  37567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37589 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3802:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37605 */     GIR_RootConstrainSelectedInstOperands,
     /*  37606 */     // GIR_Coverage, 1250,
     /*  37606 */     GIR_EraseRootFromParent_Done,
     /*  37607 */   // Label 859: @37607
     /*  37607 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(37652), // Rule ID 1251 //
     /*  37612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37634 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3802:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37650 */     GIR_RootConstrainSelectedInstOperands,
     /*  37651 */     // GIR_Coverage, 1251,
     /*  37651 */     GIR_EraseRootFromParent_Done,
     /*  37652 */   // Label 860: @37652
     /*  37652 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(37697), // Rule ID 1252 //
     /*  37657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3802:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37695 */     GIR_RootConstrainSelectedInstOperands,
     /*  37696 */     // GIR_Coverage, 1252,
     /*  37696 */     GIR_EraseRootFromParent_Done,
     /*  37697 */   // Label 861: @37697
     /*  37697 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(37742), // Rule ID 1253 //
     /*  37702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3802:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37740 */     GIR_RootConstrainSelectedInstOperands,
     /*  37741 */     // GIR_Coverage, 1253,
     /*  37741 */     GIR_EraseRootFromParent_Done,
     /*  37742 */   // Label 862: @37742
     /*  37742 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(37787), // Rule ID 1282 //
     /*  37747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37769 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37785 */     GIR_RootConstrainSelectedInstOperands,
     /*  37786 */     // GIR_Coverage, 1282,
     /*  37786 */     GIR_EraseRootFromParent_Done,
     /*  37787 */   // Label 863: @37787
     /*  37787 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(37832), // Rule ID 1283 //
     /*  37792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37830 */     GIR_RootConstrainSelectedInstOperands,
     /*  37831 */     // GIR_Coverage, 1283,
     /*  37831 */     GIR_EraseRootFromParent_Done,
     /*  37832 */   // Label 864: @37832
     /*  37832 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(37877), // Rule ID 1284 //
     /*  37837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37859 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37875 */     GIR_RootConstrainSelectedInstOperands,
     /*  37876 */     // GIR_Coverage, 1284,
     /*  37876 */     GIR_EraseRootFromParent_Done,
     /*  37877 */   // Label 865: @37877
     /*  37877 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(37922), // Rule ID 1285 //
     /*  37882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37904 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37920 */     GIR_RootConstrainSelectedInstOperands,
     /*  37921 */     // GIR_Coverage, 1285,
     /*  37921 */     GIR_EraseRootFromParent_Done,
     /*  37922 */   // Label 866: @37922
     /*  37922 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(37967), // Rule ID 1286 //
     /*  37927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37949 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3829:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37965 */     GIR_RootConstrainSelectedInstOperands,
     /*  37966 */     // GIR_Coverage, 1286,
     /*  37966 */     GIR_EraseRootFromParent_Done,
     /*  37967 */   // Label 867: @37967
     /*  37967 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38012), // Rule ID 1287 //
     /*  37972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37994 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3829:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38010 */     GIR_RootConstrainSelectedInstOperands,
     /*  38011 */     // GIR_Coverage, 1287,
     /*  38011 */     GIR_EraseRootFromParent_Done,
     /*  38012 */   // Label 868: @38012
     /*  38012 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38057), // Rule ID 1292 //
     /*  38017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38039 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3838:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  38042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38055 */     GIR_RootConstrainSelectedInstOperands,
     /*  38056 */     // GIR_Coverage, 1292,
     /*  38056 */     GIR_EraseRootFromParent_Done,
     /*  38057 */   // Label 869: @38057
     /*  38057 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38102), // Rule ID 1293 //
     /*  38062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3838:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  38087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38100 */     GIR_RootConstrainSelectedInstOperands,
     /*  38101 */     // GIR_Coverage, 1293,
     /*  38101 */     GIR_EraseRootFromParent_Done,
     /*  38102 */   // Label 870: @38102
     /*  38102 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38147), // Rule ID 1294 //
     /*  38107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38129 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3838:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  38129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  38132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38145 */     GIR_RootConstrainSelectedInstOperands,
     /*  38146 */     // GIR_Coverage, 1294,
     /*  38146 */     GIR_EraseRootFromParent_Done,
     /*  38147 */   // Label 871: @38147
     /*  38147 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38192), // Rule ID 1295 //
     /*  38152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38174 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3838:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  38174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  38177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38190 */     GIR_RootConstrainSelectedInstOperands,
     /*  38191 */     // GIR_Coverage, 1295,
     /*  38191 */     GIR_EraseRootFromParent_Done,
     /*  38192 */   // Label 872: @38192
     /*  38192 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38237), // Rule ID 1296 //
     /*  38197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38219 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3838:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  38219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  38222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38235 */     GIR_RootConstrainSelectedInstOperands,
     /*  38236 */     // GIR_Coverage, 1296,
     /*  38236 */     GIR_EraseRootFromParent_Done,
     /*  38237 */   // Label 873: @38237
     /*  38237 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38282), // Rule ID 1297 //
     /*  38242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38264 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3838:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  38267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38280 */     GIR_RootConstrainSelectedInstOperands,
     /*  38281 */     // GIR_Coverage, 1297,
     /*  38281 */     GIR_EraseRootFromParent_Done,
     /*  38282 */   // Label 874: @38282
     /*  38282 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38327), // Rule ID 1518 //
     /*  38287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38309 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3807:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  38312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38325 */     GIR_RootConstrainSelectedInstOperands,
     /*  38326 */     // GIR_Coverage, 1518,
     /*  38326 */     GIR_EraseRootFromParent_Done,
     /*  38327 */   // Label 875: @38327
     /*  38327 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38372), // Rule ID 1519 //
     /*  38332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38354 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  38357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38370 */     GIR_RootConstrainSelectedInstOperands,
     /*  38371 */     // GIR_Coverage, 1519,
     /*  38371 */     GIR_EraseRootFromParent_Done,
     /*  38372 */   // Label 876: @38372
     /*  38372 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38417), // Rule ID 1520 //
     /*  38377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38399 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38415 */     GIR_RootConstrainSelectedInstOperands,
     /*  38416 */     // GIR_Coverage, 1520,
     /*  38416 */     GIR_EraseRootFromParent_Done,
     /*  38417 */   // Label 877: @38417
     /*  38417 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38462), // Rule ID 1521 //
     /*  38422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38444 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3807:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38460 */     GIR_RootConstrainSelectedInstOperands,
     /*  38461 */     // GIR_Coverage, 1521,
     /*  38461 */     GIR_EraseRootFromParent_Done,
     /*  38462 */   // Label 878: @38462
     /*  38462 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(38507), // Rule ID 1522 //
     /*  38467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38489 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3807:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38505 */     GIR_RootConstrainSelectedInstOperands,
     /*  38506 */     // GIR_Coverage, 1522,
     /*  38506 */     GIR_EraseRootFromParent_Done,
     /*  38507 */   // Label 879: @38507
     /*  38507 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(38552), // Rule ID 1523 //
     /*  38512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38534 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3807:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38550 */     GIR_RootConstrainSelectedInstOperands,
     /*  38551 */     // GIR_Coverage, 1523,
     /*  38551 */     GIR_EraseRootFromParent_Done,
     /*  38552 */   // Label 880: @38552
     /*  38552 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(38597), // Rule ID 1534 //
     /*  38557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38579 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3813:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38595 */     GIR_RootConstrainSelectedInstOperands,
     /*  38596 */     // GIR_Coverage, 1534,
     /*  38596 */     GIR_EraseRootFromParent_Done,
     /*  38597 */   // Label 881: @38597
     /*  38597 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(38642), // Rule ID 1535 //
     /*  38602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38624 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38640 */     GIR_RootConstrainSelectedInstOperands,
     /*  38641 */     // GIR_Coverage, 1535,
     /*  38641 */     GIR_EraseRootFromParent_Done,
     /*  38642 */   // Label 882: @38642
     /*  38642 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(38687), // Rule ID 1536 //
     /*  38647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38669 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38685 */     GIR_RootConstrainSelectedInstOperands,
     /*  38686 */     // GIR_Coverage, 1536,
     /*  38686 */     GIR_EraseRootFromParent_Done,
     /*  38687 */   // Label 883: @38687
     /*  38687 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(38732), // Rule ID 1537 //
     /*  38692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38714 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3813:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38730 */     GIR_RootConstrainSelectedInstOperands,
     /*  38731 */     // GIR_Coverage, 1537,
     /*  38731 */     GIR_EraseRootFromParent_Done,
     /*  38732 */   // Label 884: @38732
     /*  38732 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(38777), // Rule ID 1538 //
     /*  38737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38759 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3813:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38775 */     GIR_RootConstrainSelectedInstOperands,
     /*  38776 */     // GIR_Coverage, 1538,
     /*  38776 */     GIR_EraseRootFromParent_Done,
     /*  38777 */   // Label 885: @38777
     /*  38777 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(38822), // Rule ID 1539 //
     /*  38782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38820 */     GIR_RootConstrainSelectedInstOperands,
     /*  38821 */     // GIR_Coverage, 1539,
     /*  38821 */     GIR_EraseRootFromParent_Done,
     /*  38822 */   // Label 886: @38822
     /*  38822 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(38867), // Rule ID 1540 //
     /*  38827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38849 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3754:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38865 */     GIR_RootConstrainSelectedInstOperands,
     /*  38866 */     // GIR_Coverage, 1540,
     /*  38866 */     GIR_EraseRootFromParent_Done,
     /*  38867 */   // Label 887: @38867
     /*  38867 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(38912), // Rule ID 1541 //
     /*  38872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38894 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3754:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38910 */     GIR_RootConstrainSelectedInstOperands,
     /*  38911 */     // GIR_Coverage, 1541,
     /*  38911 */     GIR_EraseRootFromParent_Done,
     /*  38912 */   // Label 888: @38912
     /*  38912 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(38957), // Rule ID 1542 //
     /*  38917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38939 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3754:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38955 */     GIR_RootConstrainSelectedInstOperands,
     /*  38956 */     // GIR_Coverage, 1542,
     /*  38956 */     GIR_EraseRootFromParent_Done,
     /*  38957 */   // Label 889: @38957
     /*  38957 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39002), // Rule ID 1543 //
     /*  38962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38984 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3754:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39000 */     GIR_RootConstrainSelectedInstOperands,
     /*  39001 */     // GIR_Coverage, 1543,
     /*  39001 */     GIR_EraseRootFromParent_Done,
     /*  39002 */   // Label 890: @39002
     /*  39002 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39047), // Rule ID 1544 //
     /*  39007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  39015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39029 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3754:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  39029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  39032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39045 */     GIR_RootConstrainSelectedInstOperands,
     /*  39046 */     // GIR_Coverage, 1544,
     /*  39046 */     GIR_EraseRootFromParent_Done,
     /*  39047 */   // Label 891: @39047
     /*  39047 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39092), // Rule ID 1545 //
     /*  39052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  39060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39074 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3754:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  39074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  39077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39090 */     GIR_RootConstrainSelectedInstOperands,
     /*  39091 */     // GIR_Coverage, 1545,
     /*  39091 */     GIR_EraseRootFromParent_Done,
     /*  39092 */   // Label 892: @39092
     /*  39092 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39137), // Rule ID 1589 //
     /*  39097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39119 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  39122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39135 */     GIR_RootConstrainSelectedInstOperands,
     /*  39136 */     // GIR_Coverage, 1589,
     /*  39136 */     GIR_EraseRootFromParent_Done,
     /*  39137 */   // Label 893: @39137
     /*  39137 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39182), // Rule ID 1590 //
     /*  39142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39164 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  39167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39180 */     GIR_RootConstrainSelectedInstOperands,
     /*  39181 */     // GIR_Coverage, 1590,
     /*  39181 */     GIR_EraseRootFromParent_Done,
     /*  39182 */   // Label 894: @39182
     /*  39182 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39227), // Rule ID 1591 //
     /*  39187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39209 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  39212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39225 */     GIR_RootConstrainSelectedInstOperands,
     /*  39226 */     // GIR_Coverage, 1591,
     /*  39226 */     GIR_EraseRootFromParent_Done,
     /*  39227 */   // Label 895: @39227
     /*  39227 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39272), // Rule ID 1592 //
     /*  39232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39254 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3812:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  39257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39270 */     GIR_RootConstrainSelectedInstOperands,
     /*  39271 */     // GIR_Coverage, 1592,
     /*  39271 */     GIR_EraseRootFromParent_Done,
     /*  39272 */   // Label 896: @39272
     /*  39272 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39317), // Rule ID 1593 //
     /*  39277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39299 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3812:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  39302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39315 */     GIR_RootConstrainSelectedInstOperands,
     /*  39316 */     // GIR_Coverage, 1593,
     /*  39316 */     GIR_EraseRootFromParent_Done,
     /*  39317 */   // Label 897: @39317
     /*  39317 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39362), // Rule ID 1594 //
     /*  39322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39344 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3812:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  39347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39360 */     GIR_RootConstrainSelectedInstOperands,
     /*  39361 */     // GIR_Coverage, 1594,
     /*  39361 */     GIR_EraseRootFromParent_Done,
     /*  39362 */   // Label 898: @39362
     /*  39362 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39407), // Rule ID 1595 //
     /*  39367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39389 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3811:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39405 */     GIR_RootConstrainSelectedInstOperands,
     /*  39406 */     // GIR_Coverage, 1595,
     /*  39406 */     GIR_EraseRootFromParent_Done,
     /*  39407 */   // Label 899: @39407
     /*  39407 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39452), // Rule ID 1596 //
     /*  39412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39434 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3811:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39450 */     GIR_RootConstrainSelectedInstOperands,
     /*  39451 */     // GIR_Coverage, 1596,
     /*  39451 */     GIR_EraseRootFromParent_Done,
     /*  39452 */   // Label 900: @39452
     /*  39452 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39497), // Rule ID 1597 //
     /*  39457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39479 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39495 */     GIR_RootConstrainSelectedInstOperands,
     /*  39496 */     // GIR_Coverage, 1597,
     /*  39496 */     GIR_EraseRootFromParent_Done,
     /*  39497 */   // Label 901: @39497
     /*  39497 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39533), // Rule ID 1620 //
     /*  39502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39524 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3755:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39531 */     GIR_RootConstrainSelectedInstOperands,
     /*  39532 */     // GIR_Coverage, 1620,
     /*  39532 */     GIR_EraseRootFromParent_Done,
     /*  39533 */   // Label 902: @39533
     /*  39533 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39569), // Rule ID 1621 //
     /*  39538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39560 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3755:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39567 */     GIR_RootConstrainSelectedInstOperands,
     /*  39568 */     // GIR_Coverage, 1621,
     /*  39568 */     GIR_EraseRootFromParent_Done,
     /*  39569 */   // Label 903: @39569
     /*  39569 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39605), // Rule ID 1622 //
     /*  39574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39596 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3756:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39603 */     GIR_RootConstrainSelectedInstOperands,
     /*  39604 */     // GIR_Coverage, 1622,
     /*  39604 */     GIR_EraseRootFromParent_Done,
     /*  39605 */   // Label 904: @39605
     /*  39605 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39641), // Rule ID 1623 //
     /*  39610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39632 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3756:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39639 */     GIR_RootConstrainSelectedInstOperands,
     /*  39640 */     // GIR_Coverage, 1623,
     /*  39640 */     GIR_EraseRootFromParent_Done,
     /*  39641 */   // Label 905: @39641
     /*  39641 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(39677), // Rule ID 1624 //
     /*  39646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39668 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3755:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39675 */     GIR_RootConstrainSelectedInstOperands,
     /*  39676 */     // GIR_Coverage, 1624,
     /*  39676 */     GIR_EraseRootFromParent_Done,
     /*  39677 */   // Label 906: @39677
     /*  39677 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(39713), // Rule ID 1625 //
     /*  39682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39704 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3755:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39711 */     GIR_RootConstrainSelectedInstOperands,
     /*  39712 */     // GIR_Coverage, 1625,
     /*  39712 */     GIR_EraseRootFromParent_Done,
     /*  39713 */   // Label 907: @39713
     /*  39713 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(39749), // Rule ID 1626 //
     /*  39718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39740 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3756:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39747 */     GIR_RootConstrainSelectedInstOperands,
     /*  39748 */     // GIR_Coverage, 1626,
     /*  39748 */     GIR_EraseRootFromParent_Done,
     /*  39749 */   // Label 908: @39749
     /*  39749 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(39785), // Rule ID 1627 //
     /*  39754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3756:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39783 */     GIR_RootConstrainSelectedInstOperands,
     /*  39784 */     // GIR_Coverage, 1627,
     /*  39784 */     GIR_EraseRootFromParent_Done,
     /*  39785 */   // Label 909: @39785
     /*  39785 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(39821), // Rule ID 1628 //
     /*  39790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39812 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39819 */     GIR_RootConstrainSelectedInstOperands,
     /*  39820 */     // GIR_Coverage, 1628,
     /*  39820 */     GIR_EraseRootFromParent_Done,
     /*  39821 */   // Label 910: @39821
     /*  39821 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(39857), // Rule ID 1629 //
     /*  39826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39848 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39855 */     GIR_RootConstrainSelectedInstOperands,
     /*  39856 */     // GIR_Coverage, 1629,
     /*  39856 */     GIR_EraseRootFromParent_Done,
     /*  39857 */   // Label 911: @39857
     /*  39857 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(39893), // Rule ID 1630 //
     /*  39862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39884 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3768:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39891 */     GIR_RootConstrainSelectedInstOperands,
     /*  39892 */     // GIR_Coverage, 1630,
     /*  39892 */     GIR_EraseRootFromParent_Done,
     /*  39893 */   // Label 912: @39893
     /*  39893 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(39929), // Rule ID 1631 //
     /*  39898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3768:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39927 */     GIR_RootConstrainSelectedInstOperands,
     /*  39928 */     // GIR_Coverage, 1631,
     /*  39928 */     GIR_EraseRootFromParent_Done,
     /*  39929 */   // Label 913: @39929
     /*  39929 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(39965), // Rule ID 1632 //
     /*  39934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39956 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39963 */     GIR_RootConstrainSelectedInstOperands,
     /*  39964 */     // GIR_Coverage, 1632,
     /*  39964 */     GIR_EraseRootFromParent_Done,
     /*  39965 */   // Label 914: @39965
     /*  39965 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40001), // Rule ID 1633 //
     /*  39970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39992 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39999 */     GIR_RootConstrainSelectedInstOperands,
     /*  40000 */     // GIR_Coverage, 1633,
     /*  40000 */     GIR_EraseRootFromParent_Done,
     /*  40001 */   // Label 915: @40001
     /*  40001 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40037), // Rule ID 1634 //
     /*  40006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  40014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40028 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3768:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  40031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40035 */     GIR_RootConstrainSelectedInstOperands,
     /*  40036 */     // GIR_Coverage, 1634,
     /*  40036 */     GIR_EraseRootFromParent_Done,
     /*  40037 */   // Label 916: @40037
     /*  40037 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40073), // Rule ID 1635 //
     /*  40042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  40050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40064 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3768:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  40067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40071 */     GIR_RootConstrainSelectedInstOperands,
     /*  40072 */     // GIR_Coverage, 1635,
     /*  40072 */     GIR_EraseRootFromParent_Done,
     /*  40073 */   // Label 917: @40073
     /*  40073 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40109), // Rule ID 1636 //
     /*  40078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40100 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  40103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40107 */     GIR_RootConstrainSelectedInstOperands,
     /*  40108 */     // GIR_Coverage, 1636,
     /*  40108 */     GIR_EraseRootFromParent_Done,
     /*  40109 */   // Label 918: @40109
     /*  40109 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40145), // Rule ID 1637 //
     /*  40114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40136 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3769:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  40139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40143 */     GIR_RootConstrainSelectedInstOperands,
     /*  40144 */     // GIR_Coverage, 1637,
     /*  40144 */     GIR_EraseRootFromParent_Done,
     /*  40145 */   // Label 919: @40145
     /*  40145 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40181), // Rule ID 1638 //
     /*  40150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40172 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3770:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  40175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40179 */     GIR_RootConstrainSelectedInstOperands,
     /*  40180 */     // GIR_Coverage, 1638,
     /*  40180 */     GIR_EraseRootFromParent_Done,
     /*  40181 */   // Label 920: @40181
     /*  40181 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40217), // Rule ID 1639 //
     /*  40186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40208 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3770:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  40211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40215 */     GIR_RootConstrainSelectedInstOperands,
     /*  40216 */     // GIR_Coverage, 1639,
     /*  40216 */     GIR_EraseRootFromParent_Done,
     /*  40217 */   // Label 921: @40217
     /*  40217 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40253), // Rule ID 1640 //
     /*  40222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40244 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  40247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40251 */     GIR_RootConstrainSelectedInstOperands,
     /*  40252 */     // GIR_Coverage, 1640,
     /*  40252 */     GIR_EraseRootFromParent_Done,
     /*  40253 */   // Label 922: @40253
     /*  40253 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40289), // Rule ID 1641 //
     /*  40258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3769:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  40283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40287 */     GIR_RootConstrainSelectedInstOperands,
     /*  40288 */     // GIR_Coverage, 1641,
     /*  40288 */     GIR_EraseRootFromParent_Done,
     /*  40289 */   // Label 923: @40289
     /*  40289 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40325), // Rule ID 1642 //
     /*  40294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40316 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3770:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  40319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40323 */     GIR_RootConstrainSelectedInstOperands,
     /*  40324 */     // GIR_Coverage, 1642,
     /*  40324 */     GIR_EraseRootFromParent_Done,
     /*  40325 */   // Label 924: @40325
     /*  40325 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40361), // Rule ID 1643 //
     /*  40330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40352 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3770:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  40355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40359 */     GIR_RootConstrainSelectedInstOperands,
     /*  40360 */     // GIR_Coverage, 1643,
     /*  40360 */     GIR_EraseRootFromParent_Done,
     /*  40361 */   // Label 925: @40361
     /*  40361 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40397), // Rule ID 1644 //
     /*  40366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40388 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3765:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40395 */     GIR_RootConstrainSelectedInstOperands,
     /*  40396 */     // GIR_Coverage, 1644,
     /*  40396 */     GIR_EraseRootFromParent_Done,
     /*  40397 */   // Label 926: @40397
     /*  40397 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40433), // Rule ID 1645 //
     /*  40402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3765:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40431 */     GIR_RootConstrainSelectedInstOperands,
     /*  40432 */     // GIR_Coverage, 1645,
     /*  40432 */     GIR_EraseRootFromParent_Done,
     /*  40433 */   // Label 927: @40433
     /*  40433 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40469), // Rule ID 1646 //
     /*  40438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40460 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3766:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40467 */     GIR_RootConstrainSelectedInstOperands,
     /*  40468 */     // GIR_Coverage, 1646,
     /*  40468 */     GIR_EraseRootFromParent_Done,
     /*  40469 */   // Label 928: @40469
     /*  40469 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40505), // Rule ID 1647 //
     /*  40474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40496 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3766:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40503 */     GIR_RootConstrainSelectedInstOperands,
     /*  40504 */     // GIR_Coverage, 1647,
     /*  40504 */     GIR_EraseRootFromParent_Done,
     /*  40505 */   // Label 929: @40505
     /*  40505 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40541), // Rule ID 1648 //
     /*  40510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40532 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3765:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40539 */     GIR_RootConstrainSelectedInstOperands,
     /*  40540 */     // GIR_Coverage, 1648,
     /*  40540 */     GIR_EraseRootFromParent_Done,
     /*  40541 */   // Label 930: @40541
     /*  40541 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40577), // Rule ID 1649 //
     /*  40546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40568 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3765:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40575 */     GIR_RootConstrainSelectedInstOperands,
     /*  40576 */     // GIR_Coverage, 1649,
     /*  40576 */     GIR_EraseRootFromParent_Done,
     /*  40577 */   // Label 931: @40577
     /*  40577 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40613), // Rule ID 1650 //
     /*  40582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40604 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3766:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40611 */     GIR_RootConstrainSelectedInstOperands,
     /*  40612 */     // GIR_Coverage, 1650,
     /*  40612 */     GIR_EraseRootFromParent_Done,
     /*  40613 */   // Label 932: @40613
     /*  40613 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(40649), // Rule ID 1651 //
     /*  40618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3766:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40647 */     GIR_RootConstrainSelectedInstOperands,
     /*  40648 */     // GIR_Coverage, 1651,
     /*  40648 */     GIR_EraseRootFromParent_Done,
     /*  40649 */   // Label 933: @40649
     /*  40649 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(40694), // Rule ID 1668 //
     /*  40654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40676 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3761:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40692 */     GIR_RootConstrainSelectedInstOperands,
     /*  40693 */     // GIR_Coverage, 1668,
     /*  40693 */     GIR_EraseRootFromParent_Done,
     /*  40694 */   // Label 934: @40694
     /*  40694 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(40739), // Rule ID 1669 //
     /*  40699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40721 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3764:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40737 */     GIR_RootConstrainSelectedInstOperands,
     /*  40738 */     // GIR_Coverage, 1669,
     /*  40738 */     GIR_EraseRootFromParent_Done,
     /*  40739 */   // Label 935: @40739
     /*  40739 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(40775), // Rule ID 1691 //
     /*  40744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40766 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3833:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40773 */     GIR_RootConstrainSelectedInstOperands,
     /*  40774 */     // GIR_Coverage, 1691,
     /*  40774 */     GIR_EraseRootFromParent_Done,
     /*  40775 */   // Label 936: @40775
     /*  40775 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(40811), // Rule ID 1692 //
     /*  40780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40802 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3833:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40809 */     GIR_RootConstrainSelectedInstOperands,
     /*  40810 */     // GIR_Coverage, 1692,
     /*  40810 */     GIR_EraseRootFromParent_Done,
     /*  40811 */   // Label 937: @40811
     /*  40811 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(40847), // Rule ID 1693 //
     /*  40816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40838 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3833:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40845 */     GIR_RootConstrainSelectedInstOperands,
     /*  40846 */     // GIR_Coverage, 1693,
     /*  40846 */     GIR_EraseRootFromParent_Done,
     /*  40847 */   // Label 938: @40847
     /*  40847 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(40883), // Rule ID 1694 //
     /*  40852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40874 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3833:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40881 */     GIR_RootConstrainSelectedInstOperands,
     /*  40882 */     // GIR_Coverage, 1694,
     /*  40882 */     GIR_EraseRootFromParent_Done,
     /*  40883 */   // Label 939: @40883
     /*  40883 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(40919), // Rule ID 1695 //
     /*  40888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40910 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3834:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40917 */     GIR_RootConstrainSelectedInstOperands,
     /*  40918 */     // GIR_Coverage, 1695,
     /*  40918 */     GIR_EraseRootFromParent_Done,
     /*  40919 */   // Label 940: @40919
     /*  40919 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(40955), // Rule ID 1696 //
     /*  40924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40946 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3834:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40953 */     GIR_RootConstrainSelectedInstOperands,
     /*  40954 */     // GIR_Coverage, 1696,
     /*  40954 */     GIR_EraseRootFromParent_Done,
     /*  40955 */   // Label 941: @40955
     /*  40955 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(40991), // Rule ID 1697 //
     /*  40960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40982 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3834:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40989 */     GIR_RootConstrainSelectedInstOperands,
     /*  40990 */     // GIR_Coverage, 1697,
     /*  40990 */     GIR_EraseRootFromParent_Done,
     /*  40991 */   // Label 942: @40991
     /*  40991 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41027), // Rule ID 1698 //
     /*  40996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  41004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41018 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3834:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  41021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41025 */     GIR_RootConstrainSelectedInstOperands,
     /*  41026 */     // GIR_Coverage, 1698,
     /*  41026 */     GIR_EraseRootFromParent_Done,
     /*  41027 */   // Label 943: @41027
     /*  41027 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41063), // Rule ID 1717 //
     /*  41032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41054 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3724:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41061 */     GIR_RootConstrainSelectedInstOperands,
     /*  41062 */     // GIR_Coverage, 1717,
     /*  41062 */     GIR_EraseRootFromParent_Done,
     /*  41063 */   // Label 944: @41063
     /*  41063 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41099), // Rule ID 1718 //
     /*  41068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41090 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3725:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41097 */     GIR_RootConstrainSelectedInstOperands,
     /*  41098 */     // GIR_Coverage, 1718,
     /*  41098 */     GIR_EraseRootFromParent_Done,
     /*  41099 */   // Label 945: @41099
     /*  41099 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41147), // Rule ID 1851 //
     /*  41104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41126 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41145 */     GIR_RootConstrainSelectedInstOperands,
     /*  41146 */     // GIR_Coverage, 1851,
     /*  41146 */     GIR_EraseRootFromParent_Done,
     /*  41147 */   // Label 946: @41147
     /*  41147 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41195), // Rule ID 2099 //
     /*  41152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41174 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41193 */     GIR_RootConstrainSelectedInstOperands,
     /*  41194 */     // GIR_Coverage, 2099,
     /*  41194 */     GIR_EraseRootFromParent_Done,
     /*  41195 */   // Label 947: @41195
     /*  41195 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41261), // Rule ID 3648 //
     /*  41200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41222 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3607:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41239 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41259 */     GIR_RootConstrainSelectedInstOperands,
     /*  41260 */     // GIR_Coverage, 3648,
     /*  41260 */     GIR_EraseRootFromParent_Done,
     /*  41261 */   // Label 948: @41261
     /*  41261 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41327), // Rule ID 3650 //
     /*  41266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41288 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3607:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41305 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41325 */     GIR_RootConstrainSelectedInstOperands,
     /*  41326 */     // GIR_Coverage, 3650,
     /*  41326 */     GIR_EraseRootFromParent_Done,
     /*  41327 */   // Label 949: @41327
     /*  41327 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41393), // Rule ID 3652 //
     /*  41332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3607:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41371 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41391 */     GIR_RootConstrainSelectedInstOperands,
     /*  41392 */     // GIR_Coverage, 3652,
     /*  41392 */     GIR_EraseRootFromParent_Done,
     /*  41393 */   // Label 950: @41393
     /*  41393 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41444), // Rule ID 4864 //
     /*  41398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41420 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3615:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41442 */     GIR_RootConstrainSelectedInstOperands,
     /*  41443 */     // GIR_Coverage, 4864,
     /*  41443 */     GIR_EraseRootFromParent_Done,
     /*  41444 */   // Label 951: @41444
     /*  41444 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41495), // Rule ID 4866 //
     /*  41449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41471 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3612:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41493 */     GIR_RootConstrainSelectedInstOperands,
     /*  41494 */     // GIR_Coverage, 4866,
     /*  41494 */     GIR_EraseRootFromParent_Done,
     /*  41495 */   // Label 952: @41495
     /*  41495 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41546), // Rule ID 4868 //
     /*  41500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41522 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3613:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41544 */     GIR_RootConstrainSelectedInstOperands,
     /*  41545 */     // GIR_Coverage, 4868,
     /*  41545 */     GIR_EraseRootFromParent_Done,
     /*  41546 */   // Label 953: @41546
     /*  41546 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(41597), // Rule ID 4870 //
     /*  41551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41573 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3614:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41595 */     GIR_RootConstrainSelectedInstOperands,
     /*  41596 */     // GIR_Coverage, 4870,
     /*  41596 */     GIR_EraseRootFromParent_Done,
     /*  41597 */   // Label 954: @41597
     /*  41597 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(41643), // Rule ID 600 //
     /*  41602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41617 */     // MIs[0] Rn
     /*  41617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41625 */     // (intrinsic_wo_chain:{ *:[i32] } 3497:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41641 */     GIR_RootConstrainSelectedInstOperands,
     /*  41642 */     // GIR_Coverage, 600,
     /*  41642 */     GIR_EraseRootFromParent_Done,
     /*  41643 */   // Label 955: @41643
     /*  41643 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(41689), // Rule ID 601 //
     /*  41648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41663 */     // MIs[0] Rn
     /*  41663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41671 */     // (intrinsic_wo_chain:{ *:[i32] } 3500:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41687 */     GIR_RootConstrainSelectedInstOperands,
     /*  41688 */     // GIR_Coverage, 601,
     /*  41688 */     GIR_EraseRootFromParent_Done,
     /*  41689 */   // Label 956: @41689
     /*  41689 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(41735), // Rule ID 602 //
     /*  41694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41709 */     // MIs[0] Rn
     /*  41709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41717 */     // (intrinsic_wo_chain:{ *:[i32] } 3498:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41733 */     GIR_RootConstrainSelectedInstOperands,
     /*  41734 */     // GIR_Coverage, 602,
     /*  41734 */     GIR_EraseRootFromParent_Done,
     /*  41735 */   // Label 957: @41735
     /*  41735 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(41781), // Rule ID 603 //
     /*  41740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41755 */     // MIs[0] Rn
     /*  41755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41763 */     // (intrinsic_wo_chain:{ *:[i32] } 3499:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41779 */     GIR_RootConstrainSelectedInstOperands,
     /*  41780 */     // GIR_Coverage, 603,
     /*  41780 */     GIR_EraseRootFromParent_Done,
     /*  41781 */   // Label 958: @41781
     /*  41781 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(41916), // Rule ID 2693 //
     /*  41786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  41794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41804 */     // (intrinsic_wo_chain:{ *:[i32] } 3732:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  41804 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  41807 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41811 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41816 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  41820 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41825 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  41828 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  41832 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41837 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  41840 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  41843 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  41846 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  41851 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41856 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  41859 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  41863 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41868 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  41873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41885 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  41892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  41915 */     // GIR_Coverage, 2693,
     /*  41915 */     GIR_EraseRootFromParent_Done,
     /*  41916 */   // Label 959: @41916
     /*  41916 */   GIM_Reject,
     /*  41917 */ // Label 841: @41917
     /*  41917 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(62471),
     /*  41922 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  41925 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(41982), // Rule ID 2117 //
     /*  41930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  41938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41959 */     // (intrinsic_wo_chain:{ *:[i32] } 3944:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  41959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  41962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  41968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41980 */     GIR_RootConstrainSelectedInstOperands,
     /*  41981 */     // GIR_Coverage, 2117,
     /*  41981 */     GIR_EraseRootFromParent_Done,
     /*  41982 */   // Label 961: @41982
     /*  41982 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42081), // Rule ID 1888 //
     /*  41987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  41995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42041 */     // MIs[2] Operand 1
     /*  42041 */     // No operand predicates
     /*  42041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42049 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42053 */     // MIs[3] Operand 1
     /*  42053 */     // No operand predicates
     /*  42053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42055 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42079 */     GIR_RootConstrainSelectedInstOperands,
     /*  42080 */     // GIR_Coverage, 1888,
     /*  42080 */     GIR_EraseRootFromParent_Done,
     /*  42081 */   // Label 962: @42081
     /*  42081 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42180), // Rule ID 2154 //
     /*  42086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42136 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42140 */     // MIs[2] Operand 1
     /*  42140 */     // No operand predicates
     /*  42140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42148 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42152 */     // MIs[3] Operand 1
     /*  42152 */     // No operand predicates
     /*  42152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42154 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42178 */     GIR_RootConstrainSelectedInstOperands,
     /*  42179 */     // GIR_Coverage, 2154,
     /*  42179 */     GIR_EraseRootFromParent_Done,
     /*  42180 */   // Label 963: @42180
     /*  42180 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42264), // Rule ID 5430 //
     /*  42185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42214 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42217 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42231 */     // MIs[1] Rn
     /*  42231 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42242 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42262 */     GIR_RootConstrainSelectedInstOperands,
     /*  42263 */     // GIR_Coverage, 5430,
     /*  42263 */     GIR_EraseRootFromParent_Done,
     /*  42264 */   // Label 964: @42264
     /*  42264 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42348), // Rule ID 5687 //
     /*  42269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42298 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42301 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42315 */     // MIs[1] Rn
     /*  42315 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42326 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42346 */     GIR_RootConstrainSelectedInstOperands,
     /*  42347 */     // GIR_Coverage, 5687,
     /*  42347 */     GIR_EraseRootFromParent_Done,
     /*  42348 */   // Label 965: @42348
     /*  42348 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42432), // Rule ID 109 //
     /*  42353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42386 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42389 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42403 */     // MIs[1] Rn
     /*  42403 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42410 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42430 */     GIR_RootConstrainSelectedInstOperands,
     /*  42431 */     // GIR_Coverage, 109,
     /*  42431 */     GIR_EraseRootFromParent_Done,
     /*  42432 */   // Label 966: @42432
     /*  42432 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(42516), // Rule ID 110 //
     /*  42437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42470 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42473 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42487 */     // MIs[1] Rn
     /*  42487 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42494 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42514 */     GIR_RootConstrainSelectedInstOperands,
     /*  42515 */     // GIR_Coverage, 110,
     /*  42515 */     GIR_EraseRootFromParent_Done,
     /*  42516 */   // Label 967: @42516
     /*  42516 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(42600), // Rule ID 2132 //
     /*  42521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42554 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42557 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42571 */     // MIs[1] Rn
     /*  42571 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42578 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42598 */     GIR_RootConstrainSelectedInstOperands,
     /*  42599 */     // GIR_Coverage, 2132,
     /*  42599 */     GIR_EraseRootFromParent_Done,
     /*  42600 */   // Label 968: @42600
     /*  42600 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(42684), // Rule ID 2133 //
     /*  42605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42638 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42641 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42655 */     // MIs[1] Rn
     /*  42655 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42662 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42682 */     GIR_RootConstrainSelectedInstOperands,
     /*  42683 */     // GIR_Coverage, 2133,
     /*  42683 */     GIR_EraseRootFromParent_Done,
     /*  42684 */   // Label 969: @42684
     /*  42684 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(42757), // Rule ID 4058 //
     /*  42689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42718 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42735 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42755 */     GIR_RootConstrainSelectedInstOperands,
     /*  42756 */     // GIR_Coverage, 4058,
     /*  42756 */     GIR_EraseRootFromParent_Done,
     /*  42757 */   // Label 970: @42757
     /*  42757 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(42830), // Rule ID 4060 //
     /*  42762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42791 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  42806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42808 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42828 */     GIR_RootConstrainSelectedInstOperands,
     /*  42829 */     // GIR_Coverage, 4060,
     /*  42829 */     GIR_EraseRootFromParent_Done,
     /*  42830 */   // Label 971: @42830
     /*  42830 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(42903), // Rule ID 4062 //
     /*  42835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  42843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42864 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  42879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42881 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42901 */     GIR_RootConstrainSelectedInstOperands,
     /*  42902 */     // GIR_Coverage, 4062,
     /*  42902 */     GIR_EraseRootFromParent_Done,
     /*  42903 */   // Label 972: @42903
     /*  42903 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(42976), // Rule ID 4064 //
     /*  42908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  42916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42937 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  42952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42954 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42974 */     GIR_RootConstrainSelectedInstOperands,
     /*  42975 */     // GIR_Coverage, 4064,
     /*  42975 */     GIR_EraseRootFromParent_Done,
     /*  42976 */   // Label 973: @42976
     /*  42976 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43049), // Rule ID 4066 //
     /*  42981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43010 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43027 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43047 */     GIR_RootConstrainSelectedInstOperands,
     /*  43048 */     // GIR_Coverage, 4066,
     /*  43048 */     GIR_EraseRootFromParent_Done,
     /*  43049 */   // Label 974: @43049
     /*  43049 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43122), // Rule ID 4068 //
     /*  43054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43083 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43100 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43120 */     GIR_RootConstrainSelectedInstOperands,
     /*  43121 */     // GIR_Coverage, 4068,
     /*  43121 */     GIR_EraseRootFromParent_Done,
     /*  43122 */   // Label 975: @43122
     /*  43122 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43195), // Rule ID 4070 //
     /*  43127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43156 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43173 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43193 */     GIR_RootConstrainSelectedInstOperands,
     /*  43194 */     // GIR_Coverage, 4070,
     /*  43194 */     GIR_EraseRootFromParent_Done,
     /*  43195 */   // Label 976: @43195
     /*  43195 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43268), // Rule ID 4072 //
     /*  43200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43229 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43246 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43266 */     GIR_RootConstrainSelectedInstOperands,
     /*  43267 */     // GIR_Coverage, 4072,
     /*  43267 */     GIR_EraseRootFromParent_Done,
     /*  43268 */   // Label 977: @43268
     /*  43268 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43341), // Rule ID 4074 //
     /*  43273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43302 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43319 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43339 */     GIR_RootConstrainSelectedInstOperands,
     /*  43340 */     // GIR_Coverage, 4074,
     /*  43340 */     GIR_EraseRootFromParent_Done,
     /*  43341 */   // Label 978: @43341
     /*  43341 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43414), // Rule ID 4076 //
     /*  43346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43375 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43392 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43412 */     GIR_RootConstrainSelectedInstOperands,
     /*  43413 */     // GIR_Coverage, 4076,
     /*  43413 */     GIR_EraseRootFromParent_Done,
     /*  43414 */   // Label 979: @43414
     /*  43414 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43487), // Rule ID 4078 //
     /*  43419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43465 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43485 */     GIR_RootConstrainSelectedInstOperands,
     /*  43486 */     // GIR_Coverage, 4078,
     /*  43486 */     GIR_EraseRootFromParent_Done,
     /*  43487 */   // Label 980: @43487
     /*  43487 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(43560), // Rule ID 4080 //
     /*  43492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43521 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43538 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43558 */     GIR_RootConstrainSelectedInstOperands,
     /*  43559 */     // GIR_Coverage, 4080,
     /*  43559 */     GIR_EraseRootFromParent_Done,
     /*  43560 */   // Label 981: @43560
     /*  43560 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(43633), // Rule ID 4082 //
     /*  43565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43594 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43611 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43631 */     GIR_RootConstrainSelectedInstOperands,
     /*  43632 */     // GIR_Coverage, 4082,
     /*  43632 */     GIR_EraseRootFromParent_Done,
     /*  43633 */   // Label 982: @43633
     /*  43633 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(43706), // Rule ID 4084 //
     /*  43638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43684 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43704 */     GIR_RootConstrainSelectedInstOperands,
     /*  43705 */     // GIR_Coverage, 4084,
     /*  43705 */     GIR_EraseRootFromParent_Done,
     /*  43706 */   // Label 983: @43706
     /*  43706 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(43779), // Rule ID 4086 //
     /*  43711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43740 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43757 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43777 */     GIR_RootConstrainSelectedInstOperands,
     /*  43778 */     // GIR_Coverage, 4086,
     /*  43778 */     GIR_EraseRootFromParent_Done,
     /*  43779 */   // Label 984: @43779
     /*  43779 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(43852), // Rule ID 4088 //
     /*  43784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43813 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  43828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43830 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43850 */     GIR_RootConstrainSelectedInstOperands,
     /*  43851 */     // GIR_Coverage, 4088,
     /*  43851 */     GIR_EraseRootFromParent_Done,
     /*  43852 */   // Label 985: @43852
     /*  43852 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(43925), // Rule ID 4532 //
     /*  43857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  43886 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3621:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  43901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  43905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43923 */     GIR_RootConstrainSelectedInstOperands,
     /*  43924 */     // GIR_Coverage, 4532,
     /*  43924 */     GIR_EraseRootFromParent_Done,
     /*  43925 */   // Label 986: @43925
     /*  43925 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(43998), // Rule ID 4538 //
     /*  43930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  43959 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3621:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  43974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  43978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43996 */     GIR_RootConstrainSelectedInstOperands,
     /*  43997 */     // GIR_Coverage, 4538,
     /*  43997 */     GIR_EraseRootFromParent_Done,
     /*  43998 */   // Label 987: @43998
     /*  43998 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44066), // Rule ID 1881 //
     /*  44003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44040 */     // MIs[1] Operand 1
     /*  44040 */     // No operand predicates
     /*  44040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44042 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44050 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44064 */     GIR_RootConstrainSelectedInstOperands,
     /*  44065 */     // GIR_Coverage, 1881,
     /*  44065 */     GIR_EraseRootFromParent_Done,
     /*  44066 */   // Label 988: @44066
     /*  44066 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44131), // Rule ID 1885 //
     /*  44071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44108 */     // MIs[1] Operand 1
     /*  44108 */     // No operand predicates
     /*  44108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44110 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44118 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44129 */     GIR_RootConstrainSelectedInstOperands,
     /*  44130 */     // GIR_Coverage, 1885,
     /*  44130 */     GIR_EraseRootFromParent_Done,
     /*  44131 */   // Label 989: @44131
     /*  44131 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44199), // Rule ID 2149 //
     /*  44136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44173 */     // MIs[1] Operand 1
     /*  44173 */     // No operand predicates
     /*  44173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44175 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44183 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44197 */     GIR_RootConstrainSelectedInstOperands,
     /*  44198 */     // GIR_Coverage, 2149,
     /*  44198 */     GIR_EraseRootFromParent_Done,
     /*  44199 */   // Label 990: @44199
     /*  44199 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44264), // Rule ID 2151 //
     /*  44204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44241 */     // MIs[1] Operand 1
     /*  44241 */     // No operand predicates
     /*  44241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44243 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44251 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44262 */     GIR_RootConstrainSelectedInstOperands,
     /*  44263 */     // GIR_Coverage, 2151,
     /*  44263 */     GIR_EraseRootFromParent_Done,
     /*  44264 */   // Label 991: @44264
     /*  44264 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44347), // Rule ID 3928 //
     /*  44269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44303 */     // MIs[1] Operand 1
     /*  44303 */     // No operand predicates
     /*  44303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44305 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3682:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44322 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44345 */     GIR_RootConstrainSelectedInstOperands,
     /*  44346 */     // GIR_Coverage, 3928,
     /*  44346 */     GIR_EraseRootFromParent_Done,
     /*  44347 */   // Label 992: @44347
     /*  44347 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44430), // Rule ID 3930 //
     /*  44352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44386 */     // MIs[1] Operand 1
     /*  44386 */     // No operand predicates
     /*  44386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44388 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3682:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44405 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44428 */     GIR_RootConstrainSelectedInstOperands,
     /*  44429 */     // GIR_Coverage, 3930,
     /*  44429 */     GIR_EraseRootFromParent_Done,
     /*  44430 */   // Label 993: @44430
     /*  44430 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44513), // Rule ID 3932 //
     /*  44435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44469 */     // MIs[1] Operand 1
     /*  44469 */     // No operand predicates
     /*  44469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3682:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44511 */     GIR_RootConstrainSelectedInstOperands,
     /*  44512 */     // GIR_Coverage, 3932,
     /*  44512 */     GIR_EraseRootFromParent_Done,
     /*  44513 */   // Label 994: @44513
     /*  44513 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(44574), // Rule ID 1652 //
     /*  44518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44551 */     // MIs[1] Operand 1
     /*  44551 */     // No operand predicates
     /*  44551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44553 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3759:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44572 */     GIR_RootConstrainSelectedInstOperands,
     /*  44573 */     // GIR_Coverage, 1652,
     /*  44573 */     GIR_EraseRootFromParent_Done,
     /*  44574 */   // Label 995: @44574
     /*  44574 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(44635), // Rule ID 1653 //
     /*  44579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44612 */     // MIs[1] Operand 1
     /*  44612 */     // No operand predicates
     /*  44612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44614 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3760:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44633 */     GIR_RootConstrainSelectedInstOperands,
     /*  44634 */     // GIR_Coverage, 1653,
     /*  44634 */     GIR_EraseRootFromParent_Done,
     /*  44635 */   // Label 996: @44635
     /*  44635 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(44696), // Rule ID 1654 //
     /*  44640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44673 */     // MIs[1] Operand 1
     /*  44673 */     // No operand predicates
     /*  44673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44675 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3762:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44694 */     GIR_RootConstrainSelectedInstOperands,
     /*  44695 */     // GIR_Coverage, 1654,
     /*  44695 */     GIR_EraseRootFromParent_Done,
     /*  44696 */   // Label 997: @44696
     /*  44696 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(44757), // Rule ID 1655 //
     /*  44701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44734 */     // MIs[1] Operand 1
     /*  44734 */     // No operand predicates
     /*  44734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44736 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3763:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44755 */     GIR_RootConstrainSelectedInstOperands,
     /*  44756 */     // GIR_Coverage, 1655,
     /*  44756 */     GIR_EraseRootFromParent_Done,
     /*  44757 */   // Label 998: @44757
     /*  44757 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(44818), // Rule ID 1656 //
     /*  44762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44795 */     // MIs[1] Operand 1
     /*  44795 */     // No operand predicates
     /*  44795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44797 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3759:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  44800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44816 */     GIR_RootConstrainSelectedInstOperands,
     /*  44817 */     // GIR_Coverage, 1656,
     /*  44817 */     GIR_EraseRootFromParent_Done,
     /*  44818 */   // Label 999: @44818
     /*  44818 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(44879), // Rule ID 1657 //
     /*  44823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44856 */     // MIs[1] Operand 1
     /*  44856 */     // No operand predicates
     /*  44856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44858 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3760:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  44861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44877 */     GIR_RootConstrainSelectedInstOperands,
     /*  44878 */     // GIR_Coverage, 1657,
     /*  44878 */     GIR_EraseRootFromParent_Done,
     /*  44879 */   // Label 1000: @44879
     /*  44879 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(44940), // Rule ID 1658 //
     /*  44884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44917 */     // MIs[1] Operand 1
     /*  44917 */     // No operand predicates
     /*  44917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44919 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3762:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  44922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44938 */     GIR_RootConstrainSelectedInstOperands,
     /*  44939 */     // GIR_Coverage, 1658,
     /*  44939 */     GIR_EraseRootFromParent_Done,
     /*  44940 */   // Label 1001: @44940
     /*  44940 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45001), // Rule ID 1659 //
     /*  44945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44978 */     // MIs[1] Operand 1
     /*  44978 */     // No operand predicates
     /*  44978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44980 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3763:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  44983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44999 */     GIR_RootConstrainSelectedInstOperands,
     /*  45000 */     // GIR_Coverage, 1659,
     /*  45000 */     GIR_EraseRootFromParent_Done,
     /*  45001 */   // Label 1002: @45001
     /*  45001 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45062), // Rule ID 1660 //
     /*  45006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45039 */     // MIs[1] Operand 1
     /*  45039 */     // No operand predicates
     /*  45039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45041 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3759:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45060 */     GIR_RootConstrainSelectedInstOperands,
     /*  45061 */     // GIR_Coverage, 1660,
     /*  45061 */     GIR_EraseRootFromParent_Done,
     /*  45062 */   // Label 1003: @45062
     /*  45062 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45123), // Rule ID 1661 //
     /*  45067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45100 */     // MIs[1] Operand 1
     /*  45100 */     // No operand predicates
     /*  45100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45102 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3760:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45121 */     GIR_RootConstrainSelectedInstOperands,
     /*  45122 */     // GIR_Coverage, 1661,
     /*  45122 */     GIR_EraseRootFromParent_Done,
     /*  45123 */   // Label 1004: @45123
     /*  45123 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45184), // Rule ID 1662 //
     /*  45128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45161 */     // MIs[1] Operand 1
     /*  45161 */     // No operand predicates
     /*  45161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45163 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3762:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45182 */     GIR_RootConstrainSelectedInstOperands,
     /*  45183 */     // GIR_Coverage, 1662,
     /*  45183 */     GIR_EraseRootFromParent_Done,
     /*  45184 */   // Label 1005: @45184
     /*  45184 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45245), // Rule ID 1663 //
     /*  45189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45222 */     // MIs[1] Operand 1
     /*  45222 */     // No operand predicates
     /*  45222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45224 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3763:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45243 */     GIR_RootConstrainSelectedInstOperands,
     /*  45244 */     // GIR_Coverage, 1663,
     /*  45244 */     GIR_EraseRootFromParent_Done,
     /*  45245 */   // Label 1006: @45245
     /*  45245 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45306), // Rule ID 1664 //
     /*  45250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45283 */     // MIs[1] Operand 1
     /*  45283 */     // No operand predicates
     /*  45283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45285 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3759:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45304 */     GIR_RootConstrainSelectedInstOperands,
     /*  45305 */     // GIR_Coverage, 1664,
     /*  45305 */     GIR_EraseRootFromParent_Done,
     /*  45306 */   // Label 1007: @45306
     /*  45306 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45367), // Rule ID 1665 //
     /*  45311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45344 */     // MIs[1] Operand 1
     /*  45344 */     // No operand predicates
     /*  45344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45346 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3760:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45365 */     GIR_RootConstrainSelectedInstOperands,
     /*  45366 */     // GIR_Coverage, 1665,
     /*  45366 */     GIR_EraseRootFromParent_Done,
     /*  45367 */   // Label 1008: @45367
     /*  45367 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45428), // Rule ID 1666 //
     /*  45372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45405 */     // MIs[1] Operand 1
     /*  45405 */     // No operand predicates
     /*  45405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45407 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3762:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45426 */     GIR_RootConstrainSelectedInstOperands,
     /*  45427 */     // GIR_Coverage, 1666,
     /*  45427 */     GIR_EraseRootFromParent_Done,
     /*  45428 */   // Label 1009: @45428
     /*  45428 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45489), // Rule ID 1667 //
     /*  45433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45466 */     // MIs[1] Operand 1
     /*  45466 */     // No operand predicates
     /*  45466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45468 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3763:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45487 */     GIR_RootConstrainSelectedInstOperands,
     /*  45488 */     // GIR_Coverage, 1667,
     /*  45488 */     GIR_EraseRootFromParent_Done,
     /*  45489 */   // Label 1010: @45489
     /*  45489 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45550), // Rule ID 1725 //
     /*  45494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45527 */     // MIs[1] Operand 1
     /*  45527 */     // No operand predicates
     /*  45527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45529 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45534 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45548 */     GIR_RootConstrainSelectedInstOperands,
     /*  45549 */     // GIR_Coverage, 1725,
     /*  45549 */     GIR_EraseRootFromParent_Done,
     /*  45550 */   // Label 1011: @45550
     /*  45550 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(45611), // Rule ID 1726 //
     /*  45555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45588 */     // MIs[1] Operand 1
     /*  45588 */     // No operand predicates
     /*  45588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45590 */     // (intrinsic_wo_chain:{ *:[i32] } 3589:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45595 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45609 */     GIR_RootConstrainSelectedInstOperands,
     /*  45610 */     // GIR_Coverage, 1726,
     /*  45610 */     GIR_EraseRootFromParent_Done,
     /*  45611 */   // Label 1012: @45611
     /*  45611 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(45672), // Rule ID 1727 //
     /*  45616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45649 */     // MIs[1] Operand 1
     /*  45649 */     // No operand predicates
     /*  45649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45651 */     // (intrinsic_wo_chain:{ *:[i32] } 3594:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45656 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45670 */     GIR_RootConstrainSelectedInstOperands,
     /*  45671 */     // GIR_Coverage, 1727,
     /*  45671 */     GIR_EraseRootFromParent_Done,
     /*  45672 */   // Label 1013: @45672
     /*  45672 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(45733), // Rule ID 1728 //
     /*  45677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45710 */     // MIs[1] Operand 1
     /*  45710 */     // No operand predicates
     /*  45710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45712 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45717 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45731 */     GIR_RootConstrainSelectedInstOperands,
     /*  45732 */     // GIR_Coverage, 1728,
     /*  45732 */     GIR_EraseRootFromParent_Done,
     /*  45733 */   // Label 1014: @45733
     /*  45733 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(45787), // Rule ID 105 //
     /*  45738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45767 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45785 */     GIR_RootConstrainSelectedInstOperands,
     /*  45786 */     // GIR_Coverage, 105,
     /*  45786 */     GIR_EraseRootFromParent_Done,
     /*  45787 */   // Label 1015: @45787
     /*  45787 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(45841), // Rule ID 106 //
     /*  45792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  45800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45821 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  45824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45839 */     GIR_RootConstrainSelectedInstOperands,
     /*  45840 */     // GIR_Coverage, 106,
     /*  45840 */     GIR_EraseRootFromParent_Done,
     /*  45841 */   // Label 1016: @45841
     /*  45841 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(45895), // Rule ID 107 //
     /*  45846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  45854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45875 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  45878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45893 */     GIR_RootConstrainSelectedInstOperands,
     /*  45894 */     // GIR_Coverage, 107,
     /*  45894 */     GIR_EraseRootFromParent_Done,
     /*  45895 */   // Label 1017: @45895
     /*  45895 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(45949), // Rule ID 108 //
     /*  45900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  45908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45929 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  45932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45947 */     GIR_RootConstrainSelectedInstOperands,
     /*  45948 */     // GIR_Coverage, 108,
     /*  45948 */     GIR_EraseRootFromParent_Done,
     /*  45949 */   // Label 1018: @45949
     /*  45949 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46003), // Rule ID 111 //
     /*  45954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  45962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45983 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  45983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  45986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  45990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  45992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46001 */     GIR_RootConstrainSelectedInstOperands,
     /*  46002 */     // GIR_Coverage, 111,
     /*  46002 */     GIR_EraseRootFromParent_Done,
     /*  46003 */   // Label 1019: @46003
     /*  46003 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46057), // Rule ID 112 //
     /*  46008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46037 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46055 */     GIR_RootConstrainSelectedInstOperands,
     /*  46056 */     // GIR_Coverage, 112,
     /*  46056 */     GIR_EraseRootFromParent_Done,
     /*  46057 */   // Label 1020: @46057
     /*  46057 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46111), // Rule ID 113 //
     /*  46062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46091 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46109 */     GIR_RootConstrainSelectedInstOperands,
     /*  46110 */     // GIR_Coverage, 113,
     /*  46110 */     GIR_EraseRootFromParent_Done,
     /*  46111 */   // Label 1021: @46111
     /*  46111 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46165), // Rule ID 114 //
     /*  46116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46145 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46163 */     GIR_RootConstrainSelectedInstOperands,
     /*  46164 */     // GIR_Coverage, 114,
     /*  46164 */     GIR_EraseRootFromParent_Done,
     /*  46165 */   // Label 1022: @46165
     /*  46165 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46219), // Rule ID 115 //
     /*  46170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46199 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46217 */     GIR_RootConstrainSelectedInstOperands,
     /*  46218 */     // GIR_Coverage, 115,
     /*  46218 */     GIR_EraseRootFromParent_Done,
     /*  46219 */   // Label 1023: @46219
     /*  46219 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46273), // Rule ID 116 //
     /*  46224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46253 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46271 */     GIR_RootConstrainSelectedInstOperands,
     /*  46272 */     // GIR_Coverage, 116,
     /*  46272 */     GIR_EraseRootFromParent_Done,
     /*  46273 */   // Label 1024: @46273
     /*  46273 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46327), // Rule ID 117 //
     /*  46278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46307 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46325 */     GIR_RootConstrainSelectedInstOperands,
     /*  46326 */     // GIR_Coverage, 117,
     /*  46326 */     GIR_EraseRootFromParent_Done,
     /*  46327 */   // Label 1025: @46327
     /*  46327 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46381), // Rule ID 118 //
     /*  46332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46361 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46379 */     GIR_RootConstrainSelectedInstOperands,
     /*  46380 */     // GIR_Coverage, 118,
     /*  46380 */     GIR_EraseRootFromParent_Done,
     /*  46381 */   // Label 1026: @46381
     /*  46381 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46435), // Rule ID 119 //
     /*  46386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46415 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46433 */     GIR_RootConstrainSelectedInstOperands,
     /*  46434 */     // GIR_Coverage, 119,
     /*  46434 */     GIR_EraseRootFromParent_Done,
     /*  46435 */   // Label 1027: @46435
     /*  46435 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46489), // Rule ID 120 //
     /*  46440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46469 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46487 */     GIR_RootConstrainSelectedInstOperands,
     /*  46488 */     // GIR_Coverage, 120,
     /*  46488 */     GIR_EraseRootFromParent_Done,
     /*  46489 */   // Label 1028: @46489
     /*  46489 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46543), // Rule ID 133 //
     /*  46494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46523 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46541 */     GIR_RootConstrainSelectedInstOperands,
     /*  46542 */     // GIR_Coverage, 133,
     /*  46542 */     GIR_EraseRootFromParent_Done,
     /*  46543 */   // Label 1029: @46543
     /*  46543 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(46597), // Rule ID 134 //
     /*  46548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46577 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46595 */     GIR_RootConstrainSelectedInstOperands,
     /*  46596 */     // GIR_Coverage, 134,
     /*  46596 */     GIR_EraseRootFromParent_Done,
     /*  46597 */   // Label 1030: @46597
     /*  46597 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(46651), // Rule ID 135 //
     /*  46602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46631 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46649 */     GIR_RootConstrainSelectedInstOperands,
     /*  46650 */     // GIR_Coverage, 135,
     /*  46650 */     GIR_EraseRootFromParent_Done,
     /*  46651 */   // Label 1031: @46651
     /*  46651 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(46705), // Rule ID 136 //
     /*  46656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46685 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46703 */     GIR_RootConstrainSelectedInstOperands,
     /*  46704 */     // GIR_Coverage, 136,
     /*  46704 */     GIR_EraseRootFromParent_Done,
     /*  46705 */   // Label 1032: @46705
     /*  46705 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(46759), // Rule ID 137 //
     /*  46710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46739 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46757 */     GIR_RootConstrainSelectedInstOperands,
     /*  46758 */     // GIR_Coverage, 137,
     /*  46758 */     GIR_EraseRootFromParent_Done,
     /*  46759 */   // Label 1033: @46759
     /*  46759 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(46813), // Rule ID 138 //
     /*  46764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46793 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  46796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46811 */     GIR_RootConstrainSelectedInstOperands,
     /*  46812 */     // GIR_Coverage, 138,
     /*  46812 */     GIR_EraseRootFromParent_Done,
     /*  46813 */   // Label 1034: @46813
     /*  46813 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(46867), // Rule ID 139 //
     /*  46818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  46826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46847 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  46850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46865 */     GIR_RootConstrainSelectedInstOperands,
     /*  46866 */     // GIR_Coverage, 139,
     /*  46866 */     GIR_EraseRootFromParent_Done,
     /*  46867 */   // Label 1035: @46867
     /*  46867 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(46921), // Rule ID 140 //
     /*  46872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  46880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46901 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  46904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46919 */     GIR_RootConstrainSelectedInstOperands,
     /*  46920 */     // GIR_Coverage, 140,
     /*  46920 */     GIR_EraseRootFromParent_Done,
     /*  46921 */   // Label 1036: @46921
     /*  46921 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(46975), // Rule ID 141 //
     /*  46926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  46934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46955 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  46958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46973 */     GIR_RootConstrainSelectedInstOperands,
     /*  46974 */     // GIR_Coverage, 141,
     /*  46974 */     GIR_EraseRootFromParent_Done,
     /*  46975 */   // Label 1037: @46975
     /*  46975 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47029), // Rule ID 142 //
     /*  46980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  46988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47009 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47027 */     GIR_RootConstrainSelectedInstOperands,
     /*  47028 */     // GIR_Coverage, 142,
     /*  47028 */     GIR_EraseRootFromParent_Done,
     /*  47029 */   // Label 1038: @47029
     /*  47029 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47083), // Rule ID 143 //
     /*  47034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47063 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47081 */     GIR_RootConstrainSelectedInstOperands,
     /*  47082 */     // GIR_Coverage, 143,
     /*  47082 */     GIR_EraseRootFromParent_Done,
     /*  47083 */   // Label 1039: @47083
     /*  47083 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47137), // Rule ID 144 //
     /*  47088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47117 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47135 */     GIR_RootConstrainSelectedInstOperands,
     /*  47136 */     // GIR_Coverage, 144,
     /*  47136 */     GIR_EraseRootFromParent_Done,
     /*  47137 */   // Label 1040: @47137
     /*  47137 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47191), // Rule ID 145 //
     /*  47142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47171 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47189 */     GIR_RootConstrainSelectedInstOperands,
     /*  47190 */     // GIR_Coverage, 145,
     /*  47190 */     GIR_EraseRootFromParent_Done,
     /*  47191 */   // Label 1041: @47191
     /*  47191 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47236), // Rule ID 204 //
     /*  47196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47225 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47234 */     GIR_RootConstrainSelectedInstOperands,
     /*  47235 */     // GIR_Coverage, 204,
     /*  47235 */     GIR_EraseRootFromParent_Done,
     /*  47236 */   // Label 1042: @47236
     /*  47236 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47281), // Rule ID 205 //
     /*  47241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47270 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47279 */     GIR_RootConstrainSelectedInstOperands,
     /*  47280 */     // GIR_Coverage, 205,
     /*  47280 */     GIR_EraseRootFromParent_Done,
     /*  47281 */   // Label 1043: @47281
     /*  47281 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47326), // Rule ID 206 //
     /*  47286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47315 */     // (intrinsic_wo_chain:{ *:[i32] } 3505:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47324 */     GIR_RootConstrainSelectedInstOperands,
     /*  47325 */     // GIR_Coverage, 206,
     /*  47325 */     GIR_EraseRootFromParent_Done,
     /*  47326 */   // Label 1044: @47326
     /*  47326 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47371), // Rule ID 207 //
     /*  47331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47360 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47369 */     GIR_RootConstrainSelectedInstOperands,
     /*  47370 */     // GIR_Coverage, 207,
     /*  47370 */     GIR_EraseRootFromParent_Done,
     /*  47371 */   // Label 1045: @47371
     /*  47371 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47416), // Rule ID 208 //
     /*  47376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47405 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47414 */     GIR_RootConstrainSelectedInstOperands,
     /*  47415 */     // GIR_Coverage, 208,
     /*  47415 */     GIR_EraseRootFromParent_Done,
     /*  47416 */   // Label 1046: @47416
     /*  47416 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47461), // Rule ID 209 //
     /*  47421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47450 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47459 */     GIR_RootConstrainSelectedInstOperands,
     /*  47460 */     // GIR_Coverage, 209,
     /*  47460 */     GIR_EraseRootFromParent_Done,
     /*  47461 */   // Label 1047: @47461
     /*  47461 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47515), // Rule ID 432 //
     /*  47466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47495 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47513 */     GIR_RootConstrainSelectedInstOperands,
     /*  47514 */     // GIR_Coverage, 432,
     /*  47514 */     GIR_EraseRootFromParent_Done,
     /*  47515 */   // Label 1048: @47515
     /*  47515 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(47569), // Rule ID 433 //
     /*  47520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47549 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47567 */     GIR_RootConstrainSelectedInstOperands,
     /*  47568 */     // GIR_Coverage, 433,
     /*  47568 */     GIR_EraseRootFromParent_Done,
     /*  47569 */   // Label 1049: @47569
     /*  47569 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(47623), // Rule ID 434 //
     /*  47574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47603 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47621 */     GIR_RootConstrainSelectedInstOperands,
     /*  47622 */     // GIR_Coverage, 434,
     /*  47622 */     GIR_EraseRootFromParent_Done,
     /*  47623 */   // Label 1050: @47623
     /*  47623 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(47677), // Rule ID 435 //
     /*  47628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47657 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47675 */     GIR_RootConstrainSelectedInstOperands,
     /*  47676 */     // GIR_Coverage, 435,
     /*  47676 */     GIR_EraseRootFromParent_Done,
     /*  47677 */   // Label 1051: @47677
     /*  47677 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(47731), // Rule ID 436 //
     /*  47682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47711 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47729 */     GIR_RootConstrainSelectedInstOperands,
     /*  47730 */     // GIR_Coverage, 436,
     /*  47730 */     GIR_EraseRootFromParent_Done,
     /*  47731 */   // Label 1052: @47731
     /*  47731 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(47785), // Rule ID 437 //
     /*  47736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47765 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47783 */     GIR_RootConstrainSelectedInstOperands,
     /*  47784 */     // GIR_Coverage, 437,
     /*  47784 */     GIR_EraseRootFromParent_Done,
     /*  47785 */   // Label 1053: @47785
     /*  47785 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(47839), // Rule ID 438 //
     /*  47790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  47798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47819 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  47822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47837 */     GIR_RootConstrainSelectedInstOperands,
     /*  47838 */     // GIR_Coverage, 438,
     /*  47838 */     GIR_EraseRootFromParent_Done,
     /*  47839 */   // Label 1054: @47839
     /*  47839 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(47893), // Rule ID 439 //
     /*  47844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  47852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47873 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  47876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47891 */     GIR_RootConstrainSelectedInstOperands,
     /*  47892 */     // GIR_Coverage, 439,
     /*  47892 */     GIR_EraseRootFromParent_Done,
     /*  47893 */   // Label 1055: @47893
     /*  47893 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(47947), // Rule ID 440 //
     /*  47898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  47906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47927 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  47930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47945 */     GIR_RootConstrainSelectedInstOperands,
     /*  47946 */     // GIR_Coverage, 440,
     /*  47946 */     GIR_EraseRootFromParent_Done,
     /*  47947 */   // Label 1056: @47947
     /*  47947 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48001), // Rule ID 441 //
     /*  47952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  47960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47981 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  47984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47999 */     GIR_RootConstrainSelectedInstOperands,
     /*  48000 */     // GIR_Coverage, 441,
     /*  48000 */     GIR_EraseRootFromParent_Done,
     /*  48001 */   // Label 1057: @48001
     /*  48001 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48055), // Rule ID 442 //
     /*  48006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48035 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48053 */     GIR_RootConstrainSelectedInstOperands,
     /*  48054 */     // GIR_Coverage, 442,
     /*  48054 */     GIR_EraseRootFromParent_Done,
     /*  48055 */   // Label 1058: @48055
     /*  48055 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48109), // Rule ID 443 //
     /*  48060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48089 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48107 */     GIR_RootConstrainSelectedInstOperands,
     /*  48108 */     // GIR_Coverage, 443,
     /*  48108 */     GIR_EraseRootFromParent_Done,
     /*  48109 */   // Label 1059: @48109
     /*  48109 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48163), // Rule ID 456 //
     /*  48114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48143 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48161 */     GIR_RootConstrainSelectedInstOperands,
     /*  48162 */     // GIR_Coverage, 456,
     /*  48162 */     GIR_EraseRootFromParent_Done,
     /*  48163 */   // Label 1060: @48163
     /*  48163 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48217), // Rule ID 457 //
     /*  48168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48197 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48215 */     GIR_RootConstrainSelectedInstOperands,
     /*  48216 */     // GIR_Coverage, 457,
     /*  48216 */     GIR_EraseRootFromParent_Done,
     /*  48217 */   // Label 1061: @48217
     /*  48217 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48271), // Rule ID 458 //
     /*  48222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48251 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48269 */     GIR_RootConstrainSelectedInstOperands,
     /*  48270 */     // GIR_Coverage, 458,
     /*  48270 */     GIR_EraseRootFromParent_Done,
     /*  48271 */   // Label 1062: @48271
     /*  48271 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48325), // Rule ID 459 //
     /*  48276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48305 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48323 */     GIR_RootConstrainSelectedInstOperands,
     /*  48324 */     // GIR_Coverage, 459,
     /*  48324 */     GIR_EraseRootFromParent_Done,
     /*  48325 */   // Label 1063: @48325
     /*  48325 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48379), // Rule ID 460 //
     /*  48330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48359 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48377 */     GIR_RootConstrainSelectedInstOperands,
     /*  48378 */     // GIR_Coverage, 460,
     /*  48378 */     GIR_EraseRootFromParent_Done,
     /*  48379 */   // Label 1064: @48379
     /*  48379 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48433), // Rule ID 461 //
     /*  48384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48413 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48431 */     GIR_RootConstrainSelectedInstOperands,
     /*  48432 */     // GIR_Coverage, 461,
     /*  48432 */     GIR_EraseRootFromParent_Done,
     /*  48433 */   // Label 1065: @48433
     /*  48433 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48487), // Rule ID 462 //
     /*  48438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48467 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48485 */     GIR_RootConstrainSelectedInstOperands,
     /*  48486 */     // GIR_Coverage, 462,
     /*  48486 */     GIR_EraseRootFromParent_Done,
     /*  48487 */   // Label 1066: @48487
     /*  48487 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48541), // Rule ID 463 //
     /*  48492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48521 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48539 */     GIR_RootConstrainSelectedInstOperands,
     /*  48540 */     // GIR_Coverage, 463,
     /*  48540 */     GIR_EraseRootFromParent_Done,
     /*  48541 */   // Label 1067: @48541
     /*  48541 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(48595), // Rule ID 464 //
     /*  48546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48575 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48593 */     GIR_RootConstrainSelectedInstOperands,
     /*  48594 */     // GIR_Coverage, 464,
     /*  48594 */     GIR_EraseRootFromParent_Done,
     /*  48595 */   // Label 1068: @48595
     /*  48595 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(48649), // Rule ID 465 //
     /*  48600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48629 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48647 */     GIR_RootConstrainSelectedInstOperands,
     /*  48648 */     // GIR_Coverage, 465,
     /*  48648 */     GIR_EraseRootFromParent_Done,
     /*  48649 */   // Label 1069: @48649
     /*  48649 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(48703), // Rule ID 466 //
     /*  48654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48683 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48701 */     GIR_RootConstrainSelectedInstOperands,
     /*  48702 */     // GIR_Coverage, 466,
     /*  48702 */     GIR_EraseRootFromParent_Done,
     /*  48703 */   // Label 1070: @48703
     /*  48703 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(48757), // Rule ID 467 //
     /*  48708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48737 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48755 */     GIR_RootConstrainSelectedInstOperands,
     /*  48756 */     // GIR_Coverage, 467,
     /*  48756 */     GIR_EraseRootFromParent_Done,
     /*  48757 */   // Label 1071: @48757
     /*  48757 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(48811), // Rule ID 468 //
     /*  48762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48791 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  48794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48809 */     GIR_RootConstrainSelectedInstOperands,
     /*  48810 */     // GIR_Coverage, 468,
     /*  48810 */     GIR_EraseRootFromParent_Done,
     /*  48811 */   // Label 1072: @48811
     /*  48811 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(48865), // Rule ID 524 //
     /*  48816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  48824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48845 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  48848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48863 */     GIR_RootConstrainSelectedInstOperands,
     /*  48864 */     // GIR_Coverage, 524,
     /*  48864 */     GIR_EraseRootFromParent_Done,
     /*  48865 */   // Label 1073: @48865
     /*  48865 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(48919), // Rule ID 525 //
     /*  48870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  48878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48899 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  48902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48917 */     GIR_RootConstrainSelectedInstOperands,
     /*  48918 */     // GIR_Coverage, 525,
     /*  48918 */     GIR_EraseRootFromParent_Done,
     /*  48919 */   // Label 1074: @48919
     /*  48919 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(48973), // Rule ID 526 //
     /*  48924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  48932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48953 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  48956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48971 */     GIR_RootConstrainSelectedInstOperands,
     /*  48972 */     // GIR_Coverage, 526,
     /*  48972 */     GIR_EraseRootFromParent_Done,
     /*  48973 */   // Label 1075: @48973
     /*  48973 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49027), // Rule ID 527 //
     /*  48978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  48986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49007 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49025 */     GIR_RootConstrainSelectedInstOperands,
     /*  49026 */     // GIR_Coverage, 527,
     /*  49026 */     GIR_EraseRootFromParent_Done,
     /*  49027 */   // Label 1076: @49027
     /*  49027 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49072), // Rule ID 541 //
     /*  49032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49061 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49070 */     GIR_RootConstrainSelectedInstOperands,
     /*  49071 */     // GIR_Coverage, 541,
     /*  49071 */     GIR_EraseRootFromParent_Done,
     /*  49072 */   // Label 1077: @49072
     /*  49072 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49117), // Rule ID 542 //
     /*  49077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49106 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49115 */     GIR_RootConstrainSelectedInstOperands,
     /*  49116 */     // GIR_Coverage, 542,
     /*  49116 */     GIR_EraseRootFromParent_Done,
     /*  49117 */   // Label 1078: @49117
     /*  49117 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49162), // Rule ID 543 //
     /*  49122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49151 */     // (intrinsic_wo_chain:{ *:[i32] } 3505:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49160 */     GIR_RootConstrainSelectedInstOperands,
     /*  49161 */     // GIR_Coverage, 543,
     /*  49161 */     GIR_EraseRootFromParent_Done,
     /*  49162 */   // Label 1079: @49162
     /*  49162 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49207), // Rule ID 544 //
     /*  49167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49196 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49205 */     GIR_RootConstrainSelectedInstOperands,
     /*  49206 */     // GIR_Coverage, 544,
     /*  49206 */     GIR_EraseRootFromParent_Done,
     /*  49207 */   // Label 1080: @49207
     /*  49207 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49252), // Rule ID 545 //
     /*  49212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49241 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49250 */     GIR_RootConstrainSelectedInstOperands,
     /*  49251 */     // GIR_Coverage, 545,
     /*  49251 */     GIR_EraseRootFromParent_Done,
     /*  49252 */   // Label 1081: @49252
     /*  49252 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49297), // Rule ID 546 //
     /*  49257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49286 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49295 */     GIR_RootConstrainSelectedInstOperands,
     /*  49296 */     // GIR_Coverage, 546,
     /*  49296 */     GIR_EraseRootFromParent_Done,
     /*  49297 */   // Label 1082: @49297
     /*  49297 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49351), // Rule ID 792 //
     /*  49302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49331 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49349 */     GIR_RootConstrainSelectedInstOperands,
     /*  49350 */     // GIR_Coverage, 792,
     /*  49350 */     GIR_EraseRootFromParent_Done,
     /*  49351 */   // Label 1083: @49351
     /*  49351 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49405), // Rule ID 793 //
     /*  49356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49385 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3771:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49403 */     GIR_RootConstrainSelectedInstOperands,
     /*  49404 */     // GIR_Coverage, 793,
     /*  49404 */     GIR_EraseRootFromParent_Done,
     /*  49405 */   // Label 1084: @49405
     /*  49405 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49459), // Rule ID 794 //
     /*  49410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49439 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49457 */     GIR_RootConstrainSelectedInstOperands,
     /*  49458 */     // GIR_Coverage, 794,
     /*  49458 */     GIR_EraseRootFromParent_Done,
     /*  49459 */   // Label 1085: @49459
     /*  49459 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49513), // Rule ID 795 //
     /*  49464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49493 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3771:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49511 */     GIR_RootConstrainSelectedInstOperands,
     /*  49512 */     // GIR_Coverage, 795,
     /*  49512 */     GIR_EraseRootFromParent_Done,
     /*  49513 */   // Label 1086: @49513
     /*  49513 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(49567), // Rule ID 796 //
     /*  49518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49547 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3771:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49565 */     GIR_RootConstrainSelectedInstOperands,
     /*  49566 */     // GIR_Coverage, 796,
     /*  49566 */     GIR_EraseRootFromParent_Done,
     /*  49567 */   // Label 1087: @49567
     /*  49567 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(49621), // Rule ID 797 //
     /*  49572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49601 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3771:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49619 */     GIR_RootConstrainSelectedInstOperands,
     /*  49620 */     // GIR_Coverage, 797,
     /*  49620 */     GIR_EraseRootFromParent_Done,
     /*  49621 */   // Label 1088: @49621
     /*  49621 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(49675), // Rule ID 798 //
     /*  49626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49655 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49673 */     GIR_RootConstrainSelectedInstOperands,
     /*  49674 */     // GIR_Coverage, 798,
     /*  49674 */     GIR_EraseRootFromParent_Done,
     /*  49675 */   // Label 1089: @49675
     /*  49675 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(49729), // Rule ID 799 //
     /*  49680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49709 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49727 */     GIR_RootConstrainSelectedInstOperands,
     /*  49728 */     // GIR_Coverage, 799,
     /*  49728 */     GIR_EraseRootFromParent_Done,
     /*  49729 */   // Label 1090: @49729
     /*  49729 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(49783), // Rule ID 800 //
     /*  49734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49763 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3772:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49781 */     GIR_RootConstrainSelectedInstOperands,
     /*  49782 */     // GIR_Coverage, 800,
     /*  49782 */     GIR_EraseRootFromParent_Done,
     /*  49783 */   // Label 1091: @49783
     /*  49783 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(49837), // Rule ID 801 //
     /*  49788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49817 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3772:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  49820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49835 */     GIR_RootConstrainSelectedInstOperands,
     /*  49836 */     // GIR_Coverage, 801,
     /*  49836 */     GIR_EraseRootFromParent_Done,
     /*  49837 */   // Label 1092: @49837
     /*  49837 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(49891), // Rule ID 802 //
     /*  49842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49871 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3772:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  49874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49889 */     GIR_RootConstrainSelectedInstOperands,
     /*  49890 */     // GIR_Coverage, 802,
     /*  49890 */     GIR_EraseRootFromParent_Done,
     /*  49891 */   // Label 1093: @49891
     /*  49891 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(49945), // Rule ID 803 //
     /*  49896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49925 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3772:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  49928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49943 */     GIR_RootConstrainSelectedInstOperands,
     /*  49944 */     // GIR_Coverage, 803,
     /*  49944 */     GIR_EraseRootFromParent_Done,
     /*  49945 */   // Label 1094: @49945
     /*  49945 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(49999), // Rule ID 804 //
     /*  49950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49979 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3831:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  49982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49997 */     GIR_RootConstrainSelectedInstOperands,
     /*  49998 */     // GIR_Coverage, 804,
     /*  49998 */     GIR_EraseRootFromParent_Done,
     /*  49999 */   // Label 1095: @49999
     /*  49999 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50053), // Rule ID 805 //
     /*  50004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50033 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3831:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50051 */     GIR_RootConstrainSelectedInstOperands,
     /*  50052 */     // GIR_Coverage, 805,
     /*  50052 */     GIR_EraseRootFromParent_Done,
     /*  50053 */   // Label 1096: @50053
     /*  50053 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50107), // Rule ID 806 //
     /*  50058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50087 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3831:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50105 */     GIR_RootConstrainSelectedInstOperands,
     /*  50106 */     // GIR_Coverage, 806,
     /*  50106 */     GIR_EraseRootFromParent_Done,
     /*  50107 */   // Label 1097: @50107
     /*  50107 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50161), // Rule ID 807 //
     /*  50112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50141 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3831:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50159 */     GIR_RootConstrainSelectedInstOperands,
     /*  50160 */     // GIR_Coverage, 807,
     /*  50160 */     GIR_EraseRootFromParent_Done,
     /*  50161 */   // Label 1098: @50161
     /*  50161 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50215), // Rule ID 808 //
     /*  50166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50195 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3831:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50213 */     GIR_RootConstrainSelectedInstOperands,
     /*  50214 */     // GIR_Coverage, 808,
     /*  50214 */     GIR_EraseRootFromParent_Done,
     /*  50215 */   // Label 1099: @50215
     /*  50215 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50269), // Rule ID 809 //
     /*  50220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50249 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3831:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50267 */     GIR_RootConstrainSelectedInstOperands,
     /*  50268 */     // GIR_Coverage, 809,
     /*  50268 */     GIR_EraseRootFromParent_Done,
     /*  50269 */   // Label 1100: @50269
     /*  50269 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50323), // Rule ID 810 //
     /*  50274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50303 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3832:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50321 */     GIR_RootConstrainSelectedInstOperands,
     /*  50322 */     // GIR_Coverage, 810,
     /*  50322 */     GIR_EraseRootFromParent_Done,
     /*  50323 */   // Label 1101: @50323
     /*  50323 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50377), // Rule ID 811 //
     /*  50328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50357 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3832:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50375 */     GIR_RootConstrainSelectedInstOperands,
     /*  50376 */     // GIR_Coverage, 811,
     /*  50376 */     GIR_EraseRootFromParent_Done,
     /*  50377 */   // Label 1102: @50377
     /*  50377 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50431), // Rule ID 812 //
     /*  50382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50411 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3832:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50429 */     GIR_RootConstrainSelectedInstOperands,
     /*  50430 */     // GIR_Coverage, 812,
     /*  50430 */     GIR_EraseRootFromParent_Done,
     /*  50431 */   // Label 1103: @50431
     /*  50431 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50485), // Rule ID 813 //
     /*  50436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50465 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3832:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50483 */     GIR_RootConstrainSelectedInstOperands,
     /*  50484 */     // GIR_Coverage, 813,
     /*  50484 */     GIR_EraseRootFromParent_Done,
     /*  50485 */   // Label 1104: @50485
     /*  50485 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50539), // Rule ID 814 //
     /*  50490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50519 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3832:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50537 */     GIR_RootConstrainSelectedInstOperands,
     /*  50538 */     // GIR_Coverage, 814,
     /*  50538 */     GIR_EraseRootFromParent_Done,
     /*  50539 */   // Label 1105: @50539
     /*  50539 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(50593), // Rule ID 815 //
     /*  50544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50573 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3832:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50591 */     GIR_RootConstrainSelectedInstOperands,
     /*  50592 */     // GIR_Coverage, 815,
     /*  50592 */     GIR_EraseRootFromParent_Done,
     /*  50593 */   // Label 1106: @50593
     /*  50593 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(50647), // Rule ID 832 //
     /*  50598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50627 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3828:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50645 */     GIR_RootConstrainSelectedInstOperands,
     /*  50646 */     // GIR_Coverage, 832,
     /*  50646 */     GIR_EraseRootFromParent_Done,
     /*  50647 */   // Label 1107: @50647
     /*  50647 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(50701), // Rule ID 833 //
     /*  50652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50681 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3828:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50699 */     GIR_RootConstrainSelectedInstOperands,
     /*  50700 */     // GIR_Coverage, 833,
     /*  50700 */     GIR_EraseRootFromParent_Done,
     /*  50701 */   // Label 1108: @50701
     /*  50701 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(50755), // Rule ID 834 //
     /*  50706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50735 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3828:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50753 */     GIR_RootConstrainSelectedInstOperands,
     /*  50754 */     // GIR_Coverage, 834,
     /*  50754 */     GIR_EraseRootFromParent_Done,
     /*  50755 */   // Label 1109: @50755
     /*  50755 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(50809), // Rule ID 841 //
     /*  50760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50789 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3797:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  50792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50807 */     GIR_RootConstrainSelectedInstOperands,
     /*  50808 */     // GIR_Coverage, 841,
     /*  50808 */     GIR_EraseRootFromParent_Done,
     /*  50809 */   // Label 1110: @50809
     /*  50809 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(50863), // Rule ID 842 //
     /*  50814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50843 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3797:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  50846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50861 */     GIR_RootConstrainSelectedInstOperands,
     /*  50862 */     // GIR_Coverage, 842,
     /*  50862 */     GIR_EraseRootFromParent_Done,
     /*  50863 */   // Label 1111: @50863
     /*  50863 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(50917), // Rule ID 855 //
     /*  50868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50897 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3808:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  50900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50915 */     GIR_RootConstrainSelectedInstOperands,
     /*  50916 */     // GIR_Coverage, 855,
     /*  50916 */     GIR_EraseRootFromParent_Done,
     /*  50917 */   // Label 1112: @50917
     /*  50917 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(50971), // Rule ID 856 //
     /*  50922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50951 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3808:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  50954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50969 */     GIR_RootConstrainSelectedInstOperands,
     /*  50970 */     // GIR_Coverage, 856,
     /*  50970 */     GIR_EraseRootFromParent_Done,
     /*  50971 */   // Label 1113: @50971
     /*  50971 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51025), // Rule ID 857 //
     /*  50976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51005 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3808:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51023 */     GIR_RootConstrainSelectedInstOperands,
     /*  51024 */     // GIR_Coverage, 857,
     /*  51024 */     GIR_EraseRootFromParent_Done,
     /*  51025 */   // Label 1114: @51025
     /*  51025 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51079), // Rule ID 858 //
     /*  51030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51059 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3808:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51077 */     GIR_RootConstrainSelectedInstOperands,
     /*  51078 */     // GIR_Coverage, 858,
     /*  51078 */     GIR_EraseRootFromParent_Done,
     /*  51079 */   // Label 1115: @51079
     /*  51079 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51133), // Rule ID 863 //
     /*  51084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51113 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51131 */     GIR_RootConstrainSelectedInstOperands,
     /*  51132 */     // GIR_Coverage, 863,
     /*  51132 */     GIR_EraseRootFromParent_Done,
     /*  51133 */   // Label 1116: @51133
     /*  51133 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51187), // Rule ID 864 //
     /*  51138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51167 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51185 */     GIR_RootConstrainSelectedInstOperands,
     /*  51186 */     // GIR_Coverage, 864,
     /*  51186 */     GIR_EraseRootFromParent_Done,
     /*  51187 */   // Label 1117: @51187
     /*  51187 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51241), // Rule ID 865 //
     /*  51192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51221 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51239 */     GIR_RootConstrainSelectedInstOperands,
     /*  51240 */     // GIR_Coverage, 865,
     /*  51240 */     GIR_EraseRootFromParent_Done,
     /*  51241 */   // Label 1118: @51241
     /*  51241 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51295), // Rule ID 866 //
     /*  51246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51275 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51293 */     GIR_RootConstrainSelectedInstOperands,
     /*  51294 */     // GIR_Coverage, 866,
     /*  51294 */     GIR_EraseRootFromParent_Done,
     /*  51295 */   // Label 1119: @51295
     /*  51295 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51349), // Rule ID 877 //
     /*  51300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51329 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3794:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51347 */     GIR_RootConstrainSelectedInstOperands,
     /*  51348 */     // GIR_Coverage, 877,
     /*  51348 */     GIR_EraseRootFromParent_Done,
     /*  51349 */   // Label 1120: @51349
     /*  51349 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51394), // Rule ID 878 //
     /*  51354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51383 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3794:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51392 */     GIR_RootConstrainSelectedInstOperands,
     /*  51393 */     // GIR_Coverage, 878,
     /*  51393 */     GIR_EraseRootFromParent_Done,
     /*  51394 */   // Label 1121: @51394
     /*  51394 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51448), // Rule ID 883 //
     /*  51399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51428 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51446 */     GIR_RootConstrainSelectedInstOperands,
     /*  51447 */     // GIR_Coverage, 883,
     /*  51447 */     GIR_EraseRootFromParent_Done,
     /*  51448 */   // Label 1122: @51448
     /*  51448 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51502), // Rule ID 884 //
     /*  51453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51482 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51500 */     GIR_RootConstrainSelectedInstOperands,
     /*  51501 */     // GIR_Coverage, 884,
     /*  51501 */     GIR_EraseRootFromParent_Done,
     /*  51502 */   // Label 1123: @51502
     /*  51502 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51556), // Rule ID 996 //
     /*  51507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3773:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51554 */     GIR_RootConstrainSelectedInstOperands,
     /*  51555 */     // GIR_Coverage, 996,
     /*  51555 */     GIR_EraseRootFromParent_Done,
     /*  51556 */   // Label 1124: @51556
     /*  51556 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(51610), // Rule ID 997 //
     /*  51561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51590 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3773:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51608 */     GIR_RootConstrainSelectedInstOperands,
     /*  51609 */     // GIR_Coverage, 997,
     /*  51609 */     GIR_EraseRootFromParent_Done,
     /*  51610 */   // Label 1125: @51610
     /*  51610 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(51664), // Rule ID 998 //
     /*  51615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51644 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3773:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51662 */     GIR_RootConstrainSelectedInstOperands,
     /*  51663 */     // GIR_Coverage, 998,
     /*  51663 */     GIR_EraseRootFromParent_Done,
     /*  51664 */   // Label 1126: @51664
     /*  51664 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(51718), // Rule ID 999 //
     /*  51669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51698 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3773:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51716 */     GIR_RootConstrainSelectedInstOperands,
     /*  51717 */     // GIR_Coverage, 999,
     /*  51717 */     GIR_EraseRootFromParent_Done,
     /*  51718 */   // Label 1127: @51718
     /*  51718 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(51772), // Rule ID 1000 //
     /*  51723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51752 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3773:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51770 */     GIR_RootConstrainSelectedInstOperands,
     /*  51771 */     // GIR_Coverage, 1000,
     /*  51771 */     GIR_EraseRootFromParent_Done,
     /*  51772 */   // Label 1128: @51772
     /*  51772 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(51826), // Rule ID 1001 //
     /*  51777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51806 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3773:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  51809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51824 */     GIR_RootConstrainSelectedInstOperands,
     /*  51825 */     // GIR_Coverage, 1001,
     /*  51825 */     GIR_EraseRootFromParent_Done,
     /*  51826 */   // Label 1129: @51826
     /*  51826 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(51880), // Rule ID 1002 //
     /*  51831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51860 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  51863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51878 */     GIR_RootConstrainSelectedInstOperands,
     /*  51879 */     // GIR_Coverage, 1002,
     /*  51879 */     GIR_EraseRootFromParent_Done,
     /*  51880 */   // Label 1130: @51880
     /*  51880 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(51934), // Rule ID 1003 //
     /*  51885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51914 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  51917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51932 */     GIR_RootConstrainSelectedInstOperands,
     /*  51933 */     // GIR_Coverage, 1003,
     /*  51933 */     GIR_EraseRootFromParent_Done,
     /*  51934 */   // Label 1131: @51934
     /*  51934 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(51988), // Rule ID 1004 //
     /*  51939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51968 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3774:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  51971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51986 */     GIR_RootConstrainSelectedInstOperands,
     /*  51987 */     // GIR_Coverage, 1004,
     /*  51987 */     GIR_EraseRootFromParent_Done,
     /*  51988 */   // Label 1132: @51988
     /*  51988 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52042), // Rule ID 1005 //
     /*  51993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52022 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3774:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52040 */     GIR_RootConstrainSelectedInstOperands,
     /*  52041 */     // GIR_Coverage, 1005,
     /*  52041 */     GIR_EraseRootFromParent_Done,
     /*  52042 */   // Label 1133: @52042
     /*  52042 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52096), // Rule ID 1006 //
     /*  52047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52076 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3774:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52094 */     GIR_RootConstrainSelectedInstOperands,
     /*  52095 */     // GIR_Coverage, 1006,
     /*  52095 */     GIR_EraseRootFromParent_Done,
     /*  52096 */   // Label 1134: @52096
     /*  52096 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52150), // Rule ID 1007 //
     /*  52101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52130 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3774:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52148 */     GIR_RootConstrainSelectedInstOperands,
     /*  52149 */     // GIR_Coverage, 1007,
     /*  52149 */     GIR_EraseRootFromParent_Done,
     /*  52150 */   // Label 1135: @52150
     /*  52150 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52204), // Rule ID 1024 //
     /*  52155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52184 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3840:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52202 */     GIR_RootConstrainSelectedInstOperands,
     /*  52203 */     // GIR_Coverage, 1024,
     /*  52203 */     GIR_EraseRootFromParent_Done,
     /*  52204 */   // Label 1136: @52204
     /*  52204 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52258), // Rule ID 1025 //
     /*  52209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52238 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3840:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52256 */     GIR_RootConstrainSelectedInstOperands,
     /*  52257 */     // GIR_Coverage, 1025,
     /*  52257 */     GIR_EraseRootFromParent_Done,
     /*  52258 */   // Label 1137: @52258
     /*  52258 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52312), // Rule ID 1026 //
     /*  52263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52292 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3840:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52310 */     GIR_RootConstrainSelectedInstOperands,
     /*  52311 */     // GIR_Coverage, 1026,
     /*  52311 */     GIR_EraseRootFromParent_Done,
     /*  52312 */   // Label 1138: @52312
     /*  52312 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52366), // Rule ID 1119 //
     /*  52317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52346 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3749:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52364 */     GIR_RootConstrainSelectedInstOperands,
     /*  52365 */     // GIR_Coverage, 1119,
     /*  52365 */     GIR_EraseRootFromParent_Done,
     /*  52366 */   // Label 1139: @52366
     /*  52366 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52420), // Rule ID 1120 //
     /*  52371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52400 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3749:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52418 */     GIR_RootConstrainSelectedInstOperands,
     /*  52419 */     // GIR_Coverage, 1120,
     /*  52419 */     GIR_EraseRootFromParent_Done,
     /*  52420 */   // Label 1140: @52420
     /*  52420 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52474), // Rule ID 1121 //
     /*  52425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52454 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3749:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52472 */     GIR_RootConstrainSelectedInstOperands,
     /*  52473 */     // GIR_Coverage, 1121,
     /*  52473 */     GIR_EraseRootFromParent_Done,
     /*  52474 */   // Label 1141: @52474
     /*  52474 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52528), // Rule ID 1122 //
     /*  52479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3749:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52526 */     GIR_RootConstrainSelectedInstOperands,
     /*  52527 */     // GIR_Coverage, 1122,
     /*  52527 */     GIR_EraseRootFromParent_Done,
     /*  52528 */   // Label 1142: @52528
     /*  52528 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(52582), // Rule ID 1123 //
     /*  52533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52562 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3750:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52580 */     GIR_RootConstrainSelectedInstOperands,
     /*  52581 */     // GIR_Coverage, 1123,
     /*  52581 */     GIR_EraseRootFromParent_Done,
     /*  52582 */   // Label 1143: @52582
     /*  52582 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(52636), // Rule ID 1124 //
     /*  52587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52616 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3750:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52634 */     GIR_RootConstrainSelectedInstOperands,
     /*  52635 */     // GIR_Coverage, 1124,
     /*  52635 */     GIR_EraseRootFromParent_Done,
     /*  52636 */   // Label 1144: @52636
     /*  52636 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(52690), // Rule ID 1125 //
     /*  52641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52670 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3750:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52688 */     GIR_RootConstrainSelectedInstOperands,
     /*  52689 */     // GIR_Coverage, 1125,
     /*  52689 */     GIR_EraseRootFromParent_Done,
     /*  52690 */   // Label 1145: @52690
     /*  52690 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(52744), // Rule ID 1126 //
     /*  52695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52724 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3750:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52742 */     GIR_RootConstrainSelectedInstOperands,
     /*  52743 */     // GIR_Coverage, 1126,
     /*  52743 */     GIR_EraseRootFromParent_Done,
     /*  52744 */   // Label 1146: @52744
     /*  52744 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(52798), // Rule ID 1169 //
     /*  52749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52778 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3746:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52796 */     GIR_RootConstrainSelectedInstOperands,
     /*  52797 */     // GIR_Coverage, 1169,
     /*  52797 */     GIR_EraseRootFromParent_Done,
     /*  52798 */   // Label 1147: @52798
     /*  52798 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(52852), // Rule ID 1170 //
     /*  52803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52832 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3746:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  52835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52850 */     GIR_RootConstrainSelectedInstOperands,
     /*  52851 */     // GIR_Coverage, 1170,
     /*  52851 */     GIR_EraseRootFromParent_Done,
     /*  52852 */   // Label 1148: @52852
     /*  52852 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(52906), // Rule ID 1171 //
     /*  52857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52886 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3746:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  52889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52904 */     GIR_RootConstrainSelectedInstOperands,
     /*  52905 */     // GIR_Coverage, 1171,
     /*  52905 */     GIR_EraseRootFromParent_Done,
     /*  52906 */   // Label 1149: @52906
     /*  52906 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(52960), // Rule ID 1172 //
     /*  52911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52940 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3746:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  52943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52958 */     GIR_RootConstrainSelectedInstOperands,
     /*  52959 */     // GIR_Coverage, 1172,
     /*  52959 */     GIR_EraseRootFromParent_Done,
     /*  52960 */   // Label 1150: @52960
     /*  52960 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53014), // Rule ID 1237 //
     /*  52965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52994 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3800:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  52997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53012 */     GIR_RootConstrainSelectedInstOperands,
     /*  53013 */     // GIR_Coverage, 1237,
     /*  53013 */     GIR_EraseRootFromParent_Done,
     /*  53014 */   // Label 1151: @53014
     /*  53014 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53068), // Rule ID 1238 //
     /*  53019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53048 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53066 */     GIR_RootConstrainSelectedInstOperands,
     /*  53067 */     // GIR_Coverage, 1238,
     /*  53067 */     GIR_EraseRootFromParent_Done,
     /*  53068 */   // Label 1152: @53068
     /*  53068 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53122), // Rule ID 1239 //
     /*  53073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53102 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53120 */     GIR_RootConstrainSelectedInstOperands,
     /*  53121 */     // GIR_Coverage, 1239,
     /*  53121 */     GIR_EraseRootFromParent_Done,
     /*  53122 */   // Label 1153: @53122
     /*  53122 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53176), // Rule ID 1240 //
     /*  53127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53156 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53174 */     GIR_RootConstrainSelectedInstOperands,
     /*  53175 */     // GIR_Coverage, 1240,
     /*  53175 */     GIR_EraseRootFromParent_Done,
     /*  53176 */   // Label 1154: @53176
     /*  53176 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53230), // Rule ID 1241 //
     /*  53181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53210 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53228 */     GIR_RootConstrainSelectedInstOperands,
     /*  53229 */     // GIR_Coverage, 1241,
     /*  53229 */     GIR_EraseRootFromParent_Done,
     /*  53230 */   // Label 1155: @53230
     /*  53230 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53284), // Rule ID 1254 //
     /*  53235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53282 */     GIR_RootConstrainSelectedInstOperands,
     /*  53283 */     // GIR_Coverage, 1254,
     /*  53283 */     GIR_EraseRootFromParent_Done,
     /*  53284 */   // Label 1156: @53284
     /*  53284 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53338), // Rule ID 1255 //
     /*  53289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53318 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53336 */     GIR_RootConstrainSelectedInstOperands,
     /*  53337 */     // GIR_Coverage, 1255,
     /*  53337 */     GIR_EraseRootFromParent_Done,
     /*  53338 */   // Label 1157: @53338
     /*  53338 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53392), // Rule ID 1256 //
     /*  53343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53372 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53390 */     GIR_RootConstrainSelectedInstOperands,
     /*  53391 */     // GIR_Coverage, 1256,
     /*  53391 */     GIR_EraseRootFromParent_Done,
     /*  53392 */   // Label 1158: @53392
     /*  53392 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53446), // Rule ID 1257 //
     /*  53397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53426 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3798:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53431 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53444 */     GIR_RootConstrainSelectedInstOperands,
     /*  53445 */     // GIR_Coverage, 1257,
     /*  53445 */     GIR_EraseRootFromParent_Done,
     /*  53446 */   // Label 1159: @53446
     /*  53446 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53500), // Rule ID 1258 //
     /*  53451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53480 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53498 */     GIR_RootConstrainSelectedInstOperands,
     /*  53499 */     // GIR_Coverage, 1258,
     /*  53499 */     GIR_EraseRootFromParent_Done,
     /*  53500 */   // Label 1160: @53500
     /*  53500 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53554), // Rule ID 1259 //
     /*  53505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53534 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53539 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53552 */     GIR_RootConstrainSelectedInstOperands,
     /*  53553 */     // GIR_Coverage, 1259,
     /*  53553 */     GIR_EraseRootFromParent_Done,
     /*  53554 */   // Label 1161: @53554
     /*  53554 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(53608), // Rule ID 1260 //
     /*  53559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53588 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3799:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53606 */     GIR_RootConstrainSelectedInstOperands,
     /*  53607 */     // GIR_Coverage, 1260,
     /*  53607 */     GIR_EraseRootFromParent_Done,
     /*  53608 */   // Label 1162: @53608
     /*  53608 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(53662), // Rule ID 1261 //
     /*  53613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53642 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3799:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53660 */     GIR_RootConstrainSelectedInstOperands,
     /*  53661 */     // GIR_Coverage, 1261,
     /*  53661 */     GIR_EraseRootFromParent_Done,
     /*  53662 */   // Label 1163: @53662
     /*  53662 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(53716), // Rule ID 1262 //
     /*  53667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53696 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3799:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53714 */     GIR_RootConstrainSelectedInstOperands,
     /*  53715 */     // GIR_Coverage, 1262,
     /*  53715 */     GIR_EraseRootFromParent_Done,
     /*  53716 */   // Label 1164: @53716
     /*  53716 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(53770), // Rule ID 1263 //
     /*  53721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53750 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3799:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53755 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53768 */     GIR_RootConstrainSelectedInstOperands,
     /*  53769 */     // GIR_Coverage, 1263,
     /*  53769 */     GIR_EraseRootFromParent_Done,
     /*  53770 */   // Label 1165: @53770
     /*  53770 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(53824), // Rule ID 1264 //
     /*  53775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3799:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  53807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53822 */     GIR_RootConstrainSelectedInstOperands,
     /*  53823 */     // GIR_Coverage, 1264,
     /*  53823 */     GIR_EraseRootFromParent_Done,
     /*  53824 */   // Label 1166: @53824
     /*  53824 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(53878), // Rule ID 1265 //
     /*  53829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53858 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3799:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  53861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53876 */     GIR_RootConstrainSelectedInstOperands,
     /*  53877 */     // GIR_Coverage, 1265,
     /*  53877 */     GIR_EraseRootFromParent_Done,
     /*  53878 */   // Label 1167: @53878
     /*  53878 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(53932), // Rule ID 1266 //
     /*  53883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53912 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3803:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  53915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53930 */     GIR_RootConstrainSelectedInstOperands,
     /*  53931 */     // GIR_Coverage, 1266,
     /*  53931 */     GIR_EraseRootFromParent_Done,
     /*  53932 */   // Label 1168: @53932
     /*  53932 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(53986), // Rule ID 1267 //
     /*  53937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53966 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  53969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53984 */     GIR_RootConstrainSelectedInstOperands,
     /*  53985 */     // GIR_Coverage, 1267,
     /*  53985 */     GIR_EraseRootFromParent_Done,
     /*  53986 */   // Label 1169: @53986
     /*  53986 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54040), // Rule ID 1268 //
     /*  53991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54020 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54038 */     GIR_RootConstrainSelectedInstOperands,
     /*  54039 */     // GIR_Coverage, 1268,
     /*  54039 */     GIR_EraseRootFromParent_Done,
     /*  54040 */   // Label 1170: @54040
     /*  54040 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54094), // Rule ID 1269 //
     /*  54045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54074 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3804:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54092 */     GIR_RootConstrainSelectedInstOperands,
     /*  54093 */     // GIR_Coverage, 1269,
     /*  54093 */     GIR_EraseRootFromParent_Done,
     /*  54094 */   // Label 1171: @54094
     /*  54094 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54148), // Rule ID 1270 //
     /*  54099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54128 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54146 */     GIR_RootConstrainSelectedInstOperands,
     /*  54147 */     // GIR_Coverage, 1270,
     /*  54147 */     GIR_EraseRootFromParent_Done,
     /*  54148 */   // Label 1172: @54148
     /*  54148 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54202), // Rule ID 1271 //
     /*  54153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54182 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54200 */     GIR_RootConstrainSelectedInstOperands,
     /*  54201 */     // GIR_Coverage, 1271,
     /*  54201 */     GIR_EraseRootFromParent_Done,
     /*  54202 */   // Label 1173: @54202
     /*  54202 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54256), // Rule ID 1272 //
     /*  54207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54236 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54254 */     GIR_RootConstrainSelectedInstOperands,
     /*  54255 */     // GIR_Coverage, 1272,
     /*  54255 */     GIR_EraseRootFromParent_Done,
     /*  54256 */   // Label 1174: @54256
     /*  54256 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54310), // Rule ID 1273 //
     /*  54261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54290 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54308 */     GIR_RootConstrainSelectedInstOperands,
     /*  54309 */     // GIR_Coverage, 1273,
     /*  54309 */     GIR_EraseRootFromParent_Done,
     /*  54310 */   // Label 1175: @54310
     /*  54310 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54364), // Rule ID 1274 //
     /*  54315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54344 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3805:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54362 */     GIR_RootConstrainSelectedInstOperands,
     /*  54363 */     // GIR_Coverage, 1274,
     /*  54363 */     GIR_EraseRootFromParent_Done,
     /*  54364 */   // Label 1176: @54364
     /*  54364 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54418), // Rule ID 1275 //
     /*  54369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54398 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54416 */     GIR_RootConstrainSelectedInstOperands,
     /*  54417 */     // GIR_Coverage, 1275,
     /*  54417 */     GIR_EraseRootFromParent_Done,
     /*  54418 */   // Label 1177: @54418
     /*  54418 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54472), // Rule ID 1276 //
     /*  54423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54452 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54470 */     GIR_RootConstrainSelectedInstOperands,
     /*  54471 */     // GIR_Coverage, 1276,
     /*  54471 */     GIR_EraseRootFromParent_Done,
     /*  54472 */   // Label 1178: @54472
     /*  54472 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54526), // Rule ID 1277 //
     /*  54477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54506 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3806:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54524 */     GIR_RootConstrainSelectedInstOperands,
     /*  54525 */     // GIR_Coverage, 1277,
     /*  54525 */     GIR_EraseRootFromParent_Done,
     /*  54526 */   // Label 1179: @54526
     /*  54526 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(54580), // Rule ID 1278 //
     /*  54531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54560 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3806:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54578 */     GIR_RootConstrainSelectedInstOperands,
     /*  54579 */     // GIR_Coverage, 1278,
     /*  54579 */     GIR_EraseRootFromParent_Done,
     /*  54580 */   // Label 1180: @54580
     /*  54580 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(54634), // Rule ID 1279 //
     /*  54585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54614 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3806:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54632 */     GIR_RootConstrainSelectedInstOperands,
     /*  54633 */     // GIR_Coverage, 1279,
     /*  54633 */     GIR_EraseRootFromParent_Done,
     /*  54634 */   // Label 1181: @54634
     /*  54634 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(54688), // Rule ID 1280 //
     /*  54639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54668 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54686 */     GIR_RootConstrainSelectedInstOperands,
     /*  54687 */     // GIR_Coverage, 1280,
     /*  54687 */     GIR_EraseRootFromParent_Done,
     /*  54688 */   // Label 1182: @54688
     /*  54688 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(54742), // Rule ID 1281 //
     /*  54693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54722 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54740 */     GIR_RootConstrainSelectedInstOperands,
     /*  54741 */     // GIR_Coverage, 1281,
     /*  54741 */     GIR_EraseRootFromParent_Done,
     /*  54742 */   // Label 1183: @54742
     /*  54742 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(54796), // Rule ID 1288 //
     /*  54747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54776 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3830:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54794 */     GIR_RootConstrainSelectedInstOperands,
     /*  54795 */     // GIR_Coverage, 1288,
     /*  54795 */     GIR_EraseRootFromParent_Done,
     /*  54796 */   // Label 1184: @54796
     /*  54796 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(54850), // Rule ID 1289 //
     /*  54801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54830 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3830:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  54830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  54833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54848 */     GIR_RootConstrainSelectedInstOperands,
     /*  54849 */     // GIR_Coverage, 1289,
     /*  54849 */     GIR_EraseRootFromParent_Done,
     /*  54850 */   // Label 1185: @54850
     /*  54850 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(54904), // Rule ID 1290 //
     /*  54855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54884 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3830:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  54887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54902 */     GIR_RootConstrainSelectedInstOperands,
     /*  54903 */     // GIR_Coverage, 1290,
     /*  54903 */     GIR_EraseRootFromParent_Done,
     /*  54904 */   // Label 1186: @54904
     /*  54904 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(54958), // Rule ID 1291 //
     /*  54909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54938 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3830:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  54938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  54941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54956 */     GIR_RootConstrainSelectedInstOperands,
     /*  54957 */     // GIR_Coverage, 1291,
     /*  54957 */     GIR_EraseRootFromParent_Done,
     /*  54958 */   // Label 1187: @54958
     /*  54958 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55012), // Rule ID 1298 //
     /*  54963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54992 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3839:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  54995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55010 */     GIR_RootConstrainSelectedInstOperands,
     /*  55011 */     // GIR_Coverage, 1298,
     /*  55011 */     GIR_EraseRootFromParent_Done,
     /*  55012 */   // Label 1188: @55012
     /*  55012 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55066), // Rule ID 1299 //
     /*  55017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55046 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3839:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55064 */     GIR_RootConstrainSelectedInstOperands,
     /*  55065 */     // GIR_Coverage, 1299,
     /*  55065 */     GIR_EraseRootFromParent_Done,
     /*  55066 */   // Label 1189: @55066
     /*  55066 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55120), // Rule ID 1300 //
     /*  55071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55100 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3839:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55118 */     GIR_RootConstrainSelectedInstOperands,
     /*  55119 */     // GIR_Coverage, 1300,
     /*  55119 */     GIR_EraseRootFromParent_Done,
     /*  55120 */   // Label 1190: @55120
     /*  55120 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55174), // Rule ID 1301 //
     /*  55125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55154 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3839:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55172 */     GIR_RootConstrainSelectedInstOperands,
     /*  55173 */     // GIR_Coverage, 1301,
     /*  55173 */     GIR_EraseRootFromParent_Done,
     /*  55174 */   // Label 1191: @55174
     /*  55174 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55228), // Rule ID 1302 //
     /*  55179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55208 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3842:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55226 */     GIR_RootConstrainSelectedInstOperands,
     /*  55227 */     // GIR_Coverage, 1302,
     /*  55227 */     GIR_EraseRootFromParent_Done,
     /*  55228 */   // Label 1192: @55228
     /*  55228 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55282), // Rule ID 1303 //
     /*  55233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55262 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3842:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55280 */     GIR_RootConstrainSelectedInstOperands,
     /*  55281 */     // GIR_Coverage, 1303,
     /*  55281 */     GIR_EraseRootFromParent_Done,
     /*  55282 */   // Label 1193: @55282
     /*  55282 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55336), // Rule ID 1304 //
     /*  55287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55316 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3842:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55334 */     GIR_RootConstrainSelectedInstOperands,
     /*  55335 */     // GIR_Coverage, 1304,
     /*  55335 */     GIR_EraseRootFromParent_Done,
     /*  55336 */   // Label 1194: @55336
     /*  55336 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55390), // Rule ID 1305 //
     /*  55341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55370 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3842:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55388 */     GIR_RootConstrainSelectedInstOperands,
     /*  55389 */     // GIR_Coverage, 1305,
     /*  55389 */     GIR_EraseRootFromParent_Done,
     /*  55390 */   // Label 1195: @55390
     /*  55390 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55444), // Rule ID 1306 //
     /*  55395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55424 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3842:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55442 */     GIR_RootConstrainSelectedInstOperands,
     /*  55443 */     // GIR_Coverage, 1306,
     /*  55443 */     GIR_EraseRootFromParent_Done,
     /*  55444 */   // Label 1196: @55444
     /*  55444 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55498), // Rule ID 1307 //
     /*  55449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55478 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3842:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55496 */     GIR_RootConstrainSelectedInstOperands,
     /*  55497 */     // GIR_Coverage, 1307,
     /*  55497 */     GIR_EraseRootFromParent_Done,
     /*  55498 */   // Label 1197: @55498
     /*  55498 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55552), // Rule ID 1308 //
     /*  55503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55532 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3842:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55550 */     GIR_RootConstrainSelectedInstOperands,
     /*  55551 */     // GIR_Coverage, 1308,
     /*  55551 */     GIR_EraseRootFromParent_Done,
     /*  55552 */   // Label 1198: @55552
     /*  55552 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(55606), // Rule ID 1309 //
     /*  55557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55586 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3842:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55604 */     GIR_RootConstrainSelectedInstOperands,
     /*  55605 */     // GIR_Coverage, 1309,
     /*  55605 */     GIR_EraseRootFromParent_Done,
     /*  55606 */   // Label 1199: @55606
     /*  55606 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(55660), // Rule ID 1310 //
     /*  55611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55640 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3843:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55658 */     GIR_RootConstrainSelectedInstOperands,
     /*  55659 */     // GIR_Coverage, 1310,
     /*  55659 */     GIR_EraseRootFromParent_Done,
     /*  55660 */   // Label 1200: @55660
     /*  55660 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(55714), // Rule ID 1311 //
     /*  55665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55694 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3843:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55712 */     GIR_RootConstrainSelectedInstOperands,
     /*  55713 */     // GIR_Coverage, 1311,
     /*  55713 */     GIR_EraseRootFromParent_Done,
     /*  55714 */   // Label 1201: @55714
     /*  55714 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(55768), // Rule ID 1312 //
     /*  55719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55748 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3843:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55766 */     GIR_RootConstrainSelectedInstOperands,
     /*  55767 */     // GIR_Coverage, 1312,
     /*  55767 */     GIR_EraseRootFromParent_Done,
     /*  55768 */   // Label 1202: @55768
     /*  55768 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(55822), // Rule ID 1313 //
     /*  55773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55802 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3843:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  55805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55820 */     GIR_RootConstrainSelectedInstOperands,
     /*  55821 */     // GIR_Coverage, 1313,
     /*  55821 */     GIR_EraseRootFromParent_Done,
     /*  55822 */   // Label 1203: @55822
     /*  55822 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(55876), // Rule ID 1314 //
     /*  55827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55856 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3843:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  55859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55874 */     GIR_RootConstrainSelectedInstOperands,
     /*  55875 */     // GIR_Coverage, 1314,
     /*  55875 */     GIR_EraseRootFromParent_Done,
     /*  55876 */   // Label 1204: @55876
     /*  55876 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(55930), // Rule ID 1315 //
     /*  55881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55910 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3843:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  55913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55928 */     GIR_RootConstrainSelectedInstOperands,
     /*  55929 */     // GIR_Coverage, 1315,
     /*  55929 */     GIR_EraseRootFromParent_Done,
     /*  55930 */   // Label 1205: @55930
     /*  55930 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(55984), // Rule ID 1316 //
     /*  55935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55964 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3843:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  55967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55982 */     GIR_RootConstrainSelectedInstOperands,
     /*  55983 */     // GIR_Coverage, 1316,
     /*  55983 */     GIR_EraseRootFromParent_Done,
     /*  55984 */   // Label 1206: @55984
     /*  55984 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56038), // Rule ID 1317 //
     /*  55989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56018 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3843:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56036 */     GIR_RootConstrainSelectedInstOperands,
     /*  56037 */     // GIR_Coverage, 1317,
     /*  56037 */     GIR_EraseRootFromParent_Done,
     /*  56038 */   // Label 1207: @56038
     /*  56038 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56092), // Rule ID 1351 //
     /*  56043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56072 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3836:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56090 */     GIR_RootConstrainSelectedInstOperands,
     /*  56091 */     // GIR_Coverage, 1351,
     /*  56091 */     GIR_EraseRootFromParent_Done,
     /*  56092 */   // Label 1208: @56092
     /*  56092 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56146), // Rule ID 1352 //
     /*  56097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56126 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3836:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56144 */     GIR_RootConstrainSelectedInstOperands,
     /*  56145 */     // GIR_Coverage, 1352,
     /*  56145 */     GIR_EraseRootFromParent_Done,
     /*  56146 */   // Label 1209: @56146
     /*  56146 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56200), // Rule ID 1353 //
     /*  56151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56180 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3836:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56198 */     GIR_RootConstrainSelectedInstOperands,
     /*  56199 */     // GIR_Coverage, 1353,
     /*  56199 */     GIR_EraseRootFromParent_Done,
     /*  56200 */   // Label 1210: @56200
     /*  56200 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56254), // Rule ID 1354 //
     /*  56205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56234 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3836:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56252 */     GIR_RootConstrainSelectedInstOperands,
     /*  56253 */     // GIR_Coverage, 1354,
     /*  56253 */     GIR_EraseRootFromParent_Done,
     /*  56254 */   // Label 1211: @56254
     /*  56254 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56308), // Rule ID 1355 //
     /*  56259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56288 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3836:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56306 */     GIR_RootConstrainSelectedInstOperands,
     /*  56307 */     // GIR_Coverage, 1355,
     /*  56307 */     GIR_EraseRootFromParent_Done,
     /*  56308 */   // Label 1212: @56308
     /*  56308 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56362), // Rule ID 1356 //
     /*  56313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56342 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3836:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56360 */     GIR_RootConstrainSelectedInstOperands,
     /*  56361 */     // GIR_Coverage, 1356,
     /*  56361 */     GIR_EraseRootFromParent_Done,
     /*  56362 */   // Label 1213: @56362
     /*  56362 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56416), // Rule ID 1357 //
     /*  56367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56396 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3836:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56414 */     GIR_RootConstrainSelectedInstOperands,
     /*  56415 */     // GIR_Coverage, 1357,
     /*  56415 */     GIR_EraseRootFromParent_Done,
     /*  56416 */   // Label 1214: @56416
     /*  56416 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56470), // Rule ID 1358 //
     /*  56421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56450 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3836:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56468 */     GIR_RootConstrainSelectedInstOperands,
     /*  56469 */     // GIR_Coverage, 1358,
     /*  56469 */     GIR_EraseRootFromParent_Done,
     /*  56470 */   // Label 1215: @56470
     /*  56470 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56524), // Rule ID 1359 //
     /*  56475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56504 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3837:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56522 */     GIR_RootConstrainSelectedInstOperands,
     /*  56523 */     // GIR_Coverage, 1359,
     /*  56523 */     GIR_EraseRootFromParent_Done,
     /*  56524 */   // Label 1216: @56524
     /*  56524 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(56578), // Rule ID 1360 //
     /*  56529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56558 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3837:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56576 */     GIR_RootConstrainSelectedInstOperands,
     /*  56577 */     // GIR_Coverage, 1360,
     /*  56577 */     GIR_EraseRootFromParent_Done,
     /*  56578 */   // Label 1217: @56578
     /*  56578 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(56632), // Rule ID 1361 //
     /*  56583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56612 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3837:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56630 */     GIR_RootConstrainSelectedInstOperands,
     /*  56631 */     // GIR_Coverage, 1361,
     /*  56631 */     GIR_EraseRootFromParent_Done,
     /*  56632 */   // Label 1218: @56632
     /*  56632 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(56686), // Rule ID 1362 //
     /*  56637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56666 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3837:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56684 */     GIR_RootConstrainSelectedInstOperands,
     /*  56685 */     // GIR_Coverage, 1362,
     /*  56685 */     GIR_EraseRootFromParent_Done,
     /*  56686 */   // Label 1219: @56686
     /*  56686 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(56740), // Rule ID 1363 //
     /*  56691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56720 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3837:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56738 */     GIR_RootConstrainSelectedInstOperands,
     /*  56739 */     // GIR_Coverage, 1363,
     /*  56739 */     GIR_EraseRootFromParent_Done,
     /*  56740 */   // Label 1220: @56740
     /*  56740 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(56794), // Rule ID 1364 //
     /*  56745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56774 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3837:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56792 */     GIR_RootConstrainSelectedInstOperands,
     /*  56793 */     // GIR_Coverage, 1364,
     /*  56793 */     GIR_EraseRootFromParent_Done,
     /*  56794 */   // Label 1221: @56794
     /*  56794 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(56848), // Rule ID 1365 //
     /*  56799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56828 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3837:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  56831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56846 */     GIR_RootConstrainSelectedInstOperands,
     /*  56847 */     // GIR_Coverage, 1365,
     /*  56847 */     GIR_EraseRootFromParent_Done,
     /*  56848 */   // Label 1222: @56848
     /*  56848 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(56902), // Rule ID 1366 //
     /*  56853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56882 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3837:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  56885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56900 */     GIR_RootConstrainSelectedInstOperands,
     /*  56901 */     // GIR_Coverage, 1366,
     /*  56901 */     GIR_EraseRootFromParent_Done,
     /*  56902 */   // Label 1223: @56902
     /*  56902 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(56956), // Rule ID 1386 //
     /*  56907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56936 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3825:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  56939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56954 */     GIR_RootConstrainSelectedInstOperands,
     /*  56955 */     // GIR_Coverage, 1386,
     /*  56955 */     GIR_EraseRootFromParent_Done,
     /*  56956 */   // Label 1224: @56956
     /*  56956 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57010), // Rule ID 1387 //
     /*  56961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56990 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3825:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  56993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57008 */     GIR_RootConstrainSelectedInstOperands,
     /*  57009 */     // GIR_Coverage, 1387,
     /*  57009 */     GIR_EraseRootFromParent_Done,
     /*  57010 */   // Label 1225: @57010
     /*  57010 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57064), // Rule ID 1388 //
     /*  57015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57044 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3825:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57062 */     GIR_RootConstrainSelectedInstOperands,
     /*  57063 */     // GIR_Coverage, 1388,
     /*  57063 */     GIR_EraseRootFromParent_Done,
     /*  57064 */   // Label 1226: @57064
     /*  57064 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57118), // Rule ID 1389 //
     /*  57069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57098 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3825:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57116 */     GIR_RootConstrainSelectedInstOperands,
     /*  57117 */     // GIR_Coverage, 1389,
     /*  57117 */     GIR_EraseRootFromParent_Done,
     /*  57118 */   // Label 1227: @57118
     /*  57118 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57172), // Rule ID 1390 //
     /*  57123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57152 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3825:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57170 */     GIR_RootConstrainSelectedInstOperands,
     /*  57171 */     // GIR_Coverage, 1390,
     /*  57171 */     GIR_EraseRootFromParent_Done,
     /*  57172 */   // Label 1228: @57172
     /*  57172 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57226), // Rule ID 1391 //
     /*  57177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57206 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3825:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57224 */     GIR_RootConstrainSelectedInstOperands,
     /*  57225 */     // GIR_Coverage, 1391,
     /*  57225 */     GIR_EraseRootFromParent_Done,
     /*  57226 */   // Label 1229: @57226
     /*  57226 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57280), // Rule ID 1392 //
     /*  57231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57260 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3825:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57278 */     GIR_RootConstrainSelectedInstOperands,
     /*  57279 */     // GIR_Coverage, 1392,
     /*  57279 */     GIR_EraseRootFromParent_Done,
     /*  57280 */   // Label 1230: @57280
     /*  57280 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57334), // Rule ID 1393 //
     /*  57285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57314 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3825:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57332 */     GIR_RootConstrainSelectedInstOperands,
     /*  57333 */     // GIR_Coverage, 1393,
     /*  57333 */     GIR_EraseRootFromParent_Done,
     /*  57334 */   // Label 1231: @57334
     /*  57334 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57388), // Rule ID 1394 //
     /*  57339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57368 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3827:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57386 */     GIR_RootConstrainSelectedInstOperands,
     /*  57387 */     // GIR_Coverage, 1394,
     /*  57387 */     GIR_EraseRootFromParent_Done,
     /*  57388 */   // Label 1232: @57388
     /*  57388 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57442), // Rule ID 1395 //
     /*  57393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57422 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3827:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57440 */     GIR_RootConstrainSelectedInstOperands,
     /*  57441 */     // GIR_Coverage, 1395,
     /*  57441 */     GIR_EraseRootFromParent_Done,
     /*  57442 */   // Label 1233: @57442
     /*  57442 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57496), // Rule ID 1396 //
     /*  57447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3827:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57494 */     GIR_RootConstrainSelectedInstOperands,
     /*  57495 */     // GIR_Coverage, 1396,
     /*  57495 */     GIR_EraseRootFromParent_Done,
     /*  57496 */   // Label 1234: @57496
     /*  57496 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57550), // Rule ID 1397 //
     /*  57501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57530 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3827:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57548 */     GIR_RootConstrainSelectedInstOperands,
     /*  57549 */     // GIR_Coverage, 1397,
     /*  57549 */     GIR_EraseRootFromParent_Done,
     /*  57550 */   // Label 1235: @57550
     /*  57550 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(57604), // Rule ID 1398 //
     /*  57555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57584 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3827:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57602 */     GIR_RootConstrainSelectedInstOperands,
     /*  57603 */     // GIR_Coverage, 1398,
     /*  57603 */     GIR_EraseRootFromParent_Done,
     /*  57604 */   // Label 1236: @57604
     /*  57604 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(57658), // Rule ID 1399 //
     /*  57609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57638 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3827:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57656 */     GIR_RootConstrainSelectedInstOperands,
     /*  57657 */     // GIR_Coverage, 1399,
     /*  57657 */     GIR_EraseRootFromParent_Done,
     /*  57658 */   // Label 1237: @57658
     /*  57658 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(57712), // Rule ID 1400 //
     /*  57663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57692 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3827:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57710 */     GIR_RootConstrainSelectedInstOperands,
     /*  57711 */     // GIR_Coverage, 1400,
     /*  57711 */     GIR_EraseRootFromParent_Done,
     /*  57712 */   // Label 1238: @57712
     /*  57712 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(57766), // Rule ID 1401 //
     /*  57717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57746 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3827:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57764 */     GIR_RootConstrainSelectedInstOperands,
     /*  57765 */     // GIR_Coverage, 1401,
     /*  57765 */     GIR_EraseRootFromParent_Done,
     /*  57766 */   // Label 1239: @57766
     /*  57766 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(57820), // Rule ID 1435 //
     /*  57771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57800 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3820:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  57803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57818 */     GIR_RootConstrainSelectedInstOperands,
     /*  57819 */     // GIR_Coverage, 1435,
     /*  57819 */     GIR_EraseRootFromParent_Done,
     /*  57820 */   // Label 1240: @57820
     /*  57820 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(57874), // Rule ID 1436 //
     /*  57825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57854 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3820:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  57857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57872 */     GIR_RootConstrainSelectedInstOperands,
     /*  57873 */     // GIR_Coverage, 1436,
     /*  57873 */     GIR_EraseRootFromParent_Done,
     /*  57874 */   // Label 1241: @57874
     /*  57874 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(57928), // Rule ID 1437 //
     /*  57879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57908 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3820:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  57911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57926 */     GIR_RootConstrainSelectedInstOperands,
     /*  57927 */     // GIR_Coverage, 1437,
     /*  57927 */     GIR_EraseRootFromParent_Done,
     /*  57928 */   // Label 1242: @57928
     /*  57928 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(57982), // Rule ID 1438 //
     /*  57933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57962 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3820:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  57965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57980 */     GIR_RootConstrainSelectedInstOperands,
     /*  57981 */     // GIR_Coverage, 1438,
     /*  57981 */     GIR_EraseRootFromParent_Done,
     /*  57982 */   // Label 1243: @57982
     /*  57982 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58036), // Rule ID 1439 //
     /*  57987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58016 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3820:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58034 */     GIR_RootConstrainSelectedInstOperands,
     /*  58035 */     // GIR_Coverage, 1439,
     /*  58035 */     GIR_EraseRootFromParent_Done,
     /*  58036 */   // Label 1244: @58036
     /*  58036 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58090), // Rule ID 1440 //
     /*  58041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58070 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3820:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58088 */     GIR_RootConstrainSelectedInstOperands,
     /*  58089 */     // GIR_Coverage, 1440,
     /*  58089 */     GIR_EraseRootFromParent_Done,
     /*  58090 */   // Label 1245: @58090
     /*  58090 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58144), // Rule ID 1441 //
     /*  58095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58124 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3820:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58142 */     GIR_RootConstrainSelectedInstOperands,
     /*  58143 */     // GIR_Coverage, 1441,
     /*  58143 */     GIR_EraseRootFromParent_Done,
     /*  58144 */   // Label 1246: @58144
     /*  58144 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58198), // Rule ID 1442 //
     /*  58149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58178 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3820:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58196 */     GIR_RootConstrainSelectedInstOperands,
     /*  58197 */     // GIR_Coverage, 1442,
     /*  58197 */     GIR_EraseRootFromParent_Done,
     /*  58198 */   // Label 1247: @58198
     /*  58198 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58252), // Rule ID 1443 //
     /*  58203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58232 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3821:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58250 */     GIR_RootConstrainSelectedInstOperands,
     /*  58251 */     // GIR_Coverage, 1443,
     /*  58251 */     GIR_EraseRootFromParent_Done,
     /*  58252 */   // Label 1248: @58252
     /*  58252 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58306), // Rule ID 1444 //
     /*  58257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58286 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3821:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58304 */     GIR_RootConstrainSelectedInstOperands,
     /*  58305 */     // GIR_Coverage, 1444,
     /*  58305 */     GIR_EraseRootFromParent_Done,
     /*  58306 */   // Label 1249: @58306
     /*  58306 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58360), // Rule ID 1445 //
     /*  58311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58340 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3821:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58358 */     GIR_RootConstrainSelectedInstOperands,
     /*  58359 */     // GIR_Coverage, 1445,
     /*  58359 */     GIR_EraseRootFromParent_Done,
     /*  58360 */   // Label 1250: @58360
     /*  58360 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58414), // Rule ID 1446 //
     /*  58365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58394 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3821:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58412 */     GIR_RootConstrainSelectedInstOperands,
     /*  58413 */     // GIR_Coverage, 1446,
     /*  58413 */     GIR_EraseRootFromParent_Done,
     /*  58414 */   // Label 1251: @58414
     /*  58414 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58468), // Rule ID 1447 //
     /*  58419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58448 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3821:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58466 */     GIR_RootConstrainSelectedInstOperands,
     /*  58467 */     // GIR_Coverage, 1447,
     /*  58467 */     GIR_EraseRootFromParent_Done,
     /*  58468 */   // Label 1252: @58468
     /*  58468 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58522), // Rule ID 1448 //
     /*  58473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58502 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3821:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58520 */     GIR_RootConstrainSelectedInstOperands,
     /*  58521 */     // GIR_Coverage, 1448,
     /*  58521 */     GIR_EraseRootFromParent_Done,
     /*  58522 */   // Label 1253: @58522
     /*  58522 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(58576), // Rule ID 1449 //
     /*  58527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58556 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3821:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58574 */     GIR_RootConstrainSelectedInstOperands,
     /*  58575 */     // GIR_Coverage, 1449,
     /*  58575 */     GIR_EraseRootFromParent_Done,
     /*  58576 */   // Label 1254: @58576
     /*  58576 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(58630), // Rule ID 1450 //
     /*  58581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58610 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3821:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58628 */     GIR_RootConstrainSelectedInstOperands,
     /*  58629 */     // GIR_Coverage, 1450,
     /*  58629 */     GIR_EraseRootFromParent_Done,
     /*  58630 */   // Label 1255: @58630
     /*  58630 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(58675), // Rule ID 1715 //
     /*  58635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58664 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3722:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58673 */     GIR_RootConstrainSelectedInstOperands,
     /*  58674 */     // GIR_Coverage, 1715,
     /*  58674 */     GIR_EraseRootFromParent_Done,
     /*  58675 */   // Label 1256: @58675
     /*  58675 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(58720), // Rule ID 1716 //
     /*  58680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58709 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3723:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58714 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58718 */     GIR_RootConstrainSelectedInstOperands,
     /*  58719 */     // GIR_Coverage, 1716,
     /*  58719 */     GIR_EraseRootFromParent_Done,
     /*  58720 */   // Label 1257: @58720
     /*  58720 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(58765), // Rule ID 1719 //
     /*  58725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58759 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58763 */     GIR_RootConstrainSelectedInstOperands,
     /*  58764 */     // GIR_Coverage, 1719,
     /*  58764 */     GIR_EraseRootFromParent_Done,
     /*  58765 */   // Label 1258: @58765
     /*  58765 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(58810), // Rule ID 1720 //
     /*  58770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58799 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  58802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58808 */     GIR_RootConstrainSelectedInstOperands,
     /*  58809 */     // GIR_Coverage, 1720,
     /*  58809 */     GIR_EraseRootFromParent_Done,
     /*  58810 */   // Label 1259: @58810
     /*  58810 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(58864), // Rule ID 1729 //
     /*  58815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  58823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58844 */     // (intrinsic_wo_chain:{ *:[i32] } 3585:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58849 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58862 */     GIR_RootConstrainSelectedInstOperands,
     /*  58863 */     // GIR_Coverage, 1729,
     /*  58863 */     GIR_EraseRootFromParent_Done,
     /*  58864 */   // Label 1260: @58864
     /*  58864 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(58918), // Rule ID 1730 //
     /*  58869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  58877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58898 */     // (intrinsic_wo_chain:{ *:[i32] } 3592:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  58901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58903 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58916 */     GIR_RootConstrainSelectedInstOperands,
     /*  58917 */     // GIR_Coverage, 1730,
     /*  58917 */     GIR_EraseRootFromParent_Done,
     /*  58918 */   // Label 1261: @58918
     /*  58918 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(58975), // Rule ID 1853 //
     /*  58923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  58931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58952 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  58952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  58955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58957 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  58959 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  58961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58973 */     GIR_RootConstrainSelectedInstOperands,
     /*  58974 */     // GIR_Coverage, 1853,
     /*  58974 */     GIR_EraseRootFromParent_Done,
     /*  58975 */   // Label 1262: @58975
     /*  58975 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59032), // Rule ID 1860 //
     /*  58980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  58988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59009 */     // (intrinsic_wo_chain:{ *:[i32] } 3944:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59014 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59016 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59030 */     GIR_RootConstrainSelectedInstOperands,
     /*  59031 */     // GIR_Coverage, 1860,
     /*  59031 */     GIR_EraseRootFromParent_Done,
     /*  59032 */   // Label 1263: @59032
     /*  59032 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59086), // Rule ID 1907 //
     /*  59037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59066 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59084 */     GIR_RootConstrainSelectedInstOperands,
     /*  59085 */     // GIR_Coverage, 1907,
     /*  59085 */     GIR_EraseRootFromParent_Done,
     /*  59086 */   // Label 1264: @59086
     /*  59086 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59140), // Rule ID 1908 //
     /*  59091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59120 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59138 */     GIR_RootConstrainSelectedInstOperands,
     /*  59139 */     // GIR_Coverage, 1908,
     /*  59139 */     GIR_EraseRootFromParent_Done,
     /*  59140 */   // Label 1265: @59140
     /*  59140 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59194), // Rule ID 1909 //
     /*  59145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59174 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59192 */     GIR_RootConstrainSelectedInstOperands,
     /*  59193 */     // GIR_Coverage, 1909,
     /*  59193 */     GIR_EraseRootFromParent_Done,
     /*  59194 */   // Label 1266: @59194
     /*  59194 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59248), // Rule ID 1910 //
     /*  59199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59228 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59246 */     GIR_RootConstrainSelectedInstOperands,
     /*  59247 */     // GIR_Coverage, 1910,
     /*  59247 */     GIR_EraseRootFromParent_Done,
     /*  59248 */   // Label 1267: @59248
     /*  59248 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59302), // Rule ID 1984 //
     /*  59253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59282 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59287 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59289 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59300 */     GIR_RootConstrainSelectedInstOperands,
     /*  59301 */     // GIR_Coverage, 1984,
     /*  59301 */     GIR_EraseRootFromParent_Done,
     /*  59302 */   // Label 1268: @59302
     /*  59302 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59356), // Rule ID 1985 //
     /*  59307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59336 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59341 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59343 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59354 */     GIR_RootConstrainSelectedInstOperands,
     /*  59355 */     // GIR_Coverage, 1985,
     /*  59355 */     GIR_EraseRootFromParent_Done,
     /*  59356 */   // Label 1269: @59356
     /*  59356 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59410), // Rule ID 1986 //
     /*  59361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59390 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59395 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59397 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59408 */     GIR_RootConstrainSelectedInstOperands,
     /*  59409 */     // GIR_Coverage, 1986,
     /*  59409 */     GIR_EraseRootFromParent_Done,
     /*  59410 */   // Label 1270: @59410
     /*  59410 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59464), // Rule ID 1987 //
     /*  59415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59444 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59449 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59451 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59462 */     GIR_RootConstrainSelectedInstOperands,
     /*  59463 */     // GIR_Coverage, 1987,
     /*  59463 */     GIR_EraseRootFromParent_Done,
     /*  59464 */   // Label 1271: @59464
     /*  59464 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59518), // Rule ID 1988 //
     /*  59469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59498 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59503 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59505 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59516 */     GIR_RootConstrainSelectedInstOperands,
     /*  59517 */     // GIR_Coverage, 1988,
     /*  59517 */     GIR_EraseRootFromParent_Done,
     /*  59518 */   // Label 1272: @59518
     /*  59518 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(59572), // Rule ID 1989 //
     /*  59523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59552 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59557 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59559 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59570 */     GIR_RootConstrainSelectedInstOperands,
     /*  59571 */     // GIR_Coverage, 1989,
     /*  59571 */     GIR_EraseRootFromParent_Done,
     /*  59572 */   // Label 1273: @59572
     /*  59572 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(59629), // Rule ID 2100 //
     /*  59577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59606 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59627 */     GIR_RootConstrainSelectedInstOperands,
     /*  59628 */     // GIR_Coverage, 2100,
     /*  59628 */     GIR_EraseRootFromParent_Done,
     /*  59629 */   // Label 1274: @59629
     /*  59629 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(59683), // Rule ID 2130 //
     /*  59634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59663 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59681 */     GIR_RootConstrainSelectedInstOperands,
     /*  59682 */     // GIR_Coverage, 2130,
     /*  59682 */     GIR_EraseRootFromParent_Done,
     /*  59683 */   // Label 1275: @59683
     /*  59683 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(59737), // Rule ID 2131 //
     /*  59688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59717 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59735 */     GIR_RootConstrainSelectedInstOperands,
     /*  59736 */     // GIR_Coverage, 2131,
     /*  59736 */     GIR_EraseRootFromParent_Done,
     /*  59737 */   // Label 1276: @59737
     /*  59737 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(59791), // Rule ID 2171 //
     /*  59742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59771 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59789 */     GIR_RootConstrainSelectedInstOperands,
     /*  59790 */     // GIR_Coverage, 2171,
     /*  59790 */     GIR_EraseRootFromParent_Done,
     /*  59791 */   // Label 1277: @59791
     /*  59791 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(59845), // Rule ID 2172 //
     /*  59796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59825 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  59828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59843 */     GIR_RootConstrainSelectedInstOperands,
     /*  59844 */     // GIR_Coverage, 2172,
     /*  59844 */     GIR_EraseRootFromParent_Done,
     /*  59845 */   // Label 1278: @59845
     /*  59845 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(59899), // Rule ID 2173 //
     /*  59850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59879 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  59882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59897 */     GIR_RootConstrainSelectedInstOperands,
     /*  59898 */     // GIR_Coverage, 2173,
     /*  59898 */     GIR_EraseRootFromParent_Done,
     /*  59899 */   // Label 1279: @59899
     /*  59899 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(59953), // Rule ID 2174 //
     /*  59904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59933 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  59936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59951 */     GIR_RootConstrainSelectedInstOperands,
     /*  59952 */     // GIR_Coverage, 2174,
     /*  59952 */     GIR_EraseRootFromParent_Done,
     /*  59953 */   // Label 1280: @59953
     /*  59953 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60007), // Rule ID 2175 //
     /*  59958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59987 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  59990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60005 */     GIR_RootConstrainSelectedInstOperands,
     /*  60006 */     // GIR_Coverage, 2175,
     /*  60006 */     GIR_EraseRootFromParent_Done,
     /*  60007 */   // Label 1281: @60007
     /*  60007 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60061), // Rule ID 2176 //
     /*  60012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60041 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60059 */     GIR_RootConstrainSelectedInstOperands,
     /*  60060 */     // GIR_Coverage, 2176,
     /*  60060 */     GIR_EraseRootFromParent_Done,
     /*  60061 */   // Label 1282: @60061
     /*  60061 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60109), // Rule ID 2513 //
     /*  60066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60095 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3753:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60107 */     GIR_RootConstrainSelectedInstOperands,
     /*  60108 */     // GIR_Coverage, 2513,
     /*  60108 */     GIR_EraseRootFromParent_Done,
     /*  60109 */   // Label 1283: @60109
     /*  60109 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60157), // Rule ID 2514 //
     /*  60114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60143 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3752:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60155 */     GIR_RootConstrainSelectedInstOperands,
     /*  60156 */     // GIR_Coverage, 2514,
     /*  60156 */     GIR_EraseRootFromParent_Done,
     /*  60157 */   // Label 1284: @60157
     /*  60157 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60205), // Rule ID 2515 //
     /*  60162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60191 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3753:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60203 */     GIR_RootConstrainSelectedInstOperands,
     /*  60204 */     // GIR_Coverage, 2515,
     /*  60204 */     GIR_EraseRootFromParent_Done,
     /*  60205 */   // Label 1285: @60205
     /*  60205 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60253), // Rule ID 2516 //
     /*  60210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60239 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3752:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60251 */     GIR_RootConstrainSelectedInstOperands,
     /*  60252 */     // GIR_Coverage, 2516,
     /*  60252 */     GIR_EraseRootFromParent_Done,
     /*  60253 */   // Label 1286: @60253
     /*  60253 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60301), // Rule ID 2517 //
     /*  60258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60287 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3753:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60299 */     GIR_RootConstrainSelectedInstOperands,
     /*  60300 */     // GIR_Coverage, 2517,
     /*  60300 */     GIR_EraseRootFromParent_Done,
     /*  60301 */   // Label 1287: @60301
     /*  60301 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60349), // Rule ID 2518 //
     /*  60306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60335 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3752:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60347 */     GIR_RootConstrainSelectedInstOperands,
     /*  60348 */     // GIR_Coverage, 2518,
     /*  60348 */     GIR_EraseRootFromParent_Done,
     /*  60349 */   // Label 1288: @60349
     /*  60349 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60397), // Rule ID 2519 //
     /*  60354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60383 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3753:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60395 */     GIR_RootConstrainSelectedInstOperands,
     /*  60396 */     // GIR_Coverage, 2519,
     /*  60396 */     GIR_EraseRootFromParent_Done,
     /*  60397 */   // Label 1289: @60397
     /*  60397 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(60445), // Rule ID 2520 //
     /*  60402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60431 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3752:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60443 */     GIR_RootConstrainSelectedInstOperands,
     /*  60444 */     // GIR_Coverage, 2520,
     /*  60444 */     GIR_EraseRootFromParent_Done,
     /*  60445 */   // Label 1290: @60445
     /*  60445 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(60550), // Rule ID 3105 //
     /*  60450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60479 */     // (intrinsic_wo_chain:{ *:[f32] } 3561:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60522 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60528 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60549 */     // GIR_Coverage, 3105,
     /*  60549 */     GIR_EraseRootFromParent_Done,
     /*  60550 */   // Label 1291: @60550
     /*  60550 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(60655), // Rule ID 3107 //
     /*  60555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60584 */     // (intrinsic_wo_chain:{ *:[f16] } 3561:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60596 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60624 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60627 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60633 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60654 */     // GIR_Coverage, 3107,
     /*  60654 */     GIR_EraseRootFromParent_Done,
     /*  60655 */   // Label 1292: @60655
     /*  60655 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(60760), // Rule ID 3109 //
     /*  60660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60689 */     // (intrinsic_wo_chain:{ *:[f32] } 3552:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60701 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60722 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60732 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60738 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60759 */     // GIR_Coverage, 3109,
     /*  60759 */     GIR_EraseRootFromParent_Done,
     /*  60760 */   // Label 1293: @60760
     /*  60760 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(60865), // Rule ID 3111 //
     /*  60765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60794 */     // (intrinsic_wo_chain:{ *:[f16] } 3552:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60794 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60797 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60801 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60806 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  60822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60834 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60837 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60843 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60864 */     // GIR_Coverage, 3111,
     /*  60864 */     GIR_EraseRootFromParent_Done,
     /*  60865 */   // Label 1294: @60865
     /*  60865 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(60970), // Rule ID 3113 //
     /*  60870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  60878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60899 */     // (intrinsic_wo_chain:{ *:[f32] } 3559:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60915 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  60927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60932 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60942 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60948 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60969 */     // GIR_Coverage, 3113,
     /*  60969 */     GIR_EraseRootFromParent_Done,
     /*  60970 */   // Label 1295: @60970
     /*  60970 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61075), // Rule ID 3115 //
     /*  60975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  60983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61004 */     // (intrinsic_wo_chain:{ *:[f16] } 3559:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61016 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61047 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61053 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61074 */     // GIR_Coverage, 3115,
     /*  61074 */     GIR_EraseRootFromParent_Done,
     /*  61075 */   // Label 1296: @61075
     /*  61075 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61180), // Rule ID 3117 //
     /*  61080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61109 */     // (intrinsic_wo_chain:{ *:[f32] } 3550:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61109 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61112 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61116 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61121 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61152 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61158 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61179 */     // GIR_Coverage, 3117,
     /*  61179 */     GIR_EraseRootFromParent_Done,
     /*  61180 */   // Label 1297: @61180
     /*  61180 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61285), // Rule ID 3119 //
     /*  61185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61214 */     // (intrinsic_wo_chain:{ *:[f16] } 3550:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61214 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61217 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61221 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61257 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61263 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61284 */     // GIR_Coverage, 3119,
     /*  61284 */     GIR_EraseRootFromParent_Done,
     /*  61285 */   // Label 1298: @61285
     /*  61285 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61345), // Rule ID 3169 //
     /*  61290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61319 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61324 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61326 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61343 */     GIR_RootConstrainSelectedInstOperands,
     /*  61344 */     // GIR_Coverage, 3169,
     /*  61344 */     GIR_EraseRootFromParent_Done,
     /*  61345 */   // Label 1299: @61345
     /*  61345 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61405), // Rule ID 3171 //
     /*  61350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61379 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61384 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61386 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61403 */     GIR_RootConstrainSelectedInstOperands,
     /*  61404 */     // GIR_Coverage, 3171,
     /*  61404 */     GIR_EraseRootFromParent_Done,
     /*  61405 */   // Label 1300: @61405
     /*  61405 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61465), // Rule ID 3173 //
     /*  61410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61439 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61444 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61446 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61463 */     GIR_RootConstrainSelectedInstOperands,
     /*  61464 */     // GIR_Coverage, 3173,
     /*  61464 */     GIR_EraseRootFromParent_Done,
     /*  61465 */   // Label 1301: @61465
     /*  61465 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(61525), // Rule ID 3175 //
     /*  61470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61499 */     // (intrinsic_wo_chain:{ *:[i32] } 3548:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61504 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61506 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61523 */     GIR_RootConstrainSelectedInstOperands,
     /*  61524 */     // GIR_Coverage, 3175,
     /*  61524 */     GIR_EraseRootFromParent_Done,
     /*  61525 */   // Label 1302: @61525
     /*  61525 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(61585), // Rule ID 3177 //
     /*  61530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61559 */     // (intrinsic_wo_chain:{ *:[i32] } 3548:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61564 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61566 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61583 */     GIR_RootConstrainSelectedInstOperands,
     /*  61584 */     // GIR_Coverage, 3177,
     /*  61584 */     GIR_EraseRootFromParent_Done,
     /*  61585 */   // Label 1303: @61585
     /*  61585 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(61645), // Rule ID 3179 //
     /*  61590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61619 */     // (intrinsic_wo_chain:{ *:[i32] } 3548:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61624 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61626 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61643 */     GIR_RootConstrainSelectedInstOperands,
     /*  61644 */     // GIR_Coverage, 3179,
     /*  61644 */     GIR_EraseRootFromParent_Done,
     /*  61645 */   // Label 1304: @61645
     /*  61645 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(61720), // Rule ID 3470 //
     /*  61650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61679 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3670:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61718 */     GIR_RootConstrainSelectedInstOperands,
     /*  61719 */     // GIR_Coverage, 3470,
     /*  61719 */     GIR_EraseRootFromParent_Done,
     /*  61720 */   // Label 1305: @61720
     /*  61720 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(61795), // Rule ID 3477 //
     /*  61725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61754 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3670:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61793 */     GIR_RootConstrainSelectedInstOperands,
     /*  61794 */     // GIR_Coverage, 3477,
     /*  61794 */     GIR_EraseRootFromParent_Done,
     /*  61795 */   // Label 1306: @61795
     /*  61795 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(61870), // Rule ID 3481 //
     /*  61800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61829 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3670:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  61829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  61844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61868 */     GIR_RootConstrainSelectedInstOperands,
     /*  61869 */     // GIR_Coverage, 3481,
     /*  61869 */     GIR_EraseRootFromParent_Done,
     /*  61870 */   // Label 1307: @61870
     /*  61870 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(61945), // Rule ID 3483 //
     /*  61875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61904 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  61919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61943 */     GIR_RootConstrainSelectedInstOperands,
     /*  61944 */     // GIR_Coverage, 3483,
     /*  61944 */     GIR_EraseRootFromParent_Done,
     /*  61945 */   // Label 1308: @61945
     /*  61945 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62020), // Rule ID 3485 //
     /*  61950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61979 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  61994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62018 */     GIR_RootConstrainSelectedInstOperands,
     /*  62019 */     // GIR_Coverage, 3485,
     /*  62019 */     GIR_EraseRootFromParent_Done,
     /*  62020 */   // Label 1309: @62020
     /*  62020 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62095), // Rule ID 3487 //
     /*  62025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62054 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62093 */     GIR_RootConstrainSelectedInstOperands,
     /*  62094 */     // GIR_Coverage, 3487,
     /*  62094 */     GIR_EraseRootFromParent_Done,
     /*  62095 */   // Label 1310: @62095
     /*  62095 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62170), // Rule ID 4755 //
     /*  62100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62129 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62168 */     GIR_RootConstrainSelectedInstOperands,
     /*  62169 */     // GIR_Coverage, 4755,
     /*  62169 */     GIR_EraseRootFromParent_Done,
     /*  62170 */   // Label 1311: @62170
     /*  62170 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(62245), // Rule ID 4760 //
     /*  62175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62243 */     GIR_RootConstrainSelectedInstOperands,
     /*  62244 */     // GIR_Coverage, 4760,
     /*  62244 */     GIR_EraseRootFromParent_Done,
     /*  62245 */   // Label 1312: @62245
     /*  62245 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(62320), // Rule ID 4762 //
     /*  62250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62279 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62318 */     GIR_RootConstrainSelectedInstOperands,
     /*  62319 */     // GIR_Coverage, 4762,
     /*  62319 */     GIR_EraseRootFromParent_Done,
     /*  62320 */   // Label 1313: @62320
     /*  62320 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(62395), // Rule ID 4764 //
     /*  62325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62354 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62393 */     GIR_RootConstrainSelectedInstOperands,
     /*  62394 */     // GIR_Coverage, 4764,
     /*  62394 */     GIR_EraseRootFromParent_Done,
     /*  62395 */   // Label 1314: @62395
     /*  62395 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62470), // Rule ID 4766 //
     /*  62400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62429 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62468 */     GIR_RootConstrainSelectedInstOperands,
     /*  62469 */     // GIR_Coverage, 4766,
     /*  62469 */     GIR_EraseRootFromParent_Done,
     /*  62470 */   // Label 1315: @62470
     /*  62470 */   GIM_Reject,
     /*  62471 */ // Label 960: @62471
     /*  62471 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(73394),
     /*  62476 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62479 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(62569), // Rule ID 3916 //
     /*  62484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62521 */     // MIs[1] Operand 1
     /*  62521 */     // No operand predicates
     /*  62521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62527 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3680:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62567 */     GIR_RootConstrainSelectedInstOperands,
     /*  62568 */     // GIR_Coverage, 3916,
     /*  62568 */     GIR_EraseRootFromParent_Done,
     /*  62569 */   // Label 1317: @62569
     /*  62569 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(62659), // Rule ID 3918 //
     /*  62574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62611 */     // MIs[1] Operand 1
     /*  62611 */     // No operand predicates
     /*  62611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62617 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3680:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62657 */     GIR_RootConstrainSelectedInstOperands,
     /*  62658 */     // GIR_Coverage, 3918,
     /*  62658 */     GIR_EraseRootFromParent_Done,
     /*  62659 */   // Label 1318: @62659
     /*  62659 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(62749), // Rule ID 3920 //
     /*  62664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62701 */     // MIs[1] Operand 1
     /*  62701 */     // No operand predicates
     /*  62701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62707 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3680:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62747 */     GIR_RootConstrainSelectedInstOperands,
     /*  62748 */     // GIR_Coverage, 3920,
     /*  62748 */     GIR_EraseRootFromParent_Done,
     /*  62749 */   // Label 1319: @62749
     /*  62749 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(62839), // Rule ID 3922 //
     /*  62754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62791 */     // MIs[1] Operand 1
     /*  62791 */     // No operand predicates
     /*  62791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62797 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3680:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  62812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62837 */     GIR_RootConstrainSelectedInstOperands,
     /*  62838 */     // GIR_Coverage, 3922,
     /*  62838 */     GIR_EraseRootFromParent_Done,
     /*  62839 */   // Label 1320: @62839
     /*  62839 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(62929), // Rule ID 3924 //
     /*  62844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  62881 */     // MIs[1] Operand 1
     /*  62881 */     // No operand predicates
     /*  62881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3680:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  62887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  62902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62904 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62927 */     GIR_RootConstrainSelectedInstOperands,
     /*  62928 */     // GIR_Coverage, 3924,
     /*  62928 */     GIR_EraseRootFromParent_Done,
     /*  62929 */   // Label 1321: @62929
     /*  62929 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63019), // Rule ID 3926 //
     /*  62934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  62971 */     // MIs[1] Operand 1
     /*  62971 */     // No operand predicates
     /*  62971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62977 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3680:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  62977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  62992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62994 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63017 */     GIR_RootConstrainSelectedInstOperands,
     /*  63018 */     // GIR_Coverage, 3926,
     /*  63018 */     GIR_EraseRootFromParent_Done,
     /*  63019 */   // Label 1322: @63019
     /*  63019 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63109), // Rule ID 3934 //
     /*  63024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63061 */     // MIs[1] Operand 1
     /*  63061 */     // No operand predicates
     /*  63061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63067 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3696:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63107 */     GIR_RootConstrainSelectedInstOperands,
     /*  63108 */     // GIR_Coverage, 3934,
     /*  63108 */     GIR_EraseRootFromParent_Done,
     /*  63109 */   // Label 1323: @63109
     /*  63109 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63199), // Rule ID 3936 //
     /*  63114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63151 */     // MIs[1] Operand 1
     /*  63151 */     // No operand predicates
     /*  63151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63157 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3696:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63197 */     GIR_RootConstrainSelectedInstOperands,
     /*  63198 */     // GIR_Coverage, 3936,
     /*  63198 */     GIR_EraseRootFromParent_Done,
     /*  63199 */   // Label 1324: @63199
     /*  63199 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63289), // Rule ID 3938 //
     /*  63204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63241 */     // MIs[1] Operand 1
     /*  63241 */     // No operand predicates
     /*  63241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63247 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3696:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63287 */     GIR_RootConstrainSelectedInstOperands,
     /*  63288 */     // GIR_Coverage, 3938,
     /*  63288 */     GIR_EraseRootFromParent_Done,
     /*  63289 */   // Label 1325: @63289
     /*  63289 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63379), // Rule ID 3940 //
     /*  63294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63331 */     // MIs[1] Operand 1
     /*  63331 */     // No operand predicates
     /*  63331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63337 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3696:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63377 */     GIR_RootConstrainSelectedInstOperands,
     /*  63378 */     // GIR_Coverage, 3940,
     /*  63378 */     GIR_EraseRootFromParent_Done,
     /*  63379 */   // Label 1326: @63379
     /*  63379 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(63469), // Rule ID 3942 //
     /*  63384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63421 */     // MIs[1] Operand 1
     /*  63421 */     // No operand predicates
     /*  63421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3696:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63467 */     GIR_RootConstrainSelectedInstOperands,
     /*  63468 */     // GIR_Coverage, 3942,
     /*  63468 */     GIR_EraseRootFromParent_Done,
     /*  63469 */   // Label 1327: @63469
     /*  63469 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(63559), // Rule ID 3944 //
     /*  63474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63511 */     // MIs[1] Operand 1
     /*  63511 */     // No operand predicates
     /*  63511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63517 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3696:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63534 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63557 */     GIR_RootConstrainSelectedInstOperands,
     /*  63558 */     // GIR_Coverage, 3944,
     /*  63558 */     GIR_EraseRootFromParent_Done,
     /*  63559 */   // Label 1328: @63559
     /*  63559 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(63648), // Rule ID 4042 //
     /*  63564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63604 */     // MIs[1] Operand 1
     /*  63604 */     // No operand predicates
     /*  63604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63606 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63646 */     GIR_RootConstrainSelectedInstOperands,
     /*  63647 */     // GIR_Coverage, 4042,
     /*  63647 */     GIR_EraseRootFromParent_Done,
     /*  63648 */   // Label 1329: @63648
     /*  63648 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(63737), // Rule ID 4044 //
     /*  63653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63693 */     // MIs[1] Operand 1
     /*  63693 */     // No operand predicates
     /*  63693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63695 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63735 */     GIR_RootConstrainSelectedInstOperands,
     /*  63736 */     // GIR_Coverage, 4044,
     /*  63736 */     GIR_EraseRootFromParent_Done,
     /*  63737 */   // Label 1330: @63737
     /*  63737 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(63826), // Rule ID 4046 //
     /*  63742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63782 */     // MIs[1] Operand 1
     /*  63782 */     // No operand predicates
     /*  63782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63784 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  63799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63824 */     GIR_RootConstrainSelectedInstOperands,
     /*  63825 */     // GIR_Coverage, 4046,
     /*  63825 */     GIR_EraseRootFromParent_Done,
     /*  63826 */   // Label 1331: @63826
     /*  63826 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(63915), // Rule ID 4048 //
     /*  63831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63871 */     // MIs[1] Operand 1
     /*  63871 */     // No operand predicates
     /*  63871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63873 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  63888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63913 */     GIR_RootConstrainSelectedInstOperands,
     /*  63914 */     // GIR_Coverage, 4048,
     /*  63914 */     GIR_EraseRootFromParent_Done,
     /*  63915 */   // Label 1332: @63915
     /*  63915 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64004), // Rule ID 4050 //
     /*  63920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63960 */     // MIs[1] Operand 1
     /*  63960 */     // No operand predicates
     /*  63960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63962 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  63977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64002 */     GIR_RootConstrainSelectedInstOperands,
     /*  64003 */     // GIR_Coverage, 4050,
     /*  64003 */     GIR_EraseRootFromParent_Done,
     /*  64004 */   // Label 1333: @64004
     /*  64004 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64093), // Rule ID 4052 //
     /*  64009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64049 */     // MIs[1] Operand 1
     /*  64049 */     // No operand predicates
     /*  64049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64051 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64091 */     GIR_RootConstrainSelectedInstOperands,
     /*  64092 */     // GIR_Coverage, 4052,
     /*  64092 */     GIR_EraseRootFromParent_Done,
     /*  64093 */   // Label 1334: @64093
     /*  64093 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64182), // Rule ID 4054 //
     /*  64098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64138 */     // MIs[1] Operand 1
     /*  64138 */     // No operand predicates
     /*  64138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64140 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64180 */     GIR_RootConstrainSelectedInstOperands,
     /*  64181 */     // GIR_Coverage, 4054,
     /*  64181 */     GIR_EraseRootFromParent_Done,
     /*  64182 */   // Label 1335: @64182
     /*  64182 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64271), // Rule ID 4056 //
     /*  64187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64227 */     // MIs[1] Operand 1
     /*  64227 */     // No operand predicates
     /*  64227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64229 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64269 */     GIR_RootConstrainSelectedInstOperands,
     /*  64270 */     // GIR_Coverage, 4056,
     /*  64270 */     GIR_EraseRootFromParent_Done,
     /*  64271 */   // Label 1336: @64271
     /*  64271 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64338), // Rule ID 3121 //
     /*  64276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64312 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64317 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64319 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64336 */     GIR_RootConstrainSelectedInstOperands,
     /*  64337 */     // GIR_Coverage, 3121,
     /*  64337 */     GIR_EraseRootFromParent_Done,
     /*  64338 */   // Label 1337: @64338
     /*  64338 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64405), // Rule ID 3123 //
     /*  64343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64379 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64384 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64386 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64403 */     GIR_RootConstrainSelectedInstOperands,
     /*  64404 */     // GIR_Coverage, 3123,
     /*  64404 */     GIR_EraseRootFromParent_Done,
     /*  64405 */   // Label 1338: @64405
     /*  64405 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64472), // Rule ID 3125 //
     /*  64410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64446 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64451 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64453 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64470 */     GIR_RootConstrainSelectedInstOperands,
     /*  64471 */     // GIR_Coverage, 3125,
     /*  64471 */     GIR_EraseRootFromParent_Done,
     /*  64472 */   // Label 1339: @64472
     /*  64472 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(64539), // Rule ID 3127 //
     /*  64477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64513 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64518 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64520 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64537 */     GIR_RootConstrainSelectedInstOperands,
     /*  64538 */     // GIR_Coverage, 3127,
     /*  64538 */     GIR_EraseRootFromParent_Done,
     /*  64539 */   // Label 1340: @64539
     /*  64539 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(64606), // Rule ID 3129 //
     /*  64544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64580 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64585 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64587 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64604 */     GIR_RootConstrainSelectedInstOperands,
     /*  64605 */     // GIR_Coverage, 3129,
     /*  64605 */     GIR_EraseRootFromParent_Done,
     /*  64606 */   // Label 1341: @64606
     /*  64606 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(64673), // Rule ID 3131 //
     /*  64611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64647 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64652 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64654 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64671 */     GIR_RootConstrainSelectedInstOperands,
     /*  64672 */     // GIR_Coverage, 3131,
     /*  64672 */     GIR_EraseRootFromParent_Done,
     /*  64673 */   // Label 1342: @64673
     /*  64673 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(64740), // Rule ID 3133 //
     /*  64678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64714 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64719 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64721 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64738 */     GIR_RootConstrainSelectedInstOperands,
     /*  64739 */     // GIR_Coverage, 3133,
     /*  64739 */     GIR_EraseRootFromParent_Done,
     /*  64740 */   // Label 1343: @64740
     /*  64740 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(64807), // Rule ID 3135 //
     /*  64745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64781 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64786 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64788 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64805 */     GIR_RootConstrainSelectedInstOperands,
     /*  64806 */     // GIR_Coverage, 3135,
     /*  64806 */     GIR_EraseRootFromParent_Done,
     /*  64807 */   // Label 1344: @64807
     /*  64807 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(64874), // Rule ID 3137 //
     /*  64812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64848 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  64851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64853 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64855 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64872 */     GIR_RootConstrainSelectedInstOperands,
     /*  64873 */     // GIR_Coverage, 3137,
     /*  64873 */     GIR_EraseRootFromParent_Done,
     /*  64874 */   // Label 1345: @64874
     /*  64874 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(64941), // Rule ID 3139 //
     /*  64879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64915 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  64918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64920 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64922 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64939 */     GIR_RootConstrainSelectedInstOperands,
     /*  64940 */     // GIR_Coverage, 3139,
     /*  64940 */     GIR_EraseRootFromParent_Done,
     /*  64941 */   // Label 1346: @64941
     /*  64941 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(65008), // Rule ID 3141 //
     /*  64946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64982 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  64985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64987 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64989 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65006 */     GIR_RootConstrainSelectedInstOperands,
     /*  65007 */     // GIR_Coverage, 3141,
     /*  65007 */     GIR_EraseRootFromParent_Done,
     /*  65008 */   // Label 1347: @65008
     /*  65008 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65075), // Rule ID 3143 //
     /*  65013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65049 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65054 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65056 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65073 */     GIR_RootConstrainSelectedInstOperands,
     /*  65074 */     // GIR_Coverage, 3143,
     /*  65074 */     GIR_EraseRootFromParent_Done,
     /*  65075 */   // Label 1348: @65075
     /*  65075 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65157), // Rule ID 3548 //
     /*  65080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65116 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3600:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65155 */     GIR_RootConstrainSelectedInstOperands,
     /*  65156 */     // GIR_Coverage, 3548,
     /*  65156 */     GIR_EraseRootFromParent_Done,
     /*  65157 */   // Label 1349: @65157
     /*  65157 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65239), // Rule ID 3555 //
     /*  65162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65198 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3600:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65237 */     GIR_RootConstrainSelectedInstOperands,
     /*  65238 */     // GIR_Coverage, 3555,
     /*  65238 */     GIR_EraseRootFromParent_Done,
     /*  65239 */   // Label 1350: @65239
     /*  65239 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65321), // Rule ID 3559 //
     /*  65244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65280 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3600:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65319 */     GIR_RootConstrainSelectedInstOperands,
     /*  65320 */     // GIR_Coverage, 3559,
     /*  65320 */     GIR_EraseRootFromParent_Done,
     /*  65321 */   // Label 1351: @65321
     /*  65321 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65403), // Rule ID 3563 //
     /*  65326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65362 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3600:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65401 */     GIR_RootConstrainSelectedInstOperands,
     /*  65402 */     // GIR_Coverage, 3563,
     /*  65402 */     GIR_EraseRootFromParent_Done,
     /*  65403 */   // Label 1352: @65403
     /*  65403 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(65485), // Rule ID 3567 //
     /*  65408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65444 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3600:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65483 */     GIR_RootConstrainSelectedInstOperands,
     /*  65484 */     // GIR_Coverage, 3567,
     /*  65484 */     GIR_EraseRootFromParent_Done,
     /*  65485 */   // Label 1353: @65485
     /*  65485 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(65567), // Rule ID 3571 //
     /*  65490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65526 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3600:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65565 */     GIR_RootConstrainSelectedInstOperands,
     /*  65566 */     // GIR_Coverage, 3571,
     /*  65566 */     GIR_EraseRootFromParent_Done,
     /*  65567 */   // Label 1354: @65567
     /*  65567 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(65649), // Rule ID 3572 //
     /*  65572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65608 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3686:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65647 */     GIR_RootConstrainSelectedInstOperands,
     /*  65648 */     // GIR_Coverage, 3572,
     /*  65648 */     GIR_EraseRootFromParent_Done,
     /*  65649 */   // Label 1355: @65649
     /*  65649 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(65731), // Rule ID 3579 //
     /*  65654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65690 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3686:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65729 */     GIR_RootConstrainSelectedInstOperands,
     /*  65730 */     // GIR_Coverage, 3579,
     /*  65730 */     GIR_EraseRootFromParent_Done,
     /*  65731 */   // Label 1356: @65731
     /*  65731 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(65813), // Rule ID 3583 //
     /*  65736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65772 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3686:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  65787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65811 */     GIR_RootConstrainSelectedInstOperands,
     /*  65812 */     // GIR_Coverage, 3583,
     /*  65812 */     GIR_EraseRootFromParent_Done,
     /*  65813 */   // Label 1357: @65813
     /*  65813 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(65895), // Rule ID 3587 //
     /*  65818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65854 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3686:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  65869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65893 */     GIR_RootConstrainSelectedInstOperands,
     /*  65894 */     // GIR_Coverage, 3587,
     /*  65894 */     GIR_EraseRootFromParent_Done,
     /*  65895 */   // Label 1358: @65895
     /*  65895 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(65977), // Rule ID 3591 //
     /*  65900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65936 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3686:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  65951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65975 */     GIR_RootConstrainSelectedInstOperands,
     /*  65976 */     // GIR_Coverage, 3591,
     /*  65976 */     GIR_EraseRootFromParent_Done,
     /*  65977 */   // Label 1359: @65977
     /*  65977 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66059), // Rule ID 3595 //
     /*  65982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3686:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66057 */     GIR_RootConstrainSelectedInstOperands,
     /*  66058 */     // GIR_Coverage, 3595,
     /*  66058 */     GIR_EraseRootFromParent_Done,
     /*  66059 */   // Label 1360: @66059
     /*  66059 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66141), // Rule ID 3596 //
     /*  66064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66100 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3635:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66139 */     GIR_RootConstrainSelectedInstOperands,
     /*  66140 */     // GIR_Coverage, 3596,
     /*  66140 */     GIR_EraseRootFromParent_Done,
     /*  66141 */   // Label 1361: @66141
     /*  66141 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66223), // Rule ID 3603 //
     /*  66146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66182 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3635:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66221 */     GIR_RootConstrainSelectedInstOperands,
     /*  66222 */     // GIR_Coverage, 3603,
     /*  66222 */     GIR_EraseRootFromParent_Done,
     /*  66223 */   // Label 1362: @66223
     /*  66223 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66305), // Rule ID 3607 //
     /*  66228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3635:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66303 */     GIR_RootConstrainSelectedInstOperands,
     /*  66304 */     // GIR_Coverage, 3607,
     /*  66304 */     GIR_EraseRootFromParent_Done,
     /*  66305 */   // Label 1363: @66305
     /*  66305 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66387), // Rule ID 3611 //
     /*  66310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66346 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3635:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66385 */     GIR_RootConstrainSelectedInstOperands,
     /*  66386 */     // GIR_Coverage, 3611,
     /*  66386 */     GIR_EraseRootFromParent_Done,
     /*  66387 */   // Label 1364: @66387
     /*  66387 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(66469), // Rule ID 3615 //
     /*  66392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3635:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66467 */     GIR_RootConstrainSelectedInstOperands,
     /*  66468 */     // GIR_Coverage, 3615,
     /*  66468 */     GIR_EraseRootFromParent_Done,
     /*  66469 */   // Label 1365: @66469
     /*  66469 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(66551), // Rule ID 3619 //
     /*  66474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3635:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66549 */     GIR_RootConstrainSelectedInstOperands,
     /*  66550 */     // GIR_Coverage, 3619,
     /*  66550 */     GIR_EraseRootFromParent_Done,
     /*  66551 */   // Label 1366: @66551
     /*  66551 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(66633), // Rule ID 3620 //
     /*  66556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66592 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66631 */     GIR_RootConstrainSelectedInstOperands,
     /*  66632 */     // GIR_Coverage, 3620,
     /*  66632 */     GIR_EraseRootFromParent_Done,
     /*  66633 */   // Label 1367: @66633
     /*  66633 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(66715), // Rule ID 3623 //
     /*  66638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66674 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66713 */     GIR_RootConstrainSelectedInstOperands,
     /*  66714 */     // GIR_Coverage, 3623,
     /*  66714 */     GIR_EraseRootFromParent_Done,
     /*  66715 */   // Label 1368: @66715
     /*  66715 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(66797), // Rule ID 3626 //
     /*  66720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66756 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66795 */     GIR_RootConstrainSelectedInstOperands,
     /*  66796 */     // GIR_Coverage, 3626,
     /*  66796 */     GIR_EraseRootFromParent_Done,
     /*  66797 */   // Label 1369: @66797
     /*  66797 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(66879), // Rule ID 3629 //
     /*  66802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66838 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  66853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66877 */     GIR_RootConstrainSelectedInstOperands,
     /*  66878 */     // GIR_Coverage, 3629,
     /*  66878 */     GIR_EraseRootFromParent_Done,
     /*  66879 */   // Label 1370: @66879
     /*  66879 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(66961), // Rule ID 3632 //
     /*  66884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66920 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  66935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66959 */     GIR_RootConstrainSelectedInstOperands,
     /*  66960 */     // GIR_Coverage, 3632,
     /*  66960 */     GIR_EraseRootFromParent_Done,
     /*  66961 */   // Label 1371: @66961
     /*  66961 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67043), // Rule ID 3635 //
     /*  66966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67002 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67041 */     GIR_RootConstrainSelectedInstOperands,
     /*  67042 */     // GIR_Coverage, 3635,
     /*  67042 */     GIR_EraseRootFromParent_Done,
     /*  67043 */   // Label 1372: @67043
     /*  67043 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67125), // Rule ID 4036 //
     /*  67048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67084 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3600:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67123 */     GIR_RootConstrainSelectedInstOperands,
     /*  67124 */     // GIR_Coverage, 4036,
     /*  67124 */     GIR_EraseRootFromParent_Done,
     /*  67125 */   // Label 1373: @67125
     /*  67125 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67207), // Rule ID 4038 //
     /*  67130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67166 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3600:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67205 */     GIR_RootConstrainSelectedInstOperands,
     /*  67206 */     // GIR_Coverage, 4038,
     /*  67206 */     GIR_EraseRootFromParent_Done,
     /*  67207 */   // Label 1374: @67207
     /*  67207 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67289), // Rule ID 4411 //
     /*  67212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67248 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3663:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67287 */     GIR_RootConstrainSelectedInstOperands,
     /*  67288 */     // GIR_Coverage, 4411,
     /*  67288 */     GIR_EraseRootFromParent_Done,
     /*  67289 */   // Label 1375: @67289
     /*  67289 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67371), // Rule ID 4413 //
     /*  67294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67330 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3663:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67369 */     GIR_RootConstrainSelectedInstOperands,
     /*  67370 */     // GIR_Coverage, 4413,
     /*  67370 */     GIR_EraseRootFromParent_Done,
     /*  67371 */   // Label 1376: @67371
     /*  67371 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67453), // Rule ID 4415 //
     /*  67376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67412 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3663:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67451 */     GIR_RootConstrainSelectedInstOperands,
     /*  67452 */     // GIR_Coverage, 4415,
     /*  67452 */     GIR_EraseRootFromParent_Done,
     /*  67453 */   // Label 1377: @67453
     /*  67453 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(67535), // Rule ID 4417 //
     /*  67458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67494 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3663:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67533 */     GIR_RootConstrainSelectedInstOperands,
     /*  67534 */     // GIR_Coverage, 4417,
     /*  67534 */     GIR_EraseRootFromParent_Done,
     /*  67535 */   // Label 1378: @67535
     /*  67535 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(67617), // Rule ID 4444 //
     /*  67540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67576 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3661:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67615 */     GIR_RootConstrainSelectedInstOperands,
     /*  67616 */     // GIR_Coverage, 4444,
     /*  67616 */     GIR_EraseRootFromParent_Done,
     /*  67617 */   // Label 1379: @67617
     /*  67617 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(67699), // Rule ID 4451 //
     /*  67622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67658 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3661:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67697 */     GIR_RootConstrainSelectedInstOperands,
     /*  67698 */     // GIR_Coverage, 4451,
     /*  67698 */     GIR_EraseRootFromParent_Done,
     /*  67699 */   // Label 1380: @67699
     /*  67699 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(67781), // Rule ID 4455 //
     /*  67704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67740 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3661:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67779 */     GIR_RootConstrainSelectedInstOperands,
     /*  67780 */     // GIR_Coverage, 4455,
     /*  67780 */     GIR_EraseRootFromParent_Done,
     /*  67781 */   // Label 1381: @67781
     /*  67781 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(67863), // Rule ID 4459 //
     /*  67786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3661:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  67837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67861 */     GIR_RootConstrainSelectedInstOperands,
     /*  67862 */     // GIR_Coverage, 4459,
     /*  67862 */     GIR_EraseRootFromParent_Done,
     /*  67863 */   // Label 1382: @67863
     /*  67863 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(67945), // Rule ID 4463 //
     /*  67868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67904 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3661:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  67919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67943 */     GIR_RootConstrainSelectedInstOperands,
     /*  67944 */     // GIR_Coverage, 4463,
     /*  67944 */     GIR_EraseRootFromParent_Done,
     /*  67945 */   // Label 1383: @67945
     /*  67945 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(68027), // Rule ID 4467 //
     /*  67950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67986 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3661:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68025 */     GIR_RootConstrainSelectedInstOperands,
     /*  68026 */     // GIR_Coverage, 4467,
     /*  68026 */     GIR_EraseRootFromParent_Done,
     /*  68027 */   // Label 1384: @68027
     /*  68027 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68109), // Rule ID 4468 //
     /*  68032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68068 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68107 */     GIR_RootConstrainSelectedInstOperands,
     /*  68108 */     // GIR_Coverage, 4468,
     /*  68108 */     GIR_EraseRootFromParent_Done,
     /*  68109 */   // Label 1385: @68109
     /*  68109 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68191), // Rule ID 4470 //
     /*  68114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68150 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68189 */     GIR_RootConstrainSelectedInstOperands,
     /*  68190 */     // GIR_Coverage, 4470,
     /*  68190 */     GIR_EraseRootFromParent_Done,
     /*  68191 */   // Label 1386: @68191
     /*  68191 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68273), // Rule ID 4472 //
     /*  68196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68232 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68271 */     GIR_RootConstrainSelectedInstOperands,
     /*  68272 */     // GIR_Coverage, 4472,
     /*  68272 */     GIR_EraseRootFromParent_Done,
     /*  68273 */   // Label 1387: @68273
     /*  68273 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68355), // Rule ID 4474 //
     /*  68278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68314 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68353 */     GIR_RootConstrainSelectedInstOperands,
     /*  68354 */     // GIR_Coverage, 4474,
     /*  68354 */     GIR_EraseRootFromParent_Done,
     /*  68355 */   // Label 1388: @68355
     /*  68355 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68437), // Rule ID 4476 //
     /*  68360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68396 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68435 */     GIR_RootConstrainSelectedInstOperands,
     /*  68436 */     // GIR_Coverage, 4476,
     /*  68436 */     GIR_EraseRootFromParent_Done,
     /*  68437 */   // Label 1389: @68437
     /*  68437 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(68519), // Rule ID 4478 //
     /*  68442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68478 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68517 */     GIR_RootConstrainSelectedInstOperands,
     /*  68518 */     // GIR_Coverage, 4478,
     /*  68518 */     GIR_EraseRootFromParent_Done,
     /*  68519 */   // Label 1390: @68519
     /*  68519 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(68586), // Rule ID 4529 //
     /*  68524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68560 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3619:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68584 */     GIR_RootConstrainSelectedInstOperands,
     /*  68585 */     // GIR_Coverage, 4529,
     /*  68585 */     GIR_EraseRootFromParent_Done,
     /*  68586 */   // Label 1391: @68586
     /*  68586 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(68653), // Rule ID 4535 //
     /*  68591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68627 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3619:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68651 */     GIR_RootConstrainSelectedInstOperands,
     /*  68652 */     // GIR_Coverage, 4535,
     /*  68652 */     GIR_EraseRootFromParent_Done,
     /*  68653 */   // Label 1392: @68653
     /*  68653 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(68735), // Rule ID 4553 //
     /*  68658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68694 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68733 */     GIR_RootConstrainSelectedInstOperands,
     /*  68734 */     // GIR_Coverage, 4553,
     /*  68734 */     GIR_EraseRootFromParent_Done,
     /*  68735 */   // Label 1393: @68735
     /*  68735 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(68817), // Rule ID 4555 //
     /*  68740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  68791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68815 */     GIR_RootConstrainSelectedInstOperands,
     /*  68816 */     // GIR_Coverage, 4555,
     /*  68816 */     GIR_EraseRootFromParent_Done,
     /*  68817 */   // Label 1394: @68817
     /*  68817 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(68899), // Rule ID 4557 //
     /*  68822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68858 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  68873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68897 */     GIR_RootConstrainSelectedInstOperands,
     /*  68898 */     // GIR_Coverage, 4557,
     /*  68898 */     GIR_EraseRootFromParent_Done,
     /*  68899 */   // Label 1395: @68899
     /*  68899 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(68981), // Rule ID 4559 //
     /*  68904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68940 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  68955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68979 */     GIR_RootConstrainSelectedInstOperands,
     /*  68980 */     // GIR_Coverage, 4559,
     /*  68980 */     GIR_EraseRootFromParent_Done,
     /*  68981 */   // Label 1396: @68981
     /*  68981 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69058), // Rule ID 3904 //
     /*  68986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  68991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69027 */     // MIs[1] Operand 1
     /*  69027 */     // No operand predicates
     /*  69027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69029 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3710:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69034 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69056 */     GIR_RootConstrainSelectedInstOperands,
     /*  69057 */     // GIR_Coverage, 3904,
     /*  69057 */     GIR_EraseRootFromParent_Done,
     /*  69058 */   // Label 1397: @69058
     /*  69058 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69135), // Rule ID 3906 //
     /*  69063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69104 */     // MIs[1] Operand 1
     /*  69104 */     // No operand predicates
     /*  69104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69106 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3710:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69111 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69133 */     GIR_RootConstrainSelectedInstOperands,
     /*  69134 */     // GIR_Coverage, 3906,
     /*  69134 */     GIR_EraseRootFromParent_Done,
     /*  69135 */   // Label 1398: @69135
     /*  69135 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69212), // Rule ID 3908 //
     /*  69140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69181 */     // MIs[1] Operand 1
     /*  69181 */     // No operand predicates
     /*  69181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69188 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69210 */     GIR_RootConstrainSelectedInstOperands,
     /*  69211 */     // GIR_Coverage, 3908,
     /*  69211 */     GIR_EraseRootFromParent_Done,
     /*  69212 */   // Label 1399: @69212
     /*  69212 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69289), // Rule ID 3910 //
     /*  69217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69258 */     // MIs[1] Operand 1
     /*  69258 */     // No operand predicates
     /*  69258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69260 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69265 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69287 */     GIR_RootConstrainSelectedInstOperands,
     /*  69288 */     // GIR_Coverage, 3910,
     /*  69288 */     GIR_EraseRootFromParent_Done,
     /*  69289 */   // Label 1400: @69289
     /*  69289 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69366), // Rule ID 3912 //
     /*  69294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69335 */     // MIs[1] Operand 1
     /*  69335 */     // No operand predicates
     /*  69335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69337 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69342 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69364 */     GIR_RootConstrainSelectedInstOperands,
     /*  69365 */     // GIR_Coverage, 3912,
     /*  69365 */     GIR_EraseRootFromParent_Done,
     /*  69366 */   // Label 1401: @69366
     /*  69366 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69443), // Rule ID 3914 //
     /*  69371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69412 */     // MIs[1] Operand 1
     /*  69412 */     // No operand predicates
     /*  69412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69414 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3712:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69419 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69441 */     GIR_RootConstrainSelectedInstOperands,
     /*  69442 */     // GIR_Coverage, 3914,
     /*  69442 */     GIR_EraseRootFromParent_Done,
     /*  69443 */   // Label 1402: @69443
     /*  69443 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(69534), // Rule ID 4383 //
     /*  69448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69480 */     // MIs[1] Operand 1
     /*  69480 */     // No operand predicates
     /*  69480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69490 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3610:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69532 */     GIR_RootConstrainSelectedInstOperands,
     /*  69533 */     // GIR_Coverage, 4383,
     /*  69533 */     GIR_EraseRootFromParent_Done,
     /*  69534 */   // Label 1403: @69534
     /*  69534 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(69625), // Rule ID 4385 //
     /*  69539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69571 */     // MIs[1] Operand 1
     /*  69571 */     // No operand predicates
     /*  69571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69581 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3610:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69623 */     GIR_RootConstrainSelectedInstOperands,
     /*  69624 */     // GIR_Coverage, 4385,
     /*  69624 */     GIR_EraseRootFromParent_Done,
     /*  69625 */   // Label 1404: @69625
     /*  69625 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(69688), // Rule ID 146 //
     /*  69630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69666 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69686 */     GIR_RootConstrainSelectedInstOperands,
     /*  69687 */     // GIR_Coverage, 146,
     /*  69687 */     GIR_EraseRootFromParent_Done,
     /*  69688 */   // Label 1405: @69688
     /*  69688 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(69751), // Rule ID 469 //
     /*  69693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69729 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69749 */     GIR_RootConstrainSelectedInstOperands,
     /*  69750 */     // GIR_Coverage, 469,
     /*  69750 */     GIR_EraseRootFromParent_Done,
     /*  69751 */   // Label 1406: @69751
     /*  69751 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(69814), // Rule ID 528 //
     /*  69756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69792 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  69795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69812 */     GIR_RootConstrainSelectedInstOperands,
     /*  69813 */     // GIR_Coverage, 528,
     /*  69813 */     GIR_EraseRootFromParent_Done,
     /*  69814 */   // Label 1407: @69814
     /*  69814 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(69877), // Rule ID 529 //
     /*  69819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  69827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69855 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  69858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69875 */     GIR_RootConstrainSelectedInstOperands,
     /*  69876 */     // GIR_Coverage, 529,
     /*  69876 */     GIR_EraseRootFromParent_Done,
     /*  69877 */   // Label 1408: @69877
     /*  69877 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(69940), // Rule ID 530 //
     /*  69882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  69890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69918 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  69921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69938 */     GIR_RootConstrainSelectedInstOperands,
     /*  69939 */     // GIR_Coverage, 530,
     /*  69939 */     GIR_EraseRootFromParent_Done,
     /*  69940 */   // Label 1409: @69940
     /*  69940 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70003), // Rule ID 531 //
     /*  69945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  69953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69981 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  69984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70001 */     GIR_RootConstrainSelectedInstOperands,
     /*  70002 */     // GIR_Coverage, 531,
     /*  70002 */     GIR_EraseRootFromParent_Done,
     /*  70003 */   // Label 1410: @70003
     /*  70003 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70057), // Rule ID 951 //
     /*  70008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70044 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3742:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70055 */     GIR_RootConstrainSelectedInstOperands,
     /*  70056 */     // GIR_Coverage, 951,
     /*  70056 */     GIR_EraseRootFromParent_Done,
     /*  70057 */   // Label 1411: @70057
     /*  70057 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70111), // Rule ID 952 //
     /*  70062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70098 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3730:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70109 */     GIR_RootConstrainSelectedInstOperands,
     /*  70110 */     // GIR_Coverage, 952,
     /*  70110 */     GIR_EraseRootFromParent_Done,
     /*  70111 */   // Label 1412: @70111
     /*  70111 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70165), // Rule ID 953 //
     /*  70116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70163 */     GIR_RootConstrainSelectedInstOperands,
     /*  70164 */     // GIR_Coverage, 953,
     /*  70164 */     GIR_EraseRootFromParent_Done,
     /*  70165 */   // Label 1413: @70165
     /*  70165 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70219), // Rule ID 954 //
     /*  70170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70206 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3730:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70217 */     GIR_RootConstrainSelectedInstOperands,
     /*  70218 */     // GIR_Coverage, 954,
     /*  70218 */     GIR_EraseRootFromParent_Done,
     /*  70219 */   // Label 1414: @70219
     /*  70219 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70273), // Rule ID 955 //
     /*  70224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70260 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70271 */     GIR_RootConstrainSelectedInstOperands,
     /*  70272 */     // GIR_Coverage, 955,
     /*  70272 */     GIR_EraseRootFromParent_Done,
     /*  70273 */   // Label 1415: @70273
     /*  70273 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70327), // Rule ID 956 //
     /*  70278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70314 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70325 */     GIR_RootConstrainSelectedInstOperands,
     /*  70326 */     // GIR_Coverage, 956,
     /*  70326 */     GIR_EraseRootFromParent_Done,
     /*  70327 */   // Label 1416: @70327
     /*  70327 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70381), // Rule ID 957 //
     /*  70332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70368 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3745:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70379 */     GIR_RootConstrainSelectedInstOperands,
     /*  70380 */     // GIR_Coverage, 957,
     /*  70380 */     GIR_EraseRootFromParent_Done,
     /*  70381 */   // Label 1417: @70381
     /*  70381 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70435), // Rule ID 958 //
     /*  70386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70422 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3744:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70433 */     GIR_RootConstrainSelectedInstOperands,
     /*  70434 */     // GIR_Coverage, 958,
     /*  70434 */     GIR_EraseRootFromParent_Done,
     /*  70435 */   // Label 1418: @70435
     /*  70435 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70489), // Rule ID 959 //
     /*  70440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70476 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70487 */     GIR_RootConstrainSelectedInstOperands,
     /*  70488 */     // GIR_Coverage, 959,
     /*  70488 */     GIR_EraseRootFromParent_Done,
     /*  70489 */   // Label 1419: @70489
     /*  70489 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70552), // Rule ID 1690 //
     /*  70494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70530 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3858:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70535 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70550 */     GIR_RootConstrainSelectedInstOperands,
     /*  70551 */     // GIR_Coverage, 1690,
     /*  70551 */     GIR_EraseRootFromParent_Done,
     /*  70552 */   // Label 1420: @70552
     /*  70552 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(70606), // Rule ID 1721 //
     /*  70557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70593 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70604 */     GIR_RootConstrainSelectedInstOperands,
     /*  70605 */     // GIR_Coverage, 1721,
     /*  70605 */     GIR_EraseRootFromParent_Done,
     /*  70606 */   // Label 1421: @70606
     /*  70606 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(70660), // Rule ID 1722 //
     /*  70611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70647 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70652 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70658 */     GIR_RootConstrainSelectedInstOperands,
     /*  70659 */     // GIR_Coverage, 1722,
     /*  70659 */     GIR_EraseRootFromParent_Done,
     /*  70660 */   // Label 1422: @70660
     /*  70660 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(70714), // Rule ID 1723 //
     /*  70665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70701 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70712 */     GIR_RootConstrainSelectedInstOperands,
     /*  70713 */     // GIR_Coverage, 1723,
     /*  70713 */     GIR_EraseRootFromParent_Done,
     /*  70714 */   // Label 1423: @70714
     /*  70714 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(70768), // Rule ID 1724 //
     /*  70719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70755 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70760 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70766 */     GIR_RootConstrainSelectedInstOperands,
     /*  70767 */     // GIR_Coverage, 1724,
     /*  70767 */     GIR_EraseRootFromParent_Done,
     /*  70768 */   // Label 1424: @70768
     /*  70768 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(70831), // Rule ID 1899 //
     /*  70773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70809 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  70812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70829 */     GIR_RootConstrainSelectedInstOperands,
     /*  70830 */     // GIR_Coverage, 1899,
     /*  70830 */     GIR_EraseRootFromParent_Done,
     /*  70831 */   // Label 1425: @70831
     /*  70831 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(70894), // Rule ID 1900 //
     /*  70836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70872 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  70875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70892 */     GIR_RootConstrainSelectedInstOperands,
     /*  70893 */     // GIR_Coverage, 1900,
     /*  70893 */     GIR_EraseRootFromParent_Done,
     /*  70894 */   // Label 1426: @70894
     /*  70894 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(70957), // Rule ID 1901 //
     /*  70899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70935 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  70938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70955 */     GIR_RootConstrainSelectedInstOperands,
     /*  70956 */     // GIR_Coverage, 1901,
     /*  70956 */     GIR_EraseRootFromParent_Done,
     /*  70957 */   // Label 1427: @70957
     /*  70957 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71020), // Rule ID 1902 //
     /*  70962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70998 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71018 */     GIR_RootConstrainSelectedInstOperands,
     /*  71019 */     // GIR_Coverage, 1902,
     /*  71019 */     GIR_EraseRootFromParent_Done,
     /*  71020 */   // Label 1428: @71020
     /*  71020 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71083), // Rule ID 1990 //
     /*  71025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71061 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71066 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71068 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71070 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71081 */     GIR_RootConstrainSelectedInstOperands,
     /*  71082 */     // GIR_Coverage, 1990,
     /*  71082 */     GIR_EraseRootFromParent_Done,
     /*  71083 */   // Label 1429: @71083
     /*  71083 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71146), // Rule ID 1991 //
     /*  71088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71124 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71129 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71131 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71133 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71144 */     GIR_RootConstrainSelectedInstOperands,
     /*  71145 */     // GIR_Coverage, 1991,
     /*  71145 */     GIR_EraseRootFromParent_Done,
     /*  71146 */   // Label 1430: @71146
     /*  71146 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71209), // Rule ID 1992 //
     /*  71151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71187 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71192 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71194 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71196 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71207 */     GIR_RootConstrainSelectedInstOperands,
     /*  71208 */     // GIR_Coverage, 1992,
     /*  71208 */     GIR_EraseRootFromParent_Done,
     /*  71209 */   // Label 1431: @71209
     /*  71209 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71272), // Rule ID 1993 //
     /*  71214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71250 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71255 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71257 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71259 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71270 */     GIR_RootConstrainSelectedInstOperands,
     /*  71271 */     // GIR_Coverage, 1993,
     /*  71271 */     GIR_EraseRootFromParent_Done,
     /*  71272 */   // Label 1432: @71272
     /*  71272 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71335), // Rule ID 1994 //
     /*  71277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71313 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71318 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71320 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71322 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71333 */     GIR_RootConstrainSelectedInstOperands,
     /*  71334 */     // GIR_Coverage, 1994,
     /*  71334 */     GIR_EraseRootFromParent_Done,
     /*  71335 */   // Label 1433: @71335
     /*  71335 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71398), // Rule ID 1995 //
     /*  71340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71376 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71381 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71383 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71385 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71396 */     GIR_RootConstrainSelectedInstOperands,
     /*  71397 */     // GIR_Coverage, 1995,
     /*  71397 */     GIR_EraseRootFromParent_Done,
     /*  71398 */   // Label 1434: @71398
     /*  71398 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71461), // Rule ID 2181 //
     /*  71403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71439 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71444 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71446 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71448 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71459 */     GIR_RootConstrainSelectedInstOperands,
     /*  71460 */     // GIR_Coverage, 2181,
     /*  71460 */     GIR_EraseRootFromParent_Done,
     /*  71461 */   // Label 1435: @71461
     /*  71461 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71524), // Rule ID 2182 //
     /*  71466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71502 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71507 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71509 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71511 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71522 */     GIR_RootConstrainSelectedInstOperands,
     /*  71523 */     // GIR_Coverage, 2182,
     /*  71523 */     GIR_EraseRootFromParent_Done,
     /*  71524 */   // Label 1436: @71524
     /*  71524 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(71587), // Rule ID 2183 //
     /*  71529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71565 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71570 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71572 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71574 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71585 */     GIR_RootConstrainSelectedInstOperands,
     /*  71586 */     // GIR_Coverage, 2183,
     /*  71586 */     GIR_EraseRootFromParent_Done,
     /*  71587 */   // Label 1437: @71587
     /*  71587 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(71650), // Rule ID 2184 //
     /*  71592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71628 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71633 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71635 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71637 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71648 */     GIR_RootConstrainSelectedInstOperands,
     /*  71649 */     // GIR_Coverage, 2184,
     /*  71649 */     GIR_EraseRootFromParent_Done,
     /*  71650 */   // Label 1438: @71650
     /*  71650 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(71713), // Rule ID 2185 //
     /*  71655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71691 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71696 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71698 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71700 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71711 */     GIR_RootConstrainSelectedInstOperands,
     /*  71712 */     // GIR_Coverage, 2185,
     /*  71712 */     GIR_EraseRootFromParent_Done,
     /*  71713 */   // Label 1439: @71713
     /*  71713 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(71776), // Rule ID 2186 //
     /*  71718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71754 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71759 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71761 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71763 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71774 */     GIR_RootConstrainSelectedInstOperands,
     /*  71775 */     // GIR_Coverage, 2186,
     /*  71775 */     GIR_EraseRootFromParent_Done,
     /*  71776 */   // Label 1440: @71776
     /*  71776 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(71839), // Rule ID 2472 //
     /*  71781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  71798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  71801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71817 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  71817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  71820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71837 */     GIR_RootConstrainSelectedInstOperands,
     /*  71838 */     // GIR_Coverage, 2472,
     /*  71838 */     GIR_EraseRootFromParent_Done,
     /*  71839 */   // Label 1441: @71839
     /*  71839 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(71902), // Rule ID 2473 //
     /*  71844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  71855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  71861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  71864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71880 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  71880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  71883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71900 */     GIR_RootConstrainSelectedInstOperands,
     /*  71901 */     // GIR_Coverage, 2473,
     /*  71901 */     GIR_EraseRootFromParent_Done,
     /*  71902 */   // Label 1442: @71902
     /*  71902 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(71965), // Rule ID 2474 //
     /*  71907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  71927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71943 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3814:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  71943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  71946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71963 */     GIR_RootConstrainSelectedInstOperands,
     /*  71964 */     // GIR_Coverage, 2474,
     /*  71964 */     GIR_EraseRootFromParent_Done,
     /*  71965 */   // Label 1443: @71965
     /*  71965 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72028), // Rule ID 2475 //
     /*  71970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72006 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72011 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72026 */     GIR_RootConstrainSelectedInstOperands,
     /*  72027 */     // GIR_Coverage, 2475,
     /*  72027 */     GIR_EraseRootFromParent_Done,
     /*  72028 */   // Label 1444: @72028
     /*  72028 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72091), // Rule ID 2480 //
     /*  72033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72069 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3815:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72089 */     GIR_RootConstrainSelectedInstOperands,
     /*  72090 */     // GIR_Coverage, 2480,
     /*  72090 */     GIR_EraseRootFromParent_Done,
     /*  72091 */   // Label 1445: @72091
     /*  72091 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72154), // Rule ID 2481 //
     /*  72096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72132 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3815:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72152 */     GIR_RootConstrainSelectedInstOperands,
     /*  72153 */     // GIR_Coverage, 2481,
     /*  72153 */     GIR_EraseRootFromParent_Done,
     /*  72154 */   // Label 1446: @72154
     /*  72154 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72217), // Rule ID 2482 //
     /*  72159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72195 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3815:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72215 */     GIR_RootConstrainSelectedInstOperands,
     /*  72216 */     // GIR_Coverage, 2482,
     /*  72216 */     GIR_EraseRootFromParent_Done,
     /*  72217 */   // Label 1447: @72217
     /*  72217 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72280), // Rule ID 2483 //
     /*  72222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72258 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3815:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72278 */     GIR_RootConstrainSelectedInstOperands,
     /*  72279 */     // GIR_Coverage, 2483,
     /*  72279 */     GIR_EraseRootFromParent_Done,
     /*  72280 */   // Label 1448: @72280
     /*  72280 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72349), // Rule ID 4840 //
     /*  72285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72321 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72326 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72328 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72330 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72347 */     GIR_RootConstrainSelectedInstOperands,
     /*  72348 */     // GIR_Coverage, 4840,
     /*  72348 */     GIR_EraseRootFromParent_Done,
     /*  72349 */   // Label 1449: @72349
     /*  72349 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72418), // Rule ID 4842 //
     /*  72354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72390 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72395 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72397 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72399 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72416 */     GIR_RootConstrainSelectedInstOperands,
     /*  72417 */     // GIR_Coverage, 4842,
     /*  72417 */     GIR_EraseRootFromParent_Done,
     /*  72418 */   // Label 1450: @72418
     /*  72418 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72487), // Rule ID 4844 //
     /*  72423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72464 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72466 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72468 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72485 */     GIR_RootConstrainSelectedInstOperands,
     /*  72486 */     // GIR_Coverage, 4844,
     /*  72486 */     GIR_EraseRootFromParent_Done,
     /*  72487 */   // Label 1451: @72487
     /*  72487 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(72556), // Rule ID 4846 //
     /*  72492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72528 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72533 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72535 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72537 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72554 */     GIR_RootConstrainSelectedInstOperands,
     /*  72555 */     // GIR_Coverage, 4846,
     /*  72555 */     GIR_EraseRootFromParent_Done,
     /*  72556 */   // Label 1452: @72556
     /*  72556 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(72625), // Rule ID 4848 //
     /*  72561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72597 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72602 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72604 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72606 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72623 */     GIR_RootConstrainSelectedInstOperands,
     /*  72624 */     // GIR_Coverage, 4848,
     /*  72624 */     GIR_EraseRootFromParent_Done,
     /*  72625 */   // Label 1453: @72625
     /*  72625 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(72694), // Rule ID 4850 //
     /*  72630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72666 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72671 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72673 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72675 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72692 */     GIR_RootConstrainSelectedInstOperands,
     /*  72693 */     // GIR_Coverage, 4850,
     /*  72693 */     GIR_EraseRootFromParent_Done,
     /*  72694 */   // Label 1454: @72694
     /*  72694 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(72763), // Rule ID 4852 //
     /*  72699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72735 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72740 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72742 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72744 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72761 */     GIR_RootConstrainSelectedInstOperands,
     /*  72762 */     // GIR_Coverage, 4852,
     /*  72762 */     GIR_EraseRootFromParent_Done,
     /*  72763 */   // Label 1455: @72763
     /*  72763 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(72832), // Rule ID 4854 //
     /*  72768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72804 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  72807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72809 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72811 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72813 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72830 */     GIR_RootConstrainSelectedInstOperands,
     /*  72831 */     // GIR_Coverage, 4854,
     /*  72831 */     GIR_EraseRootFromParent_Done,
     /*  72832 */   // Label 1456: @72832
     /*  72832 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(72901), // Rule ID 4856 //
     /*  72837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72873 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  72876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72878 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72880 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72882 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72899 */     GIR_RootConstrainSelectedInstOperands,
     /*  72900 */     // GIR_Coverage, 4856,
     /*  72900 */     GIR_EraseRootFromParent_Done,
     /*  72901 */   // Label 1457: @72901
     /*  72901 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(72970), // Rule ID 4858 //
     /*  72906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72942 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  72945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72947 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72949 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72951 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72968 */     GIR_RootConstrainSelectedInstOperands,
     /*  72969 */     // GIR_Coverage, 4858,
     /*  72969 */     GIR_EraseRootFromParent_Done,
     /*  72970 */   // Label 1458: @72970
     /*  72970 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73039), // Rule ID 4860 //
     /*  72975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73011 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73016 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73018 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73020 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73037 */     GIR_RootConstrainSelectedInstOperands,
     /*  73038 */     // GIR_Coverage, 4860,
     /*  73038 */     GIR_EraseRootFromParent_Done,
     /*  73039 */   // Label 1459: @73039
     /*  73039 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(73108), // Rule ID 4862 //
     /*  73044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73080 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73085 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73087 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73089 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73106 */     GIR_RootConstrainSelectedInstOperands,
     /*  73107 */     // GIR_Coverage, 4862,
     /*  73107 */     GIR_EraseRootFromParent_Done,
     /*  73108 */   // Label 1460: @73108
     /*  73108 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(73203), // Rule ID 2694 //
     /*  73113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73137 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3731:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73149 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73170 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73173 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73176 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73194 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73199 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73201 */     GIR_RootConstrainSelectedInstOperands,
     /*  73202 */     // GIR_Coverage, 2694,
     /*  73202 */     GIR_EraseRootFromParent_Done,
     /*  73203 */   // Label 1461: @73203
     /*  73203 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(73298), // Rule ID 2695 //
     /*  73208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73232 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3733:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73232 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73235 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73239 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73244 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73289 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73294 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73296 */     GIR_RootConstrainSelectedInstOperands,
     /*  73297 */     // GIR_Coverage, 2695,
     /*  73297 */     GIR_EraseRootFromParent_Done,
     /*  73298 */   // Label 1462: @73298
     /*  73298 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73393), // Rule ID 2696 //
     /*  73303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73327 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73366 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73384 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73389 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73391 */     GIR_RootConstrainSelectedInstOperands,
     /*  73392 */     // GIR_Coverage, 2696,
     /*  73392 */     GIR_EraseRootFromParent_Done,
     /*  73393 */   // Label 1463: @73393
     /*  73393 */   GIM_Reject,
     /*  73394 */ // Label 1316: @73394
     /*  73394 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(76780),
     /*  73399 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73402 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(73486), // Rule ID 3727 //
     /*  73407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73447 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73484 */     GIR_RootConstrainSelectedInstOperands,
     /*  73485 */     // GIR_Coverage, 3727,
     /*  73485 */     GIR_EraseRootFromParent_Done,
     /*  73486 */   // Label 1465: @73486
     /*  73486 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(73570), // Rule ID 3731 //
     /*  73491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73531 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73568 */     GIR_RootConstrainSelectedInstOperands,
     /*  73569 */     // GIR_Coverage, 3731,
     /*  73569 */     GIR_EraseRootFromParent_Done,
     /*  73570 */   // Label 1466: @73570
     /*  73570 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(73654), // Rule ID 3735 //
     /*  73575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73615 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73652 */     GIR_RootConstrainSelectedInstOperands,
     /*  73653 */     // GIR_Coverage, 3735,
     /*  73653 */     GIR_EraseRootFromParent_Done,
     /*  73654 */   // Label 1467: @73654
     /*  73654 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(73738), // Rule ID 3739 //
     /*  73659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73699 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73736 */     GIR_RootConstrainSelectedInstOperands,
     /*  73737 */     // GIR_Coverage, 3739,
     /*  73737 */     GIR_EraseRootFromParent_Done,
     /*  73738 */   // Label 1468: @73738
     /*  73738 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(73822), // Rule ID 3743 //
     /*  73743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73783 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  73798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73820 */     GIR_RootConstrainSelectedInstOperands,
     /*  73821 */     // GIR_Coverage, 3743,
     /*  73821 */     GIR_EraseRootFromParent_Done,
     /*  73822 */   // Label 1469: @73822
     /*  73822 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(73906), // Rule ID 3747 //
     /*  73827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73867 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  73882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73884 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73904 */     GIR_RootConstrainSelectedInstOperands,
     /*  73905 */     // GIR_Coverage, 3747,
     /*  73905 */     GIR_EraseRootFromParent_Done,
     /*  73906 */   // Label 1470: @73906
     /*  73906 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(73990), // Rule ID 3751 //
     /*  73911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73951 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  73966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73988 */     GIR_RootConstrainSelectedInstOperands,
     /*  73989 */     // GIR_Coverage, 3751,
     /*  73989 */     GIR_EraseRootFromParent_Done,
     /*  73990 */   // Label 1471: @73990
     /*  73990 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74074), // Rule ID 3755 //
     /*  73995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74035 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74072 */     GIR_RootConstrainSelectedInstOperands,
     /*  74073 */     // GIR_Coverage, 3755,
     /*  74073 */     GIR_EraseRootFromParent_Done,
     /*  74074 */   // Label 1472: @74074
     /*  74074 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74163), // Rule ID 4387 //
     /*  74079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74122 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74161 */     GIR_RootConstrainSelectedInstOperands,
     /*  74162 */     // GIR_Coverage, 4387,
     /*  74162 */     GIR_EraseRootFromParent_Done,
     /*  74163 */   // Label 1473: @74163
     /*  74163 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74252), // Rule ID 4389 //
     /*  74168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74211 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74250 */     GIR_RootConstrainSelectedInstOperands,
     /*  74251 */     // GIR_Coverage, 4389,
     /*  74251 */     GIR_EraseRootFromParent_Done,
     /*  74252 */   // Label 1474: @74252
     /*  74252 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74341), // Rule ID 4391 //
     /*  74257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74300 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74339 */     GIR_RootConstrainSelectedInstOperands,
     /*  74340 */     // GIR_Coverage, 4391,
     /*  74340 */     GIR_EraseRootFromParent_Done,
     /*  74341 */   // Label 1475: @74341
     /*  74341 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74430), // Rule ID 4393 //
     /*  74346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74389 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74428 */     GIR_RootConstrainSelectedInstOperands,
     /*  74429 */     // GIR_Coverage, 4393,
     /*  74429 */     GIR_EraseRootFromParent_Done,
     /*  74430 */   // Label 1476: @74430
     /*  74430 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(74519), // Rule ID 4395 //
     /*  74435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74478 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74517 */     GIR_RootConstrainSelectedInstOperands,
     /*  74518 */     // GIR_Coverage, 4395,
     /*  74518 */     GIR_EraseRootFromParent_Done,
     /*  74519 */   // Label 1477: @74519
     /*  74519 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(74608), // Rule ID 4397 //
     /*  74524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74567 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74606 */     GIR_RootConstrainSelectedInstOperands,
     /*  74607 */     // GIR_Coverage, 4397,
     /*  74607 */     GIR_EraseRootFromParent_Done,
     /*  74608 */   // Label 1478: @74608
     /*  74608 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(74697), // Rule ID 4399 //
     /*  74613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74656 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74695 */     GIR_RootConstrainSelectedInstOperands,
     /*  74696 */     // GIR_Coverage, 4399,
     /*  74696 */     GIR_EraseRootFromParent_Done,
     /*  74697 */   // Label 1479: @74697
     /*  74697 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(74786), // Rule ID 4401 //
     /*  74702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74745 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74784 */     GIR_RootConstrainSelectedInstOperands,
     /*  74785 */     // GIR_Coverage, 4401,
     /*  74785 */     GIR_EraseRootFromParent_Done,
     /*  74786 */   // Label 1480: @74786
     /*  74786 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(74875), // Rule ID 4403 //
     /*  74791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74834 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  74849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74873 */     GIR_RootConstrainSelectedInstOperands,
     /*  74874 */     // GIR_Coverage, 4403,
     /*  74874 */     GIR_EraseRootFromParent_Done,
     /*  74875 */   // Label 1481: @74875
     /*  74875 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(74964), // Rule ID 4405 //
     /*  74880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74923 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  74938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74962 */     GIR_RootConstrainSelectedInstOperands,
     /*  74963 */     // GIR_Coverage, 4405,
     /*  74963 */     GIR_EraseRootFromParent_Done,
     /*  74964 */   // Label 1482: @74964
     /*  74964 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75053), // Rule ID 4407 //
     /*  74969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75012 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75051 */     GIR_RootConstrainSelectedInstOperands,
     /*  75052 */     // GIR_Coverage, 4407,
     /*  75052 */     GIR_EraseRootFromParent_Done,
     /*  75053 */   // Label 1483: @75053
     /*  75053 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75142), // Rule ID 4409 //
     /*  75058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75101 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75140 */     GIR_RootConstrainSelectedInstOperands,
     /*  75141 */     // GIR_Coverage, 4409,
     /*  75141 */     GIR_EraseRootFromParent_Done,
     /*  75142 */   // Label 1484: @75142
     /*  75142 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75240), // Rule ID 4032 //
     /*  75147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75186 */     // MIs[1] Operand 1
     /*  75186 */     // No operand predicates
     /*  75186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75196 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75215 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75238 */     GIR_RootConstrainSelectedInstOperands,
     /*  75239 */     // GIR_Coverage, 4032,
     /*  75239 */     GIR_EraseRootFromParent_Done,
     /*  75240 */   // Label 1485: @75240
     /*  75240 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75338), // Rule ID 4034 //
     /*  75245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75284 */     // MIs[1] Operand 1
     /*  75284 */     // No operand predicates
     /*  75284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75294 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75336 */     GIR_RootConstrainSelectedInstOperands,
     /*  75337 */     // GIR_Coverage, 4034,
     /*  75337 */     GIR_EraseRootFromParent_Done,
     /*  75338 */   // Label 1486: @75338
     /*  75338 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(75436), // Rule ID 4541 //
     /*  75343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75382 */     // MIs[1] Operand 1
     /*  75382 */     // No operand predicates
     /*  75382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75392 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75411 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75434 */     GIR_RootConstrainSelectedInstOperands,
     /*  75435 */     // GIR_Coverage, 4541,
     /*  75435 */     GIR_EraseRootFromParent_Done,
     /*  75436 */   // Label 1487: @75436
     /*  75436 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(75534), // Rule ID 4543 //
     /*  75441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75480 */     // MIs[1] Operand 1
     /*  75480 */     // No operand predicates
     /*  75480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75490 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75509 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75532 */     GIR_RootConstrainSelectedInstOperands,
     /*  75533 */     // GIR_Coverage, 4543,
     /*  75533 */     GIR_EraseRootFromParent_Done,
     /*  75534 */   // Label 1488: @75534
     /*  75534 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(75632), // Rule ID 4545 //
     /*  75539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75578 */     // MIs[1] Operand 1
     /*  75578 */     // No operand predicates
     /*  75578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75630 */     GIR_RootConstrainSelectedInstOperands,
     /*  75631 */     // GIR_Coverage, 4545,
     /*  75631 */     GIR_EraseRootFromParent_Done,
     /*  75632 */   // Label 1489: @75632
     /*  75632 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(75730), // Rule ID 4547 //
     /*  75637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75676 */     // MIs[1] Operand 1
     /*  75676 */     // No operand predicates
     /*  75676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75686 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75705 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75728 */     GIR_RootConstrainSelectedInstOperands,
     /*  75729 */     // GIR_Coverage, 4547,
     /*  75729 */     GIR_EraseRootFromParent_Done,
     /*  75730 */   // Label 1490: @75730
     /*  75730 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(75828), // Rule ID 4549 //
     /*  75735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75774 */     // MIs[1] Operand 1
     /*  75774 */     // No operand predicates
     /*  75774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75784 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  75799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75803 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75826 */     GIR_RootConstrainSelectedInstOperands,
     /*  75827 */     // GIR_Coverage, 4549,
     /*  75827 */     GIR_EraseRootFromParent_Done,
     /*  75828 */   // Label 1491: @75828
     /*  75828 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(75926), // Rule ID 4551 //
     /*  75833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75872 */     // MIs[1] Operand 1
     /*  75872 */     // No operand predicates
     /*  75872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75882 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  75897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75901 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75924 */     GIR_RootConstrainSelectedInstOperands,
     /*  75925 */     // GIR_Coverage, 4551,
     /*  75925 */     GIR_EraseRootFromParent_Done,
     /*  75926 */   // Label 1492: @75926
     /*  75926 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(76002), // Rule ID 3037 //
     /*  75931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75974 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  75974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  75977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75983 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76000 */     GIR_RootConstrainSelectedInstOperands,
     /*  76001 */     // GIR_Coverage, 3037,
     /*  76001 */     GIR_EraseRootFromParent_Done,
     /*  76002 */   // Label 1493: @76002
     /*  76002 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76078), // Rule ID 3039 //
     /*  76007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76050 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76059 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76076 */     GIR_RootConstrainSelectedInstOperands,
     /*  76077 */     // GIR_Coverage, 3039,
     /*  76077 */     GIR_EraseRootFromParent_Done,
     /*  76078 */   // Label 1494: @76078
     /*  76078 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76154), // Rule ID 3041 //
     /*  76083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76126 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76135 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76152 */     GIR_RootConstrainSelectedInstOperands,
     /*  76153 */     // GIR_Coverage, 3041,
     /*  76153 */     GIR_EraseRootFromParent_Done,
     /*  76154 */   // Label 1495: @76154
     /*  76154 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76230), // Rule ID 3043 //
     /*  76159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76202 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76211 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76228 */     GIR_RootConstrainSelectedInstOperands,
     /*  76229 */     // GIR_Coverage, 3043,
     /*  76229 */     GIR_EraseRootFromParent_Done,
     /*  76230 */   // Label 1496: @76230
     /*  76230 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76306), // Rule ID 3045 //
     /*  76235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76278 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76304 */     GIR_RootConstrainSelectedInstOperands,
     /*  76305 */     // GIR_Coverage, 3045,
     /*  76305 */     GIR_EraseRootFromParent_Done,
     /*  76306 */   // Label 1497: @76306
     /*  76306 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76382), // Rule ID 3047 //
     /*  76311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76354 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76363 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76380 */     GIR_RootConstrainSelectedInstOperands,
     /*  76381 */     // GIR_Coverage, 3047,
     /*  76381 */     GIR_EraseRootFromParent_Done,
     /*  76382 */   // Label 1498: @76382
     /*  76382 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(76467), // Rule ID 3996 //
     /*  76387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76422 */     // MIs[1] Operand 1
     /*  76422 */     // No operand predicates
     /*  76422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76436 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3608:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76445 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76465 */     GIR_RootConstrainSelectedInstOperands,
     /*  76466 */     // GIR_Coverage, 3996,
     /*  76466 */     GIR_EraseRootFromParent_Done,
     /*  76467 */   // Label 1499: @76467
     /*  76467 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(76552), // Rule ID 3999 //
     /*  76472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76507 */     // MIs[1] Operand 1
     /*  76507 */     // No operand predicates
     /*  76507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76521 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3608:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76530 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76550 */     GIR_RootConstrainSelectedInstOperands,
     /*  76551 */     // GIR_Coverage, 3999,
     /*  76551 */     GIR_EraseRootFromParent_Done,
     /*  76552 */   // Label 1500: @76552
     /*  76552 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(76648), // Rule ID 2688 //
     /*  76557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76584 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3859:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76600 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76607 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76630 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76635 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76646 */     GIR_RootConstrainSelectedInstOperands,
     /*  76647 */     // GIR_Coverage, 2688,
     /*  76647 */     GIR_EraseRootFromParent_Done,
     /*  76648 */   // Label 1501: @76648
     /*  76648 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(76779), // Rule ID 2689 //
     /*  76653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76680 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3856:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76680 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76683 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76687 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76710 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76717 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76724 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76730 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76766 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76777 */     GIR_RootConstrainSelectedInstOperands,
     /*  76778 */     // GIR_Coverage, 2689,
     /*  76778 */     GIR_EraseRootFromParent_Done,
     /*  76779 */   // Label 1502: @76779
     /*  76779 */   GIM_Reject,
     /*  76780 */ // Label 1464: @76780
     /*  76780 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(82086),
     /*  76785 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  76788 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(76881), // Rule ID 3838 //
     /*  76793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76840 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  76840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  76855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76857 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76859 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76879 */     GIR_RootConstrainSelectedInstOperands,
     /*  76880 */     // GIR_Coverage, 3838,
     /*  76880 */     GIR_EraseRootFromParent_Done,
     /*  76881 */   // Label 1504: @76881
     /*  76881 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(76974), // Rule ID 3840 //
     /*  76886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76933 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  76933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  76948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76950 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76952 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76972 */     GIR_RootConstrainSelectedInstOperands,
     /*  76973 */     // GIR_Coverage, 3840,
     /*  76973 */     GIR_EraseRootFromParent_Done,
     /*  76974 */   // Label 1505: @76974
     /*  76974 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77067), // Rule ID 3842 //
     /*  76979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77026 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77043 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77045 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77065 */     GIR_RootConstrainSelectedInstOperands,
     /*  77066 */     // GIR_Coverage, 3842,
     /*  77066 */     GIR_EraseRootFromParent_Done,
     /*  77067 */   // Label 1506: @77067
     /*  77067 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77160), // Rule ID 3844 //
     /*  77072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77119 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77136 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77138 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77158 */     GIR_RootConstrainSelectedInstOperands,
     /*  77159 */     // GIR_Coverage, 3844,
     /*  77159 */     GIR_EraseRootFromParent_Done,
     /*  77160 */   // Label 1507: @77160
     /*  77160 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77253), // Rule ID 3846 //
     /*  77165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77212 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77229 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77231 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77251 */     GIR_RootConstrainSelectedInstOperands,
     /*  77252 */     // GIR_Coverage, 3846,
     /*  77252 */     GIR_EraseRootFromParent_Done,
     /*  77253 */   // Label 1508: @77253
     /*  77253 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77346), // Rule ID 3848 //
     /*  77258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77305 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77322 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77324 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77344 */     GIR_RootConstrainSelectedInstOperands,
     /*  77345 */     // GIR_Coverage, 3848,
     /*  77345 */     GIR_EraseRootFromParent_Done,
     /*  77346 */   // Label 1509: @77346
     /*  77346 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(77439), // Rule ID 3850 //
     /*  77351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77398 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77415 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77417 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77437 */     GIR_RootConstrainSelectedInstOperands,
     /*  77438 */     // GIR_Coverage, 3850,
     /*  77438 */     GIR_EraseRootFromParent_Done,
     /*  77439 */   // Label 1510: @77439
     /*  77439 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(77532), // Rule ID 3852 //
     /*  77444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77491 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77508 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77510 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77530 */     GIR_RootConstrainSelectedInstOperands,
     /*  77531 */     // GIR_Coverage, 3852,
     /*  77531 */     GIR_EraseRootFromParent_Done,
     /*  77532 */   // Label 1511: @77532
     /*  77532 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(77625), // Rule ID 3854 //
     /*  77537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77601 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77603 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77623 */     GIR_RootConstrainSelectedInstOperands,
     /*  77624 */     // GIR_Coverage, 3854,
     /*  77624 */     GIR_EraseRootFromParent_Done,
     /*  77625 */   // Label 1512: @77625
     /*  77625 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(77718), // Rule ID 3856 //
     /*  77630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77677 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77694 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77696 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77716 */     GIR_RootConstrainSelectedInstOperands,
     /*  77717 */     // GIR_Coverage, 3856,
     /*  77717 */     GIR_EraseRootFromParent_Done,
     /*  77718 */   // Label 1513: @77718
     /*  77718 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(77811), // Rule ID 3858 //
     /*  77723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77770 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77787 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77789 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77809 */     GIR_RootConstrainSelectedInstOperands,
     /*  77810 */     // GIR_Coverage, 3858,
     /*  77810 */     GIR_EraseRootFromParent_Done,
     /*  77811 */   // Label 1514: @77811
     /*  77811 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(77904), // Rule ID 3860 //
     /*  77816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77863 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  77878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77880 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77882 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77902 */     GIR_RootConstrainSelectedInstOperands,
     /*  77903 */     // GIR_Coverage, 3860,
     /*  77903 */     GIR_EraseRootFromParent_Done,
     /*  77904 */   // Label 1515: @77904
     /*  77904 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(77997), // Rule ID 3862 //
     /*  77909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77956 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  77971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77973 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77975 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77995 */     GIR_RootConstrainSelectedInstOperands,
     /*  77996 */     // GIR_Coverage, 3862,
     /*  77996 */     GIR_EraseRootFromParent_Done,
     /*  77997 */   // Label 1516: @77997
     /*  77997 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78090), // Rule ID 3864 //
     /*  78002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78049 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78066 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78068 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78088 */     GIR_RootConstrainSelectedInstOperands,
     /*  78089 */     // GIR_Coverage, 3864,
     /*  78089 */     GIR_EraseRootFromParent_Done,
     /*  78090 */   // Label 1517: @78090
     /*  78090 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78183), // Rule ID 3866 //
     /*  78095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78142 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78159 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78161 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78181 */     GIR_RootConstrainSelectedInstOperands,
     /*  78182 */     // GIR_Coverage, 3866,
     /*  78182 */     GIR_EraseRootFromParent_Done,
     /*  78183 */   // Label 1518: @78183
     /*  78183 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78276), // Rule ID 3868 //
     /*  78188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78235 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78252 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78254 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78274 */     GIR_RootConstrainSelectedInstOperands,
     /*  78275 */     // GIR_Coverage, 3868,
     /*  78275 */     GIR_EraseRootFromParent_Done,
     /*  78276 */   // Label 1519: @78276
     /*  78276 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78369), // Rule ID 3870 //
     /*  78281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78328 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78345 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78347 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78367 */     GIR_RootConstrainSelectedInstOperands,
     /*  78368 */     // GIR_Coverage, 3870,
     /*  78368 */     GIR_EraseRootFromParent_Done,
     /*  78369 */   // Label 1520: @78369
     /*  78369 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(78462), // Rule ID 3872 //
     /*  78374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78421 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78438 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78440 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78460 */     GIR_RootConstrainSelectedInstOperands,
     /*  78461 */     // GIR_Coverage, 3872,
     /*  78461 */     GIR_EraseRootFromParent_Done,
     /*  78462 */   // Label 1521: @78462
     /*  78462 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(78555), // Rule ID 3874 //
     /*  78467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78514 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78531 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78533 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78553 */     GIR_RootConstrainSelectedInstOperands,
     /*  78554 */     // GIR_Coverage, 3874,
     /*  78554 */     GIR_EraseRootFromParent_Done,
     /*  78555 */   // Label 1522: @78555
     /*  78555 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(78648), // Rule ID 3876 //
     /*  78560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78607 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78624 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78626 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78646 */     GIR_RootConstrainSelectedInstOperands,
     /*  78647 */     // GIR_Coverage, 3876,
     /*  78647 */     GIR_EraseRootFromParent_Done,
     /*  78648 */   // Label 1523: @78648
     /*  78648 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(78741), // Rule ID 3878 //
     /*  78653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78700 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78717 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78719 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78739 */     GIR_RootConstrainSelectedInstOperands,
     /*  78740 */     // GIR_Coverage, 3878,
     /*  78740 */     GIR_EraseRootFromParent_Done,
     /*  78741 */   // Label 1524: @78741
     /*  78741 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(78834), // Rule ID 3880 //
     /*  78746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78793 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  78808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78810 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78812 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78832 */     GIR_RootConstrainSelectedInstOperands,
     /*  78833 */     // GIR_Coverage, 3880,
     /*  78833 */     GIR_EraseRootFromParent_Done,
     /*  78834 */   // Label 1525: @78834
     /*  78834 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(78927), // Rule ID 3882 //
     /*  78839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78886 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  78901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78903 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78905 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78925 */     GIR_RootConstrainSelectedInstOperands,
     /*  78926 */     // GIR_Coverage, 3882,
     /*  78926 */     GIR_EraseRootFromParent_Done,
     /*  78927 */   // Label 1526: @78927
     /*  78927 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(79020), // Rule ID 3884 //
     /*  78932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78979 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  78994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78996 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78998 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79018 */     GIR_RootConstrainSelectedInstOperands,
     /*  79019 */     // GIR_Coverage, 3884,
     /*  79019 */     GIR_EraseRootFromParent_Done,
     /*  79020 */   // Label 1527: @79020
     /*  79020 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79098), // Rule ID 4489 //
     /*  79025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79072 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79096 */     GIR_RootConstrainSelectedInstOperands,
     /*  79097 */     // GIR_Coverage, 4489,
     /*  79097 */     GIR_EraseRootFromParent_Done,
     /*  79098 */   // Label 1528: @79098
     /*  79098 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79176), // Rule ID 4491 //
     /*  79103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79150 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79174 */     GIR_RootConstrainSelectedInstOperands,
     /*  79175 */     // GIR_Coverage, 4491,
     /*  79175 */     GIR_EraseRootFromParent_Done,
     /*  79176 */   // Label 1529: @79176
     /*  79176 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79254), // Rule ID 4493 //
     /*  79181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79228 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79252 */     GIR_RootConstrainSelectedInstOperands,
     /*  79253 */     // GIR_Coverage, 4493,
     /*  79253 */     GIR_EraseRootFromParent_Done,
     /*  79254 */   // Label 1530: @79254
     /*  79254 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79332), // Rule ID 4495 //
     /*  79259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79306 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79330 */     GIR_RootConstrainSelectedInstOperands,
     /*  79331 */     // GIR_Coverage, 4495,
     /*  79331 */     GIR_EraseRootFromParent_Done,
     /*  79332 */   // Label 1531: @79332
     /*  79332 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79410), // Rule ID 4497 //
     /*  79337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79384 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79408 */     GIR_RootConstrainSelectedInstOperands,
     /*  79409 */     // GIR_Coverage, 4497,
     /*  79409 */     GIR_EraseRootFromParent_Done,
     /*  79410 */   // Label 1532: @79410
     /*  79410 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(79488), // Rule ID 4499 //
     /*  79415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79462 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79486 */     GIR_RootConstrainSelectedInstOperands,
     /*  79487 */     // GIR_Coverage, 4499,
     /*  79487 */     GIR_EraseRootFromParent_Done,
     /*  79488 */   // Label 1533: @79488
     /*  79488 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(79566), // Rule ID 4501 //
     /*  79493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79540 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79564 */     GIR_RootConstrainSelectedInstOperands,
     /*  79565 */     // GIR_Coverage, 4501,
     /*  79565 */     GIR_EraseRootFromParent_Done,
     /*  79566 */   // Label 1534: @79566
     /*  79566 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(79644), // Rule ID 4503 //
     /*  79571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79618 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79642 */     GIR_RootConstrainSelectedInstOperands,
     /*  79643 */     // GIR_Coverage, 4503,
     /*  79643 */     GIR_EraseRootFromParent_Done,
     /*  79644 */   // Label 1535: @79644
     /*  79644 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(79722), // Rule ID 4505 //
     /*  79649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79696 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79720 */     GIR_RootConstrainSelectedInstOperands,
     /*  79721 */     // GIR_Coverage, 4505,
     /*  79721 */     GIR_EraseRootFromParent_Done,
     /*  79722 */   // Label 1536: @79722
     /*  79722 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(79800), // Rule ID 4507 //
     /*  79727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79774 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79798 */     GIR_RootConstrainSelectedInstOperands,
     /*  79799 */     // GIR_Coverage, 4507,
     /*  79799 */     GIR_EraseRootFromParent_Done,
     /*  79800 */   // Label 1537: @79800
     /*  79800 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(79878), // Rule ID 4509 //
     /*  79805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79852 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  79855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79876 */     GIR_RootConstrainSelectedInstOperands,
     /*  79877 */     // GIR_Coverage, 4509,
     /*  79877 */     GIR_EraseRootFromParent_Done,
     /*  79878 */   // Label 1538: @79878
     /*  79878 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(79956), // Rule ID 4511 //
     /*  79883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79926 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79930 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  79933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79954 */     GIR_RootConstrainSelectedInstOperands,
     /*  79955 */     // GIR_Coverage, 4511,
     /*  79955 */     GIR_EraseRootFromParent_Done,
     /*  79956 */   // Label 1539: @79956
     /*  79956 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(80034), // Rule ID 4701 //
     /*  79961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80008 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80013 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80015 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80032 */     GIR_RootConstrainSelectedInstOperands,
     /*  80033 */     // GIR_Coverage, 4701,
     /*  80033 */     GIR_EraseRootFromParent_Done,
     /*  80034 */   // Label 1540: @80034
     /*  80034 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80112), // Rule ID 4703 //
     /*  80039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80086 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80091 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80093 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80110 */     GIR_RootConstrainSelectedInstOperands,
     /*  80111 */     // GIR_Coverage, 4703,
     /*  80111 */     GIR_EraseRootFromParent_Done,
     /*  80112 */   // Label 1541: @80112
     /*  80112 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80190), // Rule ID 4705 //
     /*  80117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80169 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80171 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80188 */     GIR_RootConstrainSelectedInstOperands,
     /*  80189 */     // GIR_Coverage, 4705,
     /*  80189 */     GIR_EraseRootFromParent_Done,
     /*  80190 */   // Label 1542: @80190
     /*  80190 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80268), // Rule ID 4707 //
     /*  80195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80247 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80249 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80266 */     GIR_RootConstrainSelectedInstOperands,
     /*  80267 */     // GIR_Coverage, 4707,
     /*  80267 */     GIR_EraseRootFromParent_Done,
     /*  80268 */   // Label 1543: @80268
     /*  80268 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80346), // Rule ID 4709 //
     /*  80273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80320 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80325 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80327 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80344 */     GIR_RootConstrainSelectedInstOperands,
     /*  80345 */     // GIR_Coverage, 4709,
     /*  80345 */     GIR_EraseRootFromParent_Done,
     /*  80346 */   // Label 1544: @80346
     /*  80346 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80424), // Rule ID 4711 //
     /*  80351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80398 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80403 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80405 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80422 */     GIR_RootConstrainSelectedInstOperands,
     /*  80423 */     // GIR_Coverage, 4711,
     /*  80423 */     GIR_EraseRootFromParent_Done,
     /*  80424 */   // Label 1545: @80424
     /*  80424 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(80502), // Rule ID 4713 //
     /*  80429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80476 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80481 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80483 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80500 */     GIR_RootConstrainSelectedInstOperands,
     /*  80501 */     // GIR_Coverage, 4713,
     /*  80501 */     GIR_EraseRootFromParent_Done,
     /*  80502 */   // Label 1546: @80502
     /*  80502 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(80580), // Rule ID 4715 //
     /*  80507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80554 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80559 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80561 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80578 */     GIR_RootConstrainSelectedInstOperands,
     /*  80579 */     // GIR_Coverage, 4715,
     /*  80579 */     GIR_EraseRootFromParent_Done,
     /*  80580 */   // Label 1547: @80580
     /*  80580 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(80658), // Rule ID 4717 //
     /*  80585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80632 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80637 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80639 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80656 */     GIR_RootConstrainSelectedInstOperands,
     /*  80657 */     // GIR_Coverage, 4717,
     /*  80657 */     GIR_EraseRootFromParent_Done,
     /*  80658 */   // Label 1548: @80658
     /*  80658 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(80736), // Rule ID 4719 //
     /*  80663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80710 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80715 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80717 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80734 */     GIR_RootConstrainSelectedInstOperands,
     /*  80735 */     // GIR_Coverage, 4719,
     /*  80735 */     GIR_EraseRootFromParent_Done,
     /*  80736 */   // Label 1549: @80736
     /*  80736 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(80814), // Rule ID 4721 //
     /*  80741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80788 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  80791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80793 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80795 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80812 */     GIR_RootConstrainSelectedInstOperands,
     /*  80813 */     // GIR_Coverage, 4721,
     /*  80813 */     GIR_EraseRootFromParent_Done,
     /*  80814 */   // Label 1550: @80814
     /*  80814 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(80892), // Rule ID 4723 //
     /*  80819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80866 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  80869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80871 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80873 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80890 */     GIR_RootConstrainSelectedInstOperands,
     /*  80891 */     // GIR_Coverage, 4723,
     /*  80891 */     GIR_EraseRootFromParent_Done,
     /*  80892 */   // Label 1551: @80892
     /*  80892 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(80970), // Rule ID 4725 //
     /*  80897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80944 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  80947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80949 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80951 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80968 */     GIR_RootConstrainSelectedInstOperands,
     /*  80969 */     // GIR_Coverage, 4725,
     /*  80969 */     GIR_EraseRootFromParent_Done,
     /*  80970 */   // Label 1552: @80970
     /*  80970 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(81048), // Rule ID 4727 //
     /*  80975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81022 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81027 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81029 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81046 */     GIR_RootConstrainSelectedInstOperands,
     /*  81047 */     // GIR_Coverage, 4727,
     /*  81047 */     GIR_EraseRootFromParent_Done,
     /*  81048 */   // Label 1553: @81048
     /*  81048 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81126), // Rule ID 4729 //
     /*  81053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81100 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81105 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81107 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81124 */     GIR_RootConstrainSelectedInstOperands,
     /*  81125 */     // GIR_Coverage, 4729,
     /*  81125 */     GIR_EraseRootFromParent_Done,
     /*  81126 */   // Label 1554: @81126
     /*  81126 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81204), // Rule ID 4731 //
     /*  81131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81178 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81183 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81185 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81202 */     GIR_RootConstrainSelectedInstOperands,
     /*  81203 */     // GIR_Coverage, 4731,
     /*  81203 */     GIR_EraseRootFromParent_Done,
     /*  81204 */   // Label 1555: @81204
     /*  81204 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81282), // Rule ID 4733 //
     /*  81209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81256 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81261 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81263 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81280 */     GIR_RootConstrainSelectedInstOperands,
     /*  81281 */     // GIR_Coverage, 4733,
     /*  81281 */     GIR_EraseRootFromParent_Done,
     /*  81282 */   // Label 1556: @81282
     /*  81282 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81360), // Rule ID 4735 //
     /*  81287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81334 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81339 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81341 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81358 */     GIR_RootConstrainSelectedInstOperands,
     /*  81359 */     // GIR_Coverage, 4735,
     /*  81359 */     GIR_EraseRootFromParent_Done,
     /*  81360 */   // Label 1557: @81360
     /*  81360 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81438), // Rule ID 4737 //
     /*  81365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81412 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81417 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81419 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81436 */     GIR_RootConstrainSelectedInstOperands,
     /*  81437 */     // GIR_Coverage, 4737,
     /*  81437 */     GIR_EraseRootFromParent_Done,
     /*  81438 */   // Label 1558: @81438
     /*  81438 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(81516), // Rule ID 4739 //
     /*  81443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81490 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81495 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81497 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81514 */     GIR_RootConstrainSelectedInstOperands,
     /*  81515 */     // GIR_Coverage, 4739,
     /*  81515 */     GIR_EraseRootFromParent_Done,
     /*  81516 */   // Label 1559: @81516
     /*  81516 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(81594), // Rule ID 4741 //
     /*  81521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81568 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81573 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81575 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81592 */     GIR_RootConstrainSelectedInstOperands,
     /*  81593 */     // GIR_Coverage, 4741,
     /*  81593 */     GIR_EraseRootFromParent_Done,
     /*  81594 */   // Label 1560: @81594
     /*  81594 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(81672), // Rule ID 4743 //
     /*  81599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81646 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81651 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81653 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81670 */     GIR_RootConstrainSelectedInstOperands,
     /*  81671 */     // GIR_Coverage, 4743,
     /*  81671 */     GIR_EraseRootFromParent_Done,
     /*  81672 */   // Label 1561: @81672
     /*  81672 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(81750), // Rule ID 4745 //
     /*  81677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81724 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81729 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81731 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81748 */     GIR_RootConstrainSelectedInstOperands,
     /*  81749 */     // GIR_Coverage, 4745,
     /*  81749 */     GIR_EraseRootFromParent_Done,
     /*  81750 */   // Label 1562: @81750
     /*  81750 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(81828), // Rule ID 4747 //
     /*  81755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81802 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  81805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81807 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81809 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81826 */     GIR_RootConstrainSelectedInstOperands,
     /*  81827 */     // GIR_Coverage, 4747,
     /*  81827 */     GIR_EraseRootFromParent_Done,
     /*  81828 */   // Label 1563: @81828
     /*  81828 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(81964), // Rule ID 2690 //
     /*  81833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  81841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  81844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  81850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  81853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  81856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  81859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  81863 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3860:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  81863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  81866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  81880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  81884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  81893 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  81896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  81900 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  81903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  81907 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  81910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81913 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  81916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  81921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  81944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81946 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  81948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81951 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  81953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  81956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81962 */     GIR_RootConstrainSelectedInstOperands,
     /*  81963 */     // GIR_Coverage, 2690,
     /*  81963 */     GIR_EraseRootFromParent_Done,
     /*  81964 */   // Label 1564: @81964
     /*  81964 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(82085), // Rule ID 2691 //
     /*  81969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  81977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  81980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  81986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  81989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  81992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  81995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  81999 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3857:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  81999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82015 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82022 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82029 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82036 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82072 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82083 */     GIR_RootConstrainSelectedInstOperands,
     /*  82084 */     // GIR_Coverage, 2691,
     /*  82084 */     GIR_EraseRootFromParent_Done,
     /*  82085 */   // Label 1565: @82085
     /*  82085 */   GIM_Reject,
     /*  82086 */ // Label 1503: @82086
     /*  82086 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(86979),
     /*  82091 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82094 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82182), // Rule ID 3181 //
     /*  82099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82148 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82152 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82156 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82161 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82163 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82180 */     GIR_RootConstrainSelectedInstOperands,
     /*  82181 */     // GIR_Coverage, 3181,
     /*  82181 */     GIR_EraseRootFromParent_Done,
     /*  82182 */   // Label 1567: @82182
     /*  82182 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82270), // Rule ID 3185 //
     /*  82187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82236 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82240 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82244 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82249 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82251 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82268 */     GIR_RootConstrainSelectedInstOperands,
     /*  82269 */     // GIR_Coverage, 3185,
     /*  82269 */     GIR_EraseRootFromParent_Done,
     /*  82270 */   // Label 1568: @82270
     /*  82270 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82358), // Rule ID 3189 //
     /*  82275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82324 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82328 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82332 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82337 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82339 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82356 */     GIR_RootConstrainSelectedInstOperands,
     /*  82357 */     // GIR_Coverage, 3189,
     /*  82357 */     GIR_EraseRootFromParent_Done,
     /*  82358 */   // Label 1569: @82358
     /*  82358 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(82446), // Rule ID 3193 //
     /*  82363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82412 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82416 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82420 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82425 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82427 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82444 */     GIR_RootConstrainSelectedInstOperands,
     /*  82445 */     // GIR_Coverage, 3193,
     /*  82445 */     GIR_EraseRootFromParent_Done,
     /*  82446 */   // Label 1570: @82446
     /*  82446 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(82534), // Rule ID 3197 //
     /*  82451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82500 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82504 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82508 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82513 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82515 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82532 */     GIR_RootConstrainSelectedInstOperands,
     /*  82533 */     // GIR_Coverage, 3197,
     /*  82533 */     GIR_EraseRootFromParent_Done,
     /*  82534 */   // Label 1571: @82534
     /*  82534 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(82622), // Rule ID 3201 //
     /*  82539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82588 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82592 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82596 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82601 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82603 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82620 */     GIR_RootConstrainSelectedInstOperands,
     /*  82621 */     // GIR_Coverage, 3201,
     /*  82621 */     GIR_EraseRootFromParent_Done,
     /*  82622 */   // Label 1572: @82622
     /*  82622 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(82710), // Rule ID 3205 //
     /*  82627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82676 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82680 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82684 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82689 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82691 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82708 */     GIR_RootConstrainSelectedInstOperands,
     /*  82709 */     // GIR_Coverage, 3205,
     /*  82709 */     GIR_EraseRootFromParent_Done,
     /*  82710 */   // Label 1573: @82710
     /*  82710 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(82798), // Rule ID 3209 //
     /*  82715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82764 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82768 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82772 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82777 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82779 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82796 */     GIR_RootConstrainSelectedInstOperands,
     /*  82797 */     // GIR_Coverage, 3209,
     /*  82797 */     GIR_EraseRootFromParent_Done,
     /*  82798 */   // Label 1574: @82798
     /*  82798 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(82886), // Rule ID 3213 //
     /*  82803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82852 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82856 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82860 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  82863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82865 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82867 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82884 */     GIR_RootConstrainSelectedInstOperands,
     /*  82885 */     // GIR_Coverage, 3213,
     /*  82885 */     GIR_EraseRootFromParent_Done,
     /*  82886 */   // Label 1575: @82886
     /*  82886 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(82974), // Rule ID 3217 //
     /*  82891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82940 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82944 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82948 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  82951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82953 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82955 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82972 */     GIR_RootConstrainSelectedInstOperands,
     /*  82973 */     // GIR_Coverage, 3217,
     /*  82973 */     GIR_EraseRootFromParent_Done,
     /*  82974 */   // Label 1576: @82974
     /*  82974 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83062), // Rule ID 3221 //
     /*  82979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83028 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83032 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83036 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83041 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83043 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83060 */     GIR_RootConstrainSelectedInstOperands,
     /*  83061 */     // GIR_Coverage, 3221,
     /*  83061 */     GIR_EraseRootFromParent_Done,
     /*  83062 */   // Label 1577: @83062
     /*  83062 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83150), // Rule ID 3225 //
     /*  83067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83116 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83120 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83124 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83129 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83131 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83148 */     GIR_RootConstrainSelectedInstOperands,
     /*  83149 */     // GIR_Coverage, 3225,
     /*  83149 */     GIR_EraseRootFromParent_Done,
     /*  83150 */   // Label 1578: @83150
     /*  83150 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83238), // Rule ID 3229 //
     /*  83155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83204 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83208 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83212 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83217 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83219 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83236 */     GIR_RootConstrainSelectedInstOperands,
     /*  83237 */     // GIR_Coverage, 3229,
     /*  83237 */     GIR_EraseRootFromParent_Done,
     /*  83238 */   // Label 1579: @83238
     /*  83238 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83326), // Rule ID 3233 //
     /*  83243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83292 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83296 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83300 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83305 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83307 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83324 */     GIR_RootConstrainSelectedInstOperands,
     /*  83325 */     // GIR_Coverage, 3233,
     /*  83325 */     GIR_EraseRootFromParent_Done,
     /*  83326 */   // Label 1580: @83326
     /*  83326 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83414), // Rule ID 3237 //
     /*  83331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83380 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83384 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83388 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83393 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83395 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83412 */     GIR_RootConstrainSelectedInstOperands,
     /*  83413 */     // GIR_Coverage, 3237,
     /*  83413 */     GIR_EraseRootFromParent_Done,
     /*  83414 */   // Label 1581: @83414
     /*  83414 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(83504), // Rule ID 3183 //
     /*  83419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83468 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83472 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83476 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83481 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83483 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83485 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83502 */     GIR_RootConstrainSelectedInstOperands,
     /*  83503 */     // GIR_Coverage, 3183,
     /*  83503 */     GIR_EraseRootFromParent_Done,
     /*  83504 */   // Label 1582: @83504
     /*  83504 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(83594), // Rule ID 3187 //
     /*  83509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83558 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83562 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83566 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83571 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83573 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83575 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83592 */     GIR_RootConstrainSelectedInstOperands,
     /*  83593 */     // GIR_Coverage, 3187,
     /*  83593 */     GIR_EraseRootFromParent_Done,
     /*  83594 */   // Label 1583: @83594
     /*  83594 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(83684), // Rule ID 3191 //
     /*  83599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83648 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83652 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83656 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83661 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83663 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83665 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83682 */     GIR_RootConstrainSelectedInstOperands,
     /*  83683 */     // GIR_Coverage, 3191,
     /*  83683 */     GIR_EraseRootFromParent_Done,
     /*  83684 */   // Label 1584: @83684
     /*  83684 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(83774), // Rule ID 3195 //
     /*  83689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83738 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83742 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83746 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83751 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83753 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83755 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83772 */     GIR_RootConstrainSelectedInstOperands,
     /*  83773 */     // GIR_Coverage, 3195,
     /*  83773 */     GIR_EraseRootFromParent_Done,
     /*  83774 */   // Label 1585: @83774
     /*  83774 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(83864), // Rule ID 3199 //
     /*  83779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83828 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83832 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83836 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  83839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83841 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83843 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83845 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83862 */     GIR_RootConstrainSelectedInstOperands,
     /*  83863 */     // GIR_Coverage, 3199,
     /*  83863 */     GIR_EraseRootFromParent_Done,
     /*  83864 */   // Label 1586: @83864
     /*  83864 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(83954), // Rule ID 3203 //
     /*  83869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83918 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83922 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83926 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  83929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83931 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83933 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83935 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83952 */     GIR_RootConstrainSelectedInstOperands,
     /*  83953 */     // GIR_Coverage, 3203,
     /*  83953 */     GIR_EraseRootFromParent_Done,
     /*  83954 */   // Label 1587: @83954
     /*  83954 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84044), // Rule ID 3207 //
     /*  83959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84008 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84012 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84016 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84021 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84023 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84025 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84042 */     GIR_RootConstrainSelectedInstOperands,
     /*  84043 */     // GIR_Coverage, 3207,
     /*  84043 */     GIR_EraseRootFromParent_Done,
     /*  84044 */   // Label 1588: @84044
     /*  84044 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84134), // Rule ID 3211 //
     /*  84049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84098 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84102 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84106 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84111 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84113 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84115 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84132 */     GIR_RootConstrainSelectedInstOperands,
     /*  84133 */     // GIR_Coverage, 3211,
     /*  84133 */     GIR_EraseRootFromParent_Done,
     /*  84134 */   // Label 1589: @84134
     /*  84134 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84224), // Rule ID 3215 //
     /*  84139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84188 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84192 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84196 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84201 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84203 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84205 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84222 */     GIR_RootConstrainSelectedInstOperands,
     /*  84223 */     // GIR_Coverage, 3215,
     /*  84223 */     GIR_EraseRootFromParent_Done,
     /*  84224 */   // Label 1590: @84224
     /*  84224 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84314), // Rule ID 3219 //
     /*  84229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84278 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84282 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84286 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84291 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84293 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84295 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84312 */     GIR_RootConstrainSelectedInstOperands,
     /*  84313 */     // GIR_Coverage, 3219,
     /*  84313 */     GIR_EraseRootFromParent_Done,
     /*  84314 */   // Label 1591: @84314
     /*  84314 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84404), // Rule ID 3223 //
     /*  84319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84368 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84372 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84376 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84381 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84383 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84385 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84402 */     GIR_RootConstrainSelectedInstOperands,
     /*  84403 */     // GIR_Coverage, 3223,
     /*  84403 */     GIR_EraseRootFromParent_Done,
     /*  84404 */   // Label 1592: @84404
     /*  84404 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(84494), // Rule ID 3227 //
     /*  84409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84458 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84462 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84466 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84471 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84473 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84475 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84492 */     GIR_RootConstrainSelectedInstOperands,
     /*  84493 */     // GIR_Coverage, 3227,
     /*  84493 */     GIR_EraseRootFromParent_Done,
     /*  84494 */   // Label 1593: @84494
     /*  84494 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(84584), // Rule ID 3231 //
     /*  84499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84548 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84552 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84556 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84561 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84563 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84565 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84582 */     GIR_RootConstrainSelectedInstOperands,
     /*  84583 */     // GIR_Coverage, 3231,
     /*  84583 */     GIR_EraseRootFromParent_Done,
     /*  84584 */   // Label 1594: @84584
     /*  84584 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(84674), // Rule ID 3235 //
     /*  84589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84638 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84642 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84646 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84651 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84653 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84655 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84672 */     GIR_RootConstrainSelectedInstOperands,
     /*  84673 */     // GIR_Coverage, 3235,
     /*  84673 */     GIR_EraseRootFromParent_Done,
     /*  84674 */   // Label 1595: @84674
     /*  84674 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(84764), // Rule ID 3239 //
     /*  84679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84728 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84732 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84736 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84741 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84743 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84745 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84762 */     GIR_RootConstrainSelectedInstOperands,
     /*  84763 */     // GIR_Coverage, 3239,
     /*  84763 */     GIR_EraseRootFromParent_Done,
     /*  84764 */   // Label 1596: @84764
     /*  84764 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(84851), // Rule ID 4335 //
     /*  84769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84823 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  84823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  84826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84828 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84830 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84832 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84849 */     GIR_RootConstrainSelectedInstOperands,
     /*  84850 */     // GIR_Coverage, 4335,
     /*  84850 */     GIR_EraseRootFromParent_Done,
     /*  84851 */   // Label 1597: @84851
     /*  84851 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(84938), // Rule ID 4337 //
     /*  84856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  84864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  84870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  84873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84910 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  84910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  84913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84915 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84917 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84919 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84936 */     GIR_RootConstrainSelectedInstOperands,
     /*  84937 */     // GIR_Coverage, 4337,
     /*  84937 */     GIR_EraseRootFromParent_Done,
     /*  84938 */   // Label 1598: @84938
     /*  84938 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85025), // Rule ID 4339 //
     /*  84943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  84951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  84960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84997 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  84997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85002 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85004 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85006 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85023 */     GIR_RootConstrainSelectedInstOperands,
     /*  85024 */     // GIR_Coverage, 4339,
     /*  85024 */     GIR_EraseRootFromParent_Done,
     /*  85025 */   // Label 1599: @85025
     /*  85025 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85112), // Rule ID 4341 //
     /*  85030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85084 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85089 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85091 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85093 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85110 */     GIR_RootConstrainSelectedInstOperands,
     /*  85111 */     // GIR_Coverage, 4341,
     /*  85111 */     GIR_EraseRootFromParent_Done,
     /*  85112 */   // Label 1600: @85112
     /*  85112 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85199), // Rule ID 4343 //
     /*  85117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85171 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85176 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85178 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85180 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85197 */     GIR_RootConstrainSelectedInstOperands,
     /*  85198 */     // GIR_Coverage, 4343,
     /*  85198 */     GIR_EraseRootFromParent_Done,
     /*  85199 */   // Label 1601: @85199
     /*  85199 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85286), // Rule ID 4345 //
     /*  85204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85258 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85263 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85265 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85267 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85284 */     GIR_RootConstrainSelectedInstOperands,
     /*  85285 */     // GIR_Coverage, 4345,
     /*  85285 */     GIR_EraseRootFromParent_Done,
     /*  85286 */   // Label 1602: @85286
     /*  85286 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85373), // Rule ID 4347 //
     /*  85291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85345 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85350 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85352 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85354 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85371 */     GIR_RootConstrainSelectedInstOperands,
     /*  85372 */     // GIR_Coverage, 4347,
     /*  85372 */     GIR_EraseRootFromParent_Done,
     /*  85373 */   // Label 1603: @85373
     /*  85373 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85460), // Rule ID 4349 //
     /*  85378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85437 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85439 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85441 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85458 */     GIR_RootConstrainSelectedInstOperands,
     /*  85459 */     // GIR_Coverage, 4349,
     /*  85459 */     GIR_EraseRootFromParent_Done,
     /*  85460 */   // Label 1604: @85460
     /*  85460 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(85547), // Rule ID 4351 //
     /*  85465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85519 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85524 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85526 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85528 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85545 */     GIR_RootConstrainSelectedInstOperands,
     /*  85546 */     // GIR_Coverage, 4351,
     /*  85546 */     GIR_EraseRootFromParent_Done,
     /*  85547 */   // Label 1605: @85547
     /*  85547 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(85634), // Rule ID 4353 //
     /*  85552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85606 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85611 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85613 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85615 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85632 */     GIR_RootConstrainSelectedInstOperands,
     /*  85633 */     // GIR_Coverage, 4353,
     /*  85633 */     GIR_EraseRootFromParent_Done,
     /*  85634 */   // Label 1606: @85634
     /*  85634 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(85721), // Rule ID 4355 //
     /*  85639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85693 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85698 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85700 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85702 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85719 */     GIR_RootConstrainSelectedInstOperands,
     /*  85720 */     // GIR_Coverage, 4355,
     /*  85720 */     GIR_EraseRootFromParent_Done,
     /*  85721 */   // Label 1607: @85721
     /*  85721 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(85808), // Rule ID 4357 //
     /*  85726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85780 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85785 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85787 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85789 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85806 */     GIR_RootConstrainSelectedInstOperands,
     /*  85807 */     // GIR_Coverage, 4357,
     /*  85807 */     GIR_EraseRootFromParent_Done,
     /*  85808 */   // Label 1608: @85808
     /*  85808 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(85895), // Rule ID 4359 //
     /*  85813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  85870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85872 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85874 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85876 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85893 */     GIR_RootConstrainSelectedInstOperands,
     /*  85894 */     // GIR_Coverage, 4359,
     /*  85894 */     GIR_EraseRootFromParent_Done,
     /*  85895 */   // Label 1609: @85895
     /*  85895 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(85982), // Rule ID 4361 //
     /*  85900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85954 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  85957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85959 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85961 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85963 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85980 */     GIR_RootConstrainSelectedInstOperands,
     /*  85981 */     // GIR_Coverage, 4361,
     /*  85981 */     GIR_EraseRootFromParent_Done,
     /*  85982 */   // Label 1610: @85982
     /*  85982 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86069), // Rule ID 4363 //
     /*  85987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86041 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86046 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86048 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86050 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86067 */     GIR_RootConstrainSelectedInstOperands,
     /*  86068 */     // GIR_Coverage, 4363,
     /*  86068 */     GIR_EraseRootFromParent_Done,
     /*  86069 */   // Label 1611: @86069
     /*  86069 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86156), // Rule ID 4365 //
     /*  86074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86128 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86133 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86135 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86137 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86154 */     GIR_RootConstrainSelectedInstOperands,
     /*  86155 */     // GIR_Coverage, 4365,
     /*  86155 */     GIR_EraseRootFromParent_Done,
     /*  86156 */   // Label 1612: @86156
     /*  86156 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86243), // Rule ID 4367 //
     /*  86161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86215 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86220 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86222 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86224 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86241 */     GIR_RootConstrainSelectedInstOperands,
     /*  86242 */     // GIR_Coverage, 4367,
     /*  86242 */     GIR_EraseRootFromParent_Done,
     /*  86243 */   // Label 1613: @86243
     /*  86243 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86330), // Rule ID 4369 //
     /*  86248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86302 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86307 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86309 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86311 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86328 */     GIR_RootConstrainSelectedInstOperands,
     /*  86329 */     // GIR_Coverage, 4369,
     /*  86329 */     GIR_EraseRootFromParent_Done,
     /*  86330 */   // Label 1614: @86330
     /*  86330 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86417), // Rule ID 4371 //
     /*  86335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86389 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86394 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86396 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86398 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86415 */     GIR_RootConstrainSelectedInstOperands,
     /*  86416 */     // GIR_Coverage, 4371,
     /*  86416 */     GIR_EraseRootFromParent_Done,
     /*  86417 */   // Label 1615: @86417
     /*  86417 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(86504), // Rule ID 4373 //
     /*  86422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86481 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86483 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86485 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86502 */     GIR_RootConstrainSelectedInstOperands,
     /*  86503 */     // GIR_Coverage, 4373,
     /*  86503 */     GIR_EraseRootFromParent_Done,
     /*  86504 */   // Label 1616: @86504
     /*  86504 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(86591), // Rule ID 4375 //
     /*  86509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86563 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86568 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86570 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86572 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86589 */     GIR_RootConstrainSelectedInstOperands,
     /*  86590 */     // GIR_Coverage, 4375,
     /*  86590 */     GIR_EraseRootFromParent_Done,
     /*  86591 */   // Label 1617: @86591
     /*  86591 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(86678), // Rule ID 4377 //
     /*  86596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86650 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86655 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86657 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86659 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86676 */     GIR_RootConstrainSelectedInstOperands,
     /*  86677 */     // GIR_Coverage, 4377,
     /*  86677 */     GIR_EraseRootFromParent_Done,
     /*  86678 */   // Label 1618: @86678
     /*  86678 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(86765), // Rule ID 4379 //
     /*  86683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86737 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86742 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86744 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86746 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86763 */     GIR_RootConstrainSelectedInstOperands,
     /*  86764 */     // GIR_Coverage, 4379,
     /*  86764 */     GIR_EraseRootFromParent_Done,
     /*  86765 */   // Label 1619: @86765
     /*  86765 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(86852), // Rule ID 4381 //
     /*  86770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  86827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86829 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86831 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86833 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86850 */     GIR_RootConstrainSelectedInstOperands,
     /*  86851 */     // GIR_Coverage, 4381,
     /*  86851 */     GIR_EraseRootFromParent_Done,
     /*  86852 */   // Label 1620: @86852
     /*  86852 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(86978), // Rule ID 2692 //
     /*  86857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  86865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  86868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  86871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  86874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  86877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  86880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  86883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  86886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  86890 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3861:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  86890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  86893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  86897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  86906 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  86909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  86913 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  86916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  86920 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  86923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  86927 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  86930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  86935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  86958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86960 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  86962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86965 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  86967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  86970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86976 */     GIR_RootConstrainSelectedInstOperands,
     /*  86977 */     // GIR_Coverage, 2692,
     /*  86977 */     GIR_EraseRootFromParent_Done,
     /*  86978 */   // Label 1621: @86978
     /*  86978 */   GIM_Reject,
     /*  86979 */ // Label 1566: @86979
     /*  86979 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(91273),
     /*  86984 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  86987 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  86992 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87099), // Rule ID 3758 //
     /*  86997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87018 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87021 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87048 */     // MIs[1] Operand 1
     /*  87048 */     // No operand predicates
     /*  87048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87070 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87075 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87097 */     GIR_RootConstrainSelectedInstOperands,
     /*  87098 */     // GIR_Coverage, 3758,
     /*  87098 */     GIR_EraseRootFromParent_Done,
     /*  87099 */   // Label 1623: @87099
     /*  87099 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87206), // Rule ID 3760 //
     /*  87104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87125 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87128 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87155 */     // MIs[1] Operand 1
     /*  87155 */     // No operand predicates
     /*  87155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87177 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87182 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87204 */     GIR_RootConstrainSelectedInstOperands,
     /*  87205 */     // GIR_Coverage, 3760,
     /*  87205 */     GIR_EraseRootFromParent_Done,
     /*  87206 */   // Label 1624: @87206
     /*  87206 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87313), // Rule ID 3762 //
     /*  87211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87232 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87235 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87262 */     // MIs[1] Operand 1
     /*  87262 */     // No operand predicates
     /*  87262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87284 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87289 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87311 */     GIR_RootConstrainSelectedInstOperands,
     /*  87312 */     // GIR_Coverage, 3762,
     /*  87312 */     GIR_EraseRootFromParent_Done,
     /*  87313 */   // Label 1625: @87313
     /*  87313 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(87420), // Rule ID 3764 //
     /*  87318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87339 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87342 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87369 */     // MIs[1] Operand 1
     /*  87369 */     // No operand predicates
     /*  87369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87391 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87396 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87418 */     GIR_RootConstrainSelectedInstOperands,
     /*  87419 */     // GIR_Coverage, 3764,
     /*  87419 */     GIR_EraseRootFromParent_Done,
     /*  87420 */   // Label 1626: @87420
     /*  87420 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(87527), // Rule ID 3766 //
     /*  87425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87446 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87449 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87476 */     // MIs[1] Operand 1
     /*  87476 */     // No operand predicates
     /*  87476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87498 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87503 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87525 */     GIR_RootConstrainSelectedInstOperands,
     /*  87526 */     // GIR_Coverage, 3766,
     /*  87526 */     GIR_EraseRootFromParent_Done,
     /*  87527 */   // Label 1627: @87527
     /*  87527 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(87634), // Rule ID 3768 //
     /*  87532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87553 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87556 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87583 */     // MIs[1] Operand 1
     /*  87583 */     // No operand predicates
     /*  87583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87605 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87610 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87632 */     GIR_RootConstrainSelectedInstOperands,
     /*  87633 */     // GIR_Coverage, 3768,
     /*  87633 */     GIR_EraseRootFromParent_Done,
     /*  87634 */   // Label 1628: @87634
     /*  87634 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(87741), // Rule ID 3770 //
     /*  87639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87660 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87663 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87690 */     // MIs[1] Operand 1
     /*  87690 */     // No operand predicates
     /*  87690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87712 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87717 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87739 */     GIR_RootConstrainSelectedInstOperands,
     /*  87740 */     // GIR_Coverage, 3770,
     /*  87740 */     GIR_EraseRootFromParent_Done,
     /*  87741 */   // Label 1629: @87741
     /*  87741 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(87848), // Rule ID 3772 //
     /*  87746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87767 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87770 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87797 */     // MIs[1] Operand 1
     /*  87797 */     // No operand predicates
     /*  87797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87819 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87824 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87846 */     GIR_RootConstrainSelectedInstOperands,
     /*  87847 */     // GIR_Coverage, 3772,
     /*  87847 */     GIR_EraseRootFromParent_Done,
     /*  87848 */   // Label 1630: @87848
     /*  87848 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(87955), // Rule ID 3774 //
     /*  87853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87874 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87877 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87904 */     // MIs[1] Operand 1
     /*  87904 */     // No operand predicates
     /*  87904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87926 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  87929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87931 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87953 */     GIR_RootConstrainSelectedInstOperands,
     /*  87954 */     // GIR_Coverage, 3774,
     /*  87954 */     GIR_EraseRootFromParent_Done,
     /*  87955 */   // Label 1631: @87955
     /*  87955 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88062), // Rule ID 3776 //
     /*  87960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87981 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87984 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88011 */     // MIs[1] Operand 1
     /*  88011 */     // No operand predicates
     /*  88011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88033 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88038 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88060 */     GIR_RootConstrainSelectedInstOperands,
     /*  88061 */     // GIR_Coverage, 3776,
     /*  88061 */     GIR_EraseRootFromParent_Done,
     /*  88062 */   // Label 1632: @88062
     /*  88062 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88169), // Rule ID 3778 //
     /*  88067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88088 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88091 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88118 */     // MIs[1] Operand 1
     /*  88118 */     // No operand predicates
     /*  88118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88140 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88145 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88167 */     GIR_RootConstrainSelectedInstOperands,
     /*  88168 */     // GIR_Coverage, 3778,
     /*  88168 */     GIR_EraseRootFromParent_Done,
     /*  88169 */   // Label 1633: @88169
     /*  88169 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88276), // Rule ID 3780 //
     /*  88174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88195 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88198 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88225 */     // MIs[1] Operand 1
     /*  88225 */     // No operand predicates
     /*  88225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88247 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88252 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88274 */     GIR_RootConstrainSelectedInstOperands,
     /*  88275 */     // GIR_Coverage, 3780,
     /*  88275 */     GIR_EraseRootFromParent_Done,
     /*  88276 */   // Label 1634: @88276
     /*  88276 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(88383), // Rule ID 3782 //
     /*  88281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88302 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88305 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88332 */     // MIs[1] Operand 1
     /*  88332 */     // No operand predicates
     /*  88332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88354 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88359 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88381 */     GIR_RootConstrainSelectedInstOperands,
     /*  88382 */     // GIR_Coverage, 3782,
     /*  88382 */     GIR_EraseRootFromParent_Done,
     /*  88383 */   // Label 1635: @88383
     /*  88383 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(88490), // Rule ID 3784 //
     /*  88388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88409 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88412 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88439 */     // MIs[1] Operand 1
     /*  88439 */     // No operand predicates
     /*  88439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88461 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88466 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88488 */     GIR_RootConstrainSelectedInstOperands,
     /*  88489 */     // GIR_Coverage, 3784,
     /*  88489 */     GIR_EraseRootFromParent_Done,
     /*  88490 */   // Label 1636: @88490
     /*  88490 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(88597), // Rule ID 3786 //
     /*  88495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88516 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88519 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88546 */     // MIs[1] Operand 1
     /*  88546 */     // No operand predicates
     /*  88546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88568 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88573 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88595 */     GIR_RootConstrainSelectedInstOperands,
     /*  88596 */     // GIR_Coverage, 3786,
     /*  88596 */     GIR_EraseRootFromParent_Done,
     /*  88597 */   // Label 1637: @88597
     /*  88597 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(88704), // Rule ID 3788 //
     /*  88602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88623 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88626 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88653 */     // MIs[1] Operand 1
     /*  88653 */     // No operand predicates
     /*  88653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88675 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88680 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88702 */     GIR_RootConstrainSelectedInstOperands,
     /*  88703 */     // GIR_Coverage, 3788,
     /*  88703 */     GIR_EraseRootFromParent_Done,
     /*  88704 */   // Label 1638: @88704
     /*  88704 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(88811), // Rule ID 3790 //
     /*  88709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88730 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88733 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88760 */     // MIs[1] Operand 1
     /*  88760 */     // No operand predicates
     /*  88760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88782 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88787 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88809 */     GIR_RootConstrainSelectedInstOperands,
     /*  88810 */     // GIR_Coverage, 3790,
     /*  88810 */     GIR_EraseRootFromParent_Done,
     /*  88811 */   // Label 1639: @88811
     /*  88811 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(88918), // Rule ID 3792 //
     /*  88816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88837 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88840 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88867 */     // MIs[1] Operand 1
     /*  88867 */     // No operand predicates
     /*  88867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88889 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  88892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88894 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88916 */     GIR_RootConstrainSelectedInstOperands,
     /*  88917 */     // GIR_Coverage, 3792,
     /*  88917 */     GIR_EraseRootFromParent_Done,
     /*  88918 */   // Label 1640: @88918
     /*  88918 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89025), // Rule ID 3794 //
     /*  88923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88944 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88947 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88974 */     // MIs[1] Operand 1
     /*  88974 */     // No operand predicates
     /*  88974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  88999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89001 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89023 */     GIR_RootConstrainSelectedInstOperands,
     /*  89024 */     // GIR_Coverage, 3794,
     /*  89024 */     GIR_EraseRootFromParent_Done,
     /*  89025 */   // Label 1641: @89025
     /*  89025 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89132), // Rule ID 3796 //
     /*  89030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89051 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89054 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89081 */     // MIs[1] Operand 1
     /*  89081 */     // No operand predicates
     /*  89081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89103 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89108 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89130 */     GIR_RootConstrainSelectedInstOperands,
     /*  89131 */     // GIR_Coverage, 3796,
     /*  89131 */     GIR_EraseRootFromParent_Done,
     /*  89132 */   // Label 1642: @89132
     /*  89132 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89239), // Rule ID 3798 //
     /*  89137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89158 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89161 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89188 */     // MIs[1] Operand 1
     /*  89188 */     // No operand predicates
     /*  89188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89210 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89215 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89237 */     GIR_RootConstrainSelectedInstOperands,
     /*  89238 */     // GIR_Coverage, 3798,
     /*  89238 */     GIR_EraseRootFromParent_Done,
     /*  89239 */   // Label 1643: @89239
     /*  89239 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89346), // Rule ID 3800 //
     /*  89244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89265 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89268 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89295 */     // MIs[1] Operand 1
     /*  89295 */     // No operand predicates
     /*  89295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89317 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89322 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89344 */     GIR_RootConstrainSelectedInstOperands,
     /*  89345 */     // GIR_Coverage, 3800,
     /*  89345 */     GIR_EraseRootFromParent_Done,
     /*  89346 */   // Label 1644: @89346
     /*  89346 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(89453), // Rule ID 3802 //
     /*  89351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89372 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89375 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89402 */     // MIs[1] Operand 1
     /*  89402 */     // No operand predicates
     /*  89402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89429 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89451 */     GIR_RootConstrainSelectedInstOperands,
     /*  89452 */     // GIR_Coverage, 3802,
     /*  89452 */     GIR_EraseRootFromParent_Done,
     /*  89453 */   // Label 1645: @89453
     /*  89453 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(89560), // Rule ID 3804 //
     /*  89458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89479 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89482 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89509 */     // MIs[1] Operand 1
     /*  89509 */     // No operand predicates
     /*  89509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89531 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89536 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89558 */     GIR_RootConstrainSelectedInstOperands,
     /*  89559 */     // GIR_Coverage, 3804,
     /*  89559 */     GIR_EraseRootFromParent_Done,
     /*  89560 */   // Label 1646: @89560
     /*  89560 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(89667), // Rule ID 3806 //
     /*  89565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89586 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89589 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89616 */     // MIs[1] Operand 1
     /*  89616 */     // No operand predicates
     /*  89616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89638 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89643 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89665 */     GIR_RootConstrainSelectedInstOperands,
     /*  89666 */     // GIR_Coverage, 3806,
     /*  89666 */     GIR_EraseRootFromParent_Done,
     /*  89667 */   // Label 1647: @89667
     /*  89667 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(89774), // Rule ID 3808 //
     /*  89672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89693 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89696 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89723 */     // MIs[1] Operand 1
     /*  89723 */     // No operand predicates
     /*  89723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89745 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89750 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89772 */     GIR_RootConstrainSelectedInstOperands,
     /*  89773 */     // GIR_Coverage, 3808,
     /*  89773 */     GIR_EraseRootFromParent_Done,
     /*  89774 */   // Label 1648: @89774
     /*  89774 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(89881), // Rule ID 3810 //
     /*  89779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89800 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89803 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89830 */     // MIs[1] Operand 1
     /*  89830 */     // No operand predicates
     /*  89830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  89855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89857 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89879 */     GIR_RootConstrainSelectedInstOperands,
     /*  89880 */     // GIR_Coverage, 3810,
     /*  89880 */     GIR_EraseRootFromParent_Done,
     /*  89881 */   // Label 1649: @89881
     /*  89881 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(89988), // Rule ID 3812 //
     /*  89886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89907 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89910 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89937 */     // MIs[1] Operand 1
     /*  89937 */     // No operand predicates
     /*  89937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89959 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  89962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89964 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89986 */     GIR_RootConstrainSelectedInstOperands,
     /*  89987 */     // GIR_Coverage, 3812,
     /*  89987 */     GIR_EraseRootFromParent_Done,
     /*  89988 */   // Label 1650: @89988
     /*  89988 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90095), // Rule ID 3814 //
     /*  89993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90014 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90017 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90044 */     // MIs[1] Operand 1
     /*  90044 */     // No operand predicates
     /*  90044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90066 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90071 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90093 */     GIR_RootConstrainSelectedInstOperands,
     /*  90094 */     // GIR_Coverage, 3814,
     /*  90094 */     GIR_EraseRootFromParent_Done,
     /*  90095 */   // Label 1651: @90095
     /*  90095 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90202), // Rule ID 3816 //
     /*  90100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90121 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90124 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90151 */     // MIs[1] Operand 1
     /*  90151 */     // No operand predicates
     /*  90151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90173 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90178 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90200 */     GIR_RootConstrainSelectedInstOperands,
     /*  90201 */     // GIR_Coverage, 3816,
     /*  90201 */     GIR_EraseRootFromParent_Done,
     /*  90202 */   // Label 1652: @90202
     /*  90202 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90309), // Rule ID 3818 //
     /*  90207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90228 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90231 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90258 */     // MIs[1] Operand 1
     /*  90258 */     // No operand predicates
     /*  90258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90285 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90307 */     GIR_RootConstrainSelectedInstOperands,
     /*  90308 */     // GIR_Coverage, 3818,
     /*  90308 */     GIR_EraseRootFromParent_Done,
     /*  90309 */   // Label 1653: @90309
     /*  90309 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90416), // Rule ID 3820 //
     /*  90314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90335 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90338 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90365 */     // MIs[1] Operand 1
     /*  90365 */     // No operand predicates
     /*  90365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90387 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90392 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90414 */     GIR_RootConstrainSelectedInstOperands,
     /*  90415 */     // GIR_Coverage, 3820,
     /*  90415 */     GIR_EraseRootFromParent_Done,
     /*  90416 */   // Label 1654: @90416
     /*  90416 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(90523), // Rule ID 3822 //
     /*  90421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90442 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90445 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90472 */     // MIs[1] Operand 1
     /*  90472 */     // No operand predicates
     /*  90472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90494 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90499 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90521 */     GIR_RootConstrainSelectedInstOperands,
     /*  90522 */     // GIR_Coverage, 3822,
     /*  90522 */     GIR_EraseRootFromParent_Done,
     /*  90523 */   // Label 1655: @90523
     /*  90523 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(90630), // Rule ID 3824 //
     /*  90528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90549 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90552 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90579 */     // MIs[1] Operand 1
     /*  90579 */     // No operand predicates
     /*  90579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90601 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90606 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90628 */     GIR_RootConstrainSelectedInstOperands,
     /*  90629 */     // GIR_Coverage, 3824,
     /*  90629 */     GIR_EraseRootFromParent_Done,
     /*  90630 */   // Label 1656: @90630
     /*  90630 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(90737), // Rule ID 3826 //
     /*  90635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90656 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90659 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90686 */     // MIs[1] Operand 1
     /*  90686 */     // No operand predicates
     /*  90686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90708 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90713 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90735 */     GIR_RootConstrainSelectedInstOperands,
     /*  90736 */     // GIR_Coverage, 3826,
     /*  90736 */     GIR_EraseRootFromParent_Done,
     /*  90737 */   // Label 1657: @90737
     /*  90737 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(90844), // Rule ID 3828 //
     /*  90742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90763 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90766 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90793 */     // MIs[1] Operand 1
     /*  90793 */     // No operand predicates
     /*  90793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90815 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  90818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90820 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90842 */     GIR_RootConstrainSelectedInstOperands,
     /*  90843 */     // GIR_Coverage, 3828,
     /*  90843 */     GIR_EraseRootFromParent_Done,
     /*  90844 */   // Label 1658: @90844
     /*  90844 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(90951), // Rule ID 3830 //
     /*  90849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90870 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90873 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90900 */     // MIs[1] Operand 1
     /*  90900 */     // No operand predicates
     /*  90900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90922 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  90925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90927 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90949 */     GIR_RootConstrainSelectedInstOperands,
     /*  90950 */     // GIR_Coverage, 3830,
     /*  90950 */     GIR_EraseRootFromParent_Done,
     /*  90951 */   // Label 1659: @90951
     /*  90951 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91058), // Rule ID 3832 //
     /*  90956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90977 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90980 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91007 */     // MIs[1] Operand 1
     /*  91007 */     // No operand predicates
     /*  91007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91029 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91034 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91056 */     GIR_RootConstrainSelectedInstOperands,
     /*  91057 */     // GIR_Coverage, 3832,
     /*  91057 */     GIR_EraseRootFromParent_Done,
     /*  91058 */   // Label 1660: @91058
     /*  91058 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91165), // Rule ID 3834 //
     /*  91063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91084 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91087 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91114 */     // MIs[1] Operand 1
     /*  91114 */     // No operand predicates
     /*  91114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91136 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91141 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91163 */     GIR_RootConstrainSelectedInstOperands,
     /*  91164 */     // GIR_Coverage, 3834,
     /*  91164 */     GIR_EraseRootFromParent_Done,
     /*  91165 */   // Label 1661: @91165
     /*  91165 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91272), // Rule ID 3836 //
     /*  91170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91191 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91194 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91221 */     // MIs[1] Operand 1
     /*  91221 */     // No operand predicates
     /*  91221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91243 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91248 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91270 */     GIR_RootConstrainSelectedInstOperands,
     /*  91271 */     // GIR_Coverage, 3836,
     /*  91271 */     GIR_EraseRootFromParent_Done,
     /*  91272 */   // Label 1662: @91272
     /*  91272 */   GIM_Reject,
     /*  91273 */ // Label 1622: @91273
     /*  91273 */ GIM_Reject,
     /*  91274 */ // Label 16: @91274
     /*  91274 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91331),
     /*  91279 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91282 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91287 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91304), // Rule ID 245 //
     /*  91292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91295 */     // (intrinsic_void 3494:{ *:[iPTR] })  =>  (CLREX)
     /*  91295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91302 */     GIR_RootConstrainSelectedInstOperands,
     /*  91303 */     // GIR_Coverage, 245,
     /*  91303 */     GIR_EraseRootFromParent_Done,
     /*  91304 */   // Label 1664: @91304
     /*  91304 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91330), // Rule ID 574 //
     /*  91309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91312 */     // (intrinsic_void 3494:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91328 */     GIR_RootConstrainSelectedInstOperands,
     /*  91329 */     // GIR_Coverage, 574,
     /*  91329 */     GIR_EraseRootFromParent_Done,
     /*  91330 */   // Label 1665: @91330
     /*  91330 */   GIM_Reject,
     /*  91331 */ // Label 1663: @91331
     /*  91331 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(92133),
     /*  91336 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91339 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91375), // Rule ID 344 //
     /*  91344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91352 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91355 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91366 */     // (intrinsic_void 3930:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91373 */     GIR_RootConstrainSelectedInstOperands,
     /*  91374 */     // GIR_Coverage, 344,
     /*  91374 */     GIR_EraseRootFromParent_Done,
     /*  91375 */   // Label 1667: @91375
     /*  91375 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91427), // Rule ID 2 //
     /*  91380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91388 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91403 */     // MIs[1] Operand 1
     /*  91403 */     // No operand predicates
     /*  91403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91405 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91425 */     GIR_RootConstrainSelectedInstOperands,
     /*  91426 */     // GIR_Coverage, 2,
     /*  91426 */     GIR_EraseRootFromParent_Done,
     /*  91427 */   // Label 1668: @91427
     /*  91427 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91479), // Rule ID 10 //
     /*  91432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91440 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91455 */     // MIs[1] Operand 1
     /*  91455 */     // No operand predicates
     /*  91455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91457 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91477 */     GIR_RootConstrainSelectedInstOperands,
     /*  91478 */     // GIR_Coverage, 10,
     /*  91478 */     GIR_EraseRootFromParent_Done,
     /*  91479 */   // Label 1669: @91479
     /*  91479 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91522), // Rule ID 11 //
     /*  91484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91492 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91507 */     // MIs[1] Operand 1
     /*  91507 */     // No operand predicates
     /*  91507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91509 */     // (intrinsic_void 3930:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91520 */     GIR_RootConstrainSelectedInstOperands,
     /*  91521 */     // GIR_Coverage, 11,
     /*  91521 */     GIR_EraseRootFromParent_Done,
     /*  91522 */   // Label 1670: @91522
     /*  91522 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91565), // Rule ID 228 //
     /*  91527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91535 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91550 */     // MIs[1] Operand 1
     /*  91550 */     // No operand predicates
     /*  91550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91552 */     // (intrinsic_void 3508:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91563 */     GIR_RootConstrainSelectedInstOperands,
     /*  91564 */     // GIR_Coverage, 228,
     /*  91564 */     GIR_EraseRootFromParent_Done,
     /*  91565 */   // Label 1671: @91565
     /*  91565 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91608), // Rule ID 229 //
     /*  91570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91578 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91593 */     // MIs[1] Operand 1
     /*  91593 */     // No operand predicates
     /*  91593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91595 */     // (intrinsic_void 3509:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91606 */     GIR_RootConstrainSelectedInstOperands,
     /*  91607 */     // GIR_Coverage, 229,
     /*  91607 */     GIR_EraseRootFromParent_Done,
     /*  91608 */   // Label 1672: @91608
     /*  91608 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91651), // Rule ID 230 //
     /*  91613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91621 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91636 */     // MIs[1] Operand 1
     /*  91636 */     // No operand predicates
     /*  91636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91638 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91649 */     GIR_RootConstrainSelectedInstOperands,
     /*  91650 */     // GIR_Coverage, 230,
     /*  91650 */     GIR_EraseRootFromParent_Done,
     /*  91651 */   // Label 1673: @91651
     /*  91651 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(91703), // Rule ID 276 //
     /*  91656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91664 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91679 */     // MIs[1] Operand 1
     /*  91679 */     // No operand predicates
     /*  91679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91681 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91701 */     GIR_RootConstrainSelectedInstOperands,
     /*  91702 */     // GIR_Coverage, 276,
     /*  91702 */     GIR_EraseRootFromParent_Done,
     /*  91703 */   // Label 1674: @91703
     /*  91703 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(91746), // Rule ID 343 //
     /*  91708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91716 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91731 */     // MIs[1] Operand 1
     /*  91731 */     // No operand predicates
     /*  91731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91733 */     // (intrinsic_void 3930:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91744 */     GIR_RootConstrainSelectedInstOperands,
     /*  91745 */     // GIR_Coverage, 343,
     /*  91745 */     GIR_EraseRootFromParent_Done,
     /*  91746 */   // Label 1675: @91746
     /*  91746 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(91789), // Rule ID 494 //
     /*  91751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91759 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91774 */     // MIs[1] Operand 1
     /*  91774 */     // No operand predicates
     /*  91774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91776 */     // (intrinsic_void 3930:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91787 */     GIR_RootConstrainSelectedInstOperands,
     /*  91788 */     // GIR_Coverage, 494,
     /*  91788 */     GIR_EraseRootFromParent_Done,
     /*  91789 */   // Label 1676: @91789
     /*  91789 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(91841), // Rule ID 559 //
     /*  91794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91802 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91817 */     // MIs[1] Operand 1
     /*  91817 */     // No operand predicates
     /*  91817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91819 */     // (intrinsic_void 3508:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  91819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  91822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91839 */     GIR_RootConstrainSelectedInstOperands,
     /*  91840 */     // GIR_Coverage, 559,
     /*  91840 */     GIR_EraseRootFromParent_Done,
     /*  91841 */   // Label 1677: @91841
     /*  91841 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(91893), // Rule ID 560 //
     /*  91846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91854 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91869 */     // MIs[1] Operand 1
     /*  91869 */     // No operand predicates
     /*  91869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91871 */     // (intrinsic_void 3509:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  91871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  91874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91891 */     GIR_RootConstrainSelectedInstOperands,
     /*  91892 */     // GIR_Coverage, 560,
     /*  91892 */     GIR_EraseRootFromParent_Done,
     /*  91893 */   // Label 1678: @91893
     /*  91893 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(91945), // Rule ID 561 //
     /*  91898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91906 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91921 */     // MIs[1] Operand 1
     /*  91921 */     // No operand predicates
     /*  91921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91923 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  91923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  91926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91943 */     GIR_RootConstrainSelectedInstOperands,
     /*  91944 */     // GIR_Coverage, 561,
     /*  91944 */     GIR_EraseRootFromParent_Done,
     /*  91945 */   // Label 1679: @91945
     /*  91945 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(91997), // Rule ID 579 //
     /*  91950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91958 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91973 */     // MIs[1] Operand 1
     /*  91973 */     // No operand predicates
     /*  91973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91975 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  91975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  91978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91995 */     GIR_RootConstrainSelectedInstOperands,
     /*  91996 */     // GIR_Coverage, 579,
     /*  91996 */     GIR_EraseRootFromParent_Done,
     /*  91997 */   // Label 1680: @91997
     /*  91997 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92049), // Rule ID 580 //
     /*  92002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92010 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92025 */     // MIs[1] Operand 1
     /*  92025 */     // No operand predicates
     /*  92025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92027 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92047 */     GIR_RootConstrainSelectedInstOperands,
     /*  92048 */     // GIR_Coverage, 580,
     /*  92048 */     GIR_EraseRootFromParent_Done,
     /*  92049 */   // Label 1681: @92049
     /*  92049 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92089), // Rule ID 725 //
     /*  92054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92069 */     // (intrinsic_w_chain:{ *:[i32] } 3510:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92087 */     GIR_RootConstrainSelectedInstOperands,
     /*  92088 */     // GIR_Coverage, 725,
     /*  92088 */     GIR_EraseRootFromParent_Done,
     /*  92089 */   // Label 1682: @92089
     /*  92089 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92132), // Rule ID 726 //
     /*  92094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92102 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92109 */     // (intrinsic_void 3874:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92130 */     GIR_RootConstrainSelectedInstOperands,
     /*  92131 */     // GIR_Coverage, 726,
     /*  92131 */     GIR_EraseRootFromParent_Done,
     /*  92132 */   // Label 1683: @92132
     /*  92132 */   GIM_Reject,
     /*  92133 */ // Label 1666: @92133
     /*  92133 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92176), // Rule ID 604 //
     /*  92138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92141 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92144 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92149 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92163 */   // (intrinsic_w_chain:{ *:[i32] } 348:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92168 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92174 */   GIR_RootConstrainSelectedInstOperands,
     /*  92175 */   // GIR_Coverage, 604,
     /*  92175 */   GIR_EraseRootFromParent_Done,
     /*  92176 */ // Label 1684: @92176
     /*  92176 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(94167),
     /*  92181 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92184 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92238), // Rule ID 5051 //
     /*  92189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92219 */     // MIs[1] Operand 1
     /*  92219 */     // No operand predicates
     /*  92219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92221 */     // (intrinsic_w_chain:{ *:[v4i32] } 3643:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92226 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92236 */     GIR_RootConstrainSelectedInstOperands,
     /*  92237 */     // GIR_Coverage, 5051,
     /*  92237 */     GIR_EraseRootFromParent_Done,
     /*  92238 */   // Label 1686: @92238
     /*  92238 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92292), // Rule ID 5057 //
     /*  92243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92273 */     // MIs[1] Operand 1
     /*  92273 */     // No operand predicates
     /*  92273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92275 */     // (intrinsic_w_chain:{ *:[v4f32] } 3643:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92280 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92290 */     GIR_RootConstrainSelectedInstOperands,
     /*  92291 */     // GIR_Coverage, 5057,
     /*  92291 */     GIR_EraseRootFromParent_Done,
     /*  92292 */   // Label 1687: @92292
     /*  92292 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92346), // Rule ID 5059 //
     /*  92297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92327 */     // MIs[1] Operand 1
     /*  92327 */     // No operand predicates
     /*  92327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92329 */     // (intrinsic_w_chain:{ *:[v2i64] } 3643:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92334 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92344 */     GIR_RootConstrainSelectedInstOperands,
     /*  92345 */     // GIR_Coverage, 5059,
     /*  92345 */     GIR_EraseRootFromParent_Done,
     /*  92346 */   // Label 1688: @92346
     /*  92346 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92400), // Rule ID 5061 //
     /*  92351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92381 */     // MIs[1] Operand 1
     /*  92381 */     // No operand predicates
     /*  92381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92383 */     // (intrinsic_w_chain:{ *:[v2f64] } 3643:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92388 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92398 */     GIR_RootConstrainSelectedInstOperands,
     /*  92399 */     // GIR_Coverage, 5061,
     /*  92399 */     GIR_EraseRootFromParent_Done,
     /*  92400 */   // Label 1689: @92400
     /*  92400 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92442), // Rule ID 1741 //
     /*  92405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92420 */     // MIs[0] size
     /*  92420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92427 */     // (intrinsic_w_chain:{ *:[i32] } 3905:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92432 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92440 */     GIR_RootConstrainSelectedInstOperands,
     /*  92441 */     // GIR_Coverage, 1741,
     /*  92441 */     GIR_EraseRootFromParent_Done,
     /*  92442 */   // Label 1690: @92442
     /*  92442 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92496), // Rule ID 5053 //
     /*  92447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92452 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92473 */     // MIs[1] Operand 1
     /*  92473 */     // No operand predicates
     /*  92473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92479 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92482 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92484 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92494 */     GIR_RootConstrainSelectedInstOperands,
     /*  92495 */     // GIR_Coverage, 5053,
     /*  92495 */     GIR_EraseRootFromParent_Done,
     /*  92496 */   // Label 1691: @92496
     /*  92496 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92550), // Rule ID 5063 //
     /*  92501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92506 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92527 */     // MIs[1] Operand 1
     /*  92527 */     // No operand predicates
     /*  92527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92533 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92536 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92538 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92548 */     GIR_RootConstrainSelectedInstOperands,
     /*  92549 */     // GIR_Coverage, 5063,
     /*  92549 */     GIR_EraseRootFromParent_Done,
     /*  92550 */   // Label 1692: @92550
     /*  92550 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92604), // Rule ID 5067 //
     /*  92555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92560 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92581 */     // MIs[1] Operand 1
     /*  92581 */     // No operand predicates
     /*  92581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92587 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92590 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92592 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92602 */     GIR_RootConstrainSelectedInstOperands,
     /*  92603 */     // GIR_Coverage, 5067,
     /*  92603 */     GIR_EraseRootFromParent_Done,
     /*  92604 */   // Label 1693: @92604
     /*  92604 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92658), // Rule ID 5071 //
     /*  92609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92614 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92635 */     // MIs[1] Operand 1
     /*  92635 */     // No operand predicates
     /*  92635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92641 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92644 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92646 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92656 */     GIR_RootConstrainSelectedInstOperands,
     /*  92657 */     // GIR_Coverage, 5071,
     /*  92657 */     GIR_EraseRootFromParent_Done,
     /*  92658 */   // Label 1694: @92658
     /*  92658 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92716), // Rule ID 3 //
     /*  92663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92692 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92714 */     GIR_RootConstrainSelectedInstOperands,
     /*  92715 */     // GIR_Coverage, 3,
     /*  92715 */     GIR_EraseRootFromParent_Done,
     /*  92716 */   // Label 1695: @92716
     /*  92716 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92774), // Rule ID 121 //
     /*  92721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92750 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92772 */     GIR_RootConstrainSelectedInstOperands,
     /*  92773 */     // GIR_Coverage, 121,
     /*  92773 */     GIR_EraseRootFromParent_Done,
     /*  92774 */   // Label 1696: @92774
     /*  92774 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92832), // Rule ID 122 //
     /*  92779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  92787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92808 */     // (intrinsic_w_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  92811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92830 */     GIR_RootConstrainSelectedInstOperands,
     /*  92831 */     // GIR_Coverage, 122,
     /*  92831 */     GIR_EraseRootFromParent_Done,
     /*  92832 */   // Label 1697: @92832
     /*  92832 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92890), // Rule ID 123 //
     /*  92837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  92845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92866 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  92869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92888 */     GIR_RootConstrainSelectedInstOperands,
     /*  92889 */     // GIR_Coverage, 123,
     /*  92889 */     GIR_EraseRootFromParent_Done,
     /*  92890 */   // Label 1698: @92890
     /*  92890 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92948), // Rule ID 124 //
     /*  92895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  92903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92924 */     // (intrinsic_w_chain:{ *:[i32] } 3908:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  92927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92946 */     GIR_RootConstrainSelectedInstOperands,
     /*  92947 */     // GIR_Coverage, 124,
     /*  92947 */     GIR_EraseRootFromParent_Done,
     /*  92948 */   // Label 1699: @92948
     /*  92948 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93006), // Rule ID 125 //
     /*  92953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  92961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92982 */     // (intrinsic_w_chain:{ *:[i32] } 3909:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  92985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93004 */     GIR_RootConstrainSelectedInstOperands,
     /*  93005 */     // GIR_Coverage, 125,
     /*  93005 */     GIR_EraseRootFromParent_Done,
     /*  93006 */   // Label 1700: @93006
     /*  93006 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93064), // Rule ID 126 //
     /*  93011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93040 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93062 */     GIR_RootConstrainSelectedInstOperands,
     /*  93063 */     // GIR_Coverage, 126,
     /*  93063 */     GIR_EraseRootFromParent_Done,
     /*  93064 */   // Label 1701: @93064
     /*  93064 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93122), // Rule ID 127 //
     /*  93069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93098 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93120 */     GIR_RootConstrainSelectedInstOperands,
     /*  93121 */     // GIR_Coverage, 127,
     /*  93121 */     GIR_EraseRootFromParent_Done,
     /*  93122 */   // Label 1702: @93122
     /*  93122 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93180), // Rule ID 128 //
     /*  93127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93156 */     // (intrinsic_w_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93178 */     GIR_RootConstrainSelectedInstOperands,
     /*  93179 */     // GIR_Coverage, 128,
     /*  93179 */     GIR_EraseRootFromParent_Done,
     /*  93180 */   // Label 1703: @93180
     /*  93180 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93238), // Rule ID 129 //
     /*  93185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93214 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93236 */     GIR_RootConstrainSelectedInstOperands,
     /*  93237 */     // GIR_Coverage, 129,
     /*  93237 */     GIR_EraseRootFromParent_Done,
     /*  93238 */   // Label 1704: @93238
     /*  93238 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93296), // Rule ID 130 //
     /*  93243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93272 */     // (intrinsic_w_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93294 */     GIR_RootConstrainSelectedInstOperands,
     /*  93295 */     // GIR_Coverage, 130,
     /*  93295 */     GIR_EraseRootFromParent_Done,
     /*  93296 */   // Label 1705: @93296
     /*  93296 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93354), // Rule ID 131 //
     /*  93301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93330 */     // (intrinsic_w_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93352 */     GIR_RootConstrainSelectedInstOperands,
     /*  93353 */     // GIR_Coverage, 131,
     /*  93353 */     GIR_EraseRootFromParent_Done,
     /*  93354 */   // Label 1706: @93354
     /*  93354 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93412), // Rule ID 132 //
     /*  93359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93388 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93410 */     GIR_RootConstrainSelectedInstOperands,
     /*  93411 */     // GIR_Coverage, 132,
     /*  93411 */     GIR_EraseRootFromParent_Done,
     /*  93412 */   // Label 1707: @93412
     /*  93412 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93470), // Rule ID 431 //
     /*  93417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93446 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93468 */     GIR_RootConstrainSelectedInstOperands,
     /*  93469 */     // GIR_Coverage, 431,
     /*  93469 */     GIR_EraseRootFromParent_Done,
     /*  93470 */   // Label 1708: @93470
     /*  93470 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93528), // Rule ID 444 //
     /*  93475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93504 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93526 */     GIR_RootConstrainSelectedInstOperands,
     /*  93527 */     // GIR_Coverage, 444,
     /*  93527 */     GIR_EraseRootFromParent_Done,
     /*  93528 */   // Label 1709: @93528
     /*  93528 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93586), // Rule ID 445 //
     /*  93533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93562 */     // (intrinsic_w_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93584 */     GIR_RootConstrainSelectedInstOperands,
     /*  93585 */     // GIR_Coverage, 445,
     /*  93585 */     GIR_EraseRootFromParent_Done,
     /*  93586 */   // Label 1710: @93586
     /*  93586 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93644), // Rule ID 446 //
     /*  93591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93620 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93642 */     GIR_RootConstrainSelectedInstOperands,
     /*  93643 */     // GIR_Coverage, 446,
     /*  93643 */     GIR_EraseRootFromParent_Done,
     /*  93644 */   // Label 1711: @93644
     /*  93644 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(93702), // Rule ID 447 //
     /*  93649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93678 */     // (intrinsic_w_chain:{ *:[i32] } 3908:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93700 */     GIR_RootConstrainSelectedInstOperands,
     /*  93701 */     // GIR_Coverage, 447,
     /*  93701 */     GIR_EraseRootFromParent_Done,
     /*  93702 */   // Label 1712: @93702
     /*  93702 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(93760), // Rule ID 448 //
     /*  93707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93736 */     // (intrinsic_w_chain:{ *:[i32] } 3909:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93758 */     GIR_RootConstrainSelectedInstOperands,
     /*  93759 */     // GIR_Coverage, 448,
     /*  93759 */     GIR_EraseRootFromParent_Done,
     /*  93760 */   // Label 1713: @93760
     /*  93760 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(93818), // Rule ID 449 //
     /*  93765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93794 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  93797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93816 */     GIR_RootConstrainSelectedInstOperands,
     /*  93817 */     // GIR_Coverage, 449,
     /*  93817 */     GIR_EraseRootFromParent_Done,
     /*  93818 */   // Label 1714: @93818
     /*  93818 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(93876), // Rule ID 450 //
     /*  93823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93852 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  93855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93874 */     GIR_RootConstrainSelectedInstOperands,
     /*  93875 */     // GIR_Coverage, 450,
     /*  93875 */     GIR_EraseRootFromParent_Done,
     /*  93876 */   // Label 1715: @93876
     /*  93876 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(93934), // Rule ID 451 //
     /*  93881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93910 */     // (intrinsic_w_chain:{ *:[i32] } 3921:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  93913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93932 */     GIR_RootConstrainSelectedInstOperands,
     /*  93933 */     // GIR_Coverage, 451,
     /*  93933 */     GIR_EraseRootFromParent_Done,
     /*  93934 */   // Label 1716: @93934
     /*  93934 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(93992), // Rule ID 452 //
     /*  93939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93968 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  93971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93990 */     GIR_RootConstrainSelectedInstOperands,
     /*  93991 */     // GIR_Coverage, 452,
     /*  93991 */     GIR_EraseRootFromParent_Done,
     /*  93992 */   // Label 1717: @93992
     /*  93992 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94050), // Rule ID 453 //
     /*  93997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94026 */     // (intrinsic_w_chain:{ *:[i32] } 3941:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94048 */     GIR_RootConstrainSelectedInstOperands,
     /*  94049 */     // GIR_Coverage, 453,
     /*  94049 */     GIR_EraseRootFromParent_Done,
     /*  94050 */   // Label 1718: @94050
     /*  94050 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94108), // Rule ID 454 //
     /*  94055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94084 */     // (intrinsic_w_chain:{ *:[i32] } 3942:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94106 */     GIR_RootConstrainSelectedInstOperands,
     /*  94107 */     // GIR_Coverage, 454,
     /*  94107 */     GIR_EraseRootFromParent_Done,
     /*  94108 */   // Label 1719: @94108
     /*  94108 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94166), // Rule ID 455 //
     /*  94113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94142 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94164 */     GIR_RootConstrainSelectedInstOperands,
     /*  94165 */     // GIR_Coverage, 455,
     /*  94165 */     GIR_EraseRootFromParent_Done,
     /*  94166 */   // Label 1720: @94166
     /*  94166 */   GIM_Reject,
     /*  94167 */ // Label 1685: @94167
     /*  94167 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94413),
     /*  94172 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94175 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94180 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(94238), // Rule ID 5055 //
     /*  94185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94213 */     // MIs[1] Operand 1
     /*  94213 */     // No operand predicates
     /*  94213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94219 */     // (intrinsic_w_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94224 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94226 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94236 */     GIR_RootConstrainSelectedInstOperands,
     /*  94237 */     // GIR_Coverage, 5055,
     /*  94237 */     GIR_EraseRootFromParent_Done,
     /*  94238 */   // Label 1722: @94238
     /*  94238 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(94296), // Rule ID 5065 //
     /*  94243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94271 */     // MIs[1] Operand 1
     /*  94271 */     // No operand predicates
     /*  94271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94277 */     // (intrinsic_w_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94282 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94284 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94294 */     GIR_RootConstrainSelectedInstOperands,
     /*  94295 */     // GIR_Coverage, 5065,
     /*  94295 */     GIR_EraseRootFromParent_Done,
     /*  94296 */   // Label 1723: @94296
     /*  94296 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(94354), // Rule ID 5069 //
     /*  94301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94329 */     // MIs[1] Operand 1
     /*  94329 */     // No operand predicates
     /*  94329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94335 */     // (intrinsic_w_chain:{ *:[v2i64] } 3718:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94340 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94342 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94352 */     GIR_RootConstrainSelectedInstOperands,
     /*  94353 */     // GIR_Coverage, 5069,
     /*  94353 */     GIR_EraseRootFromParent_Done,
     /*  94354 */   // Label 1724: @94354
     /*  94354 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94412), // Rule ID 5073 //
     /*  94359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94387 */     // MIs[1] Operand 1
     /*  94387 */     // No operand predicates
     /*  94387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94393 */     // (intrinsic_w_chain:{ *:[v2i64] } 3718:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94398 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94400 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94410 */     GIR_RootConstrainSelectedInstOperands,
     /*  94411 */     // GIR_Coverage, 5073,
     /*  94411 */     GIR_EraseRootFromParent_Done,
     /*  94412 */   // Label 1725: @94412
     /*  94412 */   GIM_Reject,
     /*  94413 */ // Label 1721: @94413
     /*  94413 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(95584),
     /*  94418 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94421 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94482), // Rule ID 4943 //
     /*  94426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94443 */     // MIs[0] base
     /*  94443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94467 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94470 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94472 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94474 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94480 */     GIR_RootConstrainSelectedInstOperands,
     /*  94481 */     // GIR_Coverage, 4943,
     /*  94481 */     GIR_EraseRootFromParent_Done,
     /*  94482 */   // Label 1727: @94482
     /*  94482 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94543), // Rule ID 4944 //
     /*  94487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94504 */     // MIs[0] base
     /*  94504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94528 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94531 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94533 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94535 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94541 */     GIR_RootConstrainSelectedInstOperands,
     /*  94542 */     // GIR_Coverage, 4944,
     /*  94542 */     GIR_EraseRootFromParent_Done,
     /*  94543 */   // Label 1728: @94543
     /*  94543 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(94604), // Rule ID 4947 //
     /*  94548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94565 */     // MIs[0] base
     /*  94565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94589 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94592 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94594 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94596 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94602 */     GIR_RootConstrainSelectedInstOperands,
     /*  94603 */     // GIR_Coverage, 4947,
     /*  94603 */     GIR_EraseRootFromParent_Done,
     /*  94604 */   // Label 1729: @94604
     /*  94604 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(94665), // Rule ID 5027 //
     /*  94609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94626 */     // MIs[0] base
     /*  94626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94650 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94653 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94655 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94657 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94663 */     GIR_RootConstrainSelectedInstOperands,
     /*  94664 */     // GIR_Coverage, 5027,
     /*  94664 */     GIR_EraseRootFromParent_Done,
     /*  94665 */   // Label 1730: @94665
     /*  94665 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(94726), // Rule ID 5029 //
     /*  94670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94687 */     // MIs[0] base
     /*  94687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94711 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94714 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94716 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94718 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94724 */     GIR_RootConstrainSelectedInstOperands,
     /*  94725 */     // GIR_Coverage, 5029,
     /*  94725 */     GIR_EraseRootFromParent_Done,
     /*  94726 */   // Label 1731: @94726
     /*  94726 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(94787), // Rule ID 5031 //
     /*  94731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94748 */     // MIs[0] base
     /*  94748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94772 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94775 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94777 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94779 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94785 */     GIR_RootConstrainSelectedInstOperands,
     /*  94786 */     // GIR_Coverage, 5031,
     /*  94786 */     GIR_EraseRootFromParent_Done,
     /*  94787 */   // Label 1732: @94787
     /*  94787 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(94848), // Rule ID 5032 //
     /*  94792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94809 */     // MIs[0] base
     /*  94809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94833 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94836 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94838 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94840 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94846 */     GIR_RootConstrainSelectedInstOperands,
     /*  94847 */     // GIR_Coverage, 5032,
     /*  94847 */     GIR_EraseRootFromParent_Done,
     /*  94848 */   // Label 1733: @94848
     /*  94848 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(94909), // Rule ID 5035 //
     /*  94853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94870 */     // MIs[0] base
     /*  94870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94894 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  94897 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94899 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94901 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94907 */     GIR_RootConstrainSelectedInstOperands,
     /*  94908 */     // GIR_Coverage, 5035,
     /*  94908 */     GIR_EraseRootFromParent_Done,
     /*  94909 */   // Label 1734: @94909
     /*  94909 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(94970), // Rule ID 5036 //
     /*  94914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94931 */     // MIs[0] base
     /*  94931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94955 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  94958 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94960 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94962 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94968 */     GIR_RootConstrainSelectedInstOperands,
     /*  94969 */     // GIR_Coverage, 5036,
     /*  94969 */     GIR_EraseRootFromParent_Done,
     /*  94970 */   // Label 1735: @94970
     /*  94970 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(95031), // Rule ID 5039 //
     /*  94975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94992 */     // MIs[0] base
     /*  94992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95016 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95019 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95021 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95023 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95029 */     GIR_RootConstrainSelectedInstOperands,
     /*  95030 */     // GIR_Coverage, 5039,
     /*  95030 */     GIR_EraseRootFromParent_Done,
     /*  95031 */   // Label 1736: @95031
     /*  95031 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95092), // Rule ID 5040 //
     /*  95036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95053 */     // MIs[0] base
     /*  95053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95077 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95080 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95082 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95084 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95090 */     GIR_RootConstrainSelectedInstOperands,
     /*  95091 */     // GIR_Coverage, 5040,
     /*  95091 */     GIR_EraseRootFromParent_Done,
     /*  95092 */   // Label 1737: @95092
     /*  95092 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95153), // Rule ID 5043 //
     /*  95097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95114 */     // MIs[0] base
     /*  95114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95138 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95141 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95143 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95145 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95151 */     GIR_RootConstrainSelectedInstOperands,
     /*  95152 */     // GIR_Coverage, 5043,
     /*  95152 */     GIR_EraseRootFromParent_Done,
     /*  95153 */   // Label 1738: @95153
     /*  95153 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95214), // Rule ID 5044 //
     /*  95158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95175 */     // MIs[0] base
     /*  95175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95199 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95202 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95204 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95206 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95212 */     GIR_RootConstrainSelectedInstOperands,
     /*  95213 */     // GIR_Coverage, 5044,
     /*  95213 */     GIR_EraseRootFromParent_Done,
     /*  95214 */   // Label 1739: @95214
     /*  95214 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95275), // Rule ID 5047 //
     /*  95219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95236 */     // MIs[0] base
     /*  95236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95260 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95263 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95265 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95267 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95273 */     GIR_RootConstrainSelectedInstOperands,
     /*  95274 */     // GIR_Coverage, 5047,
     /*  95274 */     GIR_EraseRootFromParent_Done,
     /*  95275 */   // Label 1740: @95275
     /*  95275 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95336), // Rule ID 5048 //
     /*  95280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95297 */     // MIs[0] base
     /*  95297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95321 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95324 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95326 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95328 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95334 */     GIR_RootConstrainSelectedInstOperands,
     /*  95335 */     // GIR_Coverage, 5048,
     /*  95335 */     GIR_EraseRootFromParent_Done,
     /*  95336 */   // Label 1741: @95336
     /*  95336 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(95400), // Rule ID 258 //
     /*  95341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95355 */     // MIs[0] cop
     /*  95355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95358 */     // MIs[0] opc1
     /*  95358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95369 */     // MIs[0] CRm
     /*  95369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95372 */     // (intrinsic_void 3524:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95375 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95377 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95383 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95398 */     GIR_RootConstrainSelectedInstOperands,
     /*  95399 */     // GIR_Coverage, 258,
     /*  95399 */     GIR_EraseRootFromParent_Done,
     /*  95400 */   // Label 1742: @95400
     /*  95400 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(95455), // Rule ID 259 //
     /*  95405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95419 */     // MIs[0] cop
     /*  95419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95422 */     // MIs[0] opc1
     /*  95422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95433 */     // MIs[0] CRm
     /*  95433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95436 */     // (intrinsic_void 3525:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95439 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95441 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95447 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95453 */     GIR_RootConstrainSelectedInstOperands,
     /*  95454 */     // GIR_Coverage, 259,
     /*  95454 */     GIR_EraseRootFromParent_Done,
     /*  95455 */   // Label 1743: @95455
     /*  95455 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(95519), // Rule ID 596 //
     /*  95460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95474 */     // MIs[0] cop
     /*  95474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95477 */     // MIs[0] opc1
     /*  95477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95488 */     // MIs[0] CRm
     /*  95488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95491 */     // (intrinsic_void 3524:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95494 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95496 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95502 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95517 */     GIR_RootConstrainSelectedInstOperands,
     /*  95518 */     // GIR_Coverage, 596,
     /*  95518 */     GIR_EraseRootFromParent_Done,
     /*  95519 */   // Label 1744: @95519
     /*  95519 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95583), // Rule ID 597 //
     /*  95524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95538 */     // MIs[0] cop
     /*  95538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95541 */     // MIs[0] opc1
     /*  95541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95552 */     // MIs[0] CRm
     /*  95552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95555 */     // (intrinsic_void 3525:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95558 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95560 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95566 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95581 */     GIR_RootConstrainSelectedInstOperands,
     /*  95582 */     // GIR_Coverage, 597,
     /*  95582 */     GIR_EraseRootFromParent_Done,
     /*  95583 */   // Label 1745: @95583
     /*  95583 */   GIM_Reject,
     /*  95584 */ // Label 1726: @95584
     /*  95584 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(98935),
     /*  95589 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95592 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(95653), // Rule ID 246 //
     /*  95597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95605 */     // MIs[0] cop
     /*  95605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95608 */     // MIs[0] opc1
     /*  95608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95611 */     // MIs[0] CRd
     /*  95611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95614 */     // MIs[0] CRn
     /*  95614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95617 */     // MIs[0] CRm
     /*  95617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95620 */     // MIs[0] opc2
     /*  95620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95623 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95626 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95628 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95630 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95632 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95634 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95636 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95651 */     GIR_RootConstrainSelectedInstOperands,
     /*  95652 */     // GIR_Coverage, 246,
     /*  95652 */     GIR_EraseRootFromParent_Done,
     /*  95653 */   // Label 1747: @95653
     /*  95653 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(95705), // Rule ID 247 //
     /*  95658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95666 */     // MIs[0] cop
     /*  95666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95669 */     // MIs[0] opc1
     /*  95669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95672 */     // MIs[0] CRd
     /*  95672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95675 */     // MIs[0] CRn
     /*  95675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95678 */     // MIs[0] CRm
     /*  95678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95681 */     // MIs[0] opc2
     /*  95681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95684 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95687 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95689 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95691 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95693 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95695 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95697 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95703 */     GIR_RootConstrainSelectedInstOperands,
     /*  95704 */     // GIR_Coverage, 247,
     /*  95704 */     GIR_EraseRootFromParent_Done,
     /*  95705 */   // Label 1748: @95705
     /*  95705 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(95766), // Rule ID 598 //
     /*  95710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95718 */     // MIs[0] cop
     /*  95718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95721 */     // MIs[0] opc1
     /*  95721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95724 */     // MIs[0] CRd
     /*  95724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95727 */     // MIs[0] CRn
     /*  95727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95730 */     // MIs[0] CRm
     /*  95730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95733 */     // MIs[0] opc2
     /*  95733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95736 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95739 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95741 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95743 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95745 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95747 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95749 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95764 */     GIR_RootConstrainSelectedInstOperands,
     /*  95765 */     // GIR_Coverage, 598,
     /*  95765 */     GIR_EraseRootFromParent_Done,
     /*  95766 */   // Label 1749: @95766
     /*  95766 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(95827), // Rule ID 599 //
     /*  95771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95779 */     // MIs[0] cop
     /*  95779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95782 */     // MIs[0] opc1
     /*  95782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95785 */     // MIs[0] CRd
     /*  95785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95788 */     // MIs[0] CRn
     /*  95788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95791 */     // MIs[0] CRm
     /*  95791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95794 */     // MIs[0] opc2
     /*  95794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95797 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  95800 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95802 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95804 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95806 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95808 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95810 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95825 */     GIR_RootConstrainSelectedInstOperands,
     /*  95826 */     // GIR_Coverage, 599,
     /*  95826 */     GIR_EraseRootFromParent_Done,
     /*  95827 */   // Label 1750: @95827
     /*  95827 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(95895), // Rule ID 4937 //
     /*  95832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95856 */     // MIs[0] base
     /*  95856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95880 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  95883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95885 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95887 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95893 */     GIR_RootConstrainSelectedInstOperands,
     /*  95894 */     // GIR_Coverage, 4937,
     /*  95894 */     GIR_EraseRootFromParent_Done,
     /*  95895 */   // Label 1751: @95895
     /*  95895 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(95963), // Rule ID 4938 //
     /*  95900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95924 */     // MIs[0] base
     /*  95924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95948 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  95951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95953 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95955 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95961 */     GIR_RootConstrainSelectedInstOperands,
     /*  95962 */     // GIR_Coverage, 4938,
     /*  95962 */     GIR_EraseRootFromParent_Done,
     /*  95963 */   // Label 1752: @95963
     /*  95963 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96031), // Rule ID 4941 //
     /*  95968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  95976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  95979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95992 */     // MIs[0] base
     /*  95992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96016 */     // (intrinsic_w_chain:{ *:[v16i8] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96021 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96023 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96029 */     GIR_RootConstrainSelectedInstOperands,
     /*  96030 */     // GIR_Coverage, 4941,
     /*  96030 */     GIR_EraseRootFromParent_Done,
     /*  96031 */   // Label 1753: @96031
     /*  96031 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96099), // Rule ID 4949 //
     /*  96036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96060 */     // MIs[0] base
     /*  96060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96084 */     // (intrinsic_w_chain:{ *:[v16i8] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96089 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96091 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96097 */     GIR_RootConstrainSelectedInstOperands,
     /*  96098 */     // GIR_Coverage, 4949,
     /*  96098 */     GIR_EraseRootFromParent_Done,
     /*  96099 */   // Label 1754: @96099
     /*  96099 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96167), // Rule ID 4951 //
     /*  96104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96128 */     // MIs[0] base
     /*  96128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96152 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96157 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96159 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96165 */     GIR_RootConstrainSelectedInstOperands,
     /*  96166 */     // GIR_Coverage, 4951,
     /*  96166 */     GIR_EraseRootFromParent_Done,
     /*  96167 */   // Label 1755: @96167
     /*  96167 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96235), // Rule ID 4953 //
     /*  96172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96196 */     // MIs[0] base
     /*  96196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96220 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96225 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96227 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96233 */     GIR_RootConstrainSelectedInstOperands,
     /*  96234 */     // GIR_Coverage, 4953,
     /*  96234 */     GIR_EraseRootFromParent_Done,
     /*  96235 */   // Label 1756: @96235
     /*  96235 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96303), // Rule ID 4955 //
     /*  96240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96264 */     // MIs[0] base
     /*  96264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96288 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96293 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96295 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96301 */     GIR_RootConstrainSelectedInstOperands,
     /*  96302 */     // GIR_Coverage, 4955,
     /*  96302 */     GIR_EraseRootFromParent_Done,
     /*  96303 */   // Label 1757: @96303
     /*  96303 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96371), // Rule ID 4957 //
     /*  96308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96332 */     // MIs[0] base
     /*  96332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96356 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96361 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96363 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96369 */     GIR_RootConstrainSelectedInstOperands,
     /*  96370 */     // GIR_Coverage, 4957,
     /*  96370 */     GIR_EraseRootFromParent_Done,
     /*  96371 */   // Label 1758: @96371
     /*  96371 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96439), // Rule ID 4959 //
     /*  96376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96400 */     // MIs[0] base
     /*  96400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96424 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96429 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96431 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96437 */     GIR_RootConstrainSelectedInstOperands,
     /*  96438 */     // GIR_Coverage, 4959,
     /*  96438 */     GIR_EraseRootFromParent_Done,
     /*  96439 */   // Label 1759: @96439
     /*  96439 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96507), // Rule ID 4960 //
     /*  96444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96468 */     // MIs[0] base
     /*  96468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96492 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96497 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96499 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96505 */     GIR_RootConstrainSelectedInstOperands,
     /*  96506 */     // GIR_Coverage, 4960,
     /*  96506 */     GIR_EraseRootFromParent_Done,
     /*  96507 */   // Label 1760: @96507
     /*  96507 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(96575), // Rule ID 4963 //
     /*  96512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96536 */     // MIs[0] base
     /*  96536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96560 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96565 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96567 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96573 */     GIR_RootConstrainSelectedInstOperands,
     /*  96574 */     // GIR_Coverage, 4963,
     /*  96574 */     GIR_EraseRootFromParent_Done,
     /*  96575 */   // Label 1761: @96575
     /*  96575 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(96643), // Rule ID 4964 //
     /*  96580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96604 */     // MIs[0] base
     /*  96604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96628 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96633 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96635 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96641 */     GIR_RootConstrainSelectedInstOperands,
     /*  96642 */     // GIR_Coverage, 4964,
     /*  96642 */     GIR_EraseRootFromParent_Done,
     /*  96643 */   // Label 1762: @96643
     /*  96643 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(96711), // Rule ID 4967 //
     /*  96648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96672 */     // MIs[0] base
     /*  96672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96696 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96701 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96703 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96709 */     GIR_RootConstrainSelectedInstOperands,
     /*  96710 */     // GIR_Coverage, 4967,
     /*  96710 */     GIR_EraseRootFromParent_Done,
     /*  96711 */   // Label 1763: @96711
     /*  96711 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(96779), // Rule ID 4968 //
     /*  96716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96740 */     // MIs[0] base
     /*  96740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96764 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96769 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96771 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96777 */     GIR_RootConstrainSelectedInstOperands,
     /*  96778 */     // GIR_Coverage, 4968,
     /*  96778 */     GIR_EraseRootFromParent_Done,
     /*  96779 */   // Label 1764: @96779
     /*  96779 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(96847), // Rule ID 4971 //
     /*  96784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96808 */     // MIs[0] base
     /*  96808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96832 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96837 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96839 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96845 */     GIR_RootConstrainSelectedInstOperands,
     /*  96846 */     // GIR_Coverage, 4971,
     /*  96846 */     GIR_EraseRootFromParent_Done,
     /*  96847 */   // Label 1765: @96847
     /*  96847 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(96915), // Rule ID 4972 //
     /*  96852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96876 */     // MIs[0] base
     /*  96876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96900 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96905 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96907 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96913 */     GIR_RootConstrainSelectedInstOperands,
     /*  96914 */     // GIR_Coverage, 4972,
     /*  96914 */     GIR_EraseRootFromParent_Done,
     /*  96915 */   // Label 1766: @96915
     /*  96915 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(96983), // Rule ID 4975 //
     /*  96920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96944 */     // MIs[0] base
     /*  96944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96968 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96973 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96975 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96981 */     GIR_RootConstrainSelectedInstOperands,
     /*  96982 */     // GIR_Coverage, 4975,
     /*  96982 */     GIR_EraseRootFromParent_Done,
     /*  96983 */   // Label 1767: @96983
     /*  96983 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97051), // Rule ID 4976 //
     /*  96988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97012 */     // MIs[0] base
     /*  97012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97036 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97041 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97043 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97049 */     GIR_RootConstrainSelectedInstOperands,
     /*  97050 */     // GIR_Coverage, 4976,
     /*  97050 */     GIR_EraseRootFromParent_Done,
     /*  97051 */   // Label 1768: @97051
     /*  97051 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97119), // Rule ID 4979 //
     /*  97056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97080 */     // MIs[0] base
     /*  97080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97104 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97109 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97111 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97117 */     GIR_RootConstrainSelectedInstOperands,
     /*  97118 */     // GIR_Coverage, 4979,
     /*  97118 */     GIR_EraseRootFromParent_Done,
     /*  97119 */   // Label 1769: @97119
     /*  97119 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97187), // Rule ID 4980 //
     /*  97124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97148 */     // MIs[0] base
     /*  97148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97172 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97177 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97179 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97185 */     GIR_RootConstrainSelectedInstOperands,
     /*  97186 */     // GIR_Coverage, 4980,
     /*  97186 */     GIR_EraseRootFromParent_Done,
     /*  97187 */   // Label 1770: @97187
     /*  97187 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97255), // Rule ID 4983 //
     /*  97192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97216 */     // MIs[0] base
     /*  97216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97240 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97245 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97247 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97253 */     GIR_RootConstrainSelectedInstOperands,
     /*  97254 */     // GIR_Coverage, 4983,
     /*  97254 */     GIR_EraseRootFromParent_Done,
     /*  97255 */   // Label 1771: @97255
     /*  97255 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97323), // Rule ID 4984 //
     /*  97260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97284 */     // MIs[0] base
     /*  97284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97308 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97313 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97315 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97321 */     GIR_RootConstrainSelectedInstOperands,
     /*  97322 */     // GIR_Coverage, 4984,
     /*  97322 */     GIR_EraseRootFromParent_Done,
     /*  97323 */   // Label 1772: @97323
     /*  97323 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97391), // Rule ID 4987 //
     /*  97328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97352 */     // MIs[0] base
     /*  97352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97376 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97381 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97383 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97389 */     GIR_RootConstrainSelectedInstOperands,
     /*  97390 */     // GIR_Coverage, 4987,
     /*  97390 */     GIR_EraseRootFromParent_Done,
     /*  97391 */   // Label 1773: @97391
     /*  97391 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97459), // Rule ID 4988 //
     /*  97396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97420 */     // MIs[0] base
     /*  97420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97444 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97449 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97451 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97457 */     GIR_RootConstrainSelectedInstOperands,
     /*  97458 */     // GIR_Coverage, 4988,
     /*  97458 */     GIR_EraseRootFromParent_Done,
     /*  97459 */   // Label 1774: @97459
     /*  97459 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97527), // Rule ID 4991 //
     /*  97464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97488 */     // MIs[0] base
     /*  97488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97512 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97517 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97519 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97525 */     GIR_RootConstrainSelectedInstOperands,
     /*  97526 */     // GIR_Coverage, 4991,
     /*  97526 */     GIR_EraseRootFromParent_Done,
     /*  97527 */   // Label 1775: @97527
     /*  97527 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97595), // Rule ID 4992 //
     /*  97532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97556 */     // MIs[0] base
     /*  97556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97580 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97585 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97587 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97593 */     GIR_RootConstrainSelectedInstOperands,
     /*  97594 */     // GIR_Coverage, 4992,
     /*  97594 */     GIR_EraseRootFromParent_Done,
     /*  97595 */   // Label 1776: @97595
     /*  97595 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97663), // Rule ID 4995 //
     /*  97600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97624 */     // MIs[0] base
     /*  97624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97648 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97653 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97655 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97661 */     GIR_RootConstrainSelectedInstOperands,
     /*  97662 */     // GIR_Coverage, 4995,
     /*  97662 */     GIR_EraseRootFromParent_Done,
     /*  97663 */   // Label 1777: @97663
     /*  97663 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(97731), // Rule ID 4996 //
     /*  97668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97692 */     // MIs[0] base
     /*  97692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97716 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97721 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97723 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97729 */     GIR_RootConstrainSelectedInstOperands,
     /*  97730 */     // GIR_Coverage, 4996,
     /*  97730 */     GIR_EraseRootFromParent_Done,
     /*  97731 */   // Label 1778: @97731
     /*  97731 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(97799), // Rule ID 4999 //
     /*  97736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97760 */     // MIs[0] base
     /*  97760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97784 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97789 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97791 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97797 */     GIR_RootConstrainSelectedInstOperands,
     /*  97798 */     // GIR_Coverage, 4999,
     /*  97798 */     GIR_EraseRootFromParent_Done,
     /*  97799 */   // Label 1779: @97799
     /*  97799 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(97867), // Rule ID 5000 //
     /*  97804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97828 */     // MIs[0] base
     /*  97828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97852 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97857 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97859 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97865 */     GIR_RootConstrainSelectedInstOperands,
     /*  97866 */     // GIR_Coverage, 5000,
     /*  97866 */     GIR_EraseRootFromParent_Done,
     /*  97867 */   // Label 1780: @97867
     /*  97867 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(97935), // Rule ID 5003 //
     /*  97872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97896 */     // MIs[0] base
     /*  97896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97920 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97925 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97927 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97933 */     GIR_RootConstrainSelectedInstOperands,
     /*  97934 */     // GIR_Coverage, 5003,
     /*  97934 */     GIR_EraseRootFromParent_Done,
     /*  97935 */   // Label 1781: @97935
     /*  97935 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98003), // Rule ID 5004 //
     /*  97940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97964 */     // MIs[0] base
     /*  97964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97988 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97993 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97995 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98001 */     GIR_RootConstrainSelectedInstOperands,
     /*  98002 */     // GIR_Coverage, 5004,
     /*  98002 */     GIR_EraseRootFromParent_Done,
     /*  98003 */   // Label 1782: @98003
     /*  98003 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98071), // Rule ID 5007 //
     /*  98008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98032 */     // MIs[0] base
     /*  98032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98056 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98061 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98063 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98069 */     GIR_RootConstrainSelectedInstOperands,
     /*  98070 */     // GIR_Coverage, 5007,
     /*  98070 */     GIR_EraseRootFromParent_Done,
     /*  98071 */   // Label 1783: @98071
     /*  98071 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98139), // Rule ID 5008 //
     /*  98076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98100 */     // MIs[0] base
     /*  98100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98124 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98129 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98131 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98137 */     GIR_RootConstrainSelectedInstOperands,
     /*  98138 */     // GIR_Coverage, 5008,
     /*  98138 */     GIR_EraseRootFromParent_Done,
     /*  98139 */   // Label 1784: @98139
     /*  98139 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98207), // Rule ID 5011 //
     /*  98144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98168 */     // MIs[0] base
     /*  98168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98192 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98197 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98199 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98205 */     GIR_RootConstrainSelectedInstOperands,
     /*  98206 */     // GIR_Coverage, 5011,
     /*  98206 */     GIR_EraseRootFromParent_Done,
     /*  98207 */   // Label 1785: @98207
     /*  98207 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98275), // Rule ID 5012 //
     /*  98212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98236 */     // MIs[0] base
     /*  98236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98260 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98265 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98267 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98273 */     GIR_RootConstrainSelectedInstOperands,
     /*  98274 */     // GIR_Coverage, 5012,
     /*  98274 */     GIR_EraseRootFromParent_Done,
     /*  98275 */   // Label 1786: @98275
     /*  98275 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98343), // Rule ID 5015 //
     /*  98280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98304 */     // MIs[0] base
     /*  98304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98328 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98333 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98335 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98341 */     GIR_RootConstrainSelectedInstOperands,
     /*  98342 */     // GIR_Coverage, 5015,
     /*  98342 */     GIR_EraseRootFromParent_Done,
     /*  98343 */   // Label 1787: @98343
     /*  98343 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98411), // Rule ID 5016 //
     /*  98348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98372 */     // MIs[0] base
     /*  98372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98396 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98401 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98403 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98409 */     GIR_RootConstrainSelectedInstOperands,
     /*  98410 */     // GIR_Coverage, 5016,
     /*  98410 */     GIR_EraseRootFromParent_Done,
     /*  98411 */   // Label 1788: @98411
     /*  98411 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98479), // Rule ID 5019 //
     /*  98416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98440 */     // MIs[0] base
     /*  98440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98464 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98469 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98471 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98477 */     GIR_RootConstrainSelectedInstOperands,
     /*  98478 */     // GIR_Coverage, 5019,
     /*  98478 */     GIR_EraseRootFromParent_Done,
     /*  98479 */   // Label 1789: @98479
     /*  98479 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98547), // Rule ID 5020 //
     /*  98484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98508 */     // MIs[0] base
     /*  98508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98532 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98537 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98539 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98545 */     GIR_RootConstrainSelectedInstOperands,
     /*  98546 */     // GIR_Coverage, 5020,
     /*  98546 */     GIR_EraseRootFromParent_Done,
     /*  98547 */   // Label 1790: @98547
     /*  98547 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98615), // Rule ID 5023 //
     /*  98552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98576 */     // MIs[0] base
     /*  98576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98600 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98605 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98607 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98613 */     GIR_RootConstrainSelectedInstOperands,
     /*  98614 */     // GIR_Coverage, 5023,
     /*  98614 */     GIR_EraseRootFromParent_Done,
     /*  98615 */   // Label 1791: @98615
     /*  98615 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98683), // Rule ID 5024 //
     /*  98620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98644 */     // MIs[0] base
     /*  98644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98668 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98673 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98675 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98681 */     GIR_RootConstrainSelectedInstOperands,
     /*  98682 */     // GIR_Coverage, 5024,
     /*  98682 */     GIR_EraseRootFromParent_Done,
     /*  98683 */   // Label 1792: @98683
     /*  98683 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98748), // Rule ID 256 //
     /*  98688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98699 */     // MIs[0] cop
     /*  98699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98702 */     // MIs[0] opc1
     /*  98702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98709 */     // MIs[0] CRn
     /*  98709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98712 */     // MIs[0] CRm
     /*  98712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98715 */     // MIs[0] opc2
     /*  98715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98718 */     // (intrinsic_void 3522:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98721 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98723 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98727 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98729 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98731 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98746 */     GIR_RootConstrainSelectedInstOperands,
     /*  98747 */     // GIR_Coverage, 256,
     /*  98747 */     GIR_EraseRootFromParent_Done,
     /*  98748 */   // Label 1793: @98748
     /*  98748 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(98804), // Rule ID 257 //
     /*  98753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98764 */     // MIs[0] cop
     /*  98764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98767 */     // MIs[0] opc1
     /*  98767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98774 */     // MIs[0] CRn
     /*  98774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98777 */     // MIs[0] CRm
     /*  98777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98780 */     // MIs[0] opc2
     /*  98780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98783 */     // (intrinsic_void 3523:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98786 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98788 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98792 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98794 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98796 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98802 */     GIR_RootConstrainSelectedInstOperands,
     /*  98803 */     // GIR_Coverage, 257,
     /*  98803 */     GIR_EraseRootFromParent_Done,
     /*  98804 */   // Label 1794: @98804
     /*  98804 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(98869), // Rule ID 594 //
     /*  98809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  98812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98820 */     // MIs[0] cop
     /*  98820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98823 */     // MIs[0] opc1
     /*  98823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98830 */     // MIs[0] CRn
     /*  98830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98833 */     // MIs[0] CRm
     /*  98833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98836 */     // MIs[0] opc2
     /*  98836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98839 */     // (intrinsic_void 3522:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  98842 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98844 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98848 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98850 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98852 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98867 */     GIR_RootConstrainSelectedInstOperands,
     /*  98868 */     // GIR_Coverage, 594,
     /*  98868 */     GIR_EraseRootFromParent_Done,
     /*  98869 */   // Label 1795: @98869
     /*  98869 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(98934), // Rule ID 595 //
     /*  98874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  98877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98885 */     // MIs[0] cop
     /*  98885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98888 */     // MIs[0] opc1
     /*  98888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98895 */     // MIs[0] CRn
     /*  98895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98898 */     // MIs[0] CRm
     /*  98898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98901 */     // MIs[0] opc2
     /*  98901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98904 */     // (intrinsic_void 3523:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  98907 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98909 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98913 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98915 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98917 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98932 */     GIR_RootConstrainSelectedInstOperands,
     /*  98933 */     // GIR_Coverage, 595,
     /*  98933 */     GIR_EraseRootFromParent_Done,
     /*  98934 */   // Label 1796: @98934
     /*  98934 */   GIM_Reject,
     /*  98935 */ // Label 1746: @98935
     /*  98935 */ GIM_Reject,
     /*  98936 */ // Label 17: @98936
     /*  98936 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1800*/ GIMT_Encode4(99093),
     /*  98947 */ /*GILLT_v2s64*//*Label 1797*/ GIMT_Encode4(98979), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98959 */ /*GILLT_v4s32*//*Label 1798*/ GIMT_Encode4(99017), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98975 */ /*GILLT_v8s16*//*Label 1799*/ GIMT_Encode4(99055),
     /*  98979 */ // Label 1797: @98979
     /*  98979 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(99016), // Rule ID 2668 //
     /*  98984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98998 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  98998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99003 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99014 */   GIR_RootConstrainSelectedInstOperands,
     /*  99015 */   // GIR_Coverage, 2668,
     /*  99015 */   GIR_EraseRootFromParent_Done,
     /*  99016 */ // Label 1801: @99016
     /*  99016 */ GIM_Reject,
     /*  99017 */ // Label 1798: @99017
     /*  99017 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(99054), // Rule ID 2667 //
     /*  99022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99036 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99041 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99046 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99052 */   GIR_RootConstrainSelectedInstOperands,
     /*  99053 */   // GIR_Coverage, 2667,
     /*  99053 */   GIR_EraseRootFromParent_Done,
     /*  99054 */ // Label 1802: @99054
     /*  99054 */ GIM_Reject,
     /*  99055 */ // Label 1799: @99055
     /*  99055 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(99092), // Rule ID 2666 //
     /*  99060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99074 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99079 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99090 */   GIR_RootConstrainSelectedInstOperands,
     /*  99091 */   // GIR_Coverage, 2666,
     /*  99091 */   GIR_EraseRootFromParent_Done,
     /*  99092 */ // Label 1803: @99092
     /*  99092 */ GIM_Reject,
     /*  99093 */ // Label 1800: @99093
     /*  99093 */ GIM_Reject,
     /*  99094 */ // Label 18: @99094
     /*  99094 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1807*/ GIMT_Encode4(99251),
     /*  99105 */ /*GILLT_v2s32*//*Label 1804*/ GIMT_Encode4(99137), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99117 */ /*GILLT_v4s16*//*Label 1805*/ GIMT_Encode4(99175), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99133 */ /*GILLT_v8s8*//*Label 1806*/ GIMT_Encode4(99213),
     /*  99137 */ // Label 1804: @99137
     /*  99137 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99174), // Rule ID 1588 //
     /*  99142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99156 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99161 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99166 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99172 */   GIR_RootConstrainSelectedInstOperands,
     /*  99173 */   // GIR_Coverage, 1588,
     /*  99173 */   GIR_EraseRootFromParent_Done,
     /*  99174 */ // Label 1808: @99174
     /*  99174 */ GIM_Reject,
     /*  99175 */ // Label 1805: @99175
     /*  99175 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99212), // Rule ID 1587 //
     /*  99180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99194 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99199 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99204 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99210 */   GIR_RootConstrainSelectedInstOperands,
     /*  99211 */   // GIR_Coverage, 1587,
     /*  99211 */   GIR_EraseRootFromParent_Done,
     /*  99212 */ // Label 1809: @99212
     /*  99212 */ GIM_Reject,
     /*  99213 */ // Label 1806: @99213
     /*  99213 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99250), // Rule ID 1586 //
     /*  99218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99232 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99237 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99242 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99248 */   GIR_RootConstrainSelectedInstOperands,
     /*  99249 */   // GIR_Coverage, 1586,
     /*  99249 */   GIR_EraseRootFromParent_Done,
     /*  99250 */ // Label 1810: @99250
     /*  99250 */ GIM_Reject,
     /*  99251 */ // Label 1807: @99251
     /*  99251 */ GIM_Reject,
     /*  99252 */ // Label 19: @99252
     /*  99252 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99572),
     /*  99257 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99260 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99301), // Rule ID 404 //
     /*  99265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99268 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99276 */     // MIs[0] Operand 1
     /*  99276 */     // No operand predicates
     /*  99276 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99299 */     GIR_RootConstrainSelectedInstOperands,
     /*  99300 */     // GIR_Coverage, 404,
     /*  99300 */     GIR_EraseRootFromParent_Done,
     /*  99301 */   // Label 1812: @99301
     /*  99301 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99342), // Rule ID 57 //
     /*  99306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99309 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99317 */     // MIs[0] Operand 1
     /*  99317 */     // No operand predicates
     /*  99317 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99340 */     GIR_RootConstrainSelectedInstOperands,
     /*  99341 */     // GIR_Coverage, 57,
     /*  99341 */     GIR_EraseRootFromParent_Done,
     /*  99342 */   // Label 1813: @99342
     /*  99342 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99377), // Rule ID 58 //
     /*  99347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99350 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99358 */     // MIs[0] Operand 1
     /*  99358 */     // No operand predicates
     /*  99358 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99375 */     GIR_RootConstrainSelectedInstOperands,
     /*  99376 */     // GIR_Coverage, 58,
     /*  99376 */     GIR_EraseRootFromParent_Done,
     /*  99377 */   // Label 1814: @99377
     /*  99377 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99420), // Rule ID 168 //
     /*  99382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99385 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99393 */     // MIs[0] Operand 1
     /*  99393 */     // No operand predicates
     /*  99393 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99398 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99418 */     GIR_RootConstrainSelectedInstOperands,
     /*  99419 */     // GIR_Coverage, 168,
     /*  99419 */     GIR_EraseRootFromParent_Done,
     /*  99420 */   // Label 1815: @99420
     /*  99420 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99446), // Rule ID 268 //
     /*  99425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99428 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99436 */     // MIs[0] Operand 1
     /*  99436 */     // No operand predicates
     /*  99436 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99444 */     GIR_RootConstrainSelectedInstOperands,
     /*  99445 */     // GIR_Coverage, 268,
     /*  99445 */     GIR_EraseRootFromParent_Done,
     /*  99446 */   // Label 1816: @99446
     /*  99446 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99487), // Rule ID 322 //
     /*  99451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99454 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99462 */     // MIs[0] Operand 1
     /*  99462 */     // No operand predicates
     /*  99462 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99485 */     GIR_RootConstrainSelectedInstOperands,
     /*  99486 */     // GIR_Coverage, 322,
     /*  99486 */     GIR_EraseRootFromParent_Done,
     /*  99487 */   // Label 1817: @99487
     /*  99487 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99522), // Rule ID 405 //
     /*  99492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99495 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99503 */     // MIs[0] Operand 1
     /*  99503 */     // No operand predicates
     /*  99503 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99520 */     GIR_RootConstrainSelectedInstOperands,
     /*  99521 */     // GIR_Coverage, 405,
     /*  99521 */     GIR_EraseRootFromParent_Done,
     /*  99522 */   // Label 1818: @99522
     /*  99522 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(99571),
     /*  99527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99531 */     GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(99552), // Rule ID 353 //
     /*  99536 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99539 */       // MIs[0] Operand 1
     /*  99539 */       // No operand predicates
     /*  99539 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99539 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99542 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99544 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99547 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99550 */       GIR_RootConstrainSelectedInstOperands,
     /*  99551 */       // GIR_Coverage, 353,
     /*  99551 */       GIR_EraseRootFromParent_Done,
     /*  99552 */     // Label 1820: @99552
     /*  99552 */     GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99570), // Rule ID 582 //
     /*  99557 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99560 */       // MIs[0] Operand 1
     /*  99560 */       // No operand predicates
     /*  99560 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99560 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99563 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99565 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99568 */       GIR_RootConstrainSelectedInstOperands,
     /*  99569 */       // GIR_Coverage, 582,
     /*  99569 */       GIR_EraseRootFromParent_Done,
     /*  99570 */     // Label 1821: @99570
     /*  99570 */     GIM_Reject,
     /*  99571 */   // Label 1819: @99571
     /*  99571 */   GIM_Reject,
     /*  99572 */ // Label 1811: @99572
     /*  99572 */ GIM_Reject,
     /*  99573 */ // Label 20: @99573
     /*  99573 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1824*/ GIMT_Encode4(99668),
     /*  99584 */ /*GILLT_s32*//*Label 1822*/ GIMT_Encode4(99592),
     /*  99588 */ /*GILLT_s64*//*Label 1823*/ GIMT_Encode4(99630),
     /*  99592 */ // Label 1822: @99592
     /*  99592 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(99629), // Rule ID 728 //
     /*  99597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99604 */   // MIs[0] Operand 1
     /*  99604 */   // No operand predicates
     /*  99604 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99608 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99613 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99621 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99627 */   GIR_RootConstrainSelectedInstOperands,
     /*  99628 */   // GIR_Coverage, 728,
     /*  99628 */   GIR_EraseRootFromParent_Done,
     /*  99629 */ // Label 1825: @99629
     /*  99629 */ GIM_Reject,
     /*  99630 */ // Label 1823: @99630
     /*  99630 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(99667), // Rule ID 727 //
     /*  99635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99642 */   // MIs[0] Operand 1
     /*  99642 */   // No operand predicates
     /*  99642 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99646 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99651 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99659 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99665 */   GIR_RootConstrainSelectedInstOperands,
     /*  99666 */   // GIR_Coverage, 727,
     /*  99666 */   GIR_EraseRootFromParent_Done,
     /*  99667 */ // Label 1826: @99667
     /*  99667 */ GIM_Reject,
     /*  99668 */ // Label 1824: @99668
     /*  99668 */ GIM_Reject,
     /*  99669 */ // Label 21: @99669
     /*  99669 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1830*/ GIMT_Encode4(99826),
     /*  99680 */ /*GILLT_v2s64*//*Label 1827*/ GIMT_Encode4(99712), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99692 */ /*GILLT_v4s32*//*Label 1828*/ GIMT_Encode4(99750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99708 */ /*GILLT_v8s16*//*Label 1829*/ GIMT_Encode4(99788),
     /*  99712 */ // Label 1827: @99712
     /*  99712 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(99749), // Rule ID 1600 //
     /*  99717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99731 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99736 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99741 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99747 */   GIR_RootConstrainSelectedInstOperands,
     /*  99748 */   // GIR_Coverage, 1600,
     /*  99748 */   GIR_EraseRootFromParent_Done,
     /*  99749 */ // Label 1831: @99749
     /*  99749 */ GIM_Reject,
     /*  99750 */ // Label 1828: @99750
     /*  99750 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(99787), // Rule ID 1599 //
     /*  99755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99769 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99774 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99779 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99785 */   GIR_RootConstrainSelectedInstOperands,
     /*  99786 */   // GIR_Coverage, 1599,
     /*  99786 */   GIR_EraseRootFromParent_Done,
     /*  99787 */ // Label 1832: @99787
     /*  99787 */ GIM_Reject,
     /*  99788 */ // Label 1829: @99788
     /*  99788 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(99825), // Rule ID 1598 //
     /*  99793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99807 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /*  99810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99812 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99817 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99823 */   GIR_RootConstrainSelectedInstOperands,
     /*  99824 */   // GIR_Coverage, 1598,
     /*  99824 */   GIR_EraseRootFromParent_Done,
     /*  99825 */ // Label 1833: @99825
     /*  99825 */ GIM_Reject,
     /*  99826 */ // Label 1830: @99826
     /*  99826 */ GIM_Reject,
     /*  99827 */ // Label 22: @99827
     /*  99827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1837*/ GIMT_Encode4(100431),
     /*  99838 */ /*GILLT_s32*//*Label 1834*/ GIMT_Encode4(99886), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99866 */ /*GILLT_v4s32*//*Label 1835*/ GIMT_Encode4(100178), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99882 */ /*GILLT_v8s16*//*Label 1836*/ GIMT_Encode4(100361),
     /*  99886 */ // Label 1834: @99886
     /*  99886 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100177),
     /*  99891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  99894 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(99939), // Rule ID 340 //
     /*  99899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99910 */     // MIs[0] Operand 2
     /*  99910 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99921 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /*  99924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  99928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99937 */     GIR_RootConstrainSelectedInstOperands,
     /*  99938 */     // GIR_Coverage, 340,
     /*  99938 */     GIR_EraseRootFromParent_Done,
     /*  99939 */   // Label 1839: @99939
     /*  99939 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(99984), // Rule ID 341 //
     /*  99944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99955 */     // MIs[0] Operand 2
     /*  99955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99966 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /*  99969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  99973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99982 */     GIR_RootConstrainSelectedInstOperands,
     /*  99983 */     // GIR_Coverage, 341,
     /*  99983 */     GIR_EraseRootFromParent_Done,
     /*  99984 */   // Label 1840: @99984
     /*  99984 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(100032), // Rule ID 2002 //
     /*  99989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  99992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  99996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100000 */     // MIs[0] Operand 2
     /* 100000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100011 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100030 */     GIR_RootConstrainSelectedInstOperands,
     /* 100031 */     // GIR_Coverage, 2002,
     /* 100031 */     GIR_EraseRootFromParent_Done,
     /* 100032 */   // Label 1841: @100032
     /* 100032 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100080), // Rule ID 2003 //
     /* 100037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100048 */     // MIs[0] Operand 2
     /* 100048 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100059 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100078 */     GIR_RootConstrainSelectedInstOperands,
     /* 100079 */     // GIR_Coverage, 2003,
     /* 100079 */     GIR_EraseRootFromParent_Done,
     /* 100080 */   // Label 1842: @100080
     /* 100080 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100128), // Rule ID 2241 //
     /* 100085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100096 */     // MIs[0] Operand 2
     /* 100096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100107 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100126 */     GIR_RootConstrainSelectedInstOperands,
     /* 100127 */     // GIR_Coverage, 2241,
     /* 100127 */     GIR_EraseRootFromParent_Done,
     /* 100128 */   // Label 1843: @100128
     /* 100128 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100176), // Rule ID 2242 //
     /* 100133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100144 */     // MIs[0] Operand 2
     /* 100144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100155 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100174 */     GIR_RootConstrainSelectedInstOperands,
     /* 100175 */     // GIR_Coverage, 2242,
     /* 100175 */     GIR_EraseRootFromParent_Done,
     /* 100176 */   // Label 1844: @100176
     /* 100176 */   GIM_Reject,
     /* 100177 */ // Label 1838: @100177
     /* 100177 */ GIM_Reject,
     /* 100178 */ // Label 1835: @100178
     /* 100178 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100360),
     /* 100183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100194 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(100252), // Rule ID 3713 //
     /* 100199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100202 */     // MIs[0] Operand 2
     /* 100202 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100213 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100230 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100250 */     GIR_RootConstrainSelectedInstOperands,
     /* 100251 */     // GIR_Coverage, 3713,
     /* 100251 */     GIR_EraseRootFromParent_Done,
     /* 100252 */   // Label 1846: @100252
     /* 100252 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(100359), // Rule ID 3715 //
     /* 100257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100260 */     // MIs[0] Operand 2
     /* 100260 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100271 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100283 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100286 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100290 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100314 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100320 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100357 */     GIR_RootConstrainSelectedInstOperands,
     /* 100358 */     // GIR_Coverage, 3715,
     /* 100358 */     GIR_EraseRootFromParent_Done,
     /* 100359 */   // Label 1847: @100359
     /* 100359 */   GIM_Reject,
     /* 100360 */ // Label 1845: @100360
     /* 100360 */ GIM_Reject,
     /* 100361 */ // Label 1836: @100361
     /* 100361 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(100430), // Rule ID 3714 //
     /* 100366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100380 */   // MIs[0] Operand 2
     /* 100380 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100391 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100413 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100419 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100428 */   GIR_RootConstrainSelectedInstOperands,
     /* 100429 */   // GIR_Coverage, 3714,
     /* 100429 */   GIR_EraseRootFromParent_Done,
     /* 100430 */ // Label 1848: @100430
     /* 100430 */ GIM_Reject,
     /* 100431 */ // Label 1837: @100431
     /* 100431 */ GIM_Reject,
     /* 100432 */ // Label 23: @100432
     /* 100432 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1852*/ GIMT_Encode4(100589),
     /* 100443 */ /*GILLT_v2s64*//*Label 1849*/ GIMT_Encode4(100475), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100455 */ /*GILLT_v4s32*//*Label 1850*/ GIMT_Encode4(100513), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100471 */ /*GILLT_v8s16*//*Label 1851*/ GIMT_Encode4(100551),
     /* 100475 */ // Label 1849: @100475
     /* 100475 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100512), // Rule ID 1603 //
     /* 100480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100494 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100499 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100504 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100510 */   GIR_RootConstrainSelectedInstOperands,
     /* 100511 */   // GIR_Coverage, 1603,
     /* 100511 */   GIR_EraseRootFromParent_Done,
     /* 100512 */ // Label 1853: @100512
     /* 100512 */ GIM_Reject,
     /* 100513 */ // Label 1850: @100513
     /* 100513 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(100550), // Rule ID 1602 //
     /* 100518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100532 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100537 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100542 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100548 */   GIR_RootConstrainSelectedInstOperands,
     /* 100549 */   // GIR_Coverage, 1602,
     /* 100549 */   GIR_EraseRootFromParent_Done,
     /* 100550 */ // Label 1854: @100550
     /* 100550 */ GIM_Reject,
     /* 100551 */ // Label 1851: @100551
     /* 100551 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100588), // Rule ID 1601 //
     /* 100556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100570 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100575 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100580 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100586 */   GIR_RootConstrainSelectedInstOperands,
     /* 100587 */   // GIR_Coverage, 1601,
     /* 100587 */   GIR_EraseRootFromParent_Done,
     /* 100588 */ // Label 1855: @100588
     /* 100588 */ GIM_Reject,
     /* 100589 */ // Label 1852: @100589
     /* 100589 */ GIM_Reject,
     /* 100590 */ // Label 24: @100590
     /* 100590 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100805),
     /* 100595 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100604 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100661), // Rule ID 470 //
     /* 100609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100632 */     // MIs[1] Operand 1
     /* 100632 */     // No operand predicates
     /* 100632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100634 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100659 */     GIR_RootConstrainSelectedInstOperands,
     /* 100660 */     // GIR_Coverage, 470,
     /* 100660 */     GIR_EraseRootFromParent_Done,
     /* 100661 */   // Label 1857: @100661
     /* 100661 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100758),
     /* 100666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100674 */     GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100719), // Rule ID 318 //
     /* 100679 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100682 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100686 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100690 */       // MIs[1] Operand 1
     /* 100690 */       // No operand predicates
     /* 100690 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100692 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100692 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100695 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100697 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100703 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100705 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100708 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100711 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100717 */       GIR_RootConstrainSelectedInstOperands,
     /* 100718 */       // GIR_Coverage, 318,
     /* 100718 */       GIR_EraseRootFromParent_Done,
     /* 100719 */     // Label 1859: @100719
     /* 100719 */     GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100757), // Rule ID 319 //
     /* 100724 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100727 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100731 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100731 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100734 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100736 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100742 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100744 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100746 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100749 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100755 */       GIR_RootConstrainSelectedInstOperands,
     /* 100756 */       // GIR_Coverage, 319,
     /* 100756 */       GIR_EraseRootFromParent_Done,
     /* 100757 */     // Label 1860: @100757
     /* 100757 */     GIM_Reject,
     /* 100758 */   // Label 1858: @100758
     /* 100758 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100804), // Rule ID 471 //
     /* 100763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100778 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100802 */     GIR_RootConstrainSelectedInstOperands,
     /* 100803 */     // GIR_Coverage, 471,
     /* 100803 */     GIR_EraseRootFromParent_Done,
     /* 100804 */   // Label 1861: @100804
     /* 100804 */   GIM_Reject,
     /* 100805 */ // Label 1856: @100805
     /* 100805 */ GIM_Reject,
     /* 100806 */ // Label 25: @100806
     /* 100806 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(100913),
     /* 100811 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100820 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(100866), // Rule ID 321 //
     /* 100825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100840 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 100843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100864 */     GIR_RootConstrainSelectedInstOperands,
     /* 100865 */     // GIR_Coverage, 321,
     /* 100865 */     GIR_EraseRootFromParent_Done,
     /* 100866 */   // Label 1863: @100866
     /* 100866 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(100912), // Rule ID 473 //
     /* 100871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100886 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 100889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100910 */     GIR_RootConstrainSelectedInstOperands,
     /* 100911 */     // GIR_Coverage, 473,
     /* 100911 */     GIR_EraseRootFromParent_Done,
     /* 100912 */   // Label 1864: @100912
     /* 100912 */   GIM_Reject,
     /* 100913 */ // Label 1862: @100913
     /* 100913 */ GIM_Reject,
     /* 100914 */ // Label 26: @100914
     /* 100914 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101186),
     /* 100919 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100928 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100983), // Rule ID 201 //
     /* 100933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100963 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 100963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 100966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100981 */     GIR_RootConstrainSelectedInstOperands,
     /* 100982 */     // GIR_Coverage, 201,
     /* 100982 */     GIR_EraseRootFromParent_Done,
     /* 100983 */   // Label 1866: @100983
     /* 100983 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101038), // Rule ID 328 //
     /* 100988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101018 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101036 */     GIR_RootConstrainSelectedInstOperands,
     /* 101037 */     // GIR_Coverage, 328,
     /* 101037 */     GIR_EraseRootFromParent_Done,
     /* 101038 */   // Label 1867: @101038
     /* 101038 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101093), // Rule ID 538 //
     /* 101043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101073 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101091 */     GIR_RootConstrainSelectedInstOperands,
     /* 101092 */     // GIR_Coverage, 538,
     /* 101092 */     GIR_EraseRootFromParent_Done,
     /* 101093 */   // Label 1868: @101093
     /* 101093 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(101139), // Rule ID 312 //
     /* 101098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101113 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101137 */     GIR_RootConstrainSelectedInstOperands,
     /* 101138 */     // GIR_Coverage, 312,
     /* 101138 */     GIR_EraseRootFromParent_Done,
     /* 101139 */   // Label 1869: @101139
     /* 101139 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101185), // Rule ID 475 //
     /* 101144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101159 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101183 */     GIR_RootConstrainSelectedInstOperands,
     /* 101184 */     // GIR_Coverage, 475,
     /* 101184 */     GIR_EraseRootFromParent_Done,
     /* 101185 */   // Label 1870: @101185
     /* 101185 */   GIM_Reject,
     /* 101186 */ // Label 1865: @101186
     /* 101186 */ GIM_Reject,
     /* 101187 */ // Label 27: @101187
     /* 101187 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101518),
     /* 101192 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101201 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101256), // Rule ID 200 //
     /* 101206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101236 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101254 */     GIR_RootConstrainSelectedInstOperands,
     /* 101255 */     // GIR_Coverage, 200,
     /* 101255 */     GIR_EraseRootFromParent_Done,
     /* 101256 */   // Label 1872: @101256
     /* 101256 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101311), // Rule ID 327 //
     /* 101261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101291 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101309 */     GIR_RootConstrainSelectedInstOperands,
     /* 101310 */     // GIR_Coverage, 327,
     /* 101310 */     GIR_EraseRootFromParent_Done,
     /* 101311 */   // Label 1873: @101311
     /* 101311 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101425),
     /* 101316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101320 */     GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101371), // Rule ID 537 //
     /* 101325 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101328 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101332 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101336 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101340 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101345 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101349 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101351 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101351 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101354 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101356 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101360 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101363 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101369 */       GIR_RootConstrainSelectedInstOperands,
     /* 101370 */       // GIR_Coverage, 537,
     /* 101370 */       GIR_EraseRootFromParent_Done,
     /* 101371 */     // Label 1875: @101371
     /* 101371 */     GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(101424), // Rule ID 476 //
     /* 101376 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101379 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101383 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101387 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101391 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101395 */       // MIs[1] Operand 1
     /* 101395 */       // No operand predicates
     /* 101395 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101397 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101397 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101400 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101402 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101404 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101407 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101410 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101416 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101422 */       GIR_RootConstrainSelectedInstOperands,
     /* 101423 */       // GIR_Coverage, 476,
     /* 101423 */       GIR_EraseRootFromParent_Done,
     /* 101424 */     // Label 1876: @101424
     /* 101424 */     GIM_Reject,
     /* 101425 */   // Label 1874: @101425
     /* 101425 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(101471), // Rule ID 329 //
     /* 101430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101445 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101469 */     GIR_RootConstrainSelectedInstOperands,
     /* 101470 */     // GIR_Coverage, 329,
     /* 101470 */     GIR_EraseRootFromParent_Done,
     /* 101471 */   // Label 1877: @101471
     /* 101471 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(101517), // Rule ID 477 //
     /* 101476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101491 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101515 */     GIR_RootConstrainSelectedInstOperands,
     /* 101516 */     // GIR_Coverage, 477,
     /* 101516 */     GIR_EraseRootFromParent_Done,
     /* 101517 */   // Label 1878: @101517
     /* 101517 */   GIM_Reject,
     /* 101518 */ // Label 1871: @101518
     /* 101518 */ GIM_Reject,
     /* 101519 */ // Label 28: @101519
     /* 101519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1882*/ GIMT_Encode4(101766),
     /* 101530 */ /*GILLT_v4s32*//*Label 1879*/ GIMT_Encode4(101562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101546 */ /*GILLT_v8s16*//*Label 1880*/ GIMT_Encode4(101630), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101558 */ /*GILLT_v16s8*//*Label 1881*/ GIMT_Encode4(101698),
     /* 101562 */ // Label 1879: @101562
     /* 101562 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101629), // Rule ID 4464 //
     /* 101567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101588 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101605 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101607 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101618 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101627 */   GIR_RootConstrainSelectedInstOperands,
     /* 101628 */   // GIR_Coverage, 4464,
     /* 101628 */   GIR_EraseRootFromParent_Done,
     /* 101629 */ // Label 1883: @101629
     /* 101629 */ GIM_Reject,
     /* 101630 */ // Label 1880: @101630
     /* 101630 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101697), // Rule ID 4460 //
     /* 101635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101656 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101673 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101675 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101680 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101686 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101695 */   GIR_RootConstrainSelectedInstOperands,
     /* 101696 */   // GIR_Coverage, 4460,
     /* 101696 */   GIR_EraseRootFromParent_Done,
     /* 101697 */ // Label 1884: @101697
     /* 101697 */ GIM_Reject,
     /* 101698 */ // Label 1881: @101698
     /* 101698 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101765), // Rule ID 4456 //
     /* 101703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101724 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101741 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101743 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101754 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101763 */   GIR_RootConstrainSelectedInstOperands,
     /* 101764 */   // GIR_Coverage, 4456,
     /* 101764 */   GIR_EraseRootFromParent_Done,
     /* 101765 */ // Label 1885: @101765
     /* 101765 */ GIM_Reject,
     /* 101766 */ // Label 1882: @101766
     /* 101766 */ GIM_Reject,
     /* 101767 */ // Label 29: @101767
     /* 101767 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1890*/ GIMT_Encode4(102135),
     /* 101778 */ /*GILLT_s32*//*Label 1886*/ GIMT_Encode4(101838), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101806 */ /*GILLT_v4s32*//*Label 1887*/ GIMT_Encode4(101931), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101822 */ /*GILLT_v8s16*//*Label 1888*/ GIMT_Encode4(101999), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101834 */ /*GILLT_v16s8*//*Label 1889*/ GIMT_Encode4(102067),
     /* 101838 */ // Label 1886: @101838
     /* 101838 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(101930),
     /* 101843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101849 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(101889), // Rule ID 178 //
     /* 101854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101869 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 101869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 101872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101887 */     GIR_RootConstrainSelectedInstOperands,
     /* 101888 */     // GIR_Coverage, 178,
     /* 101888 */     GIR_EraseRootFromParent_Done,
     /* 101889 */   // Label 1892: @101889
     /* 101889 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(101929), // Rule ID 507 //
     /* 101894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 101897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101909 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 101912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101927 */     GIR_RootConstrainSelectedInstOperands,
     /* 101928 */     // GIR_Coverage, 507,
     /* 101928 */     GIR_EraseRootFromParent_Done,
     /* 101929 */   // Label 1893: @101929
     /* 101929 */   GIM_Reject,
     /* 101930 */ // Label 1891: @101930
     /* 101930 */ GIM_Reject,
     /* 101931 */ // Label 1887: @101931
     /* 101931 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(101998), // Rule ID 4452 //
     /* 101936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101957 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 101972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101974 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101976 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101981 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101987 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101996 */   GIR_RootConstrainSelectedInstOperands,
     /* 101997 */   // GIR_Coverage, 4452,
     /* 101997 */   GIR_EraseRootFromParent_Done,
     /* 101998 */ // Label 1894: @101998
     /* 101998 */ GIM_Reject,
     /* 101999 */ // Label 1888: @101999
     /* 101999 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(102066), // Rule ID 4448 //
     /* 102004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102025 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102042 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102044 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102049 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102064 */   GIR_RootConstrainSelectedInstOperands,
     /* 102065 */   // GIR_Coverage, 4448,
     /* 102065 */   GIR_EraseRootFromParent_Done,
     /* 102066 */ // Label 1895: @102066
     /* 102066 */ GIM_Reject,
     /* 102067 */ // Label 1889: @102067
     /* 102067 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102134), // Rule ID 4445 //
     /* 102072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102093 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102110 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102112 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102117 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102123 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102132 */   GIR_RootConstrainSelectedInstOperands,
     /* 102133 */   // GIR_Coverage, 4445,
     /* 102133 */   GIR_EraseRootFromParent_Done,
     /* 102134 */ // Label 1896: @102134
     /* 102134 */ GIM_Reject,
     /* 102135 */ // Label 1890: @102135
     /* 102135 */ GIM_Reject,
     /* 102136 */ // Label 30: @102136
     /* 102136 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1905*/ GIMT_Encode4(102780),
     /* 102147 */ /*GILLT_s64*//*Label 1897*/ GIMT_Encode4(102203), GIMT_Encode4(0),
     /* 102155 */ /*GILLT_v2s32*//*Label 1898*/ GIMT_Encode4(102250),
     /* 102159 */ /*GILLT_v2s64*//*Label 1899*/ GIMT_Encode4(102297), GIMT_Encode4(0),
     /* 102167 */ /*GILLT_v4s16*//*Label 1900*/ GIMT_Encode4(102344),
     /* 102171 */ /*GILLT_v4s32*//*Label 1901*/ GIMT_Encode4(102391), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102183 */ /*GILLT_v8s8*//*Label 1902*/ GIMT_Encode4(102505),
     /* 102187 */ /*GILLT_v8s16*//*Label 1903*/ GIMT_Encode4(102552), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102199 */ /*GILLT_v16s8*//*Label 1904*/ GIMT_Encode4(102666),
     /* 102203 */ // Label 1897: @102203
     /* 102203 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102249), // Rule ID 830 //
     /* 102208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102229 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102234 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102236 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102241 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102247 */   GIR_RootConstrainSelectedInstOperands,
     /* 102248 */   // GIR_Coverage, 830,
     /* 102248 */   GIR_EraseRootFromParent_Done,
     /* 102249 */ // Label 1906: @102249
     /* 102249 */ GIM_Reject,
     /* 102250 */ // Label 1898: @102250
     /* 102250 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102296), // Rule ID 825 //
     /* 102255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102276 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102281 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102283 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102294 */   GIR_RootConstrainSelectedInstOperands,
     /* 102295 */   // GIR_Coverage, 825,
     /* 102295 */   GIR_EraseRootFromParent_Done,
     /* 102296 */ // Label 1907: @102296
     /* 102296 */ GIM_Reject,
     /* 102297 */ // Label 1899: @102297
     /* 102297 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102343), // Rule ID 831 //
     /* 102302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102323 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102328 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102330 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102341 */   GIR_RootConstrainSelectedInstOperands,
     /* 102342 */   // GIR_Coverage, 831,
     /* 102342 */   GIR_EraseRootFromParent_Done,
     /* 102343 */ // Label 1908: @102343
     /* 102343 */ GIM_Reject,
     /* 102344 */ // Label 1900: @102344
     /* 102344 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102390), // Rule ID 824 //
     /* 102349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102370 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102375 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102377 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102382 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102388 */   GIR_RootConstrainSelectedInstOperands,
     /* 102389 */   // GIR_Coverage, 824,
     /* 102389 */   GIR_EraseRootFromParent_Done,
     /* 102390 */ // Label 1909: @102390
     /* 102390 */ GIM_Reject,
     /* 102391 */ // Label 1901: @102391
     /* 102391 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102504),
     /* 102396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102402 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102442), // Rule ID 827 //
     /* 102407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102422 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102440 */     GIR_RootConstrainSelectedInstOperands,
     /* 102441 */     // GIR_Coverage, 827,
     /* 102441 */     GIR_EraseRootFromParent_Done,
     /* 102442 */   // Label 1911: @102442
     /* 102442 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102503), // Rule ID 3527 //
     /* 102447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102462 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102501 */     GIR_RootConstrainSelectedInstOperands,
     /* 102502 */     // GIR_Coverage, 3527,
     /* 102502 */     GIR_EraseRootFromParent_Done,
     /* 102503 */   // Label 1912: @102503
     /* 102503 */   GIM_Reject,
     /* 102504 */ // Label 1910: @102504
     /* 102504 */ GIM_Reject,
     /* 102505 */ // Label 1902: @102505
     /* 102505 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102551), // Rule ID 828 //
     /* 102510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102531 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102536 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102538 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102543 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102549 */   GIR_RootConstrainSelectedInstOperands,
     /* 102550 */   // GIR_Coverage, 828,
     /* 102550 */   GIR_EraseRootFromParent_Done,
     /* 102551 */ // Label 1913: @102551
     /* 102551 */ GIM_Reject,
     /* 102552 */ // Label 1903: @102552
     /* 102552 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102665),
     /* 102557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102563 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102603), // Rule ID 826 //
     /* 102568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102583 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102601 */     GIR_RootConstrainSelectedInstOperands,
     /* 102602 */     // GIR_Coverage, 826,
     /* 102602 */     GIR_EraseRootFromParent_Done,
     /* 102603 */   // Label 1915: @102603
     /* 102603 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102664), // Rule ID 3524 //
     /* 102608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102623 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102662 */     GIR_RootConstrainSelectedInstOperands,
     /* 102663 */     // GIR_Coverage, 3524,
     /* 102663 */     GIR_EraseRootFromParent_Done,
     /* 102664 */   // Label 1916: @102664
     /* 102664 */   GIM_Reject,
     /* 102665 */ // Label 1914: @102665
     /* 102665 */ GIM_Reject,
     /* 102666 */ // Label 1904: @102666
     /* 102666 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(102779),
     /* 102671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102677 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(102717), // Rule ID 829 //
     /* 102682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102697 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102715 */     GIR_RootConstrainSelectedInstOperands,
     /* 102716 */     // GIR_Coverage, 829,
     /* 102716 */     GIR_EraseRootFromParent_Done,
     /* 102717 */   // Label 1918: @102717
     /* 102717 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(102778), // Rule ID 3521 //
     /* 102722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102737 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102776 */     GIR_RootConstrainSelectedInstOperands,
     /* 102777 */     // GIR_Coverage, 3521,
     /* 102777 */     GIR_EraseRootFromParent_Done,
     /* 102778 */   // Label 1919: @102778
     /* 102778 */   GIM_Reject,
     /* 102779 */ // Label 1917: @102779
     /* 102779 */ GIM_Reject,
     /* 102780 */ // Label 1905: @102780
     /* 102780 */ GIM_Reject,
     /* 102781 */ // Label 31: @102781
     /* 102781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1929*/ GIMT_Encode4(104080),
     /* 102792 */ /*GILLT_s32*//*Label 1920*/ GIMT_Encode4(102852),
     /* 102796 */ /*GILLT_s64*//*Label 1921*/ GIMT_Encode4(103193), GIMT_Encode4(0),
     /* 102804 */ /*GILLT_v2s32*//*Label 1922*/ GIMT_Encode4(103240),
     /* 102808 */ /*GILLT_v2s64*//*Label 1923*/ GIMT_Encode4(103287), GIMT_Encode4(0),
     /* 102816 */ /*GILLT_v4s16*//*Label 1924*/ GIMT_Encode4(103488),
     /* 102820 */ /*GILLT_v4s32*//*Label 1925*/ GIMT_Encode4(103535), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102832 */ /*GILLT_v8s8*//*Label 1926*/ GIMT_Encode4(103805),
     /* 102836 */ /*GILLT_v8s16*//*Label 1927*/ GIMT_Encode4(103852), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102848 */ /*GILLT_v16s8*//*Label 1928*/ GIMT_Encode4(103966),
     /* 102852 */ // Label 1920: @102852
     /* 102852 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103192),
     /* 102857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102863 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(102925), // Rule ID 5654 //
     /* 102868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102892 */     // MIs[1] Rn
     /* 102892 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102903 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 102906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102923 */     GIR_RootConstrainSelectedInstOperands,
     /* 102924 */     // GIR_Coverage, 5654,
     /* 102924 */     GIR_EraseRootFromParent_Done,
     /* 102925 */   // Label 1931: @102925
     /* 102925 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(102987), // Rule ID 5688 //
     /* 102930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102954 */     // MIs[1] Rn
     /* 102954 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102965 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 102968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102985 */     GIR_RootConstrainSelectedInstOperands,
     /* 102986 */     // GIR_Coverage, 5688,
     /* 102986 */     GIR_EraseRootFromParent_Done,
     /* 102987 */   // Label 1932: @102987
     /* 102987 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103049), // Rule ID 1870 //
     /* 102992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103020 */     // MIs[1] Rn
     /* 103020 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103027 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103047 */     GIR_RootConstrainSelectedInstOperands,
     /* 103048 */     // GIR_Coverage, 1870,
     /* 103048 */     GIR_EraseRootFromParent_Done,
     /* 103049 */   // Label 1933: @103049
     /* 103049 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(103111), // Rule ID 2136 //
     /* 103054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103082 */     // MIs[1] Rn
     /* 103082 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103089 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103109 */     GIR_RootConstrainSelectedInstOperands,
     /* 103110 */     // GIR_Coverage, 2136,
     /* 103110 */     GIR_EraseRootFromParent_Done,
     /* 103111 */   // Label 1934: @103111
     /* 103111 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103151), // Rule ID 1868 //
     /* 103116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103131 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103136 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103138 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103149 */     GIR_RootConstrainSelectedInstOperands,
     /* 103150 */     // GIR_Coverage, 1868,
     /* 103150 */     GIR_EraseRootFromParent_Done,
     /* 103151 */   // Label 1935: @103151
     /* 103151 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103191), // Rule ID 2134 //
     /* 103156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103171 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103189 */     GIR_RootConstrainSelectedInstOperands,
     /* 103190 */     // GIR_Coverage, 2134,
     /* 103190 */     GIR_EraseRootFromParent_Done,
     /* 103191 */   // Label 1936: @103191
     /* 103191 */   GIM_Reject,
     /* 103192 */ // Label 1930: @103192
     /* 103192 */ GIM_Reject,
     /* 103193 */ // Label 1921: @103193
     /* 103193 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103239), // Rule ID 822 //
     /* 103198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103219 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103224 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103226 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103231 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103237 */   GIR_RootConstrainSelectedInstOperands,
     /* 103238 */   // GIR_Coverage, 822,
     /* 103238 */   GIR_EraseRootFromParent_Done,
     /* 103239 */ // Label 1937: @103239
     /* 103239 */ GIM_Reject,
     /* 103240 */ // Label 1922: @103240
     /* 103240 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103286), // Rule ID 817 //
     /* 103245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103266 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103271 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103273 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103278 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103284 */   GIR_RootConstrainSelectedInstOperands,
     /* 103285 */   // GIR_Coverage, 817,
     /* 103285 */   GIR_EraseRootFromParent_Done,
     /* 103286 */ // Label 1938: @103286
     /* 103286 */ GIM_Reject,
     /* 103287 */ // Label 1923: @103287
     /* 103287 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103487),
     /* 103292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103302 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103376), // Rule ID 5745 //
     /* 103307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103318 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103321 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103330 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103350 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103374 */     GIR_RootConstrainSelectedInstOperands,
     /* 103375 */     // GIR_Coverage, 5745,
     /* 103375 */     GIR_EraseRootFromParent_Done,
     /* 103376 */   // Label 1940: @103376
     /* 103376 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103450), // Rule ID 2489 //
     /* 103381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103396 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103399 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103408 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103424 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103448 */     GIR_RootConstrainSelectedInstOperands,
     /* 103449 */     // GIR_Coverage, 2489,
     /* 103449 */     GIR_EraseRootFromParent_Done,
     /* 103450 */   // Label 1941: @103450
     /* 103450 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103486), // Rule ID 823 //
     /* 103455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103466 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103484 */     GIR_RootConstrainSelectedInstOperands,
     /* 103485 */     // GIR_Coverage, 823,
     /* 103485 */     GIR_EraseRootFromParent_Done,
     /* 103486 */   // Label 1942: @103486
     /* 103486 */   GIM_Reject,
     /* 103487 */ // Label 1939: @103487
     /* 103487 */ GIM_Reject,
     /* 103488 */ // Label 1924: @103488
     /* 103488 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103534), // Rule ID 816 //
     /* 103493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103514 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103519 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103521 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103526 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103532 */   GIR_RootConstrainSelectedInstOperands,
     /* 103533 */   // GIR_Coverage, 816,
     /* 103533 */   GIR_EraseRootFromParent_Done,
     /* 103534 */ // Label 1943: @103534
     /* 103534 */ GIM_Reject,
     /* 103535 */ // Label 1925: @103535
     /* 103535 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(103804),
     /* 103540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103546 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(103624), // Rule ID 5744 //
     /* 103551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103566 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103569 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103578 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103598 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103622 */     GIR_RootConstrainSelectedInstOperands,
     /* 103623 */     // GIR_Coverage, 5744,
     /* 103623 */     GIR_EraseRootFromParent_Done,
     /* 103624 */   // Label 1945: @103624
     /* 103624 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(103702), // Rule ID 2488 //
     /* 103629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103648 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103651 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103660 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103676 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103700 */     GIR_RootConstrainSelectedInstOperands,
     /* 103701 */     // GIR_Coverage, 2488,
     /* 103701 */     GIR_EraseRootFromParent_Done,
     /* 103702 */   // Label 1946: @103702
     /* 103702 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(103742), // Rule ID 819 //
     /* 103707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103722 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103740 */     GIR_RootConstrainSelectedInstOperands,
     /* 103741 */     // GIR_Coverage, 819,
     /* 103741 */     GIR_EraseRootFromParent_Done,
     /* 103742 */   // Label 1947: @103742
     /* 103742 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(103803), // Rule ID 3518 //
     /* 103747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103762 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103801 */     GIR_RootConstrainSelectedInstOperands,
     /* 103802 */     // GIR_Coverage, 3518,
     /* 103802 */     GIR_EraseRootFromParent_Done,
     /* 103803 */   // Label 1948: @103803
     /* 103803 */   GIM_Reject,
     /* 103804 */ // Label 1944: @103804
     /* 103804 */ GIM_Reject,
     /* 103805 */ // Label 1926: @103805
     /* 103805 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(103851), // Rule ID 820 //
     /* 103810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 103816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 103819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103831 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 103831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 103834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103836 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103838 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103843 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103849 */   GIR_RootConstrainSelectedInstOperands,
     /* 103850 */   // GIR_Coverage, 820,
     /* 103850 */   GIR_EraseRootFromParent_Done,
     /* 103851 */ // Label 1949: @103851
     /* 103851 */ GIM_Reject,
     /* 103852 */ // Label 1927: @103852
     /* 103852 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(103965),
     /* 103857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103863 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(103903), // Rule ID 818 //
     /* 103868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103883 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 103883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 103886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103901 */     GIR_RootConstrainSelectedInstOperands,
     /* 103902 */     // GIR_Coverage, 818,
     /* 103902 */     GIR_EraseRootFromParent_Done,
     /* 103903 */   // Label 1951: @103903
     /* 103903 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(103964), // Rule ID 3515 //
     /* 103908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103923 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 103923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 103938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103962 */     GIR_RootConstrainSelectedInstOperands,
     /* 103963 */     // GIR_Coverage, 3515,
     /* 103963 */     GIR_EraseRootFromParent_Done,
     /* 103964 */   // Label 1952: @103964
     /* 103964 */   GIM_Reject,
     /* 103965 */ // Label 1950: @103965
     /* 103965 */ GIM_Reject,
     /* 103966 */ // Label 1928: @103966
     /* 103966 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(104079),
     /* 103971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 103974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 103977 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(104017), // Rule ID 821 //
     /* 103982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103997 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 103997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104015 */     GIR_RootConstrainSelectedInstOperands,
     /* 104016 */     // GIR_Coverage, 821,
     /* 104016 */     GIR_EraseRootFromParent_Done,
     /* 104017 */   // Label 1954: @104017
     /* 104017 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104078), // Rule ID 3512 //
     /* 104022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104037 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104076 */     GIR_RootConstrainSelectedInstOperands,
     /* 104077 */     // GIR_Coverage, 3512,
     /* 104077 */     GIR_EraseRootFromParent_Done,
     /* 104078 */   // Label 1955: @104078
     /* 104078 */   GIM_Reject,
     /* 104079 */ // Label 1953: @104079
     /* 104079 */ GIM_Reject,
     /* 104080 */ // Label 1929: @104080
     /* 104080 */ GIM_Reject,
     /* 104081 */ // Label 32: @104081
     /* 104081 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1964*/ GIMT_Encode4(104725),
     /* 104092 */ /*GILLT_s64*//*Label 1956*/ GIMT_Encode4(104148), GIMT_Encode4(0),
     /* 104100 */ /*GILLT_v2s32*//*Label 1957*/ GIMT_Encode4(104195),
     /* 104104 */ /*GILLT_v2s64*//*Label 1958*/ GIMT_Encode4(104242), GIMT_Encode4(0),
     /* 104112 */ /*GILLT_v4s16*//*Label 1959*/ GIMT_Encode4(104289),
     /* 104116 */ /*GILLT_v4s32*//*Label 1960*/ GIMT_Encode4(104336), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104128 */ /*GILLT_v8s8*//*Label 1961*/ GIMT_Encode4(104450),
     /* 104132 */ /*GILLT_v8s16*//*Label 1962*/ GIMT_Encode4(104497), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104144 */ /*GILLT_v16s8*//*Label 1963*/ GIMT_Encode4(104611),
     /* 104148 */ // Label 1956: @104148
     /* 104148 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104194), // Rule ID 1022 //
     /* 104153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104174 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104179 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104181 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104186 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104192 */   GIR_RootConstrainSelectedInstOperands,
     /* 104193 */   // GIR_Coverage, 1022,
     /* 104193 */   GIR_EraseRootFromParent_Done,
     /* 104194 */ // Label 1965: @104194
     /* 104194 */ GIM_Reject,
     /* 104195 */ // Label 1957: @104195
     /* 104195 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104241), // Rule ID 1017 //
     /* 104200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104221 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104226 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104228 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104233 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104239 */   GIR_RootConstrainSelectedInstOperands,
     /* 104240 */   // GIR_Coverage, 1017,
     /* 104240 */   GIR_EraseRootFromParent_Done,
     /* 104241 */ // Label 1966: @104241
     /* 104241 */ GIM_Reject,
     /* 104242 */ // Label 1958: @104242
     /* 104242 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104288), // Rule ID 1023 //
     /* 104247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104268 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104273 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104275 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104280 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104286 */   GIR_RootConstrainSelectedInstOperands,
     /* 104287 */   // GIR_Coverage, 1023,
     /* 104287 */   GIR_EraseRootFromParent_Done,
     /* 104288 */ // Label 1967: @104288
     /* 104288 */ GIM_Reject,
     /* 104289 */ // Label 1959: @104289
     /* 104289 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104335), // Rule ID 1016 //
     /* 104294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104315 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104320 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104322 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104327 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104333 */   GIR_RootConstrainSelectedInstOperands,
     /* 104334 */   // GIR_Coverage, 1016,
     /* 104334 */   GIR_EraseRootFromParent_Done,
     /* 104335 */ // Label 1968: @104335
     /* 104335 */ GIM_Reject,
     /* 104336 */ // Label 1960: @104336
     /* 104336 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104449),
     /* 104341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104347 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104387), // Rule ID 1019 //
     /* 104352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104367 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104385 */     GIR_RootConstrainSelectedInstOperands,
     /* 104386 */     // GIR_Coverage, 1019,
     /* 104386 */     GIR_EraseRootFromParent_Done,
     /* 104387 */   // Label 1970: @104387
     /* 104387 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104448), // Rule ID 3545 //
     /* 104392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104407 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104446 */     GIR_RootConstrainSelectedInstOperands,
     /* 104447 */     // GIR_Coverage, 3545,
     /* 104447 */     GIR_EraseRootFromParent_Done,
     /* 104448 */   // Label 1971: @104448
     /* 104448 */   GIM_Reject,
     /* 104449 */ // Label 1969: @104449
     /* 104449 */ GIM_Reject,
     /* 104450 */ // Label 1961: @104450
     /* 104450 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104496), // Rule ID 1020 //
     /* 104455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104476 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104481 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104483 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104488 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104494 */   GIR_RootConstrainSelectedInstOperands,
     /* 104495 */   // GIR_Coverage, 1020,
     /* 104495 */   GIR_EraseRootFromParent_Done,
     /* 104496 */ // Label 1972: @104496
     /* 104496 */ GIM_Reject,
     /* 104497 */ // Label 1962: @104497
     /* 104497 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104610),
     /* 104502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104508 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104548), // Rule ID 1018 //
     /* 104513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104528 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104546 */     GIR_RootConstrainSelectedInstOperands,
     /* 104547 */     // GIR_Coverage, 1018,
     /* 104547 */     GIR_EraseRootFromParent_Done,
     /* 104548 */   // Label 1974: @104548
     /* 104548 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(104609), // Rule ID 3542 //
     /* 104553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104568 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104607 */     GIR_RootConstrainSelectedInstOperands,
     /* 104608 */     // GIR_Coverage, 3542,
     /* 104608 */     GIR_EraseRootFromParent_Done,
     /* 104609 */   // Label 1975: @104609
     /* 104609 */   GIM_Reject,
     /* 104610 */ // Label 1973: @104610
     /* 104610 */ GIM_Reject,
     /* 104611 */ // Label 1963: @104611
     /* 104611 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(104724),
     /* 104616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104622 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(104662), // Rule ID 1021 //
     /* 104627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104642 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104660 */     GIR_RootConstrainSelectedInstOperands,
     /* 104661 */     // GIR_Coverage, 1021,
     /* 104661 */     GIR_EraseRootFromParent_Done,
     /* 104662 */   // Label 1977: @104662
     /* 104662 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(104723), // Rule ID 3539 //
     /* 104667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104682 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104721 */     GIR_RootConstrainSelectedInstOperands,
     /* 104722 */     // GIR_Coverage, 3539,
     /* 104722 */     GIR_EraseRootFromParent_Done,
     /* 104723 */   // Label 1978: @104723
     /* 104723 */   GIM_Reject,
     /* 104724 */ // Label 1976: @104724
     /* 104724 */ GIM_Reject,
     /* 104725 */ // Label 1964: @104725
     /* 104725 */ GIM_Reject,
     /* 104726 */ // Label 33: @104726
     /* 104726 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1988*/ GIMT_Encode4(105745),
     /* 104737 */ /*GILLT_s32*//*Label 1979*/ GIMT_Encode4(104797),
     /* 104741 */ /*GILLT_s64*//*Label 1980*/ GIMT_Encode4(105014), GIMT_Encode4(0),
     /* 104749 */ /*GILLT_v2s32*//*Label 1981*/ GIMT_Encode4(105061),
     /* 104753 */ /*GILLT_v2s64*//*Label 1982*/ GIMT_Encode4(105108), GIMT_Encode4(0),
     /* 104761 */ /*GILLT_v4s16*//*Label 1983*/ GIMT_Encode4(105231),
     /* 104765 */ /*GILLT_v4s32*//*Label 1984*/ GIMT_Encode4(105278), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104777 */ /*GILLT_v8s8*//*Label 1985*/ GIMT_Encode4(105470),
     /* 104781 */ /*GILLT_v8s16*//*Label 1986*/ GIMT_Encode4(105517), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104793 */ /*GILLT_v16s8*//*Label 1987*/ GIMT_Encode4(105631),
     /* 104797 */ // Label 1979: @104797
     /* 104797 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105013),
     /* 104802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 104808 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(104870), // Rule ID 1871 //
     /* 104813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104841 */     // MIs[1] Rn
     /* 104841 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104848 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 104851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104868 */     GIR_RootConstrainSelectedInstOperands,
     /* 104869 */     // GIR_Coverage, 1871,
     /* 104869 */     GIR_EraseRootFromParent_Done,
     /* 104870 */   // Label 1990: @104870
     /* 104870 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(104932), // Rule ID 2137 //
     /* 104875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 104878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104903 */     // MIs[1] Rn
     /* 104903 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104910 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 104913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104930 */     GIR_RootConstrainSelectedInstOperands,
     /* 104931 */     // GIR_Coverage, 2137,
     /* 104931 */     GIR_EraseRootFromParent_Done,
     /* 104932 */   // Label 1991: @104932
     /* 104932 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(104972), // Rule ID 1869 //
     /* 104937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104952 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 104952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 104955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104957 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 104959 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 104961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104970 */     GIR_RootConstrainSelectedInstOperands,
     /* 104971 */     // GIR_Coverage, 1869,
     /* 104971 */     GIR_EraseRootFromParent_Done,
     /* 104972 */   // Label 1992: @104972
     /* 104972 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105012), // Rule ID 2135 //
     /* 104977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 104980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104992 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 104995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105010 */     GIR_RootConstrainSelectedInstOperands,
     /* 105011 */     // GIR_Coverage, 2135,
     /* 105011 */     GIR_EraseRootFromParent_Done,
     /* 105012 */   // Label 1993: @105012
     /* 105012 */   GIM_Reject,
     /* 105013 */ // Label 1989: @105013
     /* 105013 */ GIM_Reject,
     /* 105014 */ // Label 1980: @105014
     /* 105014 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105060), // Rule ID 1014 //
     /* 105019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105040 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105045 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105047 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105052 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105058 */   GIR_RootConstrainSelectedInstOperands,
     /* 105059 */   // GIR_Coverage, 1014,
     /* 105059 */   GIR_EraseRootFromParent_Done,
     /* 105060 */ // Label 1994: @105060
     /* 105060 */ GIM_Reject,
     /* 105061 */ // Label 1981: @105061
     /* 105061 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105107), // Rule ID 1009 //
     /* 105066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105087 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105092 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105094 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105099 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105105 */   GIR_RootConstrainSelectedInstOperands,
     /* 105106 */   // GIR_Coverage, 1009,
     /* 105106 */   GIR_EraseRootFromParent_Done,
     /* 105107 */ // Label 1995: @105107
     /* 105107 */ GIM_Reject,
     /* 105108 */ // Label 1982: @105108
     /* 105108 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105230),
     /* 105113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105127 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105197), // Rule ID 2496 //
     /* 105132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105143 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105146 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105155 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105171 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105195 */     GIR_RootConstrainSelectedInstOperands,
     /* 105196 */     // GIR_Coverage, 2496,
     /* 105196 */     GIR_EraseRootFromParent_Done,
     /* 105197 */   // Label 1997: @105197
     /* 105197 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105229), // Rule ID 1015 //
     /* 105202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105209 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105227 */     GIR_RootConstrainSelectedInstOperands,
     /* 105228 */     // GIR_Coverage, 1015,
     /* 105228 */     GIR_EraseRootFromParent_Done,
     /* 105229 */   // Label 1998: @105229
     /* 105229 */   GIM_Reject,
     /* 105230 */ // Label 1996: @105230
     /* 105230 */ GIM_Reject,
     /* 105231 */ // Label 1983: @105231
     /* 105231 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105277), // Rule ID 1008 //
     /* 105236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105257 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105262 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105264 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105269 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105275 */   GIR_RootConstrainSelectedInstOperands,
     /* 105276 */   // GIR_Coverage, 1008,
     /* 105276 */   GIR_EraseRootFromParent_Done,
     /* 105277 */ // Label 1999: @105277
     /* 105277 */ GIM_Reject,
     /* 105278 */ // Label 1984: @105278
     /* 105278 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105469),
     /* 105283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105289 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105367), // Rule ID 2495 //
     /* 105294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105313 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105316 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105325 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105341 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105365 */     GIR_RootConstrainSelectedInstOperands,
     /* 105366 */     // GIR_Coverage, 2495,
     /* 105366 */     GIR_EraseRootFromParent_Done,
     /* 105367 */   // Label 2001: @105367
     /* 105367 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105407), // Rule ID 1011 //
     /* 105372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105387 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105405 */     GIR_RootConstrainSelectedInstOperands,
     /* 105406 */     // GIR_Coverage, 1011,
     /* 105406 */     GIR_EraseRootFromParent_Done,
     /* 105407 */   // Label 2002: @105407
     /* 105407 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105468), // Rule ID 3536 //
     /* 105412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105427 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105466 */     GIR_RootConstrainSelectedInstOperands,
     /* 105467 */     // GIR_Coverage, 3536,
     /* 105467 */     GIR_EraseRootFromParent_Done,
     /* 105468 */   // Label 2003: @105468
     /* 105468 */   GIM_Reject,
     /* 105469 */ // Label 2000: @105469
     /* 105469 */ GIM_Reject,
     /* 105470 */ // Label 1985: @105470
     /* 105470 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105516), // Rule ID 1012 //
     /* 105475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105496 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105501 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105503 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105508 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105514 */   GIR_RootConstrainSelectedInstOperands,
     /* 105515 */   // GIR_Coverage, 1012,
     /* 105515 */   GIR_EraseRootFromParent_Done,
     /* 105516 */ // Label 2004: @105516
     /* 105516 */ GIM_Reject,
     /* 105517 */ // Label 1986: @105517
     /* 105517 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105630),
     /* 105522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105528 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(105568), // Rule ID 1010 //
     /* 105533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105548 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105566 */     GIR_RootConstrainSelectedInstOperands,
     /* 105567 */     // GIR_Coverage, 1010,
     /* 105567 */     GIR_EraseRootFromParent_Done,
     /* 105568 */   // Label 2006: @105568
     /* 105568 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(105629), // Rule ID 3533 //
     /* 105573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105588 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105627 */     GIR_RootConstrainSelectedInstOperands,
     /* 105628 */     // GIR_Coverage, 3533,
     /* 105628 */     GIR_EraseRootFromParent_Done,
     /* 105629 */   // Label 2007: @105629
     /* 105629 */   GIM_Reject,
     /* 105630 */ // Label 2005: @105630
     /* 105630 */ GIM_Reject,
     /* 105631 */ // Label 1987: @105631
     /* 105631 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(105744),
     /* 105636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105642 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(105682), // Rule ID 1013 //
     /* 105647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105662 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105680 */     GIR_RootConstrainSelectedInstOperands,
     /* 105681 */     // GIR_Coverage, 1013,
     /* 105681 */     GIR_EraseRootFromParent_Done,
     /* 105682 */   // Label 2009: @105682
     /* 105682 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(105743), // Rule ID 3530 //
     /* 105687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105702 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105741 */     GIR_RootConstrainSelectedInstOperands,
     /* 105742 */     // GIR_Coverage, 3530,
     /* 105742 */     GIR_EraseRootFromParent_Done,
     /* 105743 */   // Label 2010: @105743
     /* 105743 */   GIM_Reject,
     /* 105744 */ // Label 2008: @105744
     /* 105744 */ GIM_Reject,
     /* 105745 */ // Label 1988: @105745
     /* 105745 */ GIM_Reject,
     /* 105746 */ // Label 34: @105746
     /* 105746 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2018*/ GIMT_Encode4(108098),
     /* 105757 */ /*GILLT_s16*//*Label 2011*/ GIMT_Encode4(105809),
     /* 105761 */ /*GILLT_s32*//*Label 2012*/ GIMT_Encode4(105856),
     /* 105765 */ /*GILLT_s64*//*Label 2013*/ GIMT_Encode4(107451), GIMT_Encode4(0),
     /* 105773 */ /*GILLT_v2s32*//*Label 2014*/ GIMT_Encode4(107498), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105785 */ /*GILLT_v4s16*//*Label 2015*/ GIMT_Encode4(107545),
     /* 105789 */ /*GILLT_v4s32*//*Label 2016*/ GIMT_Encode4(107730), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105805 */ /*GILLT_v8s16*//*Label 2017*/ GIMT_Encode4(107844),
     /* 105809 */ // Label 2011: @105809
     /* 105809 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(105855), // Rule ID 614 //
     /* 105814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 105817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 105820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 105823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105835 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 105835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 105838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 105840 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 105842 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 105844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105847 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105853 */   GIR_RootConstrainSelectedInstOperands,
     /* 105854 */   // GIR_Coverage, 614,
     /* 105854 */   GIR_EraseRootFromParent_Done,
     /* 105855 */ // Label 2019: @105855
     /* 105855 */ GIM_Reject,
     /* 105856 */ // Label 2012: @105856
     /* 105856 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107450),
     /* 105861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105871 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(106199), // Rule ID 5921 //
     /* 105876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 105879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 105887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105911 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 105911 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 105914 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105918 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 105925 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 105928 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105932 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105937 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 105940 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105945 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 105948 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105952 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105957 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 105960 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 105964 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 105967 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105972 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105977 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105982 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 105985 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105989 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 105996 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 105999 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106003 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106008 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106011 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106016 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106019 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106023 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106028 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106031 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106035 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106038 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106043 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106048 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106053 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106056 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106060 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106067 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106070 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106074 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106079 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106082 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106087 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106090 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106094 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106099 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106102 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106106 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106109 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106114 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106119 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106136 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106139 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106142 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106145 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106148 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106181 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106198 */     // GIR_Coverage, 5921,
     /* 106198 */     GIR_EraseRootFromParent_Done,
     /* 106199 */   // Label 2021: @106199
     /* 106199 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(106527), // Rule ID 5922 //
     /* 106204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106239 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106239 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106242 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106246 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106253 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106256 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106260 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106265 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106268 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106273 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106276 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106280 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106285 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106288 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106292 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106295 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106300 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106305 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106310 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106313 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106317 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106324 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106327 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106331 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106336 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106339 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106344 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106347 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106351 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106356 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106359 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106363 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106366 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106371 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106376 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106381 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106384 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106388 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106395 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106398 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106402 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106407 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106410 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106415 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106418 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106422 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106427 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106430 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106434 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106437 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106442 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106447 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106452 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106455 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106459 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106464 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106467 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106470 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106473 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106476 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106496 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106526 */     // GIR_Coverage, 5922,
     /* 106526 */     GIR_EraseRootFromParent_Done,
     /* 106527 */   // Label 2022: @106527
     /* 106527 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(106855), // Rule ID 2700 //
     /* 106532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106567 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106567 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106570 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106574 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106581 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106584 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106588 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106593 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106596 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106601 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106604 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106608 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106613 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106616 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106620 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106623 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106628 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106633 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106638 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106641 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106645 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106652 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106655 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106659 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106664 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106667 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106672 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106675 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106679 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106684 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106687 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106691 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106694 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106699 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106704 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106709 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106712 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106716 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106723 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106726 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106730 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106735 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106738 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106743 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106746 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106750 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106755 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106758 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106762 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106765 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106770 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106775 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106780 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106783 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106787 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106792 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106795 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106798 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106801 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106804 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106824 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106837 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106854 */     // GIR_Coverage, 2700,
     /* 106854 */     GIR_EraseRootFromParent_Done,
     /* 106855 */   // Label 2023: @106855
     /* 106855 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107183), // Rule ID 2702 //
     /* 106860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106895 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106895 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106898 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106902 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106909 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106912 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106916 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106921 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106924 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106929 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106932 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106936 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106941 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106944 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106948 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106951 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106956 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106961 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106966 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106969 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106973 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106980 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106983 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106987 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106992 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106995 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107000 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107003 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107007 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107012 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107015 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107019 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107022 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107027 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107032 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107037 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107040 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107044 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107051 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107054 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107058 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107063 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107066 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107071 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107074 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107078 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107083 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107086 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107090 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107093 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107098 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107103 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107120 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107123 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107126 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107129 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107132 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107165 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107182 */     // GIR_Coverage, 2702,
     /* 107182 */     GIR_EraseRootFromParent_Done,
     /* 107183 */   // Label 2024: @107183
     /* 107183 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107219), // Rule ID 613 //
     /* 107188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107199 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107217 */     GIR_RootConstrainSelectedInstOperands,
     /* 107218 */     // GIR_Coverage, 613,
     /* 107218 */     GIR_EraseRootFromParent_Done,
     /* 107219 */   // Label 2025: @107219
     /* 107219 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107449), // Rule ID 2697 //
     /* 107224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107235 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107235 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107238 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107242 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107249 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107252 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107256 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107261 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107264 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107269 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107272 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107276 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107281 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107284 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107288 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107291 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107296 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107301 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107306 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107309 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107313 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107320 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107323 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107327 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107332 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107335 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107340 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107343 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107347 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107352 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107355 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107359 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107362 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107367 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107372 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107389 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107392 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107395 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107398 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107418 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107431 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107448 */     // GIR_Coverage, 2697,
     /* 107448 */     GIR_EraseRootFromParent_Done,
     /* 107449 */   // Label 2026: @107449
     /* 107449 */   GIM_Reject,
     /* 107450 */ // Label 2020: @107450
     /* 107450 */ GIM_Reject,
     /* 107451 */ // Label 2013: @107451
     /* 107451 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107497), // Rule ID 612 //
     /* 107456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107477 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107482 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107484 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107489 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107495 */   GIR_RootConstrainSelectedInstOperands,
     /* 107496 */   // GIR_Coverage, 612,
     /* 107496 */   GIR_EraseRootFromParent_Done,
     /* 107497 */ // Label 2027: @107497
     /* 107497 */ GIM_Reject,
     /* 107498 */ // Label 2014: @107498
     /* 107498 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107544), // Rule ID 764 //
     /* 107503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107524 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107529 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107531 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107536 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107542 */   GIR_RootConstrainSelectedInstOperands,
     /* 107543 */   // GIR_Coverage, 764,
     /* 107543 */   GIR_EraseRootFromParent_Done,
     /* 107544 */ // Label 2028: @107544
     /* 107544 */ GIM_Reject,
     /* 107545 */ // Label 2015: @107545
     /* 107545 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107729),
     /* 107550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107560 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107626), // Rule ID 5584 //
     /* 107565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107600 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107624 */     GIR_RootConstrainSelectedInstOperands,
     /* 107625 */     // GIR_Coverage, 5584,
     /* 107625 */     GIR_EraseRootFromParent_Done,
     /* 107626 */   // Label 2030: @107626
     /* 107626 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107692), // Rule ID 945 //
     /* 107631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107666 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107671 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107690 */     GIR_RootConstrainSelectedInstOperands,
     /* 107691 */     // GIR_Coverage, 945,
     /* 107691 */     GIR_EraseRootFromParent_Done,
     /* 107692 */   // Label 2031: @107692
     /* 107692 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107728), // Rule ID 766 //
     /* 107697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107708 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107726 */     GIR_RootConstrainSelectedInstOperands,
     /* 107727 */     // GIR_Coverage, 766,
     /* 107727 */     GIR_EraseRootFromParent_Done,
     /* 107728 */   // Label 2032: @107728
     /* 107728 */   GIM_Reject,
     /* 107729 */ // Label 2029: @107729
     /* 107729 */ GIM_Reject,
     /* 107730 */ // Label 2016: @107730
     /* 107730 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107843),
     /* 107735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107741 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107781), // Rule ID 765 //
     /* 107746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107761 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107779 */     GIR_RootConstrainSelectedInstOperands,
     /* 107780 */     // GIR_Coverage, 765,
     /* 107780 */     GIR_EraseRootFromParent_Done,
     /* 107781 */   // Label 2034: @107781
     /* 107781 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(107842), // Rule ID 4016 //
     /* 107786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107801 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 107801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 107804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 107816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 107818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 107820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 107822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107840 */     GIR_RootConstrainSelectedInstOperands,
     /* 107841 */     // GIR_Coverage, 4016,
     /* 107841 */     GIR_EraseRootFromParent_Done,
     /* 107842 */   // Label 2035: @107842
     /* 107842 */   GIM_Reject,
     /* 107843 */ // Label 2033: @107843
     /* 107843 */ GIM_Reject,
     /* 107844 */ // Label 2017: @107844
     /* 107844 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108097),
     /* 107849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107855 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(107925), // Rule ID 5585 //
     /* 107860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107899 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 107902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107904 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107923 */     GIR_RootConstrainSelectedInstOperands,
     /* 107924 */     // GIR_Coverage, 5585,
     /* 107924 */     GIR_EraseRootFromParent_Done,
     /* 107925 */   // Label 2037: @107925
     /* 107925 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(107995), // Rule ID 946 //
     /* 107930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107969 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 107972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107993 */     GIR_RootConstrainSelectedInstOperands,
     /* 107994 */     // GIR_Coverage, 946,
     /* 107994 */     GIR_EraseRootFromParent_Done,
     /* 107995 */   // Label 2038: @107995
     /* 107995 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108035), // Rule ID 767 //
     /* 108000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108015 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108033 */     GIR_RootConstrainSelectedInstOperands,
     /* 108034 */     // GIR_Coverage, 767,
     /* 108034 */     GIR_EraseRootFromParent_Done,
     /* 108035 */   // Label 2039: @108035
     /* 108035 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108096), // Rule ID 4020 //
     /* 108040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108055 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108094 */     GIR_RootConstrainSelectedInstOperands,
     /* 108095 */     // GIR_Coverage, 4020,
     /* 108095 */     GIR_EraseRootFromParent_Done,
     /* 108096 */   // Label 2040: @108096
     /* 108096 */   GIM_Reject,
     /* 108097 */ // Label 2036: @108097
     /* 108097 */ GIM_Reject,
     /* 108098 */ // Label 2018: @108098
     /* 108098 */ GIM_Reject,
     /* 108099 */ // Label 35: @108099
     /* 108099 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2048*/ GIMT_Encode4(109775),
     /* 108110 */ /*GILLT_s16*//*Label 2041*/ GIMT_Encode4(108162),
     /* 108114 */ /*GILLT_s32*//*Label 2042*/ GIMT_Encode4(108209),
     /* 108118 */ /*GILLT_s64*//*Label 2043*/ GIMT_Encode4(109136), GIMT_Encode4(0),
     /* 108126 */ /*GILLT_v2s32*//*Label 2044*/ GIMT_Encode4(109183), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108138 */ /*GILLT_v4s16*//*Label 2045*/ GIMT_Encode4(109230),
     /* 108142 */ /*GILLT_v4s32*//*Label 2046*/ GIMT_Encode4(109407), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108158 */ /*GILLT_v8s16*//*Label 2047*/ GIMT_Encode4(109521),
     /* 108162 */ // Label 2041: @108162
     /* 108162 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108208), // Rule ID 617 //
     /* 108167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108188 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108193 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108195 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108206 */   GIR_RootConstrainSelectedInstOperands,
     /* 108207 */   // GIR_Coverage, 617,
     /* 108207 */   GIR_EraseRootFromParent_Done,
     /* 108208 */ // Label 2049: @108208
     /* 108208 */ GIM_Reject,
     /* 108209 */ // Label 2042: @108209
     /* 108209 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109135),
     /* 108214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108228 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108552), // Rule ID 2701 //
     /* 108233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108264 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108264 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108267 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108271 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108278 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108281 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108285 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108290 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108293 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108298 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108301 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108305 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108310 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108313 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108317 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108320 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108325 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108330 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108335 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108338 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108342 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108349 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108352 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108356 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108361 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108364 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108369 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108372 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108376 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108381 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108384 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108388 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108391 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108396 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108401 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108406 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108409 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108413 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108420 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108423 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108427 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108432 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108435 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108440 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108443 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108447 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108452 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108455 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108459 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108462 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108467 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108472 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108489 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108492 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108495 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108498 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108501 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108534 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108551 */     // GIR_Coverage, 2701,
     /* 108551 */     GIR_EraseRootFromParent_Done,
     /* 108552 */   // Label 2051: @108552
     /* 108552 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(108876), // Rule ID 2703 //
     /* 108557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108588 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108588 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108591 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108595 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108602 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108605 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108609 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108614 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108617 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108622 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108625 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108629 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108634 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108637 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108641 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108644 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108649 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108654 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108659 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108662 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108666 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108673 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108676 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108680 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108685 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108688 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108693 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108696 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108700 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108705 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108708 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108712 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108715 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108720 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108725 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108730 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108733 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108737 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108744 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108747 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108751 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108756 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108759 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108764 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108767 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108771 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108776 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108779 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108783 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108786 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108791 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108796 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 108808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108813 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108816 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108819 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108822 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108825 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108845 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108858 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108875 */     // GIR_Coverage, 2703,
     /* 108875 */     GIR_EraseRootFromParent_Done,
     /* 108876 */   // Label 2052: @108876
     /* 108876 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(108908), // Rule ID 616 //
     /* 108881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 108884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108888 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 108888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 108891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108906 */     GIR_RootConstrainSelectedInstOperands,
     /* 108907 */     // GIR_Coverage, 616,
     /* 108907 */     GIR_EraseRootFromParent_Done,
     /* 108908 */   // Label 2053: @108908
     /* 108908 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109134), // Rule ID 2698 //
     /* 108913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 108916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108920 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108920 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108923 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108927 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108934 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108937 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108941 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108946 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108949 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108954 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108957 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108961 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108966 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108969 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 108973 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108976 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108981 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108986 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108991 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108994 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108998 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109005 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109008 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109012 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109017 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109020 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109037 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109040 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109044 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109047 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109052 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109057 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109074 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109077 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109080 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109083 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109133 */     // GIR_Coverage, 2698,
     /* 109133 */     GIR_EraseRootFromParent_Done,
     /* 109134 */   // Label 2054: @109134
     /* 109134 */   GIM_Reject,
     /* 109135 */ // Label 2050: @109135
     /* 109135 */ GIM_Reject,
     /* 109136 */ // Label 2043: @109136
     /* 109136 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109182), // Rule ID 615 //
     /* 109141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109162 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109167 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109169 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109174 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109180 */   GIR_RootConstrainSelectedInstOperands,
     /* 109181 */   // GIR_Coverage, 615,
     /* 109181 */   GIR_EraseRootFromParent_Done,
     /* 109182 */ // Label 2055: @109182
     /* 109182 */ GIM_Reject,
     /* 109183 */ // Label 2044: @109183
     /* 109183 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109229), // Rule ID 968 //
     /* 109188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109209 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109214 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109216 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109227 */   GIR_RootConstrainSelectedInstOperands,
     /* 109228 */   // GIR_Coverage, 968,
     /* 109228 */   GIR_EraseRootFromParent_Done,
     /* 109229 */ // Label 2056: @109229
     /* 109229 */ GIM_Reject,
     /* 109230 */ // Label 2045: @109230
     /* 109230 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109406),
     /* 109235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109249 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109311), // Rule ID 923 //
     /* 109254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109285 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109309 */     GIR_RootConstrainSelectedInstOperands,
     /* 109310 */     // GIR_Coverage, 923,
     /* 109310 */     GIR_EraseRootFromParent_Done,
     /* 109311 */   // Label 2058: @109311
     /* 109311 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109373), // Rule ID 949 //
     /* 109316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109347 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109371 */     GIR_RootConstrainSelectedInstOperands,
     /* 109372 */     // GIR_Coverage, 949,
     /* 109372 */     GIR_EraseRootFromParent_Done,
     /* 109373 */   // Label 2059: @109373
     /* 109373 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109405), // Rule ID 970 //
     /* 109378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109385 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109403 */     GIR_RootConstrainSelectedInstOperands,
     /* 109404 */     // GIR_Coverage, 970,
     /* 109404 */     GIR_EraseRootFromParent_Done,
     /* 109405 */   // Label 2060: @109405
     /* 109405 */   GIM_Reject,
     /* 109406 */ // Label 2057: @109406
     /* 109406 */ GIM_Reject,
     /* 109407 */ // Label 2046: @109407
     /* 109407 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109520),
     /* 109412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109418 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109458), // Rule ID 969 //
     /* 109423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109438 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109456 */     GIR_RootConstrainSelectedInstOperands,
     /* 109457 */     // GIR_Coverage, 969,
     /* 109457 */     GIR_EraseRootFromParent_Done,
     /* 109458 */   // Label 2062: @109458
     /* 109458 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109519), // Rule ID 4024 //
     /* 109463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109478 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109517 */     GIR_RootConstrainSelectedInstOperands,
     /* 109518 */     // GIR_Coverage, 4024,
     /* 109518 */     GIR_EraseRootFromParent_Done,
     /* 109519 */   // Label 2063: @109519
     /* 109519 */   GIM_Reject,
     /* 109520 */ // Label 2061: @109520
     /* 109520 */ GIM_Reject,
     /* 109521 */ // Label 2047: @109521
     /* 109521 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109774),
     /* 109526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109532 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109602), // Rule ID 924 //
     /* 109537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109576 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109600 */     GIR_RootConstrainSelectedInstOperands,
     /* 109601 */     // GIR_Coverage, 924,
     /* 109601 */     GIR_EraseRootFromParent_Done,
     /* 109602 */   // Label 2065: @109602
     /* 109602 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109672), // Rule ID 950 //
     /* 109607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109646 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109670 */     GIR_RootConstrainSelectedInstOperands,
     /* 109671 */     // GIR_Coverage, 950,
     /* 109671 */     GIR_EraseRootFromParent_Done,
     /* 109672 */   // Label 2066: @109672
     /* 109672 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(109712), // Rule ID 971 //
     /* 109677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109692 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109710 */     GIR_RootConstrainSelectedInstOperands,
     /* 109711 */     // GIR_Coverage, 971,
     /* 109711 */     GIR_EraseRootFromParent_Done,
     /* 109712 */   // Label 2067: @109712
     /* 109712 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(109773), // Rule ID 4028 //
     /* 109717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109732 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109771 */     GIR_RootConstrainSelectedInstOperands,
     /* 109772 */     // GIR_Coverage, 4028,
     /* 109772 */     GIR_EraseRootFromParent_Done,
     /* 109773 */   // Label 2068: @109773
     /* 109773 */   GIM_Reject,
     /* 109774 */ // Label 2064: @109774
     /* 109774 */ GIM_Reject,
     /* 109775 */ // Label 2048: @109775
     /* 109775 */ GIM_Reject,
     /* 109776 */ // Label 36: @109776
     /* 109776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2076*/ GIMT_Encode4(110756),
     /* 109787 */ /*GILLT_s16*//*Label 2069*/ GIMT_Encode4(109839),
     /* 109791 */ /*GILLT_s32*//*Label 2070*/ GIMT_Encode4(109886),
     /* 109795 */ /*GILLT_s64*//*Label 2071*/ GIMT_Encode4(110275), GIMT_Encode4(0),
     /* 109803 */ /*GILLT_v2s32*//*Label 2072*/ GIMT_Encode4(110434), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109815 */ /*GILLT_v4s16*//*Label 2073*/ GIMT_Encode4(110481),
     /* 109819 */ /*GILLT_v4s32*//*Label 2074*/ GIMT_Encode4(110528), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109835 */ /*GILLT_v8s16*//*Label 2075*/ GIMT_Encode4(110642),
     /* 109839 */ // Label 2069: @109839
     /* 109839 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(109885), // Rule ID 623 //
     /* 109844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 109847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 109853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109865 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 109865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 109868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109870 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109872 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109877 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109883 */   GIR_RootConstrainSelectedInstOperands,
     /* 109884 */   // GIR_Coverage, 623,
     /* 109884 */   GIR_EraseRootFromParent_Done,
     /* 109885 */ // Label 2077: @109885
     /* 109885 */ GIM_Reject,
     /* 109886 */ // Label 2070: @109886
     /* 109886 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110274),
     /* 109891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109901 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(109954), // Rule ID 2302 //
     /* 109906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 109917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 109921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109932 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 109932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 109935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109941 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 109943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109952 */     GIR_RootConstrainSelectedInstOperands,
     /* 109953 */     // GIR_Coverage, 2302,
     /* 109953 */     GIR_EraseRootFromParent_Done,
     /* 109954 */   // Label 2079: @109954
     /* 109954 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110007), // Rule ID 5711 //
     /* 109959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 109974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 109978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109985 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 109985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 109988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109994 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 109996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110005 */     GIR_RootConstrainSelectedInstOperands,
     /* 110006 */     // GIR_Coverage, 5711,
     /* 110006 */     GIR_EraseRootFromParent_Done,
     /* 110007 */   // Label 2080: @110007
     /* 110007 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110043), // Rule ID 622 //
     /* 110012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110023 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110041 */     GIR_RootConstrainSelectedInstOperands,
     /* 110042 */     // GIR_Coverage, 622,
     /* 110042 */     GIR_EraseRootFromParent_Done,
     /* 110043 */   // Label 2081: @110043
     /* 110043 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110273), // Rule ID 2699 //
     /* 110048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110059 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110059 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110062 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110066 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110073 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110076 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110080 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110085 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110088 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110093 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110096 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110100 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110105 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110108 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110112 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110115 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110120 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110125 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110130 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110133 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110137 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110144 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110147 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110151 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110156 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110159 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110164 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110167 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110171 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110176 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110179 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110183 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110186 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110191 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110196 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110213 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110216 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110219 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110222 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110272 */     // GIR_Coverage, 2699,
     /* 110272 */     GIR_EraseRootFromParent_Done,
     /* 110273 */   // Label 2082: @110273
     /* 110273 */   GIM_Reject,
     /* 110274 */ // Label 2078: @110274
     /* 110274 */ GIM_Reject,
     /* 110275 */ // Label 2071: @110275
     /* 110275 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110433),
     /* 110280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110290 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110343), // Rule ID 2301 //
     /* 110295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110321 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110330 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110341 */     GIR_RootConstrainSelectedInstOperands,
     /* 110342 */     // GIR_Coverage, 2301,
     /* 110342 */     GIR_EraseRootFromParent_Done,
     /* 110343 */   // Label 2084: @110343
     /* 110343 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110396), // Rule ID 5710 //
     /* 110348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110374 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110383 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110394 */     GIR_RootConstrainSelectedInstOperands,
     /* 110395 */     // GIR_Coverage, 5710,
     /* 110395 */     GIR_EraseRootFromParent_Done,
     /* 110396 */   // Label 2085: @110396
     /* 110396 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110432), // Rule ID 621 //
     /* 110401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110412 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110430 */     GIR_RootConstrainSelectedInstOperands,
     /* 110431 */     // GIR_Coverage, 621,
     /* 110431 */     GIR_EraseRootFromParent_Done,
     /* 110432 */   // Label 2086: @110432
     /* 110432 */   GIM_Reject,
     /* 110433 */ // Label 2083: @110433
     /* 110433 */ GIM_Reject,
     /* 110434 */ // Label 2072: @110434
     /* 110434 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110480), // Rule ID 843 //
     /* 110439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110460 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110465 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110467 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110478 */   GIR_RootConstrainSelectedInstOperands,
     /* 110479 */   // GIR_Coverage, 843,
     /* 110479 */   GIR_EraseRootFromParent_Done,
     /* 110480 */ // Label 2087: @110480
     /* 110480 */ GIM_Reject,
     /* 110481 */ // Label 2073: @110481
     /* 110481 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110527), // Rule ID 845 //
     /* 110486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110507 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110512 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110514 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110519 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110525 */   GIR_RootConstrainSelectedInstOperands,
     /* 110526 */   // GIR_Coverage, 845,
     /* 110526 */   GIR_EraseRootFromParent_Done,
     /* 110527 */ // Label 2088: @110527
     /* 110527 */ GIM_Reject,
     /* 110528 */ // Label 2074: @110528
     /* 110528 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110641),
     /* 110533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110539 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110579), // Rule ID 844 //
     /* 110544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110559 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110577 */     GIR_RootConstrainSelectedInstOperands,
     /* 110578 */     // GIR_Coverage, 844,
     /* 110578 */     GIR_EraseRootFromParent_Done,
     /* 110579 */   // Label 2090: @110579
     /* 110579 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110640), // Rule ID 3988 //
     /* 110584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110599 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110638 */     GIR_RootConstrainSelectedInstOperands,
     /* 110639 */     // GIR_Coverage, 3988,
     /* 110639 */     GIR_EraseRootFromParent_Done,
     /* 110640 */   // Label 2091: @110640
     /* 110640 */   GIM_Reject,
     /* 110641 */ // Label 2089: @110641
     /* 110641 */ GIM_Reject,
     /* 110642 */ // Label 2075: @110642
     /* 110642 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(110755),
     /* 110647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110653 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(110693), // Rule ID 846 //
     /* 110658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110673 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110691 */     GIR_RootConstrainSelectedInstOperands,
     /* 110692 */     // GIR_Coverage, 846,
     /* 110692 */     GIR_EraseRootFromParent_Done,
     /* 110693 */   // Label 2093: @110693
     /* 110693 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(110754), // Rule ID 3992 //
     /* 110698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110713 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110752 */     GIR_RootConstrainSelectedInstOperands,
     /* 110753 */     // GIR_Coverage, 3992,
     /* 110753 */     GIR_EraseRootFromParent_Done,
     /* 110754 */   // Label 2094: @110754
     /* 110754 */   GIM_Reject,
     /* 110755 */ // Label 2092: @110755
     /* 110755 */ GIM_Reject,
     /* 110756 */ // Label 2076: @110756
     /* 110756 */ GIM_Reject,
     /* 110757 */ // Label 37: @110757
     /* 110757 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2102*/ GIMT_Encode4(112847),
     /* 110768 */ /*GILLT_s16*//*Label 2095*/ GIMT_Encode4(110820),
     /* 110772 */ /*GILLT_s32*//*Label 2096*/ GIMT_Encode4(111207),
     /* 110776 */ /*GILLT_s64*//*Label 2097*/ GIMT_Encode4(111594), GIMT_Encode4(0),
     /* 110784 */ /*GILLT_v2s32*//*Label 2098*/ GIMT_Encode4(111981), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110796 */ /*GILLT_v4s16*//*Label 2099*/ GIMT_Encode4(112161),
     /* 110800 */ /*GILLT_v4s32*//*Label 2100*/ GIMT_Encode4(112217), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110816 */ /*GILLT_v8s16*//*Label 2101*/ GIMT_Encode4(112595),
     /* 110820 */ // Label 2095: @110820
     /* 110820 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111206),
     /* 110825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 110834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110838 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(110912), // Rule ID 2406 //
     /* 110843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110886 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110910 */     GIR_RootConstrainSelectedInstOperands,
     /* 110911 */     // GIR_Coverage, 2406,
     /* 110911 */     GIR_EraseRootFromParent_Done,
     /* 110912 */   // Label 2104: @110912
     /* 110912 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(110986), // Rule ID 5719 //
     /* 110917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110960 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 110975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110984 */     GIR_RootConstrainSelectedInstOperands,
     /* 110985 */     // GIR_Coverage, 5719,
     /* 110985 */     GIR_EraseRootFromParent_Done,
     /* 110986 */   // Label 2105: @110986
     /* 110986 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111045), // Rule ID 2398 //
     /* 110991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111021 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111043 */     GIR_RootConstrainSelectedInstOperands,
     /* 111044 */     // GIR_Coverage, 2398,
     /* 111044 */     GIR_EraseRootFromParent_Done,
     /* 111045 */   // Label 2106: @111045
     /* 111045 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111104), // Rule ID 5716 //
     /* 111050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111080 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111102 */     GIR_RootConstrainSelectedInstOperands,
     /* 111103 */     // GIR_Coverage, 5716,
     /* 111103 */     GIR_EraseRootFromParent_Done,
     /* 111104 */   // Label 2107: @111104
     /* 111104 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111163), // Rule ID 2411 //
     /* 111109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111139 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111161 */     GIR_RootConstrainSelectedInstOperands,
     /* 111162 */     // GIR_Coverage, 2411,
     /* 111162 */     GIR_EraseRootFromParent_Done,
     /* 111163 */   // Label 2108: @111163
     /* 111163 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111205), // Rule ID 2392 //
     /* 111168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111183 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111203 */     GIR_RootConstrainSelectedInstOperands,
     /* 111204 */     // GIR_Coverage, 2392,
     /* 111204 */     GIR_EraseRootFromParent_Done,
     /* 111205 */   // Label 2109: @111205
     /* 111205 */   GIM_Reject,
     /* 111206 */ // Label 2103: @111206
     /* 111206 */ GIM_Reject,
     /* 111207 */ // Label 2096: @111207
     /* 111207 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111593),
     /* 111212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111218 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111225 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111299), // Rule ID 2405 //
     /* 111230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111273 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111297 */     GIR_RootConstrainSelectedInstOperands,
     /* 111298 */     // GIR_Coverage, 2405,
     /* 111298 */     GIR_EraseRootFromParent_Done,
     /* 111299 */   // Label 2111: @111299
     /* 111299 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111373), // Rule ID 5718 //
     /* 111304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111347 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111371 */     GIR_RootConstrainSelectedInstOperands,
     /* 111372 */     // GIR_Coverage, 5718,
     /* 111372 */     GIR_EraseRootFromParent_Done,
     /* 111373 */   // Label 2112: @111373
     /* 111373 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(111432), // Rule ID 2397 //
     /* 111378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111408 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111430 */     GIR_RootConstrainSelectedInstOperands,
     /* 111431 */     // GIR_Coverage, 2397,
     /* 111431 */     GIR_EraseRootFromParent_Done,
     /* 111432 */   // Label 2113: @111432
     /* 111432 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111491), // Rule ID 5715 //
     /* 111437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111467 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111489 */     GIR_RootConstrainSelectedInstOperands,
     /* 111490 */     // GIR_Coverage, 5715,
     /* 111490 */     GIR_EraseRootFromParent_Done,
     /* 111491 */   // Label 2114: @111491
     /* 111491 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(111550), // Rule ID 2410 //
     /* 111496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111526 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111548 */     GIR_RootConstrainSelectedInstOperands,
     /* 111549 */     // GIR_Coverage, 2410,
     /* 111549 */     GIR_EraseRootFromParent_Done,
     /* 111550 */   // Label 2115: @111550
     /* 111550 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(111592), // Rule ID 2391 //
     /* 111555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111570 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111590 */     GIR_RootConstrainSelectedInstOperands,
     /* 111591 */     // GIR_Coverage, 2391,
     /* 111591 */     GIR_EraseRootFromParent_Done,
     /* 111592 */   // Label 2116: @111592
     /* 111592 */   GIM_Reject,
     /* 111593 */ // Label 2110: @111593
     /* 111593 */ GIM_Reject,
     /* 111594 */ // Label 2097: @111594
     /* 111594 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(111980),
     /* 111599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111612 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111686), // Rule ID 2404 //
     /* 111617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111660 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111684 */     GIR_RootConstrainSelectedInstOperands,
     /* 111685 */     // GIR_Coverage, 2404,
     /* 111685 */     GIR_EraseRootFromParent_Done,
     /* 111686 */   // Label 2118: @111686
     /* 111686 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111760), // Rule ID 5717 //
     /* 111691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111734 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111758 */     GIR_RootConstrainSelectedInstOperands,
     /* 111759 */     // GIR_Coverage, 5717,
     /* 111759 */     GIR_EraseRootFromParent_Done,
     /* 111760 */   // Label 2119: @111760
     /* 111760 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111819), // Rule ID 2396 //
     /* 111765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111795 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111817 */     GIR_RootConstrainSelectedInstOperands,
     /* 111818 */     // GIR_Coverage, 2396,
     /* 111818 */     GIR_EraseRootFromParent_Done,
     /* 111819 */   // Label 2120: @111819
     /* 111819 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111878), // Rule ID 5714 //
     /* 111824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111854 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111876 */     GIR_RootConstrainSelectedInstOperands,
     /* 111877 */     // GIR_Coverage, 5714,
     /* 111877 */     GIR_EraseRootFromParent_Done,
     /* 111878 */   // Label 2121: @111878
     /* 111878 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111937), // Rule ID 2409 //
     /* 111883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111913 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 111916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 111922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111935 */     GIR_RootConstrainSelectedInstOperands,
     /* 111936 */     // GIR_Coverage, 2409,
     /* 111936 */     GIR_EraseRootFromParent_Done,
     /* 111937 */   // Label 2122: @111937
     /* 111937 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111979), // Rule ID 2390 //
     /* 111942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111957 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 111960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111977 */     GIR_RootConstrainSelectedInstOperands,
     /* 111978 */     // GIR_Coverage, 2390,
     /* 111978 */     GIR_EraseRootFromParent_Done,
     /* 111979 */   // Label 2123: @111979
     /* 111979 */   GIM_Reject,
     /* 111980 */ // Label 2117: @111980
     /* 111980 */ GIM_Reject,
     /* 111981 */ // Label 2098: @111981
     /* 111981 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112160),
     /* 111986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 111992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 111995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111999 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112058), // Rule ID 2503 //
     /* 112004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112034 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112039 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112056 */     GIR_RootConstrainSelectedInstOperands,
     /* 112057 */     // GIR_Coverage, 2503,
     /* 112057 */     GIR_EraseRootFromParent_Done,
     /* 112058 */   // Label 2125: @112058
     /* 112058 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112117), // Rule ID 5757 //
     /* 112063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112093 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112098 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112115 */     GIR_RootConstrainSelectedInstOperands,
     /* 112116 */     // GIR_Coverage, 5757,
     /* 112116 */     GIR_EraseRootFromParent_Done,
     /* 112117 */   // Label 2126: @112117
     /* 112117 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112159), // Rule ID 2501 //
     /* 112122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112137 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112142 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112157 */     GIR_RootConstrainSelectedInstOperands,
     /* 112158 */     // GIR_Coverage, 2501,
     /* 112158 */     GIR_EraseRootFromParent_Done,
     /* 112159 */   // Label 2127: @112159
     /* 112159 */   GIM_Reject,
     /* 112160 */ // Label 2124: @112160
     /* 112160 */ GIM_Reject,
     /* 112161 */ // Label 2099: @112161
     /* 112161 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112216), // Rule ID 2499 //
     /* 112166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112190 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112194 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112199 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112201 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112203 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112208 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112214 */   GIR_RootConstrainSelectedInstOperands,
     /* 112215 */   // GIR_Coverage, 2499,
     /* 112215 */   GIR_EraseRootFromParent_Done,
     /* 112216 */ // Label 2128: @112216
     /* 112216 */ GIM_Reject,
     /* 112217 */ // Label 2100: @112217
     /* 112217 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112594),
     /* 112222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112231 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112294), // Rule ID 2504 //
     /* 112236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112270 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112275 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112292 */     GIR_RootConstrainSelectedInstOperands,
     /* 112293 */     // GIR_Coverage, 2504,
     /* 112293 */     GIR_EraseRootFromParent_Done,
     /* 112294 */   // Label 2130: @112294
     /* 112294 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112363), // Rule ID 4002 //
     /* 112299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112333 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112338 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112344 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112361 */     GIR_RootConstrainSelectedInstOperands,
     /* 112362 */     // GIR_Coverage, 4002,
     /* 112362 */     GIR_EraseRootFromParent_Done,
     /* 112363 */   // Label 2131: @112363
     /* 112363 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112426), // Rule ID 5758 //
     /* 112368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112402 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112407 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112424 */     GIR_RootConstrainSelectedInstOperands,
     /* 112425 */     // GIR_Coverage, 5758,
     /* 112425 */     GIR_EraseRootFromParent_Done,
     /* 112426 */   // Label 2132: @112426
     /* 112426 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112495), // Rule ID 6038 //
     /* 112431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112465 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112470 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112476 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112493 */     GIR_RootConstrainSelectedInstOperands,
     /* 112494 */     // GIR_Coverage, 6038,
     /* 112494 */     GIR_EraseRootFromParent_Done,
     /* 112495 */   // Label 2133: @112495
     /* 112495 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112541), // Rule ID 2502 //
     /* 112500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112519 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112524 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112539 */     GIR_RootConstrainSelectedInstOperands,
     /* 112540 */     // GIR_Coverage, 2502,
     /* 112540 */     GIR_EraseRootFromParent_Done,
     /* 112541 */   // Label 2134: @112541
     /* 112541 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112593), // Rule ID 4006 //
     /* 112546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112565 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112570 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112572 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112574 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112591 */     GIR_RootConstrainSelectedInstOperands,
     /* 112592 */     // GIR_Coverage, 4006,
     /* 112592 */     GIR_EraseRootFromParent_Done,
     /* 112593 */   // Label 2135: @112593
     /* 112593 */   GIM_Reject,
     /* 112594 */ // Label 2129: @112594
     /* 112594 */ GIM_Reject,
     /* 112595 */ // Label 2101: @112595
     /* 112595 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112846),
     /* 112600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112609 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112678), // Rule ID 4012 //
     /* 112614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112648 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112653 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112659 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112676 */     GIR_RootConstrainSelectedInstOperands,
     /* 112677 */     // GIR_Coverage, 4012,
     /* 112677 */     GIR_EraseRootFromParent_Done,
     /* 112678 */   // Label 2137: @112678
     /* 112678 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112747), // Rule ID 6040 //
     /* 112683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112717 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112722 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112728 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112745 */     GIR_RootConstrainSelectedInstOperands,
     /* 112746 */     // GIR_Coverage, 6040,
     /* 112746 */     GIR_EraseRootFromParent_Done,
     /* 112747 */   // Label 2138: @112747
     /* 112747 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112793), // Rule ID 2500 //
     /* 112752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112771 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112776 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112791 */     GIR_RootConstrainSelectedInstOperands,
     /* 112792 */     // GIR_Coverage, 2500,
     /* 112792 */     GIR_EraseRootFromParent_Done,
     /* 112793 */   // Label 2139: @112793
     /* 112793 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112845), // Rule ID 4009 //
     /* 112798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112817 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 112820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112822 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112824 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112826 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112843 */     GIR_RootConstrainSelectedInstOperands,
     /* 112844 */     // GIR_Coverage, 4009,
     /* 112844 */     GIR_EraseRootFromParent_Done,
     /* 112845 */   // Label 2140: @112845
     /* 112845 */   GIM_Reject,
     /* 112846 */ // Label 2136: @112846
     /* 112846 */ GIM_Reject,
     /* 112847 */ // Label 2102: @112847
     /* 112847 */ GIM_Reject,
     /* 112848 */ // Label 38: @112848
     /* 112848 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2144*/ GIMT_Encode4(113012),
     /* 112859 */ /*GILLT_s16*//*Label 2141*/ GIMT_Encode4(112871),
     /* 112863 */ /*GILLT_s32*//*Label 2142*/ GIMT_Encode4(112918),
     /* 112867 */ /*GILLT_s64*//*Label 2143*/ GIMT_Encode4(112965),
     /* 112871 */ // Label 2141: @112871
     /* 112871 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(112917), // Rule ID 620 //
     /* 112876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 112885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112897 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 112900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112902 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112904 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112909 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112915 */   GIR_RootConstrainSelectedInstOperands,
     /* 112916 */   // GIR_Coverage, 620,
     /* 112916 */   GIR_EraseRootFromParent_Done,
     /* 112917 */ // Label 2145: @112917
     /* 112917 */ GIM_Reject,
     /* 112918 */ // Label 2142: @112918
     /* 112918 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(112964), // Rule ID 619 //
     /* 112923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 112926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 112932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112944 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 112944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 112947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112949 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112951 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112962 */   GIR_RootConstrainSelectedInstOperands,
     /* 112963 */   // GIR_Coverage, 619,
     /* 112963 */   GIR_EraseRootFromParent_Done,
     /* 112964 */ // Label 2146: @112964
     /* 112964 */ GIM_Reject,
     /* 112965 */ // Label 2143: @112965
     /* 112965 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113011), // Rule ID 618 //
     /* 112970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 112973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 112979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112991 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 112994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112996 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112998 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113003 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113009 */   GIR_RootConstrainSelectedInstOperands,
     /* 113010 */   // GIR_Coverage, 618,
     /* 113010 */   GIR_EraseRootFromParent_Done,
     /* 113011 */ // Label 2147: @113011
     /* 113011 */ GIM_Reject,
     /* 113012 */ // Label 2144: @113012
     /* 113012 */ GIM_Reject,
     /* 113013 */ // Label 39: @113013
     /* 113013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2155*/ GIMT_Encode4(114543),
     /* 113024 */ /*GILLT_s16*//*Label 2148*/ GIMT_Encode4(113076),
     /* 113028 */ /*GILLT_s32*//*Label 2149*/ GIMT_Encode4(113423),
     /* 113032 */ /*GILLT_s64*//*Label 2150*/ GIMT_Encode4(113922), GIMT_Encode4(0),
     /* 113040 */ /*GILLT_v2s32*//*Label 2151*/ GIMT_Encode4(114269), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113052 */ /*GILLT_v4s16*//*Label 2152*/ GIMT_Encode4(114307),
     /* 113056 */ /*GILLT_v4s32*//*Label 2153*/ GIMT_Encode4(114345), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113072 */ /*GILLT_v8s16*//*Label 2154*/ GIMT_Encode4(114444),
     /* 113076 */ // Label 2148: @113076
     /* 113076 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113422),
     /* 113081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113088 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113173), // Rule ID 2414 //
     /* 113093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113112 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113145 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113171 */     GIR_RootConstrainSelectedInstOperands,
     /* 113172 */     // GIR_Coverage, 2414,
     /* 113172 */     GIR_EraseRootFromParent_Done,
     /* 113173 */   // Label 2157: @113173
     /* 113173 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113258), // Rule ID 5722 //
     /* 113178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113197 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113230 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113256 */     GIR_RootConstrainSelectedInstOperands,
     /* 113257 */     // GIR_Coverage, 5722,
     /* 113257 */     GIR_EraseRootFromParent_Done,
     /* 113258 */   // Label 2158: @113258
     /* 113258 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113331), // Rule ID 2403 //
     /* 113263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113282 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113303 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113329 */     GIR_RootConstrainSelectedInstOperands,
     /* 113330 */     // GIR_Coverage, 2403,
     /* 113330 */     GIR_EraseRootFromParent_Done,
     /* 113331 */   // Label 2159: @113331
     /* 113331 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113391), // Rule ID 626 //
     /* 113336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113367 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113389 */     GIR_RootConstrainSelectedInstOperands,
     /* 113390 */     // GIR_Coverage, 626,
     /* 113390 */     GIR_EraseRootFromParent_Done,
     /* 113391 */   // Label 2160: @113391
     /* 113391 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113421), // Rule ID 664 //
     /* 113396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113403 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113419 */     GIR_RootConstrainSelectedInstOperands,
     /* 113420 */     // GIR_Coverage, 664,
     /* 113420 */     GIR_EraseRootFromParent_Done,
     /* 113421 */   // Label 2161: @113421
     /* 113421 */   GIM_Reject,
     /* 113422 */ // Label 2156: @113422
     /* 113422 */ GIM_Reject,
     /* 113423 */ // Label 2149: @113423
     /* 113423 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113921),
     /* 113428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113435 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113520), // Rule ID 2413 //
     /* 113440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113492 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113518 */     GIR_RootConstrainSelectedInstOperands,
     /* 113519 */     // GIR_Coverage, 2413,
     /* 113519 */     GIR_EraseRootFromParent_Done,
     /* 113520 */   // Label 2163: @113520
     /* 113520 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113605), // Rule ID 5721 //
     /* 113525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113544 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113577 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113603 */     GIR_RootConstrainSelectedInstOperands,
     /* 113604 */     // GIR_Coverage, 5721,
     /* 113604 */     GIR_EraseRootFromParent_Done,
     /* 113605 */   // Label 2164: @113605
     /* 113605 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113678), // Rule ID 2402 //
     /* 113610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113629 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113650 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113676 */     GIR_RootConstrainSelectedInstOperands,
     /* 113677 */     // GIR_Coverage, 2402,
     /* 113677 */     GIR_EraseRootFromParent_Done,
     /* 113678 */   // Label 2165: @113678
     /* 113678 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(113738), // Rule ID 625 //
     /* 113683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113714 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113736 */     GIR_RootConstrainSelectedInstOperands,
     /* 113737 */     // GIR_Coverage, 625,
     /* 113737 */     GIR_EraseRootFromParent_Done,
     /* 113738 */   // Label 2166: @113738
     /* 113738 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(113768), // Rule ID 663 //
     /* 113743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113750 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113766 */     GIR_RootConstrainSelectedInstOperands,
     /* 113767 */     // GIR_Coverage, 663,
     /* 113767 */     GIR_EraseRootFromParent_Done,
     /* 113768 */   // Label 2167: @113768
     /* 113768 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(113920), // Rule ID 2705 //
     /* 113773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113780 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113780 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113783 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 113787 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 113794 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 113797 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113801 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113806 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 113809 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113814 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 113817 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 113821 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113826 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 113829 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 113833 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 113836 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113841 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113846 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 113854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 113858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113863 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 113866 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 113869 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 113880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113902 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 113909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113919 */     // GIR_Coverage, 2705,
     /* 113919 */     GIR_EraseRootFromParent_Done,
     /* 113920 */   // Label 2168: @113920
     /* 113920 */   GIM_Reject,
     /* 113921 */ // Label 2162: @113921
     /* 113921 */ GIM_Reject,
     /* 113922 */ // Label 2150: @113922
     /* 113922 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114268),
     /* 113927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113934 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114019), // Rule ID 2412 //
     /* 113939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113958 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 113974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113991 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 113994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114017 */     GIR_RootConstrainSelectedInstOperands,
     /* 114018 */     // GIR_Coverage, 2412,
     /* 114018 */     GIR_EraseRootFromParent_Done,
     /* 114019 */   // Label 2170: @114019
     /* 114019 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114104), // Rule ID 5720 //
     /* 114024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114043 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114076 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114102 */     GIR_RootConstrainSelectedInstOperands,
     /* 114103 */     // GIR_Coverage, 5720,
     /* 114103 */     GIR_EraseRootFromParent_Done,
     /* 114104 */   // Label 2171: @114104
     /* 114104 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114177), // Rule ID 2401 //
     /* 114109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114149 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114175 */     GIR_RootConstrainSelectedInstOperands,
     /* 114176 */     // GIR_Coverage, 2401,
     /* 114176 */     GIR_EraseRootFromParent_Done,
     /* 114177 */   // Label 2172: @114177
     /* 114177 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114237), // Rule ID 624 //
     /* 114182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114213 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114235 */     GIR_RootConstrainSelectedInstOperands,
     /* 114236 */     // GIR_Coverage, 624,
     /* 114236 */     GIR_EraseRootFromParent_Done,
     /* 114237 */   // Label 2173: @114237
     /* 114237 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114267), // Rule ID 662 //
     /* 114242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114249 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114265 */     GIR_RootConstrainSelectedInstOperands,
     /* 114266 */     // GIR_Coverage, 662,
     /* 114266 */     GIR_EraseRootFromParent_Done,
     /* 114267 */   // Label 2174: @114267
     /* 114267 */   GIM_Reject,
     /* 114268 */ // Label 2169: @114268
     /* 114268 */ GIM_Reject,
     /* 114269 */ // Label 2151: @114269
     /* 114269 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114306), // Rule ID 1530 //
     /* 114274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114288 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114293 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114304 */   GIR_RootConstrainSelectedInstOperands,
     /* 114305 */   // GIR_Coverage, 1530,
     /* 114305 */   GIR_EraseRootFromParent_Done,
     /* 114306 */ // Label 2175: @114306
     /* 114306 */ GIM_Reject,
     /* 114307 */ // Label 2152: @114307
     /* 114307 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114344), // Rule ID 1532 //
     /* 114312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114326 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114331 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114336 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114342 */   GIR_RootConstrainSelectedInstOperands,
     /* 114343 */   // GIR_Coverage, 1532,
     /* 114343 */   GIR_EraseRootFromParent_Done,
     /* 114344 */ // Label 2176: @114344
     /* 114344 */ GIM_Reject,
     /* 114345 */ // Label 2153: @114345
     /* 114345 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114443),
     /* 114350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114353 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114387), // Rule ID 1531 //
     /* 114358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114369 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114385 */     GIR_RootConstrainSelectedInstOperands,
     /* 114386 */     // GIR_Coverage, 1531,
     /* 114386 */     GIR_EraseRootFromParent_Done,
     /* 114387 */   // Label 2178: @114387
     /* 114387 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114442), // Rule ID 4116 //
     /* 114392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114403 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114420 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114440 */     GIR_RootConstrainSelectedInstOperands,
     /* 114441 */     // GIR_Coverage, 4116,
     /* 114441 */     GIR_EraseRootFromParent_Done,
     /* 114442 */   // Label 2179: @114442
     /* 114442 */   GIM_Reject,
     /* 114443 */ // Label 2177: @114443
     /* 114443 */ GIM_Reject,
     /* 114444 */ // Label 2154: @114444
     /* 114444 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114542),
     /* 114449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114452 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(114486), // Rule ID 1533 //
     /* 114457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114468 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114484 */     GIR_RootConstrainSelectedInstOperands,
     /* 114485 */     // GIR_Coverage, 1533,
     /* 114485 */     GIR_EraseRootFromParent_Done,
     /* 114486 */   // Label 2181: @114486
     /* 114486 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(114541), // Rule ID 4114 //
     /* 114491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114502 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114519 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114539 */     GIR_RootConstrainSelectedInstOperands,
     /* 114540 */     // GIR_Coverage, 4114,
     /* 114540 */     GIR_EraseRootFromParent_Done,
     /* 114541 */   // Label 2182: @114541
     /* 114541 */   GIM_Reject,
     /* 114542 */ // Label 2180: @114542
     /* 114542 */ GIM_Reject,
     /* 114543 */ // Label 2155: @114543
     /* 114543 */ GIM_Reject,
     /* 114544 */ // Label 40: @114544
     /* 114544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2186*/ GIMT_Encode4(114779),
     /* 114555 */ /*GILLT_s32*//*Label 2183*/ GIMT_Encode4(114587),
     /* 114559 */ /*GILLT_s64*//*Label 2184*/ GIMT_Encode4(114647), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114583 */ /*GILLT_v4s32*//*Label 2185*/ GIMT_Encode4(114744),
     /* 114587 */ // Label 2183: @114587
     /* 114587 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(114646), // Rule ID 2303 //
     /* 114592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114606 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114618 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114638 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114644 */   GIR_RootConstrainSelectedInstOperands,
     /* 114645 */   // GIR_Coverage, 2303,
     /* 114645 */   GIR_EraseRootFromParent_Done,
     /* 114646 */ // Label 2187: @114646
     /* 114646 */ GIM_Reject,
     /* 114647 */ // Label 2184: @114647
     /* 114647 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(114684), // Rule ID 660 //
     /* 114652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114666 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114671 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114682 */   GIR_RootConstrainSelectedInstOperands,
     /* 114683 */   // GIR_Coverage, 660,
     /* 114683 */   GIR_EraseRootFromParent_Done,
     /* 114684 */ // Label 2188: @114684
     /* 114684 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(114743), // Rule ID 2313 //
     /* 114689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114703 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114719 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114735 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114741 */   GIR_RootConstrainSelectedInstOperands,
     /* 114742 */   // GIR_Coverage, 2313,
     /* 114742 */   GIR_EraseRootFromParent_Done,
     /* 114743 */ // Label 2189: @114743
     /* 114743 */ GIM_Reject,
     /* 114744 */ // Label 2185: @114744
     /* 114744 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(114778), // Rule ID 2670 //
     /* 114749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114760 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114765 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114770 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114776 */   GIR_RootConstrainSelectedInstOperands,
     /* 114777 */   // GIR_Coverage, 2670,
     /* 114777 */   GIR_EraseRootFromParent_Done,
     /* 114778 */ // Label 2190: @114778
     /* 114778 */ GIM_Reject,
     /* 114779 */ // Label 2186: @114779
     /* 114779 */ GIM_Reject,
     /* 114780 */ // Label 41: @114780
     /* 114780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2194*/ GIMT_Encode4(115051),
     /* 114791 */ /*GILLT_s16*//*Label 2191*/ GIMT_Encode4(114823),
     /* 114795 */ /*GILLT_s32*//*Label 2192*/ GIMT_Encode4(114978), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114819 */ /*GILLT_v4s16*//*Label 2193*/ GIMT_Encode4(115016),
     /* 114823 */ // Label 2191: @114823
     /* 114823 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(114900), // Rule ID 2305 //
     /* 114828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114842 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 114842 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114845 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114849 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 114863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114868 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114871 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114875 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114878 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 114899 */   // GIR_Coverage, 2305,
     /* 114899 */   GIR_EraseRootFromParent_Done,
     /* 114900 */ // Label 2195: @114900
     /* 114900 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(114977), // Rule ID 2315 //
     /* 114905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114919 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 114919 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114922 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114926 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 114940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114945 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114948 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 114952 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114955 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 114976 */   // GIR_Coverage, 2315,
     /* 114976 */   GIR_EraseRootFromParent_Done,
     /* 114977 */ // Label 2196: @114977
     /* 114977 */ GIM_Reject,
     /* 114978 */ // Label 2192: @114978
     /* 114978 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(115015), // Rule ID 661 //
     /* 114983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114997 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 114997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115002 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115007 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115013 */   GIR_RootConstrainSelectedInstOperands,
     /* 115014 */   // GIR_Coverage, 661,
     /* 115014 */   GIR_EraseRootFromParent_Done,
     /* 115015 */ // Label 2197: @115015
     /* 115015 */ GIM_Reject,
     /* 115016 */ // Label 2193: @115016
     /* 115016 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(115050), // Rule ID 2669 //
     /* 115021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115032 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115048 */   GIR_RootConstrainSelectedInstOperands,
     /* 115049 */   // GIR_Coverage, 2669,
     /* 115049 */   GIR_EraseRootFromParent_Done,
     /* 115050 */ // Label 2198: @115050
     /* 115050 */ GIM_Reject,
     /* 115051 */ // Label 2194: @115051
     /* 115051 */ GIM_Reject,
     /* 115052 */ // Label 42: @115052
     /* 115052 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2206*/ GIMT_Encode4(116385),
     /* 115063 */ /*GILLT_s32*//*Label 2199*/ GIMT_Encode4(115111), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115075 */ /*GILLT_v2s32*//*Label 2200*/ GIMT_Encode4(116005), GIMT_Encode4(0),
     /* 115083 */ /*GILLT_v4s1*//*Label 2201*/ GIMT_Encode4(116043),
     /* 115087 */ /*GILLT_v4s16*//*Label 2202*/ GIMT_Encode4(116096),
     /* 115091 */ /*GILLT_v4s32*//*Label 2203*/ GIMT_Encode4(116134), GIMT_Encode4(0),
     /* 115099 */ /*GILLT_v8s1*//*Label 2204*/ GIMT_Encode4(116233), GIMT_Encode4(0),
     /* 115107 */ /*GILLT_v8s16*//*Label 2205*/ GIMT_Encode4(116286),
     /* 115111 */ // Label 2199: @115111
     /* 115111 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115177), // Rule ID 2323 //
     /* 115116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115134 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115138 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115145 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115157 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115176 */   // GIR_Coverage, 2323,
     /* 115176 */   GIR_EraseRootFromParent_Done,
     /* 115177 */ // Label 2207: @115177
     /* 115177 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115243), // Rule ID 2325 //
     /* 115182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115192 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115200 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115204 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115211 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115242 */   // GIR_Coverage, 2325,
     /* 115242 */   GIR_EraseRootFromParent_Done,
     /* 115243 */ // Label 2208: @115243
     /* 115243 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115309), // Rule ID 2327 //
     /* 115248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115266 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115270 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115277 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115289 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115308 */   // GIR_Coverage, 2327,
     /* 115308 */   GIR_EraseRootFromParent_Done,
     /* 115309 */ // Label 2209: @115309
     /* 115309 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115375), // Rule ID 2329 //
     /* 115314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115332 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115336 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115343 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115355 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115374 */   // GIR_Coverage, 2329,
     /* 115374 */   GIR_EraseRootFromParent_Done,
     /* 115375 */ // Label 2210: @115375
     /* 115375 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115441), // Rule ID 2331 //
     /* 115380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115398 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115402 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115409 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115421 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115435 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115440 */   // GIR_Coverage, 2331,
     /* 115440 */   GIR_EraseRootFromParent_Done,
     /* 115441 */ // Label 2211: @115441
     /* 115441 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115507), // Rule ID 2333 //
     /* 115446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115464 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115468 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115475 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115475 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115478 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115482 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115487 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115506 */   // GIR_Coverage, 2333,
     /* 115506 */   GIR_EraseRootFromParent_Done,
     /* 115507 */ // Label 2212: @115507
     /* 115507 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(115573), // Rule ID 2317 //
     /* 115512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115530 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115534 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115539 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115541 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115541 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115544 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115548 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115553 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115572 */   // GIR_Coverage, 2317,
     /* 115572 */   GIR_EraseRootFromParent_Done,
     /* 115573 */ // Label 2213: @115573
     /* 115573 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(115639), // Rule ID 2319 //
     /* 115578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115596 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115600 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115607 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115619 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115638 */   // GIR_Coverage, 2319,
     /* 115638 */   GIR_EraseRootFromParent_Done,
     /* 115639 */ // Label 2214: @115639
     /* 115639 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(115705), // Rule ID 2321 //
     /* 115644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115654 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115658 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115662 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115666 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115673 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115704 */   // GIR_Coverage, 2321,
     /* 115704 */   GIR_EraseRootFromParent_Done,
     /* 115705 */ // Label 2215: @115705
     /* 115705 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(115765), // Rule ID 2352 //
     /* 115710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115724 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115736 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115740 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115743 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115764 */   // GIR_Coverage, 2352,
     /* 115764 */   GIR_EraseRootFromParent_Done,
     /* 115765 */ // Label 2216: @115765
     /* 115765 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(115825), // Rule ID 2356 //
     /* 115770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115784 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 115791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115796 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115800 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115803 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115824 */   // GIR_Coverage, 2356,
     /* 115824 */   GIR_EraseRootFromParent_Done,
     /* 115825 */ // Label 2217: @115825
     /* 115825 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(115885), // Rule ID 2360 //
     /* 115830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115844 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 115851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115856 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115860 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115863 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115884 */   // GIR_Coverage, 2360,
     /* 115884 */   GIR_EraseRootFromParent_Done,
     /* 115885 */ // Label 2218: @115885
     /* 115885 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116004), // Rule ID 2710 //
     /* 115890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 115893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115904 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 115904 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 115907 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115911 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115918 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 115921 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115925 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115930 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 115933 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115937 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 115940 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115945 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115950 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 115958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 115962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115967 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115970 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115973 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115986 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 115993 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116003 */   // GIR_Coverage, 2710,
     /* 116003 */   GIR_EraseRootFromParent_Done,
     /* 116004 */ // Label 2219: @116004
     /* 116004 */ GIM_Reject,
     /* 116005 */ // Label 2200: @116005
     /* 116005 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(116042), // Rule ID 1604 //
     /* 116010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116024 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116029 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116034 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116040 */   GIR_RootConstrainSelectedInstOperands,
     /* 116041 */   // GIR_Coverage, 1604,
     /* 116041 */   GIR_EraseRootFromParent_Done,
     /* 116042 */ // Label 2220: @116042
     /* 116042 */ GIM_Reject,
     /* 116043 */ // Label 2201: @116043
     /* 116043 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(116095), // Rule ID 5105 //
     /* 116048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116062 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116067 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116069 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116081 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116093 */   GIR_RootConstrainSelectedInstOperands,
     /* 116094 */   // GIR_Coverage, 5105,
     /* 116094 */   GIR_EraseRootFromParent_Done,
     /* 116095 */ // Label 2221: @116095
     /* 116095 */ GIM_Reject,
     /* 116096 */ // Label 2202: @116096
     /* 116096 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(116133), // Rule ID 1612 //
     /* 116101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116115 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116120 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116125 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116131 */   GIR_RootConstrainSelectedInstOperands,
     /* 116132 */   // GIR_Coverage, 1612,
     /* 116132 */   GIR_EraseRootFromParent_Done,
     /* 116133 */ // Label 2222: @116133
     /* 116133 */ GIM_Reject,
     /* 116134 */ // Label 2203: @116134
     /* 116134 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116232),
     /* 116139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116142 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116176), // Rule ID 1608 //
     /* 116147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116158 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116174 */     GIR_RootConstrainSelectedInstOperands,
     /* 116175 */     // GIR_Coverage, 1608,
     /* 116175 */     GIR_EraseRootFromParent_Done,
     /* 116176 */   // Label 2224: @116176
     /* 116176 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116231), // Rule ID 4094 //
     /* 116181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116192 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116229 */     GIR_RootConstrainSelectedInstOperands,
     /* 116230 */     // GIR_Coverage, 4094,
     /* 116230 */     GIR_EraseRootFromParent_Done,
     /* 116231 */   // Label 2225: @116231
     /* 116231 */   GIM_Reject,
     /* 116232 */ // Label 2223: @116232
     /* 116232 */ GIM_Reject,
     /* 116233 */ // Label 2204: @116233
     /* 116233 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(116285), // Rule ID 5106 //
     /* 116238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116252 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116257 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116259 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116283 */   GIR_RootConstrainSelectedInstOperands,
     /* 116284 */   // GIR_Coverage, 5106,
     /* 116284 */   GIR_EraseRootFromParent_Done,
     /* 116285 */ // Label 2226: @116285
     /* 116285 */ GIM_Reject,
     /* 116286 */ // Label 2205: @116286
     /* 116286 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(116384),
     /* 116291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116294 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(116328), // Rule ID 1616 //
     /* 116299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116310 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116326 */     GIR_RootConstrainSelectedInstOperands,
     /* 116327 */     // GIR_Coverage, 1616,
     /* 116327 */     GIR_EraseRootFromParent_Done,
     /* 116328 */   // Label 2228: @116328
     /* 116328 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(116383), // Rule ID 4090 //
     /* 116333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116344 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116381 */     GIR_RootConstrainSelectedInstOperands,
     /* 116382 */     // GIR_Coverage, 4090,
     /* 116382 */     GIR_EraseRootFromParent_Done,
     /* 116383 */   // Label 2229: @116383
     /* 116383 */   GIM_Reject,
     /* 116384 */ // Label 2227: @116384
     /* 116384 */ GIM_Reject,
     /* 116385 */ // Label 2206: @116385
     /* 116385 */ GIM_Reject,
     /* 116386 */ // Label 43: @116386
     /* 116386 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2237*/ GIMT_Encode4(117719),
     /* 116397 */ /*GILLT_s32*//*Label 2230*/ GIMT_Encode4(116445), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116409 */ /*GILLT_v2s32*//*Label 2231*/ GIMT_Encode4(117339), GIMT_Encode4(0),
     /* 116417 */ /*GILLT_v4s1*//*Label 2232*/ GIMT_Encode4(117377),
     /* 116421 */ /*GILLT_v4s16*//*Label 2233*/ GIMT_Encode4(117430),
     /* 116425 */ /*GILLT_v4s32*//*Label 2234*/ GIMT_Encode4(117468), GIMT_Encode4(0),
     /* 116433 */ /*GILLT_v8s1*//*Label 2235*/ GIMT_Encode4(117567), GIMT_Encode4(0),
     /* 116441 */ /*GILLT_v8s16*//*Label 2236*/ GIMT_Encode4(117620),
     /* 116445 */ // Label 2230: @116445
     /* 116445 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116511), // Rule ID 2324 //
     /* 116450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116468 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116472 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116479 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116510 */   // GIR_Coverage, 2324,
     /* 116510 */   GIR_EraseRootFromParent_Done,
     /* 116511 */ // Label 2238: @116511
     /* 116511 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(116577), // Rule ID 2326 //
     /* 116516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116534 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116538 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116545 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116557 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116576 */   // GIR_Coverage, 2326,
     /* 116576 */   GIR_EraseRootFromParent_Done,
     /* 116577 */ // Label 2239: @116577
     /* 116577 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(116643), // Rule ID 2328 //
     /* 116582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116604 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116611 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116611 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116614 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116618 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116623 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116642 */   // GIR_Coverage, 2328,
     /* 116642 */   GIR_EraseRootFromParent_Done,
     /* 116643 */ // Label 2240: @116643
     /* 116643 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(116709), // Rule ID 2330 //
     /* 116648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116666 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116670 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116675 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116677 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116689 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116708 */   // GIR_Coverage, 2330,
     /* 116708 */   GIR_EraseRootFromParent_Done,
     /* 116709 */ // Label 2241: @116709
     /* 116709 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(116775), // Rule ID 2332 //
     /* 116714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116724 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116728 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116732 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116736 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116741 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116743 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116755 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116769 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116774 */   // GIR_Coverage, 2332,
     /* 116774 */   GIR_EraseRootFromParent_Done,
     /* 116775 */ // Label 2242: @116775
     /* 116775 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(116841), // Rule ID 2334 //
     /* 116780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116798 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116809 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 116816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116840 */   // GIR_Coverage, 2334,
     /* 116840 */   GIR_EraseRootFromParent_Done,
     /* 116841 */ // Label 2243: @116841
     /* 116841 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(116907), // Rule ID 2318 //
     /* 116846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116864 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116868 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116875 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 116882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116887 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116906 */   // GIR_Coverage, 2318,
     /* 116906 */   GIR_EraseRootFromParent_Done,
     /* 116907 */ // Label 2244: @116907
     /* 116907 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(116973), // Rule ID 2320 //
     /* 116912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116934 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116939 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116941 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 116948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116953 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116972 */   // GIR_Coverage, 2320,
     /* 116972 */   GIR_EraseRootFromParent_Done,
     /* 116973 */ // Label 2245: @116973
     /* 116973 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117039), // Rule ID 2322 //
     /* 116978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116996 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117000 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117007 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117033 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117038 */   // GIR_Coverage, 2322,
     /* 117038 */   GIR_EraseRootFromParent_Done,
     /* 117039 */ // Label 2246: @117039
     /* 117039 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117099), // Rule ID 2362 //
     /* 117044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117058 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117070 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117074 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117077 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117093 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117098 */   // GIR_Coverage, 2362,
     /* 117098 */   GIR_EraseRootFromParent_Done,
     /* 117099 */ // Label 2247: @117099
     /* 117099 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117159), // Rule ID 2366 //
     /* 117104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117118 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117130 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117134 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117137 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117158 */   // GIR_Coverage, 2366,
     /* 117158 */   GIR_EraseRootFromParent_Done,
     /* 117159 */ // Label 2248: @117159
     /* 117159 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117219), // Rule ID 2370 //
     /* 117164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117178 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117190 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117194 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117197 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117213 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117218 */   // GIR_Coverage, 2370,
     /* 117218 */   GIR_EraseRootFromParent_Done,
     /* 117219 */ // Label 2249: @117219
     /* 117219 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117338), // Rule ID 2711 //
     /* 117224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117238 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117238 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117241 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117245 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117252 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117255 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117259 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117264 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117267 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117271 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117274 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117279 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117284 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117301 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117304 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117307 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117320 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117337 */   // GIR_Coverage, 2711,
     /* 117337 */   GIR_EraseRootFromParent_Done,
     /* 117338 */ // Label 2250: @117338
     /* 117338 */ GIM_Reject,
     /* 117339 */ // Label 2231: @117339
     /* 117339 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117376), // Rule ID 1605 //
     /* 117344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117358 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117363 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117368 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117374 */   GIR_RootConstrainSelectedInstOperands,
     /* 117375 */   // GIR_Coverage, 1605,
     /* 117375 */   GIR_EraseRootFromParent_Done,
     /* 117376 */ // Label 2251: @117376
     /* 117376 */ GIM_Reject,
     /* 117377 */ // Label 2232: @117377
     /* 117377 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117429), // Rule ID 5103 //
     /* 117382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117396 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117401 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117403 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117415 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117421 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117427 */   GIR_RootConstrainSelectedInstOperands,
     /* 117428 */   // GIR_Coverage, 5103,
     /* 117428 */   GIR_EraseRootFromParent_Done,
     /* 117429 */ // Label 2252: @117429
     /* 117429 */ GIM_Reject,
     /* 117430 */ // Label 2233: @117430
     /* 117430 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117467), // Rule ID 1613 //
     /* 117435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117449 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117454 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117465 */   GIR_RootConstrainSelectedInstOperands,
     /* 117466 */   // GIR_Coverage, 1613,
     /* 117466 */   GIR_EraseRootFromParent_Done,
     /* 117467 */ // Label 2253: @117467
     /* 117467 */ GIM_Reject,
     /* 117468 */ // Label 2234: @117468
     /* 117468 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117566),
     /* 117473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117476 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117510), // Rule ID 1609 //
     /* 117481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117492 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117508 */     GIR_RootConstrainSelectedInstOperands,
     /* 117509 */     // GIR_Coverage, 1609,
     /* 117509 */     GIR_EraseRootFromParent_Done,
     /* 117510 */   // Label 2255: @117510
     /* 117510 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(117565), // Rule ID 4096 //
     /* 117515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117526 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117543 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117563 */     GIR_RootConstrainSelectedInstOperands,
     /* 117564 */     // GIR_Coverage, 4096,
     /* 117564 */     GIR_EraseRootFromParent_Done,
     /* 117565 */   // Label 2256: @117565
     /* 117565 */   GIM_Reject,
     /* 117566 */ // Label 2254: @117566
     /* 117566 */ GIM_Reject,
     /* 117567 */ // Label 2235: @117567
     /* 117567 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(117619), // Rule ID 5104 //
     /* 117572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117586 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117591 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117593 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117605 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117611 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117617 */   GIR_RootConstrainSelectedInstOperands,
     /* 117618 */   // GIR_Coverage, 5104,
     /* 117618 */   GIR_EraseRootFromParent_Done,
     /* 117619 */ // Label 2257: @117619
     /* 117619 */ GIM_Reject,
     /* 117620 */ // Label 2236: @117620
     /* 117620 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(117718),
     /* 117625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117628 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(117662), // Rule ID 1617 //
     /* 117633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117644 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117660 */     GIR_RootConstrainSelectedInstOperands,
     /* 117661 */     // GIR_Coverage, 1617,
     /* 117661 */     GIR_EraseRootFromParent_Done,
     /* 117662 */   // Label 2259: @117662
     /* 117662 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(117717), // Rule ID 4092 //
     /* 117667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117678 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117715 */     GIR_RootConstrainSelectedInstOperands,
     /* 117716 */     // GIR_Coverage, 4092,
     /* 117716 */     GIR_EraseRootFromParent_Done,
     /* 117717 */   // Label 2260: @117717
     /* 117717 */   GIM_Reject,
     /* 117718 */ // Label 2258: @117718
     /* 117718 */ GIM_Reject,
     /* 117719 */ // Label 2237: @117719
     /* 117719 */ GIM_Reject,
     /* 117720 */ // Label 44: @117720
     /* 117720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2268*/ GIMT_Encode4(118371),
     /* 117731 */ /*GILLT_s16*//*Label 2261*/ GIMT_Encode4(117783),
     /* 117735 */ /*GILLT_s32*//*Label 2262*/ GIMT_Encode4(117843),
     /* 117739 */ /*GILLT_s64*//*Label 2263*/ GIMT_Encode4(118037), GIMT_Encode4(0),
     /* 117747 */ /*GILLT_v2s32*//*Label 2264*/ GIMT_Encode4(118097), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117759 */ /*GILLT_v4s16*//*Label 2265*/ GIMT_Encode4(118135),
     /* 117763 */ /*GILLT_v4s32*//*Label 2266*/ GIMT_Encode4(118173), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117779 */ /*GILLT_v8s16*//*Label 2267*/ GIMT_Encode4(118272),
     /* 117783 */ // Label 2261: @117783
     /* 117783 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(117842), // Rule ID 2346 //
     /* 117788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117802 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117814 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117818 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 117826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117834 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117840 */   GIR_RootConstrainSelectedInstOperands,
     /* 117841 */   // GIR_Coverage, 2346,
     /* 117841 */   GIR_EraseRootFromParent_Done,
     /* 117842 */ // Label 2269: @117842
     /* 117842 */ GIM_Reject,
     /* 117843 */ // Label 2262: @117843
     /* 117843 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118036),
     /* 117848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117859 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(117907), // Rule ID 2344 //
     /* 117864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117867 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 117891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117905 */     GIR_RootConstrainSelectedInstOperands,
     /* 117906 */     // GIR_Coverage, 2344,
     /* 117906 */     GIR_EraseRootFromParent_Done,
     /* 117907 */   // Label 2271: @117907
     /* 117907 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(118035), // Rule ID 2712 //
     /* 117912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117915 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117915 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117918 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117922 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117927 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117931 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117936 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117939 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117943 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117962 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117965 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 117968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 117993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118004 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118017 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118034 */     // GIR_Coverage, 2712,
     /* 118034 */     GIR_EraseRootFromParent_Done,
     /* 118035 */   // Label 2272: @118035
     /* 118035 */   GIM_Reject,
     /* 118036 */ // Label 2270: @118036
     /* 118036 */ GIM_Reject,
     /* 118037 */ // Label 2263: @118037
     /* 118037 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(118096), // Rule ID 2342 //
     /* 118042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118056 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118068 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118088 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118094 */   GIR_RootConstrainSelectedInstOperands,
     /* 118095 */   // GIR_Coverage, 2342,
     /* 118095 */   GIR_EraseRootFromParent_Done,
     /* 118096 */ // Label 2273: @118096
     /* 118096 */ GIM_Reject,
     /* 118097 */ // Label 2264: @118097
     /* 118097 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(118134), // Rule ID 1606 //
     /* 118102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118116 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118121 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118126 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118132 */   GIR_RootConstrainSelectedInstOperands,
     /* 118133 */   // GIR_Coverage, 1606,
     /* 118133 */   GIR_EraseRootFromParent_Done,
     /* 118134 */ // Label 2274: @118134
     /* 118134 */ GIM_Reject,
     /* 118135 */ // Label 2265: @118135
     /* 118135 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(118172), // Rule ID 1614 //
     /* 118140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118154 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118159 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118164 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118170 */   GIR_RootConstrainSelectedInstOperands,
     /* 118171 */   // GIR_Coverage, 1614,
     /* 118171 */   GIR_EraseRootFromParent_Done,
     /* 118172 */ // Label 2275: @118172
     /* 118172 */ GIM_Reject,
     /* 118173 */ // Label 2266: @118173
     /* 118173 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118271),
     /* 118178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118181 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118215), // Rule ID 1610 //
     /* 118186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118197 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118213 */     GIR_RootConstrainSelectedInstOperands,
     /* 118214 */     // GIR_Coverage, 1610,
     /* 118214 */     GIR_EraseRootFromParent_Done,
     /* 118215 */   // Label 2277: @118215
     /* 118215 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(118270), // Rule ID 4102 //
     /* 118220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118231 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118268 */     GIR_RootConstrainSelectedInstOperands,
     /* 118269 */     // GIR_Coverage, 4102,
     /* 118269 */     GIR_EraseRootFromParent_Done,
     /* 118270 */   // Label 2278: @118270
     /* 118270 */   GIM_Reject,
     /* 118271 */ // Label 2276: @118271
     /* 118271 */ GIM_Reject,
     /* 118272 */ // Label 2267: @118272
     /* 118272 */ GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(118370),
     /* 118277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118280 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(118314), // Rule ID 1618 //
     /* 118285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118296 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118312 */     GIR_RootConstrainSelectedInstOperands,
     /* 118313 */     // GIR_Coverage, 1618,
     /* 118313 */     GIR_EraseRootFromParent_Done,
     /* 118314 */   // Label 2280: @118314
     /* 118314 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(118369), // Rule ID 4098 //
     /* 118319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118330 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118347 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118367 */     GIR_RootConstrainSelectedInstOperands,
     /* 118368 */     // GIR_Coverage, 4098,
     /* 118368 */     GIR_EraseRootFromParent_Done,
     /* 118369 */   // Label 2281: @118369
     /* 118369 */   GIM_Reject,
     /* 118370 */ // Label 2279: @118370
     /* 118370 */ GIM_Reject,
     /* 118371 */ // Label 2268: @118371
     /* 118371 */ GIM_Reject,
     /* 118372 */ // Label 45: @118372
     /* 118372 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2289*/ GIMT_Encode4(119023),
     /* 118383 */ /*GILLT_s16*//*Label 2282*/ GIMT_Encode4(118435),
     /* 118387 */ /*GILLT_s32*//*Label 2283*/ GIMT_Encode4(118495),
     /* 118391 */ /*GILLT_s64*//*Label 2284*/ GIMT_Encode4(118689), GIMT_Encode4(0),
     /* 118399 */ /*GILLT_v2s32*//*Label 2285*/ GIMT_Encode4(118749), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118411 */ /*GILLT_v4s16*//*Label 2286*/ GIMT_Encode4(118787),
     /* 118415 */ /*GILLT_v4s32*//*Label 2287*/ GIMT_Encode4(118825), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118431 */ /*GILLT_v8s16*//*Label 2288*/ GIMT_Encode4(118924),
     /* 118435 */ // Label 2282: @118435
     /* 118435 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118494), // Rule ID 2351 //
     /* 118440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118454 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118466 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118486 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118492 */   GIR_RootConstrainSelectedInstOperands,
     /* 118493 */   // GIR_Coverage, 2351,
     /* 118493 */   GIR_EraseRootFromParent_Done,
     /* 118494 */ // Label 2290: @118494
     /* 118494 */ GIM_Reject,
     /* 118495 */ // Label 2283: @118495
     /* 118495 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(118688),
     /* 118500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118511 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(118559), // Rule ID 2349 //
     /* 118516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118519 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118557 */     GIR_RootConstrainSelectedInstOperands,
     /* 118558 */     // GIR_Coverage, 2349,
     /* 118558 */     GIR_EraseRootFromParent_Done,
     /* 118559 */   // Label 2292: @118559
     /* 118559 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(118687), // Rule ID 2713 //
     /* 118564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118567 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118567 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118570 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118574 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118579 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118583 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118588 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118591 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118595 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118602 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118605 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118609 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118614 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118617 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118620 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118623 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118628 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118633 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118650 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118656 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118669 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118686 */     // GIR_Coverage, 2713,
     /* 118686 */     GIR_EraseRootFromParent_Done,
     /* 118687 */   // Label 2293: @118687
     /* 118687 */   GIM_Reject,
     /* 118688 */ // Label 2291: @118688
     /* 118688 */ GIM_Reject,
     /* 118689 */ // Label 2284: @118689
     /* 118689 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(118748), // Rule ID 2347 //
     /* 118694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118708 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118720 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118740 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118746 */   GIR_RootConstrainSelectedInstOperands,
     /* 118747 */   // GIR_Coverage, 2347,
     /* 118747 */   GIR_EraseRootFromParent_Done,
     /* 118748 */ // Label 2294: @118748
     /* 118748 */ GIM_Reject,
     /* 118749 */ // Label 2285: @118749
     /* 118749 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(118786), // Rule ID 1607 //
     /* 118754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118768 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118773 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118778 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118784 */   GIR_RootConstrainSelectedInstOperands,
     /* 118785 */   // GIR_Coverage, 1607,
     /* 118785 */   GIR_EraseRootFromParent_Done,
     /* 118786 */ // Label 2295: @118786
     /* 118786 */ GIM_Reject,
     /* 118787 */ // Label 2286: @118787
     /* 118787 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(118824), // Rule ID 1615 //
     /* 118792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118806 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 118809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118811 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118816 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118822 */   GIR_RootConstrainSelectedInstOperands,
     /* 118823 */   // GIR_Coverage, 1615,
     /* 118823 */   GIR_EraseRootFromParent_Done,
     /* 118824 */ // Label 2296: @118824
     /* 118824 */ GIM_Reject,
     /* 118825 */ // Label 2287: @118825
     /* 118825 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(118923),
     /* 118830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118833 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(118867), // Rule ID 1611 //
     /* 118838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118849 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 118852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118865 */     GIR_RootConstrainSelectedInstOperands,
     /* 118866 */     // GIR_Coverage, 1611,
     /* 118866 */     GIR_EraseRootFromParent_Done,
     /* 118867 */   // Label 2298: @118867
     /* 118867 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(118922), // Rule ID 4104 //
     /* 118872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118883 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 118898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118920 */     GIR_RootConstrainSelectedInstOperands,
     /* 118921 */     // GIR_Coverage, 4104,
     /* 118921 */     GIR_EraseRootFromParent_Done,
     /* 118922 */   // Label 2299: @118922
     /* 118922 */   GIM_Reject,
     /* 118923 */ // Label 2297: @118923
     /* 118923 */ GIM_Reject,
     /* 118924 */ // Label 2288: @118924
     /* 118924 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(119022),
     /* 118929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118932 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(118966), // Rule ID 1619 //
     /* 118937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118948 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 118951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118964 */     GIR_RootConstrainSelectedInstOperands,
     /* 118965 */     // GIR_Coverage, 1619,
     /* 118965 */     GIR_EraseRootFromParent_Done,
     /* 118966 */   // Label 2301: @118966
     /* 118966 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(119021), // Rule ID 4100 //
     /* 118971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118982 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 118997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119019 */     GIR_RootConstrainSelectedInstOperands,
     /* 119020 */     // GIR_Coverage, 4100,
     /* 119020 */     GIR_EraseRootFromParent_Done,
     /* 119021 */   // Label 2302: @119021
     /* 119021 */   GIM_Reject,
     /* 119022 */ // Label 2300: @119022
     /* 119022 */ GIM_Reject,
     /* 119023 */ // Label 2289: @119023
     /* 119023 */ GIM_Reject,
     /* 119024 */ // Label 46: @119024
     /* 119024 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2310*/ GIMT_Encode4(119799),
     /* 119035 */ /*GILLT_s16*//*Label 2303*/ GIMT_Encode4(119087),
     /* 119039 */ /*GILLT_s32*//*Label 2304*/ GIMT_Encode4(119125),
     /* 119043 */ /*GILLT_s64*//*Label 2305*/ GIMT_Encode4(119317), GIMT_Encode4(0),
     /* 119051 */ /*GILLT_v2s32*//*Label 2306*/ GIMT_Encode4(119355), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119063 */ /*GILLT_v4s16*//*Label 2307*/ GIMT_Encode4(119393),
     /* 119067 */ /*GILLT_v4s32*//*Label 2308*/ GIMT_Encode4(119431), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119083 */ /*GILLT_v8s16*//*Label 2309*/ GIMT_Encode4(119615),
     /* 119087 */ // Label 2303: @119087
     /* 119087 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119124), // Rule ID 653 //
     /* 119092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119106 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119111 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119116 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119122 */   GIR_RootConstrainSelectedInstOperands,
     /* 119123 */   // GIR_Coverage, 653,
     /* 119123 */   GIR_EraseRootFromParent_Done,
     /* 119124 */ // Label 2311: @119124
     /* 119124 */ GIM_Reject,
     /* 119125 */ // Label 2304: @119125
     /* 119125 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119316),
     /* 119130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119141 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119167), // Rule ID 652 //
     /* 119146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119149 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119165 */     GIR_RootConstrainSelectedInstOperands,
     /* 119166 */     // GIR_Coverage, 652,
     /* 119166 */     GIR_EraseRootFromParent_Done,
     /* 119167 */   // Label 2313: @119167
     /* 119167 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119315), // Rule ID 2704 //
     /* 119172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119175 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119175 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119178 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119182 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119189 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119192 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119196 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119201 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119204 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119209 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119212 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119216 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119221 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119224 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119228 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119231 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119236 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119241 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119258 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119261 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119264 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119297 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119314 */     // GIR_Coverage, 2704,
     /* 119314 */     GIR_EraseRootFromParent_Done,
     /* 119315 */   // Label 2314: @119315
     /* 119315 */   GIM_Reject,
     /* 119316 */ // Label 2312: @119316
     /* 119316 */ GIM_Reject,
     /* 119317 */ // Label 2305: @119317
     /* 119317 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119354), // Rule ID 651 //
     /* 119322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119336 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119341 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119346 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119352 */   GIR_RootConstrainSelectedInstOperands,
     /* 119353 */   // GIR_Coverage, 651,
     /* 119353 */   GIR_EraseRootFromParent_Done,
     /* 119354 */ // Label 2315: @119354
     /* 119354 */ GIM_Reject,
     /* 119355 */ // Label 2306: @119355
     /* 119355 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119392), // Rule ID 1514 //
     /* 119360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119374 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119379 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119384 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119390 */   GIR_RootConstrainSelectedInstOperands,
     /* 119391 */   // GIR_Coverage, 1514,
     /* 119391 */   GIR_EraseRootFromParent_Done,
     /* 119392 */ // Label 2316: @119392
     /* 119392 */ GIM_Reject,
     /* 119393 */ // Label 2307: @119393
     /* 119393 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119430), // Rule ID 1516 //
     /* 119398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119412 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119417 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119428 */   GIR_RootConstrainSelectedInstOperands,
     /* 119429 */   // GIR_Coverage, 1516,
     /* 119429 */   GIR_EraseRootFromParent_Done,
     /* 119430 */ // Label 2317: @119430
     /* 119430 */ GIM_Reject,
     /* 119431 */ // Label 2308: @119431
     /* 119431 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(119614),
     /* 119436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119439 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119524), // Rule ID 4041 //
     /* 119444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119479 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119522 */     GIR_RootConstrainSelectedInstOperands,
     /* 119523 */     // GIR_Coverage, 4041,
     /* 119523 */     GIR_EraseRootFromParent_Done,
     /* 119524 */   // Label 2319: @119524
     /* 119524 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(119558), // Rule ID 1515 //
     /* 119529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119540 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119556 */     GIR_RootConstrainSelectedInstOperands,
     /* 119557 */     // GIR_Coverage, 1515,
     /* 119557 */     GIR_EraseRootFromParent_Done,
     /* 119558 */   // Label 2320: @119558
     /* 119558 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(119613), // Rule ID 4112 //
     /* 119563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119574 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119591 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119611 */     GIR_RootConstrainSelectedInstOperands,
     /* 119612 */     // GIR_Coverage, 4112,
     /* 119612 */     GIR_EraseRootFromParent_Done,
     /* 119613 */   // Label 2321: @119613
     /* 119613 */   GIM_Reject,
     /* 119614 */ // Label 2318: @119614
     /* 119614 */ GIM_Reject,
     /* 119615 */ // Label 2309: @119615
     /* 119615 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(119798),
     /* 119620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119623 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(119708), // Rule ID 4040 //
     /* 119628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119663 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119706 */     GIR_RootConstrainSelectedInstOperands,
     /* 119707 */     // GIR_Coverage, 4040,
     /* 119707 */     GIR_EraseRootFromParent_Done,
     /* 119708 */   // Label 2323: @119708
     /* 119708 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(119742), // Rule ID 1517 //
     /* 119713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119724 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119740 */     GIR_RootConstrainSelectedInstOperands,
     /* 119741 */     // GIR_Coverage, 1517,
     /* 119741 */     GIR_EraseRootFromParent_Done,
     /* 119742 */   // Label 2324: @119742
     /* 119742 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(119797), // Rule ID 4110 //
     /* 119747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119758 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119775 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119795 */     GIR_RootConstrainSelectedInstOperands,
     /* 119796 */     // GIR_Coverage, 4110,
     /* 119796 */     GIR_EraseRootFromParent_Done,
     /* 119797 */   // Label 2325: @119797
     /* 119797 */   GIM_Reject,
     /* 119798 */ // Label 2322: @119798
     /* 119798 */ GIM_Reject,
     /* 119799 */ // Label 2310: @119799
     /* 119799 */ GIM_Reject,
     /* 119800 */ // Label 47: @119800
     /* 119800 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2333*/ GIMT_Encode4(120391),
     /* 119811 */ /*GILLT_s16*//*Label 2326*/ GIMT_Encode4(119863),
     /* 119815 */ /*GILLT_s32*//*Label 2327*/ GIMT_Encode4(119897),
     /* 119819 */ /*GILLT_s64*//*Label 2328*/ GIMT_Encode4(119931), GIMT_Encode4(0),
     /* 119827 */ /*GILLT_v2s32*//*Label 2329*/ GIMT_Encode4(119965), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119839 */ /*GILLT_v4s16*//*Label 2330*/ GIMT_Encode4(119999),
     /* 119843 */ /*GILLT_v4s32*//*Label 2331*/ GIMT_Encode4(120033), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119859 */ /*GILLT_v8s16*//*Label 2332*/ GIMT_Encode4(120212),
     /* 119863 */ // Label 2326: @119863
     /* 119863 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(119896), // Rule ID 642 //
     /* 119868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 119877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119889 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 119889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 119894 */   GIR_RootConstrainSelectedInstOperands,
     /* 119895 */   // GIR_Coverage, 642,
     /* 119895 */   GIR_Done,
     /* 119896 */ // Label 2334: @119896
     /* 119896 */ GIM_Reject,
     /* 119897 */ // Label 2327: @119897
     /* 119897 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(119930), // Rule ID 643 //
     /* 119902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 119911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119923 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 119923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 119928 */   GIR_RootConstrainSelectedInstOperands,
     /* 119929 */   // GIR_Coverage, 643,
     /* 119929 */   GIR_Done,
     /* 119930 */ // Label 2335: @119930
     /* 119930 */ GIM_Reject,
     /* 119931 */ // Label 2328: @119931
     /* 119931 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(119964), // Rule ID 644 //
     /* 119936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 119939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 119945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119957 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 119957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 119962 */   GIR_RootConstrainSelectedInstOperands,
     /* 119963 */   // GIR_Coverage, 644,
     /* 119963 */   GIR_Done,
     /* 119964 */ // Label 2336: @119964
     /* 119964 */ GIM_Reject,
     /* 119965 */ // Label 2329: @119965
     /* 119965 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(119998), // Rule ID 1233 //
     /* 119970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 119973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 119979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119991 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 119991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 119996 */   GIR_RootConstrainSelectedInstOperands,
     /* 119997 */   // GIR_Coverage, 1233,
     /* 119997 */   GIR_Done,
     /* 119998 */ // Label 2337: @119998
     /* 119998 */ GIM_Reject,
     /* 119999 */ // Label 2330: @119999
     /* 119999 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(120032), // Rule ID 1235 //
     /* 120004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120025 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120030 */   GIR_RootConstrainSelectedInstOperands,
     /* 120031 */   // GIR_Coverage, 1235,
     /* 120031 */   GIR_Done,
     /* 120032 */ // Label 2338: @120032
     /* 120032 */ GIM_Reject,
     /* 120033 */ // Label 2331: @120033
     /* 120033 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(120211),
     /* 120038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120044 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120122), // Rule ID 4122 //
     /* 120049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120092 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120120 */     GIR_RootConstrainSelectedInstOperands,
     /* 120121 */     // GIR_Coverage, 4122,
     /* 120121 */     GIR_EraseRootFromParent_Done,
     /* 120122 */   // Label 2340: @120122
     /* 120122 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120149), // Rule ID 1234 //
     /* 120127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120142 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120147 */     GIR_RootConstrainSelectedInstOperands,
     /* 120148 */     // GIR_Coverage, 1234,
     /* 120148 */     GIR_Done,
     /* 120149 */   // Label 2341: @120149
     /* 120149 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120210), // Rule ID 3288 //
     /* 120154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120169 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120208 */     GIR_RootConstrainSelectedInstOperands,
     /* 120209 */     // GIR_Coverage, 3288,
     /* 120209 */     GIR_EraseRootFromParent_Done,
     /* 120210 */   // Label 2342: @120210
     /* 120210 */   GIM_Reject,
     /* 120211 */ // Label 2339: @120211
     /* 120211 */ GIM_Reject,
     /* 120212 */ // Label 2332: @120212
     /* 120212 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(120390),
     /* 120217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120223 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(120301), // Rule ID 4124 //
     /* 120228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120271 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120299 */     GIR_RootConstrainSelectedInstOperands,
     /* 120300 */     // GIR_Coverage, 4124,
     /* 120300 */     GIR_EraseRootFromParent_Done,
     /* 120301 */   // Label 2344: @120301
     /* 120301 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(120328), // Rule ID 1236 //
     /* 120306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120321 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120326 */     GIR_RootConstrainSelectedInstOperands,
     /* 120327 */     // GIR_Coverage, 1236,
     /* 120327 */     GIR_Done,
     /* 120328 */   // Label 2345: @120328
     /* 120328 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(120389), // Rule ID 3291 //
     /* 120333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120348 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120387 */     GIR_RootConstrainSelectedInstOperands,
     /* 120388 */     // GIR_Coverage, 3291,
     /* 120388 */     GIR_EraseRootFromParent_Done,
     /* 120389 */   // Label 2346: @120389
     /* 120389 */   GIM_Reject,
     /* 120390 */ // Label 2343: @120390
     /* 120390 */ GIM_Reject,
     /* 120391 */ // Label 2333: @120391
     /* 120391 */ GIM_Reject,
     /* 120392 */ // Label 48: @120392
     /* 120392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2354*/ GIMT_Encode4(120983),
     /* 120403 */ /*GILLT_s16*//*Label 2347*/ GIMT_Encode4(120455),
     /* 120407 */ /*GILLT_s32*//*Label 2348*/ GIMT_Encode4(120489),
     /* 120411 */ /*GILLT_s64*//*Label 2349*/ GIMT_Encode4(120523), GIMT_Encode4(0),
     /* 120419 */ /*GILLT_v2s32*//*Label 2350*/ GIMT_Encode4(120557), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120431 */ /*GILLT_v4s16*//*Label 2351*/ GIMT_Encode4(120591),
     /* 120435 */ /*GILLT_v4s32*//*Label 2352*/ GIMT_Encode4(120625), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120451 */ /*GILLT_v8s16*//*Label 2353*/ GIMT_Encode4(120804),
     /* 120455 */ // Label 2347: @120455
     /* 120455 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120488), // Rule ID 639 //
     /* 120460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120481 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120486 */   GIR_RootConstrainSelectedInstOperands,
     /* 120487 */   // GIR_Coverage, 639,
     /* 120487 */   GIR_Done,
     /* 120488 */ // Label 2355: @120488
     /* 120488 */ GIM_Reject,
     /* 120489 */ // Label 2348: @120489
     /* 120489 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(120522), // Rule ID 640 //
     /* 120494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120515 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120520 */   GIR_RootConstrainSelectedInstOperands,
     /* 120521 */   // GIR_Coverage, 640,
     /* 120521 */   GIR_Done,
     /* 120522 */ // Label 2356: @120522
     /* 120522 */ GIM_Reject,
     /* 120523 */ // Label 2349: @120523
     /* 120523 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120556), // Rule ID 641 //
     /* 120528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120549 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120554 */   GIR_RootConstrainSelectedInstOperands,
     /* 120555 */   // GIR_Coverage, 641,
     /* 120555 */   GIR_Done,
     /* 120556 */ // Label 2357: @120556
     /* 120556 */ GIM_Reject,
     /* 120557 */ // Label 2350: @120557
     /* 120557 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(120590), // Rule ID 1213 //
     /* 120562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120583 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120588 */   GIR_RootConstrainSelectedInstOperands,
     /* 120589 */   // GIR_Coverage, 1213,
     /* 120589 */   GIR_Done,
     /* 120590 */ // Label 2358: @120590
     /* 120590 */ GIM_Reject,
     /* 120591 */ // Label 2351: @120591
     /* 120591 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(120624), // Rule ID 1215 //
     /* 120596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120617 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120622 */   GIR_RootConstrainSelectedInstOperands,
     /* 120623 */   // GIR_Coverage, 1215,
     /* 120623 */   GIR_Done,
     /* 120624 */ // Label 2359: @120624
     /* 120624 */ GIM_Reject,
     /* 120625 */ // Label 2352: @120625
     /* 120625 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(120803),
     /* 120630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120636 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(120714), // Rule ID 4118 //
     /* 120641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120684 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120712 */     GIR_RootConstrainSelectedInstOperands,
     /* 120713 */     // GIR_Coverage, 4118,
     /* 120713 */     GIR_EraseRootFromParent_Done,
     /* 120714 */   // Label 2361: @120714
     /* 120714 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(120741), // Rule ID 1214 //
     /* 120719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120734 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120739 */     GIR_RootConstrainSelectedInstOperands,
     /* 120740 */     // GIR_Coverage, 1214,
     /* 120740 */     GIR_Done,
     /* 120741 */   // Label 2362: @120741
     /* 120741 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(120802), // Rule ID 3030 //
     /* 120746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120761 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120800 */     GIR_RootConstrainSelectedInstOperands,
     /* 120801 */     // GIR_Coverage, 3030,
     /* 120801 */     GIR_EraseRootFromParent_Done,
     /* 120802 */   // Label 2363: @120802
     /* 120802 */   GIM_Reject,
     /* 120803 */ // Label 2360: @120803
     /* 120803 */ GIM_Reject,
     /* 120804 */ // Label 2353: @120804
     /* 120804 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(120982),
     /* 120809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120815 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(120893), // Rule ID 4120 //
     /* 120820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120863 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 120866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120891 */     GIR_RootConstrainSelectedInstOperands,
     /* 120892 */     // GIR_Coverage, 4120,
     /* 120892 */     GIR_EraseRootFromParent_Done,
     /* 120893 */   // Label 2365: @120893
     /* 120893 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(120920), // Rule ID 1216 //
     /* 120898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120913 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 120918 */     GIR_RootConstrainSelectedInstOperands,
     /* 120919 */     // GIR_Coverage, 1216,
     /* 120919 */     GIR_Done,
     /* 120920 */   // Label 2366: @120920
     /* 120920 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(120981), // Rule ID 3285 //
     /* 120925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120940 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 120955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120979 */     GIR_RootConstrainSelectedInstOperands,
     /* 120980 */     // GIR_Coverage, 3285,
     /* 120980 */     GIR_EraseRootFromParent_Done,
     /* 120981 */   // Label 2367: @120981
     /* 120981 */   GIM_Reject,
     /* 120982 */ // Label 2364: @120982
     /* 120982 */ GIM_Reject,
     /* 120983 */ // Label 2354: @120983
     /* 120983 */ GIM_Reject,
     /* 120984 */ // Label 49: @120984
     /* 120984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2374*/ GIMT_Encode4(121717),
     /* 120995 */ /*GILLT_s16*//*Label 2368*/ GIMT_Encode4(121047),
     /* 120999 */ /*GILLT_s32*//*Label 2369*/ GIMT_Encode4(121288), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121011 */ /*GILLT_v2s32*//*Label 2370*/ GIMT_Encode4(121529), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121023 */ /*GILLT_v4s16*//*Label 2371*/ GIMT_Encode4(121576),
     /* 121027 */ /*GILLT_v4s32*//*Label 2372*/ GIMT_Encode4(121623), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121043 */ /*GILLT_v8s16*//*Label 2373*/ GIMT_Encode4(121670),
     /* 121047 */ // Label 2368: @121047
     /* 121047 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121287), // Rule ID 2707 //
     /* 121052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121073 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121073 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121076 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121080 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121087 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121090 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121094 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121099 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121102 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121107 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121110 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121114 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121119 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121122 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121126 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121129 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121134 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121139 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121144 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121147 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121151 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121158 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121161 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121165 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121170 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121173 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121178 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121181 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121185 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121190 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121193 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121197 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121200 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121205 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121210 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121215 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121218 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121222 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121227 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121230 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121233 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121236 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121256 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121269 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121286 */   // GIR_Coverage, 2707,
     /* 121286 */   GIR_EraseRootFromParent_Done,
     /* 121287 */ // Label 2375: @121287
     /* 121287 */ GIM_Reject,
     /* 121288 */ // Label 2369: @121288
     /* 121288 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121528), // Rule ID 2709 //
     /* 121293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121314 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121314 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121317 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121321 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121328 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121331 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121335 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121340 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121343 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121348 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121351 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121355 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121360 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121363 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121367 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121370 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121375 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121380 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121385 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121388 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121392 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121399 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121402 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121406 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121411 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121414 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121419 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121422 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121426 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121431 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121434 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121438 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121441 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121446 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121451 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121456 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121459 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121463 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121468 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121471 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121474 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121477 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121497 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121500 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121510 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121527 */   // GIR_Coverage, 2709,
     /* 121527 */   GIR_EraseRootFromParent_Done,
     /* 121528 */ // Label 2376: @121528
     /* 121528 */ GIM_Reject,
     /* 121529 */ // Label 2370: @121529
     /* 121529 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(121575), // Rule ID 1229 //
     /* 121534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121555 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121560 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121562 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121573 */   GIR_RootConstrainSelectedInstOperands,
     /* 121574 */   // GIR_Coverage, 1229,
     /* 121574 */   GIR_EraseRootFromParent_Done,
     /* 121575 */ // Label 2377: @121575
     /* 121575 */ GIM_Reject,
     /* 121576 */ // Label 2371: @121576
     /* 121576 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(121622), // Rule ID 1231 //
     /* 121581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121602 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121607 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121609 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121620 */   GIR_RootConstrainSelectedInstOperands,
     /* 121621 */   // GIR_Coverage, 1231,
     /* 121621 */   GIR_EraseRootFromParent_Done,
     /* 121622 */ // Label 2378: @121622
     /* 121622 */ GIM_Reject,
     /* 121623 */ // Label 2372: @121623
     /* 121623 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(121669), // Rule ID 1230 //
     /* 121628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121649 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121654 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121656 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121661 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121667 */   GIR_RootConstrainSelectedInstOperands,
     /* 121668 */   // GIR_Coverage, 1230,
     /* 121668 */   GIR_EraseRootFromParent_Done,
     /* 121669 */ // Label 2379: @121669
     /* 121669 */ GIM_Reject,
     /* 121670 */ // Label 2373: @121670
     /* 121670 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(121716), // Rule ID 1232 //
     /* 121675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121696 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121701 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121703 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121714 */   GIR_RootConstrainSelectedInstOperands,
     /* 121715 */   // GIR_Coverage, 1232,
     /* 121715 */   GIR_EraseRootFromParent_Done,
     /* 121716 */ // Label 2380: @121716
     /* 121716 */ GIM_Reject,
     /* 121717 */ // Label 2374: @121717
     /* 121717 */ GIM_Reject,
     /* 121718 */ // Label 50: @121718
     /* 121718 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2387*/ GIMT_Encode4(122451),
     /* 121729 */ /*GILLT_s16*//*Label 2381*/ GIMT_Encode4(121781),
     /* 121733 */ /*GILLT_s32*//*Label 2382*/ GIMT_Encode4(122022), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121745 */ /*GILLT_v2s32*//*Label 2383*/ GIMT_Encode4(122263), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121757 */ /*GILLT_v4s16*//*Label 2384*/ GIMT_Encode4(122310),
     /* 121761 */ /*GILLT_v4s32*//*Label 2385*/ GIMT_Encode4(122357), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121777 */ /*GILLT_v8s16*//*Label 2386*/ GIMT_Encode4(122404),
     /* 121781 */ // Label 2381: @121781
     /* 121781 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122021), // Rule ID 2706 //
     /* 121786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121807 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121807 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121810 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121814 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121821 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121824 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121828 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121833 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121836 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121841 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121844 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121848 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121853 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121856 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121860 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121863 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121868 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121873 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121878 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121881 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121885 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121892 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121895 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121899 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121904 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121907 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121924 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121927 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121931 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121934 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121939 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121944 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121949 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121952 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 121956 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121961 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121964 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121967 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121970 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121990 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122003 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122010 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122020 */   // GIR_Coverage, 2706,
     /* 122020 */   GIR_EraseRootFromParent_Done,
     /* 122021 */ // Label 2388: @122021
     /* 122021 */ GIM_Reject,
     /* 122022 */ // Label 2382: @122022
     /* 122022 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122262), // Rule ID 2708 //
     /* 122027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122048 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122048 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122051 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122055 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122062 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122065 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122069 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122074 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122077 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122082 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122085 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122089 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122094 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122097 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122101 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122104 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122109 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122114 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122119 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122122 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122126 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122133 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122136 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122140 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122145 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122148 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122153 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122156 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122160 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122165 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122168 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122172 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122175 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122180 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122185 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122190 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122193 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122197 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122202 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122205 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122208 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122211 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122231 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122244 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122261 */   // GIR_Coverage, 2708,
     /* 122261 */   GIR_EraseRootFromParent_Done,
     /* 122262 */ // Label 2389: @122262
     /* 122262 */ GIM_Reject,
     /* 122263 */ // Label 2383: @122263
     /* 122263 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122309), // Rule ID 1209 //
     /* 122268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122289 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122294 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122296 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122301 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122307 */   GIR_RootConstrainSelectedInstOperands,
     /* 122308 */   // GIR_Coverage, 1209,
     /* 122308 */   GIR_EraseRootFromParent_Done,
     /* 122309 */ // Label 2390: @122309
     /* 122309 */ GIM_Reject,
     /* 122310 */ // Label 2384: @122310
     /* 122310 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122356), // Rule ID 1211 //
     /* 122315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122336 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122341 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122343 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122354 */   GIR_RootConstrainSelectedInstOperands,
     /* 122355 */   // GIR_Coverage, 1211,
     /* 122355 */   GIR_EraseRootFromParent_Done,
     /* 122356 */ // Label 2391: @122356
     /* 122356 */ GIM_Reject,
     /* 122357 */ // Label 2385: @122357
     /* 122357 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122403), // Rule ID 1210 //
     /* 122362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122383 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122388 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122390 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122395 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122401 */   GIR_RootConstrainSelectedInstOperands,
     /* 122402 */   // GIR_Coverage, 1210,
     /* 122402 */   GIR_EraseRootFromParent_Done,
     /* 122403 */ // Label 2392: @122403
     /* 122403 */ GIM_Reject,
     /* 122404 */ // Label 2386: @122404
     /* 122404 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122450), // Rule ID 1212 //
     /* 122409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122430 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122435 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122437 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122442 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122448 */   GIR_RootConstrainSelectedInstOperands,
     /* 122449 */   // GIR_Coverage, 1212,
     /* 122449 */   GIR_EraseRootFromParent_Done,
     /* 122450 */ // Label 2393: @122450
     /* 122450 */ GIM_Reject,
     /* 122451 */ // Label 2387: @122451
     /* 122451 */ GIM_Reject,
     /* 122452 */ // Label 51: @122452
     /* 122452 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122484), // Rule ID 2419 //
     /* 122457 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122464 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122482 */   GIR_RootConstrainSelectedInstOperands,
     /* 122483 */   // GIR_Coverage, 2419,
     /* 122483 */   GIR_EraseRootFromParent_Done,
     /* 122484 */ // Label 2394: @122484
     /* 122484 */ GIM_Reject,
     /* 122485 */ // Label 52: @122485
     /* 122485 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(122520), // Rule ID 2420 //
     /* 122490 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122497 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122500 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122505 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122511 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122518 */   GIR_RootConstrainSelectedInstOperands,
     /* 122519 */   // GIR_Coverage, 2420,
     /* 122519 */   GIR_EraseRootFromParent_Done,
     /* 122520 */ // Label 2395: @122520
     /* 122520 */ GIM_Reject,
     /* 122521 */ // Label 53: @122521
     /* 122521 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(122585), // Rule ID 2421 //
     /* 122526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122529 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122529 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122532 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122536 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122541 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122544 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122547 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122553 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122570 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122576 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122579 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122583 */   GIR_RootConstrainSelectedInstOperands,
     /* 122584 */   // GIR_Coverage, 2421,
     /* 122584 */   GIR_EraseRootFromParent_Done,
     /* 122585 */ // Label 2396: @122585
     /* 122585 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(122649), // Rule ID 2422 //
     /* 122590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122593 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122593 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122596 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122600 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122605 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122611 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122614 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122617 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122634 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122640 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122643 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122647 */   GIR_RootConstrainSelectedInstOperands,
     /* 122648 */   // GIR_Coverage, 2422,
     /* 122648 */   GIR_EraseRootFromParent_Done,
     /* 122649 */ // Label 2397: @122649
     /* 122649 */ GIM_Reject,
     /* 122650 */ // Label 54: @122650
     /* 122650 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(122682), // Rule ID 2423 //
     /* 122655 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122662 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122670 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122680 */   GIR_RootConstrainSelectedInstOperands,
     /* 122681 */   // GIR_Coverage, 2423,
     /* 122681 */   GIR_EraseRootFromParent_Done,
     /* 122682 */ // Label 2398: @122682
     /* 122682 */ GIM_Reject,
     /* 122683 */ // Label 55: @122683
     /* 122683 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2405*/ GIMT_Encode4(123225),
     /* 122694 */ /*GILLT_v2s32*//*Label 2399*/ GIMT_Encode4(122742), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122706 */ /*GILLT_v4s16*//*Label 2400*/ GIMT_Encode4(122789),
     /* 122710 */ /*GILLT_v4s32*//*Label 2401*/ GIMT_Encode4(122836), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122722 */ /*GILLT_v8s8*//*Label 2402*/ GIMT_Encode4(122950),
     /* 122726 */ /*GILLT_v8s16*//*Label 2403*/ GIMT_Encode4(122997), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122738 */ /*GILLT_v16s8*//*Label 2404*/ GIMT_Encode4(123111),
     /* 122742 */ // Label 2399: @122742
     /* 122742 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(122788), // Rule ID 1218 //
     /* 122747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122768 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122773 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122775 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122780 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122786 */   GIR_RootConstrainSelectedInstOperands,
     /* 122787 */   // GIR_Coverage, 1218,
     /* 122787 */   GIR_EraseRootFromParent_Done,
     /* 122788 */ // Label 2406: @122788
     /* 122788 */ GIM_Reject,
     /* 122789 */ // Label 2400: @122789
     /* 122789 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(122835), // Rule ID 1217 //
     /* 122794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122815 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 122815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 122818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122820 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122822 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122827 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122833 */   GIR_RootConstrainSelectedInstOperands,
     /* 122834 */   // GIR_Coverage, 1217,
     /* 122834 */   GIR_EraseRootFromParent_Done,
     /* 122835 */ // Label 2407: @122835
     /* 122835 */ GIM_Reject,
     /* 122836 */ // Label 2401: @122836
     /* 122836 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(122949),
     /* 122841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122847 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(122887), // Rule ID 1220 //
     /* 122852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122867 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 122867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 122870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122885 */     GIR_RootConstrainSelectedInstOperands,
     /* 122886 */     // GIR_Coverage, 1220,
     /* 122886 */     GIR_EraseRootFromParent_Done,
     /* 122887 */   // Label 2409: @122887
     /* 122887 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(122948), // Rule ID 3300 //
     /* 122892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122907 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 122907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 122922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122946 */     GIR_RootConstrainSelectedInstOperands,
     /* 122947 */     // GIR_Coverage, 3300,
     /* 122947 */     GIR_EraseRootFromParent_Done,
     /* 122948 */   // Label 2410: @122948
     /* 122948 */   GIM_Reject,
     /* 122949 */ // Label 2408: @122949
     /* 122949 */ GIM_Reject,
     /* 122950 */ // Label 2402: @122950
     /* 122950 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(122996), // Rule ID 1221 //
     /* 122955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 122961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 122964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122976 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 122976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 122979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122981 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122983 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122988 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122994 */   GIR_RootConstrainSelectedInstOperands,
     /* 122995 */   // GIR_Coverage, 1221,
     /* 122995 */   GIR_EraseRootFromParent_Done,
     /* 122996 */ // Label 2411: @122996
     /* 122996 */ GIM_Reject,
     /* 122997 */ // Label 2403: @122997
     /* 122997 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(123110),
     /* 123002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123008 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(123048), // Rule ID 1219 //
     /* 123013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123028 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123046 */     GIR_RootConstrainSelectedInstOperands,
     /* 123047 */     // GIR_Coverage, 1219,
     /* 123047 */     GIR_EraseRootFromParent_Done,
     /* 123048 */   // Label 2413: @123048
     /* 123048 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(123109), // Rule ID 3297 //
     /* 123053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123068 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123107 */     GIR_RootConstrainSelectedInstOperands,
     /* 123108 */     // GIR_Coverage, 3297,
     /* 123108 */     GIR_EraseRootFromParent_Done,
     /* 123109 */   // Label 2414: @123109
     /* 123109 */   GIM_Reject,
     /* 123110 */ // Label 2412: @123110
     /* 123110 */ GIM_Reject,
     /* 123111 */ // Label 2404: @123111
     /* 123111 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(123224),
     /* 123116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123122 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(123162), // Rule ID 1222 //
     /* 123127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123142 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123160 */     GIR_RootConstrainSelectedInstOperands,
     /* 123161 */     // GIR_Coverage, 1222,
     /* 123161 */     GIR_EraseRootFromParent_Done,
     /* 123162 */   // Label 2416: @123162
     /* 123162 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(123223), // Rule ID 3294 //
     /* 123167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123182 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123221 */     GIR_RootConstrainSelectedInstOperands,
     /* 123222 */     // GIR_Coverage, 3294,
     /* 123222 */     GIR_EraseRootFromParent_Done,
     /* 123223 */   // Label 2417: @123223
     /* 123223 */   GIM_Reject,
     /* 123224 */ // Label 2415: @123224
     /* 123224 */ GIM_Reject,
     /* 123225 */ // Label 2405: @123225
     /* 123225 */ GIM_Reject,
     /* 123226 */ // Label 56: @123226
     /* 123226 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2424*/ GIMT_Encode4(123768),
     /* 123237 */ /*GILLT_v2s32*//*Label 2418*/ GIMT_Encode4(123285), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123249 */ /*GILLT_v4s16*//*Label 2419*/ GIMT_Encode4(123332),
     /* 123253 */ /*GILLT_v4s32*//*Label 2420*/ GIMT_Encode4(123379), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123265 */ /*GILLT_v8s8*//*Label 2421*/ GIMT_Encode4(123493),
     /* 123269 */ /*GILLT_v8s16*//*Label 2422*/ GIMT_Encode4(123540), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123281 */ /*GILLT_v16s8*//*Label 2423*/ GIMT_Encode4(123654),
     /* 123285 */ // Label 2418: @123285
     /* 123285 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123331), // Rule ID 1198 //
     /* 123290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123311 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123316 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123318 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123323 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123329 */   GIR_RootConstrainSelectedInstOperands,
     /* 123330 */   // GIR_Coverage, 1198,
     /* 123330 */   GIR_EraseRootFromParent_Done,
     /* 123331 */ // Label 2425: @123331
     /* 123331 */ GIM_Reject,
     /* 123332 */ // Label 2419: @123332
     /* 123332 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123378), // Rule ID 1197 //
     /* 123337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123358 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123363 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123365 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123370 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123376 */   GIR_RootConstrainSelectedInstOperands,
     /* 123377 */   // GIR_Coverage, 1197,
     /* 123377 */   GIR_EraseRootFromParent_Done,
     /* 123378 */ // Label 2426: @123378
     /* 123378 */ GIM_Reject,
     /* 123379 */ // Label 2420: @123379
     /* 123379 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123492),
     /* 123384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123390 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123430), // Rule ID 1200 //
     /* 123395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123410 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123428 */     GIR_RootConstrainSelectedInstOperands,
     /* 123429 */     // GIR_Coverage, 1200,
     /* 123429 */     GIR_EraseRootFromParent_Done,
     /* 123430 */   // Label 2428: @123430
     /* 123430 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123491), // Rule ID 3318 //
     /* 123435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123450 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123489 */     GIR_RootConstrainSelectedInstOperands,
     /* 123490 */     // GIR_Coverage, 3318,
     /* 123490 */     GIR_EraseRootFromParent_Done,
     /* 123491 */   // Label 2429: @123491
     /* 123491 */   GIM_Reject,
     /* 123492 */ // Label 2427: @123492
     /* 123492 */ GIM_Reject,
     /* 123493 */ // Label 2421: @123493
     /* 123493 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123539), // Rule ID 1201 //
     /* 123498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123519 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123524 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123526 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123531 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123537 */   GIR_RootConstrainSelectedInstOperands,
     /* 123538 */   // GIR_Coverage, 1201,
     /* 123538 */   GIR_EraseRootFromParent_Done,
     /* 123539 */ // Label 2430: @123539
     /* 123539 */ GIM_Reject,
     /* 123540 */ // Label 2422: @123540
     /* 123540 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(123653),
     /* 123545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123551 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(123591), // Rule ID 1199 //
     /* 123556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123571 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123589 */     GIR_RootConstrainSelectedInstOperands,
     /* 123590 */     // GIR_Coverage, 1199,
     /* 123590 */     GIR_EraseRootFromParent_Done,
     /* 123591 */   // Label 2432: @123591
     /* 123591 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(123652), // Rule ID 3315 //
     /* 123596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123611 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123650 */     GIR_RootConstrainSelectedInstOperands,
     /* 123651 */     // GIR_Coverage, 3315,
     /* 123651 */     GIR_EraseRootFromParent_Done,
     /* 123652 */   // Label 2433: @123652
     /* 123652 */   GIM_Reject,
     /* 123653 */ // Label 2431: @123653
     /* 123653 */ GIM_Reject,
     /* 123654 */ // Label 2423: @123654
     /* 123654 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(123767),
     /* 123659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123665 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(123705), // Rule ID 1202 //
     /* 123670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123685 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123703 */     GIR_RootConstrainSelectedInstOperands,
     /* 123704 */     // GIR_Coverage, 1202,
     /* 123704 */     GIR_EraseRootFromParent_Done,
     /* 123705 */   // Label 2435: @123705
     /* 123705 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(123766), // Rule ID 3312 //
     /* 123710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123725 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123764 */     GIR_RootConstrainSelectedInstOperands,
     /* 123765 */     // GIR_Coverage, 3312,
     /* 123765 */     GIR_EraseRootFromParent_Done,
     /* 123766 */   // Label 2436: @123766
     /* 123766 */   GIM_Reject,
     /* 123767 */ // Label 2434: @123767
     /* 123767 */ GIM_Reject,
     /* 123768 */ // Label 2424: @123768
     /* 123768 */ GIM_Reject,
     /* 123769 */ // Label 57: @123769
     /* 123769 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2443*/ GIMT_Encode4(124689),
     /* 123780 */ /*GILLT_v2s32*//*Label 2437*/ GIMT_Encode4(123828), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123792 */ /*GILLT_v4s16*//*Label 2438*/ GIMT_Encode4(123875),
     /* 123796 */ /*GILLT_v4s32*//*Label 2439*/ GIMT_Encode4(123922), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123808 */ /*GILLT_v8s8*//*Label 2440*/ GIMT_Encode4(124162),
     /* 123812 */ /*GILLT_v8s16*//*Label 2441*/ GIMT_Encode4(124209), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123824 */ /*GILLT_v16s8*//*Label 2442*/ GIMT_Encode4(124449),
     /* 123828 */ // Label 2437: @123828
     /* 123828 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(123874), // Rule ID 1224 //
     /* 123833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123854 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 123857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123859 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123861 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123866 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123872 */   GIR_RootConstrainSelectedInstOperands,
     /* 123873 */   // GIR_Coverage, 1224,
     /* 123873 */   GIR_EraseRootFromParent_Done,
     /* 123874 */ // Label 2444: @123874
     /* 123874 */ GIM_Reject,
     /* 123875 */ // Label 2438: @123875
     /* 123875 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(123921), // Rule ID 1223 //
     /* 123880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123901 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 123904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123906 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123908 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123913 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123919 */   GIR_RootConstrainSelectedInstOperands,
     /* 123920 */   // GIR_Coverage, 1223,
     /* 123920 */   GIR_EraseRootFromParent_Done,
     /* 123921 */ // Label 2445: @123921
     /* 123921 */ GIM_Reject,
     /* 123922 */ // Label 2439: @123922
     /* 123922 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124161),
     /* 123927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123933 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(123996), // Rule ID 6027 //
     /* 123938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123968 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 123968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 123971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 123975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 123979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123994 */     GIR_RootConstrainSelectedInstOperands,
     /* 123995 */     // GIR_Coverage, 6027,
     /* 123995 */     GIR_EraseRootFromParent_Done,
     /* 123996 */   // Label 2447: @123996
     /* 123996 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124059), // Rule ID 3697 //
     /* 124001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124031 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124057 */     GIR_RootConstrainSelectedInstOperands,
     /* 124058 */     // GIR_Coverage, 3697,
     /* 124058 */     GIR_EraseRootFromParent_Done,
     /* 124059 */   // Label 2448: @124059
     /* 124059 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124099), // Rule ID 1226 //
     /* 124064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124079 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124097 */     GIR_RootConstrainSelectedInstOperands,
     /* 124098 */     // GIR_Coverage, 1226,
     /* 124098 */     GIR_EraseRootFromParent_Done,
     /* 124099 */   // Label 2449: @124099
     /* 124099 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124160), // Rule ID 3309 //
     /* 124104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124119 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124158 */     GIR_RootConstrainSelectedInstOperands,
     /* 124159 */     // GIR_Coverage, 3309,
     /* 124159 */     GIR_EraseRootFromParent_Done,
     /* 124160 */   // Label 2450: @124160
     /* 124160 */   GIM_Reject,
     /* 124161 */ // Label 2446: @124161
     /* 124161 */ GIM_Reject,
     /* 124162 */ // Label 2440: @124162
     /* 124162 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124208), // Rule ID 1227 //
     /* 124167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124188 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124193 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124195 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124206 */   GIR_RootConstrainSelectedInstOperands,
     /* 124207 */   // GIR_Coverage, 1227,
     /* 124207 */   GIR_EraseRootFromParent_Done,
     /* 124208 */ // Label 2451: @124208
     /* 124208 */ GIM_Reject,
     /* 124209 */ // Label 2441: @124209
     /* 124209 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124448),
     /* 124214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124220 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124283), // Rule ID 6026 //
     /* 124225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124255 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124281 */     GIR_RootConstrainSelectedInstOperands,
     /* 124282 */     // GIR_Coverage, 6026,
     /* 124282 */     GIR_EraseRootFromParent_Done,
     /* 124283 */   // Label 2453: @124283
     /* 124283 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124346), // Rule ID 3695 //
     /* 124288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124318 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124344 */     GIR_RootConstrainSelectedInstOperands,
     /* 124345 */     // GIR_Coverage, 3695,
     /* 124345 */     GIR_EraseRootFromParent_Done,
     /* 124346 */   // Label 2454: @124346
     /* 124346 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(124386), // Rule ID 1225 //
     /* 124351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124366 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124384 */     GIR_RootConstrainSelectedInstOperands,
     /* 124385 */     // GIR_Coverage, 1225,
     /* 124385 */     GIR_EraseRootFromParent_Done,
     /* 124386 */   // Label 2455: @124386
     /* 124386 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124447), // Rule ID 3306 //
     /* 124391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124406 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124445 */     GIR_RootConstrainSelectedInstOperands,
     /* 124446 */     // GIR_Coverage, 3306,
     /* 124446 */     GIR_EraseRootFromParent_Done,
     /* 124447 */   // Label 2456: @124447
     /* 124447 */   GIM_Reject,
     /* 124448 */ // Label 2452: @124448
     /* 124448 */ GIM_Reject,
     /* 124449 */ // Label 2442: @124449
     /* 124449 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(124688),
     /* 124454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124460 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(124523), // Rule ID 6025 //
     /* 124465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124495 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124521 */     GIR_RootConstrainSelectedInstOperands,
     /* 124522 */     // GIR_Coverage, 6025,
     /* 124522 */     GIR_EraseRootFromParent_Done,
     /* 124523 */   // Label 2458: @124523
     /* 124523 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(124586), // Rule ID 3693 //
     /* 124528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124558 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124584 */     GIR_RootConstrainSelectedInstOperands,
     /* 124585 */     // GIR_Coverage, 3693,
     /* 124585 */     GIR_EraseRootFromParent_Done,
     /* 124586 */   // Label 2459: @124586
     /* 124586 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(124626), // Rule ID 1228 //
     /* 124591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124606 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124624 */     GIR_RootConstrainSelectedInstOperands,
     /* 124625 */     // GIR_Coverage, 1228,
     /* 124625 */     GIR_EraseRootFromParent_Done,
     /* 124626 */   // Label 2460: @124626
     /* 124626 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(124687), // Rule ID 3303 //
     /* 124631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124646 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124685 */     GIR_RootConstrainSelectedInstOperands,
     /* 124686 */     // GIR_Coverage, 3303,
     /* 124686 */     GIR_EraseRootFromParent_Done,
     /* 124687 */   // Label 2461: @124687
     /* 124687 */   GIM_Reject,
     /* 124688 */ // Label 2457: @124688
     /* 124688 */ GIM_Reject,
     /* 124689 */ // Label 2443: @124689
     /* 124689 */ GIM_Reject,
     /* 124690 */ // Label 58: @124690
     /* 124690 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2468*/ GIMT_Encode4(125610),
     /* 124701 */ /*GILLT_v2s32*//*Label 2462*/ GIMT_Encode4(124749), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124713 */ /*GILLT_v4s16*//*Label 2463*/ GIMT_Encode4(124796),
     /* 124717 */ /*GILLT_v4s32*//*Label 2464*/ GIMT_Encode4(124843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124729 */ /*GILLT_v8s8*//*Label 2465*/ GIMT_Encode4(125083),
     /* 124733 */ /*GILLT_v8s16*//*Label 2466*/ GIMT_Encode4(125130), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124745 */ /*GILLT_v16s8*//*Label 2467*/ GIMT_Encode4(125370),
     /* 124749 */ // Label 2462: @124749
     /* 124749 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(124795), // Rule ID 1204 //
     /* 124754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124775 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124780 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124782 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124787 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124793 */   GIR_RootConstrainSelectedInstOperands,
     /* 124794 */   // GIR_Coverage, 1204,
     /* 124794 */   GIR_EraseRootFromParent_Done,
     /* 124795 */ // Label 2469: @124795
     /* 124795 */ GIM_Reject,
     /* 124796 */ // Label 2463: @124796
     /* 124796 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(124842), // Rule ID 1203 //
     /* 124801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124822 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 124825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124827 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124829 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124834 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124840 */   GIR_RootConstrainSelectedInstOperands,
     /* 124841 */   // GIR_Coverage, 1203,
     /* 124841 */   GIR_EraseRootFromParent_Done,
     /* 124842 */ // Label 2470: @124842
     /* 124842 */ GIM_Reject,
     /* 124843 */ // Label 2464: @124843
     /* 124843 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125082),
     /* 124848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124854 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(124917), // Rule ID 6030 //
     /* 124859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124889 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124915 */     GIR_RootConstrainSelectedInstOperands,
     /* 124916 */     // GIR_Coverage, 6030,
     /* 124916 */     GIR_EraseRootFromParent_Done,
     /* 124917 */   // Label 2472: @124917
     /* 124917 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(124980), // Rule ID 3703 //
     /* 124922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124952 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124978 */     GIR_RootConstrainSelectedInstOperands,
     /* 124979 */     // GIR_Coverage, 3703,
     /* 124979 */     GIR_EraseRootFromParent_Done,
     /* 124980 */   // Label 2473: @124980
     /* 124980 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125020), // Rule ID 1206 //
     /* 124985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125000 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125018 */     GIR_RootConstrainSelectedInstOperands,
     /* 125019 */     // GIR_Coverage, 1206,
     /* 125019 */     GIR_EraseRootFromParent_Done,
     /* 125020 */   // Label 2474: @125020
     /* 125020 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125081), // Rule ID 3327 //
     /* 125025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125040 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125079 */     GIR_RootConstrainSelectedInstOperands,
     /* 125080 */     // GIR_Coverage, 3327,
     /* 125080 */     GIR_EraseRootFromParent_Done,
     /* 125081 */   // Label 2475: @125081
     /* 125081 */   GIM_Reject,
     /* 125082 */ // Label 2471: @125082
     /* 125082 */ GIM_Reject,
     /* 125083 */ // Label 2465: @125083
     /* 125083 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125129), // Rule ID 1207 //
     /* 125088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125109 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125114 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125116 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125121 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125127 */   GIR_RootConstrainSelectedInstOperands,
     /* 125128 */   // GIR_Coverage, 1207,
     /* 125128 */   GIR_EraseRootFromParent_Done,
     /* 125129 */ // Label 2476: @125129
     /* 125129 */ GIM_Reject,
     /* 125130 */ // Label 2466: @125130
     /* 125130 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125369),
     /* 125135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125141 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125204), // Rule ID 6029 //
     /* 125146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125176 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125202 */     GIR_RootConstrainSelectedInstOperands,
     /* 125203 */     // GIR_Coverage, 6029,
     /* 125203 */     GIR_EraseRootFromParent_Done,
     /* 125204 */   // Label 2478: @125204
     /* 125204 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125267), // Rule ID 3701 //
     /* 125209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125239 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125265 */     GIR_RootConstrainSelectedInstOperands,
     /* 125266 */     // GIR_Coverage, 3701,
     /* 125266 */     GIR_EraseRootFromParent_Done,
     /* 125267 */   // Label 2479: @125267
     /* 125267 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125307), // Rule ID 1205 //
     /* 125272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125287 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125305 */     GIR_RootConstrainSelectedInstOperands,
     /* 125306 */     // GIR_Coverage, 1205,
     /* 125306 */     GIR_EraseRootFromParent_Done,
     /* 125307 */   // Label 2480: @125307
     /* 125307 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125368), // Rule ID 3324 //
     /* 125312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125327 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125366 */     GIR_RootConstrainSelectedInstOperands,
     /* 125367 */     // GIR_Coverage, 3324,
     /* 125367 */     GIR_EraseRootFromParent_Done,
     /* 125368 */   // Label 2481: @125368
     /* 125368 */   GIM_Reject,
     /* 125369 */ // Label 2477: @125369
     /* 125369 */ GIM_Reject,
     /* 125370 */ // Label 2467: @125370
     /* 125370 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125609),
     /* 125375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125381 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(125444), // Rule ID 6028 //
     /* 125386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125416 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125442 */     GIR_RootConstrainSelectedInstOperands,
     /* 125443 */     // GIR_Coverage, 6028,
     /* 125443 */     GIR_EraseRootFromParent_Done,
     /* 125444 */   // Label 2483: @125444
     /* 125444 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(125507), // Rule ID 3699 //
     /* 125449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125479 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125505 */     GIR_RootConstrainSelectedInstOperands,
     /* 125506 */     // GIR_Coverage, 3699,
     /* 125506 */     GIR_EraseRootFromParent_Done,
     /* 125507 */   // Label 2484: @125507
     /* 125507 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(125547), // Rule ID 1208 //
     /* 125512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125527 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125545 */     GIR_RootConstrainSelectedInstOperands,
     /* 125546 */     // GIR_Coverage, 1208,
     /* 125546 */     GIR_EraseRootFromParent_Done,
     /* 125547 */   // Label 2485: @125547
     /* 125547 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(125608), // Rule ID 3321 //
     /* 125552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125567 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125606 */     GIR_RootConstrainSelectedInstOperands,
     /* 125607 */     // GIR_Coverage, 3321,
     /* 125607 */     GIR_EraseRootFromParent_Done,
     /* 125608 */   // Label 2486: @125608
     /* 125608 */   GIM_Reject,
     /* 125609 */ // Label 2482: @125609
     /* 125609 */ GIM_Reject,
     /* 125610 */ // Label 2468: @125610
     /* 125610 */ GIM_Reject,
     /* 125611 */ // Label 59: @125611
     /* 125611 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2493*/ GIMT_Encode4(126081),
     /* 125622 */ /*GILLT_v2s32*//*Label 2487*/ GIMT_Encode4(125670), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125634 */ /*GILLT_v4s16*//*Label 2488*/ GIMT_Encode4(125708),
     /* 125638 */ /*GILLT_v4s32*//*Label 2489*/ GIMT_Encode4(125746), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125650 */ /*GILLT_v8s8*//*Label 2490*/ GIMT_Encode4(125845),
     /* 125654 */ /*GILLT_v8s16*//*Label 2491*/ GIMT_Encode4(125883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125666 */ /*GILLT_v16s8*//*Label 2492*/ GIMT_Encode4(125982),
     /* 125670 */ // Label 2487: @125670
     /* 125670 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(125707), // Rule ID 1510 //
     /* 125675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125689 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125694 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125699 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125705 */   GIR_RootConstrainSelectedInstOperands,
     /* 125706 */   // GIR_Coverage, 1510,
     /* 125706 */   GIR_EraseRootFromParent_Done,
     /* 125707 */ // Label 2494: @125707
     /* 125707 */ GIM_Reject,
     /* 125708 */ // Label 2488: @125708
     /* 125708 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(125745), // Rule ID 1509 //
     /* 125713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125727 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125732 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125737 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125743 */   GIR_RootConstrainSelectedInstOperands,
     /* 125744 */   // GIR_Coverage, 1509,
     /* 125744 */   GIR_EraseRootFromParent_Done,
     /* 125745 */ // Label 2495: @125745
     /* 125745 */ GIM_Reject,
     /* 125746 */ // Label 2489: @125746
     /* 125746 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(125844),
     /* 125751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125754 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(125788), // Rule ID 1513 //
     /* 125759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125770 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125786 */     GIR_RootConstrainSelectedInstOperands,
     /* 125787 */     // GIR_Coverage, 1513,
     /* 125787 */     GIR_EraseRootFromParent_Done,
     /* 125788 */   // Label 2497: @125788
     /* 125788 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(125843), // Rule ID 3672 //
     /* 125793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125804 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 125804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 125819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125821 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125841 */     GIR_RootConstrainSelectedInstOperands,
     /* 125842 */     // GIR_Coverage, 3672,
     /* 125842 */     GIR_EraseRootFromParent_Done,
     /* 125843 */   // Label 2498: @125843
     /* 125843 */   GIM_Reject,
     /* 125844 */ // Label 2496: @125844
     /* 125844 */ GIM_Reject,
     /* 125845 */ // Label 2490: @125845
     /* 125845 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(125882), // Rule ID 1508 //
     /* 125850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125864 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 125864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 125867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125869 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125874 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125880 */   GIR_RootConstrainSelectedInstOperands,
     /* 125881 */   // GIR_Coverage, 1508,
     /* 125881 */   GIR_EraseRootFromParent_Done,
     /* 125882 */ // Label 2499: @125882
     /* 125882 */ GIM_Reject,
     /* 125883 */ // Label 2491: @125883
     /* 125883 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(125981),
     /* 125888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125891 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(125925), // Rule ID 1512 //
     /* 125896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125907 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 125907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 125910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125923 */     GIR_RootConstrainSelectedInstOperands,
     /* 125924 */     // GIR_Coverage, 1512,
     /* 125924 */     GIR_EraseRootFromParent_Done,
     /* 125925 */   // Label 2501: @125925
     /* 125925 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(125980), // Rule ID 3666 //
     /* 125930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125941 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 125941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 125956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125958 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125978 */     GIR_RootConstrainSelectedInstOperands,
     /* 125979 */     // GIR_Coverage, 3666,
     /* 125979 */     GIR_EraseRootFromParent_Done,
     /* 125980 */   // Label 2502: @125980
     /* 125980 */   GIM_Reject,
     /* 125981 */ // Label 2500: @125981
     /* 125981 */ GIM_Reject,
     /* 125982 */ // Label 2492: @125982
     /* 125982 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(126080),
     /* 125987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125990 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(126024), // Rule ID 1511 //
     /* 125995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126006 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126022 */     GIR_RootConstrainSelectedInstOperands,
     /* 126023 */     // GIR_Coverage, 1511,
     /* 126023 */     GIR_EraseRootFromParent_Done,
     /* 126024 */   // Label 2504: @126024
     /* 126024 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126079), // Rule ID 3660 //
     /* 126029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126040 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126057 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126077 */     GIR_RootConstrainSelectedInstOperands,
     /* 126078 */     // GIR_Coverage, 3660,
     /* 126078 */     GIR_EraseRootFromParent_Done,
     /* 126079 */   // Label 2505: @126079
     /* 126079 */   GIM_Reject,
     /* 126080 */ // Label 2503: @126080
     /* 126080 */ GIM_Reject,
     /* 126081 */ // Label 2493: @126081
     /* 126081 */ GIM_Reject,
     /* 126082 */ // Label 60: @126082
     /* 126082 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(126154),
     /* 126087 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126090 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(126105), // Rule ID 32 //
     /* 126095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126098 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126103 */     GIR_RootConstrainSelectedInstOperands,
     /* 126104 */     // GIR_Coverage, 32,
     /* 126104 */     GIR_Done,
     /* 126105 */   // Label 2507: @126105
     /* 126105 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(126129), // Rule ID 283 //
     /* 126110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126113 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126116 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126127 */     GIR_RootConstrainSelectedInstOperands,
     /* 126128 */     // GIR_Coverage, 283,
     /* 126128 */     GIR_EraseRootFromParent_Done,
     /* 126129 */   // Label 2508: @126129
     /* 126129 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(126153), // Rule ID 577 //
     /* 126134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126137 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126140 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126151 */     GIR_RootConstrainSelectedInstOperands,
     /* 126152 */     // GIR_Coverage, 577,
     /* 126152 */     GIR_EraseRootFromParent_Done,
     /* 126153 */   // Label 2509: @126153
     /* 126153 */   GIM_Reject,
     /* 126154 */ // Label 2506: @126154
     /* 126154 */ GIM_Reject,
     /* 126155 */ // Label 61: @126155
     /* 126155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2514*/ GIMT_Encode4(126454),
     /* 126166 */ /*GILLT_v4s16*//*Label 2510*/ GIMT_Encode4(126202), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126182 */ /*GILLT_v8s8*//*Label 2511*/ GIMT_Encode4(126265),
     /* 126186 */ /*GILLT_v8s16*//*Label 2512*/ GIMT_Encode4(126328), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126198 */ /*GILLT_v16s8*//*Label 2513*/ GIMT_Encode4(126391),
     /* 126202 */ // Label 2510: @126202
     /* 126202 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126264), // Rule ID 1572 //
     /* 126207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126239 */   // MIs[1] Operand 1
     /* 126239 */   // No operand predicates
     /* 126239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126241 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126248 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126250 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126256 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126262 */   GIR_RootConstrainSelectedInstOperands,
     /* 126263 */   // GIR_Coverage, 1572,
     /* 126263 */   GIR_EraseRootFromParent_Done,
     /* 126264 */ // Label 2515: @126264
     /* 126264 */ GIM_Reject,
     /* 126265 */ // Label 2511: @126265
     /* 126265 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(126327), // Rule ID 1571 //
     /* 126270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126279 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126302 */   // MIs[1] Operand 1
     /* 126302 */   // No operand predicates
     /* 126302 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126304 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126309 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126311 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126313 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126319 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126325 */   GIR_RootConstrainSelectedInstOperands,
     /* 126326 */   // GIR_Coverage, 1571,
     /* 126326 */   GIR_EraseRootFromParent_Done,
     /* 126327 */ // Label 2516: @126327
     /* 126327 */ GIM_Reject,
     /* 126328 */ // Label 2512: @126328
     /* 126328 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(126390), // Rule ID 3436 //
     /* 126333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126365 */   // MIs[1] Operand 1
     /* 126365 */   // No operand predicates
     /* 126365 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126367 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126372 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126374 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126376 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126382 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126388 */   GIR_RootConstrainSelectedInstOperands,
     /* 126389 */   // GIR_Coverage, 3436,
     /* 126389 */   GIR_EraseRootFromParent_Done,
     /* 126390 */ // Label 2517: @126390
     /* 126390 */ GIM_Reject,
     /* 126391 */ // Label 2513: @126391
     /* 126391 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(126453), // Rule ID 3435 //
     /* 126396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126420 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126424 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126428 */   // MIs[1] Operand 1
     /* 126428 */   // No operand predicates
     /* 126428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126430 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126437 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126439 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126451 */   GIR_RootConstrainSelectedInstOperands,
     /* 126452 */   // GIR_Coverage, 3435,
     /* 126452 */   GIR_EraseRootFromParent_Done,
     /* 126453 */ // Label 2518: @126453
     /* 126453 */ GIM_Reject,
     /* 126454 */ // Label 2514: @126454
     /* 126454 */ GIM_Reject,
     /* 126455 */ // Label 62: @126455
     /* 126455 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(126511), // Rule ID 1570 //
     /* 126460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126463 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126488 */   // MIs[1] Operand 1
     /* 126488 */   // No operand predicates
     /* 126488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126490 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126495 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126497 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126509 */   GIR_RootConstrainSelectedInstOperands,
     /* 126510 */   // GIR_Coverage, 1570,
     /* 126510 */   GIR_EraseRootFromParent_Done,
     /* 126511 */ // Label 2519: @126511
     /* 126511 */ GIM_Reject,
     /* 126512 */ // Label 63: @126512
     /* 126512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2527*/ GIMT_Encode4(127072),
     /* 126523 */ /*GILLT_s32*//*Label 2520*/ GIMT_Encode4(126583), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126535 */ /*GILLT_v2s32*//*Label 2521*/ GIMT_Encode4(126661), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126547 */ /*GILLT_v4s16*//*Label 2522*/ GIMT_Encode4(126699),
     /* 126551 */ /*GILLT_v4s32*//*Label 2523*/ GIMT_Encode4(126737), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126563 */ /*GILLT_v8s8*//*Label 2524*/ GIMT_Encode4(126836),
     /* 126567 */ /*GILLT_v8s16*//*Label 2525*/ GIMT_Encode4(126874), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126579 */ /*GILLT_v16s8*//*Label 2526*/ GIMT_Encode4(126973),
     /* 126583 */ // Label 2520: @126583
     /* 126583 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(126660),
     /* 126588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126591 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(126625), // Rule ID 197 //
     /* 126596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126607 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126623 */     GIR_RootConstrainSelectedInstOperands,
     /* 126624 */     // GIR_Coverage, 197,
     /* 126624 */     GIR_EraseRootFromParent_Done,
     /* 126625 */   // Label 2529: @126625
     /* 126625 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(126659), // Rule ID 534 //
     /* 126630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126641 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126657 */     GIR_RootConstrainSelectedInstOperands,
     /* 126658 */     // GIR_Coverage, 534,
     /* 126658 */     GIR_EraseRootFromParent_Done,
     /* 126659 */   // Label 2530: @126659
     /* 126659 */   GIM_Reject,
     /* 126660 */ // Label 2528: @126660
     /* 126660 */ GIM_Reject,
     /* 126661 */ // Label 2521: @126661
     /* 126661 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(126698), // Rule ID 1548 //
     /* 126666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126680 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126685 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126690 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126696 */   GIR_RootConstrainSelectedInstOperands,
     /* 126697 */   // GIR_Coverage, 1548,
     /* 126697 */   GIR_EraseRootFromParent_Done,
     /* 126698 */ // Label 2531: @126698
     /* 126698 */ GIM_Reject,
     /* 126699 */ // Label 2522: @126699
     /* 126699 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(126736), // Rule ID 1547 //
     /* 126704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126718 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126723 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126728 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126734 */   GIR_RootConstrainSelectedInstOperands,
     /* 126735 */   // GIR_Coverage, 1547,
     /* 126735 */   GIR_EraseRootFromParent_Done,
     /* 126736 */ // Label 2532: @126736
     /* 126736 */ GIM_Reject,
     /* 126737 */ // Label 2523: @126737
     /* 126737 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(126835),
     /* 126742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126745 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(126779), // Rule ID 1551 //
     /* 126750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126761 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126777 */     GIR_RootConstrainSelectedInstOperands,
     /* 126778 */     // GIR_Coverage, 1551,
     /* 126778 */     GIR_EraseRootFromParent_Done,
     /* 126779 */   // Label 2534: @126779
     /* 126779 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(126834), // Rule ID 3658 //
     /* 126784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126795 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 126795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 126810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126812 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126832 */     GIR_RootConstrainSelectedInstOperands,
     /* 126833 */     // GIR_Coverage, 3658,
     /* 126833 */     GIR_EraseRootFromParent_Done,
     /* 126834 */   // Label 2535: @126834
     /* 126834 */   GIM_Reject,
     /* 126835 */ // Label 2533: @126835
     /* 126835 */ GIM_Reject,
     /* 126836 */ // Label 2524: @126836
     /* 126836 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(126873), // Rule ID 1546 //
     /* 126841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126855 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 126858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126860 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126865 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126871 */   GIR_RootConstrainSelectedInstOperands,
     /* 126872 */   // GIR_Coverage, 1546,
     /* 126872 */   GIR_EraseRootFromParent_Done,
     /* 126873 */ // Label 2536: @126873
     /* 126873 */ GIM_Reject,
     /* 126874 */ // Label 2525: @126874
     /* 126874 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(126972),
     /* 126879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126882 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(126916), // Rule ID 1550 //
     /* 126887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126898 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 126901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126914 */     GIR_RootConstrainSelectedInstOperands,
     /* 126915 */     // GIR_Coverage, 1550,
     /* 126915 */     GIR_EraseRootFromParent_Done,
     /* 126916 */   // Label 2538: @126916
     /* 126916 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(126971), // Rule ID 3656 //
     /* 126921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126932 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 126932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 126947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126949 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126969 */     GIR_RootConstrainSelectedInstOperands,
     /* 126970 */     // GIR_Coverage, 3656,
     /* 126970 */     GIR_EraseRootFromParent_Done,
     /* 126971 */   // Label 2539: @126971
     /* 126971 */   GIM_Reject,
     /* 126972 */ // Label 2537: @126972
     /* 126972 */ GIM_Reject,
     /* 126973 */ // Label 2526: @126973
     /* 126973 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(127071),
     /* 126978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126981 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(127015), // Rule ID 1549 //
     /* 126986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126997 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127013 */     GIR_RootConstrainSelectedInstOperands,
     /* 127014 */     // GIR_Coverage, 1549,
     /* 127014 */     GIR_EraseRootFromParent_Done,
     /* 127015 */   // Label 2541: @127015
     /* 127015 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127070), // Rule ID 3654 //
     /* 127020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127031 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127048 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127068 */     GIR_RootConstrainSelectedInstOperands,
     /* 127069 */     // GIR_Coverage, 3654,
     /* 127069 */     GIR_EraseRootFromParent_Done,
     /* 127070 */   // Label 2542: @127070
     /* 127070 */   GIM_Reject,
     /* 127071 */ // Label 2540: @127071
     /* 127071 */ GIM_Reject,
     /* 127072 */ // Label 2527: @127072
     /* 127072 */ GIM_Reject,
     /* 127073 */ // Label 64: @127073
     /* 127073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2545*/ GIMT_Encode4(127180),
     /* 127084 */ /*GILLT_v8s8*//*Label 2543*/ GIMT_Encode4(127104), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127100 */ /*GILLT_v16s8*//*Label 2544*/ GIMT_Encode4(127142),
     /* 127104 */ // Label 2543: @127104
     /* 127104 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(127141), // Rule ID 1552 //
     /* 127109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127123 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127128 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127133 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127139 */   GIR_RootConstrainSelectedInstOperands,
     /* 127140 */   // GIR_Coverage, 1552,
     /* 127140 */   GIR_EraseRootFromParent_Done,
     /* 127141 */ // Label 2546: @127141
     /* 127141 */ GIM_Reject,
     /* 127142 */ // Label 2544: @127142
     /* 127142 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(127179), // Rule ID 1553 //
     /* 127147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127161 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127166 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127171 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127177 */   GIR_RootConstrainSelectedInstOperands,
     /* 127178 */   // GIR_Coverage, 1553,
     /* 127178 */   GIR_EraseRootFromParent_Done,
     /* 127179 */ // Label 2547: @127179
     /* 127179 */ GIM_Reject,
     /* 127180 */ // Label 2545: @127180
     /* 127180 */ GIM_Reject,
     /* 127181 */ // Label 65: @127181
     /* 127181 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2551*/ GIMT_Encode4(127470),
     /* 127192 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(127240), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127220 */ /*GILLT_v4s32*//*Label 2549*/ GIMT_Encode4(127352), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127236 */ /*GILLT_v8s16*//*Label 2550*/ GIMT_Encode4(127411),
     /* 127240 */ // Label 2548: @127240
     /* 127240 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127351),
     /* 127245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127248 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127282), // Rule ID 199 //
     /* 127253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127264 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127280 */     GIR_RootConstrainSelectedInstOperands,
     /* 127281 */     // GIR_Coverage, 199,
     /* 127281 */     GIR_EraseRootFromParent_Done,
     /* 127282 */   // Label 2553: @127282
     /* 127282 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127316), // Rule ID 326 //
     /* 127287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127298 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127314 */     GIR_RootConstrainSelectedInstOperands,
     /* 127315 */     // GIR_Coverage, 326,
     /* 127315 */     GIR_EraseRootFromParent_Done,
     /* 127316 */   // Label 2554: @127316
     /* 127316 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(127350), // Rule ID 536 //
     /* 127321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127332 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127348 */     GIR_RootConstrainSelectedInstOperands,
     /* 127349 */     // GIR_Coverage, 536,
     /* 127349 */     GIR_EraseRootFromParent_Done,
     /* 127350 */   // Label 2555: @127350
     /* 127350 */   GIM_Reject,
     /* 127351 */ // Label 2552: @127351
     /* 127351 */ GIM_Reject,
     /* 127352 */ // Label 2549: @127352
     /* 127352 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(127410), // Rule ID 3331 //
     /* 127357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127371 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127388 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127399 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127408 */   GIR_RootConstrainSelectedInstOperands,
     /* 127409 */   // GIR_Coverage, 3331,
     /* 127409 */   GIR_EraseRootFromParent_Done,
     /* 127410 */ // Label 2556: @127410
     /* 127410 */ GIM_Reject,
     /* 127411 */ // Label 2550: @127411
     /* 127411 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(127469), // Rule ID 3330 //
     /* 127416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127430 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127447 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127452 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127458 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127467 */   GIR_RootConstrainSelectedInstOperands,
     /* 127468 */   // GIR_Coverage, 3330,
     /* 127468 */   GIR_EraseRootFromParent_Done,
     /* 127469 */ // Label 2557: @127469
     /* 127469 */ GIM_Reject,
     /* 127470 */ // Label 2551: @127470
     /* 127470 */ GIM_Reject,
     /* 127471 */ // Label 66: @127471
     /* 127471 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2562*/ GIMT_Encode4(127902),
     /* 127482 */ /*GILLT_s32*//*Label 2558*/ GIMT_Encode4(127542), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127510 */ /*GILLT_v4s32*//*Label 2559*/ GIMT_Encode4(127620), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127526 */ /*GILLT_v8s16*//*Label 2560*/ GIMT_Encode4(127714), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127538 */ /*GILLT_v16s8*//*Label 2561*/ GIMT_Encode4(127808),
     /* 127542 */ // Label 2558: @127542
     /* 127542 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(127619),
     /* 127547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127550 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(127584), // Rule ID 198 //
     /* 127555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127566 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127582 */     GIR_RootConstrainSelectedInstOperands,
     /* 127583 */     // GIR_Coverage, 198,
     /* 127583 */     GIR_EraseRootFromParent_Done,
     /* 127584 */   // Label 2564: @127584
     /* 127584 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(127618), // Rule ID 535 //
     /* 127589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127600 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127616 */     GIR_RootConstrainSelectedInstOperands,
     /* 127617 */     // GIR_Coverage, 535,
     /* 127617 */     GIR_EraseRootFromParent_Done,
     /* 127618 */   // Label 2565: @127618
     /* 127618 */   GIM_Reject,
     /* 127619 */ // Label 2563: @127619
     /* 127619 */ GIM_Reject,
     /* 127620 */ // Label 2559: @127620
     /* 127620 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(127713), // Rule ID 4758 //
     /* 127625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127639 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127639 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127642 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127646 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127663 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127666 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127669 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127675 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127688 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127696 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127702 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127711 */   GIR_RootConstrainSelectedInstOperands,
     /* 127712 */   // GIR_Coverage, 4758,
     /* 127712 */   GIR_EraseRootFromParent_Done,
     /* 127713 */ // Label 2566: @127713
     /* 127713 */ GIM_Reject,
     /* 127714 */ // Label 2560: @127714
     /* 127714 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(127807), // Rule ID 4759 //
     /* 127719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127733 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127733 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127736 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127740 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127757 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127760 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127763 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127769 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127782 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127790 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127796 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127805 */   GIR_RootConstrainSelectedInstOperands,
     /* 127806 */   // GIR_Coverage, 4759,
     /* 127806 */   GIR_EraseRootFromParent_Done,
     /* 127807 */ // Label 2567: @127807
     /* 127807 */ GIM_Reject,
     /* 127808 */ // Label 2561: @127808
     /* 127808 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(127901), // Rule ID 4757 //
     /* 127813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127827 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 127827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127851 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 127854 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127857 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127863 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 127874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127876 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127884 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127890 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127899 */   GIR_RootConstrainSelectedInstOperands,
     /* 127900 */   // GIR_Coverage, 4757,
     /* 127900 */   GIR_EraseRootFromParent_Done,
     /* 127901 */ // Label 2568: @127901
     /* 127901 */ GIM_Reject,
     /* 127902 */ // Label 2562: @127902
     /* 127902 */ GIM_Reject,
     /* 127903 */ // Label 67: @127903
     /* 127903 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2576*/ GIMT_Encode4(128277),
     /* 127914 */ /*GILLT_s16*//*Label 2569*/ GIMT_Encode4(127966),
     /* 127918 */ /*GILLT_s32*//*Label 2570*/ GIMT_Encode4(127993),
     /* 127922 */ /*GILLT_s64*//*Label 2571*/ GIMT_Encode4(128020), GIMT_Encode4(0),
     /* 127930 */ /*GILLT_v2s32*//*Label 2572*/ GIMT_Encode4(128047), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127942 */ /*GILLT_v4s16*//*Label 2573*/ GIMT_Encode4(128074),
     /* 127946 */ /*GILLT_v4s32*//*Label 2574*/ GIMT_Encode4(128101), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127962 */ /*GILLT_v8s16*//*Label 2575*/ GIMT_Encode4(128189),
     /* 127966 */ // Label 2569: @127966
     /* 127966 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(127992), // Rule ID 683 //
     /* 127971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 127974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 127981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 127985 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 127985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 127990 */   GIR_RootConstrainSelectedInstOperands,
     /* 127991 */   // GIR_Coverage, 683,
     /* 127991 */   GIR_Done,
     /* 127992 */ // Label 2577: @127992
     /* 127992 */ GIM_Reject,
     /* 127993 */ // Label 2570: @127993
     /* 127993 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(128019), // Rule ID 684 //
     /* 127998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128012 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128017 */   GIR_RootConstrainSelectedInstOperands,
     /* 128018 */   // GIR_Coverage, 684,
     /* 128018 */   GIR_Done,
     /* 128019 */ // Label 2578: @128019
     /* 128019 */ GIM_Reject,
     /* 128020 */ // Label 2571: @128020
     /* 128020 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(128046), // Rule ID 685 //
     /* 128025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128039 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128044 */   GIR_RootConstrainSelectedInstOperands,
     /* 128045 */   // GIR_Coverage, 685,
     /* 128045 */   GIR_Done,
     /* 128046 */ // Label 2579: @128046
     /* 128046 */ GIM_Reject,
     /* 128047 */ // Label 2572: @128047
     /* 128047 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(128073), // Rule ID 1711 //
     /* 128052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128066 */   // (fceil:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /* 128071 */   GIR_RootConstrainSelectedInstOperands,
     /* 128072 */   // GIR_Coverage, 1711,
     /* 128072 */   GIR_Done,
     /* 128073 */ // Label 2580: @128073
     /* 128073 */ GIM_Reject,
     /* 128074 */ // Label 2573: @128074
     /* 128074 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(128100), // Rule ID 1713 //
     /* 128079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128093 */   // (fceil:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /* 128098 */   GIR_RootConstrainSelectedInstOperands,
     /* 128099 */   // GIR_Coverage, 1713,
     /* 128099 */   GIR_Done,
     /* 128100 */ // Label 2581: @128100
     /* 128100 */ GIM_Reject,
     /* 128101 */ // Label 2574: @128101
     /* 128101 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(128188),
     /* 128106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128109 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(128132), // Rule ID 1712 //
     /* 128114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128125 */     // (fceil:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /* 128130 */     GIR_RootConstrainSelectedInstOperands,
     /* 128131 */     // GIR_Coverage, 1712,
     /* 128131 */     GIR_Done,
     /* 128132 */   // Label 2583: @128132
     /* 128132 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128187), // Rule ID 3986 //
     /* 128137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128148 */     // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128165 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128185 */     GIR_RootConstrainSelectedInstOperands,
     /* 128186 */     // GIR_Coverage, 3986,
     /* 128186 */     GIR_EraseRootFromParent_Done,
     /* 128187 */   // Label 2584: @128187
     /* 128187 */   GIM_Reject,
     /* 128188 */ // Label 2582: @128188
     /* 128188 */ GIM_Reject,
     /* 128189 */ // Label 2575: @128189
     /* 128189 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(128276),
     /* 128194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128197 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(128220), // Rule ID 1714 //
     /* 128202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128213 */     // (fceil:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /* 128218 */     GIR_RootConstrainSelectedInstOperands,
     /* 128219 */     // GIR_Coverage, 1714,
     /* 128219 */     GIR_Done,
     /* 128220 */   // Label 2586: @128220
     /* 128220 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(128275), // Rule ID 3974 //
     /* 128225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128236 */     // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128253 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128273 */     GIR_RootConstrainSelectedInstOperands,
     /* 128274 */     // GIR_Coverage, 3974,
     /* 128274 */     GIR_EraseRootFromParent_Done,
     /* 128275 */   // Label 2587: @128275
     /* 128275 */   GIM_Reject,
     /* 128276 */ // Label 2585: @128276
     /* 128276 */ GIM_Reject,
     /* 128277 */ // Label 2576: @128277
     /* 128277 */ GIM_Reject,
     /* 128278 */ // Label 68: @128278
     /* 128278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2591*/ GIMT_Encode4(128415),
     /* 128289 */ /*GILLT_s16*//*Label 2588*/ GIMT_Encode4(128301),
     /* 128293 */ /*GILLT_s32*//*Label 2589*/ GIMT_Encode4(128339),
     /* 128297 */ /*GILLT_s64*//*Label 2590*/ GIMT_Encode4(128377),
     /* 128301 */ // Label 2588: @128301
     /* 128301 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(128338), // Rule ID 691 //
     /* 128306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128320 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128325 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128336 */   GIR_RootConstrainSelectedInstOperands,
     /* 128337 */   // GIR_Coverage, 691,
     /* 128337 */   GIR_EraseRootFromParent_Done,
     /* 128338 */ // Label 2592: @128338
     /* 128338 */ GIM_Reject,
     /* 128339 */ // Label 2589: @128339
     /* 128339 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(128376), // Rule ID 690 //
     /* 128344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128358 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128363 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128368 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128374 */   GIR_RootConstrainSelectedInstOperands,
     /* 128375 */   // GIR_Coverage, 690,
     /* 128375 */   GIR_EraseRootFromParent_Done,
     /* 128376 */ // Label 2593: @128376
     /* 128376 */ GIM_Reject,
     /* 128377 */ // Label 2590: @128377
     /* 128377 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(128414), // Rule ID 689 //
     /* 128382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128396 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128401 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128412 */   GIR_RootConstrainSelectedInstOperands,
     /* 128413 */   // GIR_Coverage, 689,
     /* 128413 */   GIR_EraseRootFromParent_Done,
     /* 128414 */ // Label 2594: @128414
     /* 128414 */ GIM_Reject,
     /* 128415 */ // Label 2591: @128415
     /* 128415 */ GIM_Reject,
     /* 128416 */ // Label 69: @128416
     /* 128416 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2602*/ GIMT_Encode4(128790),
     /* 128427 */ /*GILLT_s16*//*Label 2595*/ GIMT_Encode4(128479),
     /* 128431 */ /*GILLT_s32*//*Label 2596*/ GIMT_Encode4(128506),
     /* 128435 */ /*GILLT_s64*//*Label 2597*/ GIMT_Encode4(128533), GIMT_Encode4(0),
     /* 128443 */ /*GILLT_v2s32*//*Label 2598*/ GIMT_Encode4(128560), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128455 */ /*GILLT_v4s16*//*Label 2599*/ GIMT_Encode4(128587),
     /* 128459 */ /*GILLT_v4s32*//*Label 2600*/ GIMT_Encode4(128614), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128475 */ /*GILLT_v8s16*//*Label 2601*/ GIMT_Encode4(128702),
     /* 128479 */ // Label 2595: @128479
     /* 128479 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(128505), // Rule ID 686 //
     /* 128484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128498 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128503 */   GIR_RootConstrainSelectedInstOperands,
     /* 128504 */   // GIR_Coverage, 686,
     /* 128504 */   GIR_Done,
     /* 128505 */ // Label 2603: @128505
     /* 128505 */ GIM_Reject,
     /* 128506 */ // Label 2596: @128506
     /* 128506 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(128532), // Rule ID 687 //
     /* 128511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128525 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128530 */   GIR_RootConstrainSelectedInstOperands,
     /* 128531 */   // GIR_Coverage, 687,
     /* 128531 */   GIR_Done,
     /* 128532 */ // Label 2604: @128532
     /* 128532 */ GIM_Reject,
     /* 128533 */ // Label 2597: @128533
     /* 128533 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(128559), // Rule ID 688 //
     /* 128538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128552 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128557 */   GIR_RootConstrainSelectedInstOperands,
     /* 128558 */   // GIR_Coverage, 688,
     /* 128558 */   GIR_Done,
     /* 128559 */ // Label 2605: @128559
     /* 128559 */ GIM_Reject,
     /* 128560 */ // Label 2598: @128560
     /* 128560 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(128586), // Rule ID 1707 //
     /* 128565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128579 */   // (ffloor:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /* 128584 */   GIR_RootConstrainSelectedInstOperands,
     /* 128585 */   // GIR_Coverage, 1707,
     /* 128585 */   GIR_Done,
     /* 128586 */ // Label 2606: @128586
     /* 128586 */ GIM_Reject,
     /* 128587 */ // Label 2599: @128587
     /* 128587 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(128613), // Rule ID 1709 //
     /* 128592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128606 */   // (ffloor:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /* 128611 */   GIR_RootConstrainSelectedInstOperands,
     /* 128612 */   // GIR_Coverage, 1709,
     /* 128612 */   GIR_Done,
     /* 128613 */ // Label 2607: @128613
     /* 128613 */ GIM_Reject,
     /* 128614 */ // Label 2600: @128614
     /* 128614 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(128701),
     /* 128619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128622 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(128645), // Rule ID 1708 //
     /* 128627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128638 */     // (ffloor:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /* 128643 */     GIR_RootConstrainSelectedInstOperands,
     /* 128644 */     // GIR_Coverage, 1708,
     /* 128644 */     GIR_Done,
     /* 128645 */   // Label 2609: @128645
     /* 128645 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(128700), // Rule ID 3984 //
     /* 128650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128661 */     // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128678 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128698 */     GIR_RootConstrainSelectedInstOperands,
     /* 128699 */     // GIR_Coverage, 3984,
     /* 128699 */     GIR_EraseRootFromParent_Done,
     /* 128700 */   // Label 2610: @128700
     /* 128700 */   GIM_Reject,
     /* 128701 */ // Label 2608: @128701
     /* 128701 */ GIM_Reject,
     /* 128702 */ // Label 2601: @128702
     /* 128702 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(128789),
     /* 128707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128710 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(128733), // Rule ID 1710 //
     /* 128715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128726 */     // (ffloor:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /* 128731 */     GIR_RootConstrainSelectedInstOperands,
     /* 128732 */     // GIR_Coverage, 1710,
     /* 128732 */     GIR_Done,
     /* 128733 */   // Label 2612: @128733
     /* 128733 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(128788), // Rule ID 3972 //
     /* 128738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128749 */     // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128766 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128786 */     GIR_RootConstrainSelectedInstOperands,
     /* 128787 */     // GIR_Coverage, 3972,
     /* 128787 */     GIR_EraseRootFromParent_Done,
     /* 128788 */   // Label 2613: @128788
     /* 128788 */   GIM_Reject,
     /* 128789 */ // Label 2611: @128789
     /* 128789 */ GIM_Reject,
     /* 128790 */ // Label 2602: @128790
     /* 128790 */ GIM_Reject,
     /* 128791 */ // Label 70: @128791
     /* 128791 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2619*/ GIMT_Encode4(129086),
     /* 128802 */ /*GILLT_s16*//*Label 2614*/ GIMT_Encode4(128854),
     /* 128806 */ /*GILLT_s32*//*Label 2615*/ GIMT_Encode4(128892),
     /* 128810 */ /*GILLT_s64*//*Label 2616*/ GIMT_Encode4(128930), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128834 */ /*GILLT_v4s32*//*Label 2617*/ GIMT_Encode4(128968), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128850 */ /*GILLT_v8s16*//*Label 2618*/ GIMT_Encode4(129027),
     /* 128854 */ // Label 2614: @128854
     /* 128854 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(128891), // Rule ID 671 //
     /* 128859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128873 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128878 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128883 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128889 */   GIR_RootConstrainSelectedInstOperands,
     /* 128890 */   // GIR_Coverage, 671,
     /* 128890 */   GIR_EraseRootFromParent_Done,
     /* 128891 */ // Label 2620: @128891
     /* 128891 */ GIM_Reject,
     /* 128892 */ // Label 2615: @128892
     /* 128892 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(128929), // Rule ID 672 //
     /* 128897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128911 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128916 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128921 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128927 */   GIR_RootConstrainSelectedInstOperands,
     /* 128928 */   // GIR_Coverage, 672,
     /* 128928 */   GIR_EraseRootFromParent_Done,
     /* 128929 */ // Label 2621: @128929
     /* 128929 */ GIM_Reject,
     /* 128930 */ // Label 2616: @128930
     /* 128930 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(128967), // Rule ID 673 //
     /* 128935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128949 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 128952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128954 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128959 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128965 */   GIR_RootConstrainSelectedInstOperands,
     /* 128966 */   // GIR_Coverage, 673,
     /* 128966 */   GIR_EraseRootFromParent_Done,
     /* 128967 */ // Label 2622: @128967
     /* 128967 */ GIM_Reject,
     /* 128968 */ // Label 2617: @128968
     /* 128968 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(129026), // Rule ID 3978 //
     /* 128973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128987 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 129002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129004 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129009 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129015 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129024 */   GIR_RootConstrainSelectedInstOperands,
     /* 129025 */   // GIR_Coverage, 3978,
     /* 129025 */   GIR_EraseRootFromParent_Done,
     /* 129026 */ // Label 2623: @129026
     /* 129026 */ GIM_Reject,
     /* 129027 */ // Label 2618: @129027
     /* 129027 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(129085), // Rule ID 3966 //
     /* 129032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129046 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129063 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129068 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129074 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129083 */   GIR_RootConstrainSelectedInstOperands,
     /* 129084 */   // GIR_Coverage, 3966,
     /* 129084 */   GIR_EraseRootFromParent_Done,
     /* 129085 */ // Label 2624: @129085
     /* 129085 */ GIM_Reject,
     /* 129086 */ // Label 2619: @129086
     /* 129086 */ GIM_Reject,
     /* 129087 */ // Label 71: @129087
     /* 129087 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2628*/ GIMT_Encode4(129224),
     /* 129098 */ /*GILLT_s16*//*Label 2625*/ GIMT_Encode4(129110),
     /* 129102 */ /*GILLT_s32*//*Label 2626*/ GIMT_Encode4(129148),
     /* 129106 */ /*GILLT_s64*//*Label 2627*/ GIMT_Encode4(129186),
     /* 129110 */ // Label 2625: @129110
     /* 129110 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(129147), // Rule ID 668 //
     /* 129115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129129 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129134 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129139 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129145 */   GIR_RootConstrainSelectedInstOperands,
     /* 129146 */   // GIR_Coverage, 668,
     /* 129146 */   GIR_EraseRootFromParent_Done,
     /* 129147 */ // Label 2629: @129147
     /* 129147 */ GIM_Reject,
     /* 129148 */ // Label 2626: @129148
     /* 129148 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(129185), // Rule ID 669 //
     /* 129153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129167 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129172 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129183 */   GIR_RootConstrainSelectedInstOperands,
     /* 129184 */   // GIR_Coverage, 669,
     /* 129184 */   GIR_EraseRootFromParent_Done,
     /* 129185 */ // Label 2630: @129185
     /* 129185 */ GIM_Reject,
     /* 129186 */ // Label 2627: @129186
     /* 129186 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(129223), // Rule ID 670 //
     /* 129191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129205 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129210 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129215 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129221 */   GIR_RootConstrainSelectedInstOperands,
     /* 129222 */   // GIR_Coverage, 670,
     /* 129222 */   GIR_EraseRootFromParent_Done,
     /* 129223 */ // Label 2631: @129223
     /* 129223 */ GIM_Reject,
     /* 129224 */ // Label 2628: @129224
     /* 129224 */ GIM_Reject,
     /* 129225 */ // Label 72: @129225
     /* 129225 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(129240), // Rule ID 12 //
     /* 129230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129233 */   // (trap)  =>  (TRAPNaCl)
     /* 129233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129238 */   GIR_RootConstrainSelectedInstOperands,
     /* 129239 */   // GIR_Coverage, 12,
     /* 129239 */   GIR_Done,
     /* 129240 */ // Label 2632: @129240
     /* 129240 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(129255), // Rule ID 13 //
     /* 129245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129248 */   // (trap)  =>  (TRAP)
     /* 129248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129253 */   GIR_RootConstrainSelectedInstOperands,
     /* 129254 */   // GIR_Coverage, 13,
     /* 129254 */   GIR_Done,
     /* 129255 */ // Label 2633: @129255
     /* 129255 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(129270), // Rule ID 285 //
     /* 129260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129263 */   // (trap)  =>  (tTRAP)
     /* 129263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129268 */   GIR_RootConstrainSelectedInstOperands,
     /* 129269 */   // GIR_Coverage, 285,
     /* 129269 */   GIR_Done,
     /* 129270 */ // Label 2634: @129270
     /* 129270 */ GIM_Reject,
     /* 129271 */ // Label 73: @129271
     /* 129271 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(129287), // Rule ID 1838 //
     /* 129276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129279 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129285 */   GIR_RootConstrainSelectedInstOperands,
     /* 129286 */   // GIR_Coverage, 1838,
     /* 129286 */   GIR_EraseRootFromParent_Done,
     /* 129287 */ // Label 2635: @129287
     /* 129287 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(129314), // Rule ID 1839 //
     /* 129292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129295 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129298 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129308 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129312 */   GIR_RootConstrainSelectedInstOperands,
     /* 129313 */   // GIR_Coverage, 1839,
     /* 129313 */   GIR_EraseRootFromParent_Done,
     /* 129314 */ // Label 2636: @129314
     /* 129314 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(129330), // Rule ID 2024 //
     /* 129319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129322 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129328 */   GIR_RootConstrainSelectedInstOperands,
     /* 129329 */   // GIR_Coverage, 2024,
     /* 129329 */   GIR_EraseRootFromParent_Done,
     /* 129330 */ // Label 2637: @129330
     /* 129330 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(129357), // Rule ID 2025 //
     /* 129335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129338 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129341 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129355 */   GIR_RootConstrainSelectedInstOperands,
     /* 129356 */   // GIR_Coverage, 2025,
     /* 129356 */   GIR_EraseRootFromParent_Done,
     /* 129357 */ // Label 2638: @129357
     /* 129357 */ GIM_Reject,
     /* 129358 */ // Label 74: @129358
     /* 129358 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(129778),
     /* 129363 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129366 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2643*/ GIMT_Encode4(129664),
     /* 129377 */   /*GILLT_v4s32*//*Label 2640*/ GIMT_Encode4(129409), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129393 */   /*GILLT_v8s16*//*Label 2641*/ GIMT_Encode4(129480), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129405 */   /*GILLT_v16s8*//*Label 2642*/ GIMT_Encode4(129551),
     /* 129409 */   // Label 2640: @129409
     /* 129409 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(129479), // Rule ID 3241 //
     /* 129414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129449 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129477 */     GIR_RootConstrainSelectedInstOperands,
     /* 129478 */     // GIR_Coverage, 3241,
     /* 129478 */     GIR_EraseRootFromParent_Done,
     /* 129479 */   // Label 2644: @129479
     /* 129479 */   GIM_Reject,
     /* 129480 */   // Label 2641: @129480
     /* 129480 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(129550), // Rule ID 3242 //
     /* 129485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129520 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129548 */     GIR_RootConstrainSelectedInstOperands,
     /* 129549 */     // GIR_Coverage, 3242,
     /* 129549 */     GIR_EraseRootFromParent_Done,
     /* 129550 */   // Label 2645: @129550
     /* 129550 */   GIM_Reject,
     /* 129551 */   // Label 2642: @129551
     /* 129551 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(129663),
     /* 129556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129560 */     GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(129626), // Rule ID 3245 //
     /* 129565 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129568 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129572 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129576 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129580 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129584 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129589 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129594 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129596 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129596 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129599 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129601 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129605 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129609 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129612 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129618 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129624 */       GIR_RootConstrainSelectedInstOperands,
     /* 129625 */       // GIR_Coverage, 3245,
     /* 129625 */       GIR_EraseRootFromParent_Done,
     /* 129626 */     // Label 2647: @129626
     /* 129626 */     GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(129662), // Rule ID 3049 //
     /* 129631 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129634 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129638 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129638 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129641 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129643 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129645 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129648 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129654 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129660 */       GIR_RootConstrainSelectedInstOperands,
     /* 129661 */       // GIR_Coverage, 3049,
     /* 129661 */       GIR_EraseRootFromParent_Done,
     /* 129662 */     // Label 2648: @129662
     /* 129662 */     GIM_Reject,
     /* 129663 */   // Label 2646: @129663
     /* 129663 */   GIM_Reject,
     /* 129664 */   // Label 2643: @129664
     /* 129664 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2651*/ GIMT_Encode4(129777),
     /* 129675 */   /*GILLT_v4s32*//*Label 2649*/ GIMT_Encode4(129695), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129691 */   /*GILLT_v8s16*//*Label 2650*/ GIMT_Encode4(129736),
     /* 129695 */   // Label 2649: @129695
     /* 129695 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(129735), // Rule ID 3087 //
     /* 129700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129711 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129716 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129733 */     GIR_RootConstrainSelectedInstOperands,
     /* 129734 */     // GIR_Coverage, 3087,
     /* 129734 */     GIR_EraseRootFromParent_Done,
     /* 129735 */   // Label 2652: @129735
     /* 129735 */   GIM_Reject,
     /* 129736 */   // Label 2650: @129736
     /* 129736 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(129776), // Rule ID 3077 //
     /* 129741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129752 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129757 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129774 */     GIR_RootConstrainSelectedInstOperands,
     /* 129775 */     // GIR_Coverage, 3077,
     /* 129775 */     GIR_EraseRootFromParent_Done,
     /* 129776 */   // Label 2653: @129776
     /* 129776 */   GIM_Reject,
     /* 129777 */   // Label 2651: @129777
     /* 129777 */   GIM_Reject,
     /* 129778 */ // Label 2639: @129778
     /* 129778 */ GIM_Reject,
     /* 129779 */ // Label 75: @129779
     /* 129779 */ GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(130058),
     /* 129784 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129787 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2658*/ GIMT_Encode4(130057),
     /* 129798 */   /*GILLT_v4s32*//*Label 2655*/ GIMT_Encode4(129830), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129814 */   /*GILLT_v8s16*//*Label 2656*/ GIMT_Encode4(129913), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129826 */   /*GILLT_v16s8*//*Label 2657*/ GIMT_Encode4(129981),
     /* 129830 */   // Label 2655: @129830
     /* 129830 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(129912), // Rule ID 3147 //
     /* 129835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129846 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129858 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129871 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129877 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129910 */     GIR_RootConstrainSelectedInstOperands,
     /* 129911 */     // GIR_Coverage, 3147,
     /* 129911 */     GIR_EraseRootFromParent_Done,
     /* 129912 */   // Label 2659: @129912
     /* 129912 */   GIM_Reject,
     /* 129913 */   // Label 2656: @129913
     /* 129913 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(129980), // Rule ID 3146 //
     /* 129918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129929 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 129936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129941 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 129951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 129956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129978 */     GIR_RootConstrainSelectedInstOperands,
     /* 129979 */     // GIR_Coverage, 3146,
     /* 129979 */     GIR_EraseRootFromParent_Done,
     /* 129980 */   // Label 2660: @129980
     /* 129980 */   GIM_Reject,
     /* 129981 */   // Label 2657: @129981
     /* 129981 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(130056), // Rule ID 3145 //
     /* 129986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129997 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 129997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130015 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130021 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130054 */     GIR_RootConstrainSelectedInstOperands,
     /* 130055 */     // GIR_Coverage, 3145,
     /* 130055 */     GIR_EraseRootFromParent_Done,
     /* 130056 */   // Label 2661: @130056
     /* 130056 */   GIM_Reject,
     /* 130057 */   // Label 2658: @130057
     /* 130057 */   GIM_Reject,
     /* 130058 */ // Label 2654: @130058
     /* 130058 */ GIM_Reject,
     /* 130059 */ // Label 76: @130059
     /* 130059 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(130347),
     /* 130064 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130067 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2666*/ GIMT_Encode4(130346),
     /* 130078 */   /*GILLT_v4s32*//*Label 2663*/ GIMT_Encode4(130110), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130094 */   /*GILLT_v8s16*//*Label 2664*/ GIMT_Encode4(130193), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130106 */   /*GILLT_v16s8*//*Label 2665*/ GIMT_Encode4(130270),
     /* 130110 */   // Label 2663: @130110
     /* 130110 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(130192), // Rule ID 3153 //
     /* 130115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130126 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130138 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130151 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130157 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130190 */     GIR_RootConstrainSelectedInstOperands,
     /* 130191 */     // GIR_Coverage, 3153,
     /* 130191 */     GIR_EraseRootFromParent_Done,
     /* 130192 */   // Label 2667: @130192
     /* 130192 */   GIM_Reject,
     /* 130193 */   // Label 2664: @130193
     /* 130193 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(130269), // Rule ID 3152 //
     /* 130198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130209 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130221 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130234 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130267 */     GIR_RootConstrainSelectedInstOperands,
     /* 130268 */     // GIR_Coverage, 3152,
     /* 130268 */     GIR_EraseRootFromParent_Done,
     /* 130269 */   // Label 2668: @130269
     /* 130269 */   GIM_Reject,
     /* 130270 */   // Label 2665: @130270
     /* 130270 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(130345), // Rule ID 3151 //
     /* 130275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130286 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130304 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130310 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130343 */     GIR_RootConstrainSelectedInstOperands,
     /* 130344 */     // GIR_Coverage, 3151,
     /* 130344 */     GIR_EraseRootFromParent_Done,
     /* 130345 */   // Label 2669: @130345
     /* 130345 */   GIM_Reject,
     /* 130346 */   // Label 2666: @130346
     /* 130346 */   GIM_Reject,
     /* 130347 */ // Label 2662: @130347
     /* 130347 */ GIM_Reject,
     /* 130348 */ // Label 77: @130348
     /* 130348 */ GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(130628),
     /* 130353 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130356 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2674*/ GIMT_Encode4(130627),
     /* 130367 */   /*GILLT_v4s32*//*Label 2671*/ GIMT_Encode4(130399), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130383 */   /*GILLT_v8s16*//*Label 2672*/ GIMT_Encode4(130475), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130395 */   /*GILLT_v16s8*//*Label 2673*/ GIMT_Encode4(130551),
     /* 130399 */   // Label 2671: @130399
     /* 130399 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(130474), // Rule ID 3150 //
     /* 130404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130415 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130433 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130439 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130455 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130472 */     GIR_RootConstrainSelectedInstOperands,
     /* 130473 */     // GIR_Coverage, 3150,
     /* 130473 */     GIR_EraseRootFromParent_Done,
     /* 130474 */   // Label 2675: @130474
     /* 130474 */   GIM_Reject,
     /* 130475 */   // Label 2672: @130475
     /* 130475 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(130550), // Rule ID 3149 //
     /* 130480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130491 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130503 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130506 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130509 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130515 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130548 */     GIR_RootConstrainSelectedInstOperands,
     /* 130549 */     // GIR_Coverage, 3149,
     /* 130549 */     GIR_EraseRootFromParent_Done,
     /* 130550 */   // Label 2676: @130550
     /* 130550 */   GIM_Reject,
     /* 130551 */   // Label 2673: @130551
     /* 130551 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(130626), // Rule ID 3148 //
     /* 130556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130567 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130582 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130585 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130591 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130624 */     GIR_RootConstrainSelectedInstOperands,
     /* 130625 */     // GIR_Coverage, 3148,
     /* 130625 */     GIR_EraseRootFromParent_Done,
     /* 130626 */   // Label 2677: @130626
     /* 130626 */   GIM_Reject,
     /* 130627 */   // Label 2674: @130627
     /* 130627 */   GIM_Reject,
     /* 130628 */ // Label 2670: @130628
     /* 130628 */ GIM_Reject,
     /* 130629 */ // Label 78: @130629
     /* 130629 */ GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(130924),
     /* 130634 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130637 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2682*/ GIMT_Encode4(130923),
     /* 130648 */   /*GILLT_v4s32*//*Label 2679*/ GIMT_Encode4(130680), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130664 */   /*GILLT_v8s16*//*Label 2680*/ GIMT_Encode4(130763), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130676 */   /*GILLT_v16s8*//*Label 2681*/ GIMT_Encode4(130840),
     /* 130680 */   // Label 2679: @130680
     /* 130680 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(130762), // Rule ID 3156 //
     /* 130685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130696 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130708 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130721 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130727 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130760 */     GIR_RootConstrainSelectedInstOperands,
     /* 130761 */     // GIR_Coverage, 3156,
     /* 130761 */     GIR_EraseRootFromParent_Done,
     /* 130762 */   // Label 2683: @130762
     /* 130762 */   GIM_Reject,
     /* 130763 */   // Label 2680: @130763
     /* 130763 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(130839), // Rule ID 3155 //
     /* 130768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130779 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130791 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130804 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130837 */     GIR_RootConstrainSelectedInstOperands,
     /* 130838 */     // GIR_Coverage, 3155,
     /* 130838 */     GIR_EraseRootFromParent_Done,
     /* 130839 */   // Label 2684: @130839
     /* 130839 */   GIM_Reject,
     /* 130840 */   // Label 2681: @130840
     /* 130840 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(130922), // Rule ID 3154 //
     /* 130845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130856 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130868 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130878 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130881 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130887 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130920 */     GIR_RootConstrainSelectedInstOperands,
     /* 130921 */     // GIR_Coverage, 3154,
     /* 130921 */     GIR_EraseRootFromParent_Done,
     /* 130922 */   // Label 2685: @130922
     /* 130922 */   GIM_Reject,
     /* 130923 */   // Label 2682: @130923
     /* 130923 */   GIM_Reject,
     /* 130924 */ // Label 2678: @130924
     /* 130924 */ GIM_Reject,
     /* 130925 */ // Label 79: @130925
     /* 130925 */ GIM_Reject,
     /* 130926 */ }; // Size: 130926 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
